/*-------------------------------------------------
	STOOD v5.0
	AADL rules checker 
	Main program

	Copyright TNI Europe & Ellidiss Technologies 2005
	Pierre DISSAUX (pierre.dissaux@tni-world.com)
	18.Mar.05
------------------------------------------------*/
 
/* go */

go :- 
	$init_sys,
	$getenv('PREDICATS',File),
	$consult(File),
	check, fail.
 
/* check */

check :- check(N,R,S), memezTra(N,'Legality'), 
	$loadqual(R,0), $tell(S); checkL, fail; $told.
 
/* i/o */

write(T) :- $writename(T).
print(T) :- $telling(F), $tell('user'), $writename(T), $tell(F).
printlf(T) :- $telling(F), $tell('user'), $writename(T), $nl, $tell(F).
nl :- $nl.
writeTime :- $writename('STOOD check on : '), $system('SHOW TIME'), nl; true.
 
/* misc */

memezTra(A,B) :- $name(A,L1), $name(B,L2), id(L1,L2).
neoKetMemezTra(A,B) :- $name(A,L1), $name(B,L2), not(id(L1,L2)).

id([],[]) :- true.
id([E|L1],[F|L2]) :- ( E =:= F ; E =:= F-32 ; E-32 =:= F ), id(L1,L2).

shortName(F1,F2) :- 
	$name(F1,L1), $reverse(L1,R1), $name(N1,R1),
	$subdelim(1,'/',N2,0,N1,_),
	$name(N2,R2), $reverse(R2,L2), $name(F2,L2).

/* HOOD interface */
/* 13 July 2000 */

hoodObject(X,T,Z) :- isObject(X,T,Z), 
	X \= 'SYSTEM_DIAGRAM', X \= 'SYSTEM_CONFIGURATION', 
	X \= 'FORMAL_PARAMETERS'.

brothers(X,Y) :- hoodObject(X,_,Z),hoodObject(Y,_,Z), X \= Y.

isNotTerm(Y) :-  hoodObject(Y,_,_), isParent(Y).

isParent(Y) :- hoodObject(_,_,Y), !.

isTerm(Y) :- hoodObject(Y,_,_), not(hoodObject(_,_,Y)).

isNotEnv(X) :- isCurrentRoot(Y), hoodObject(X,_,Z),
	( Z \= 'SYSTEM_CONFIGURATION' -> true; memezTra(Y,X) ).

isNotInst(X) :- not(isInstance(X,_,_)).

hasParameter(U,X) :- return(U,'OPERATION',X,_,_,_), !.
hasParameter(U,X) :- argument(U,'OPERATION',X,_,_,_,_,_,_), !.

return(U,'OPERATION',X,_,_) :- return(U,'OPERATION',X,_,_,_).
argument(U,'OPERATION',X,_,_,_,_,_) :- argument(U,'OPERATION',X,_,_,_,_,_,_).
arg(O,X,P,M,T,Q) :- argument(O,'OPERATION',X,_,P,M,T,_,Q).
arg(O,X,'return',M,T,Q) :-  return(O,'OPERATION',X,M,T,Q).

getRoot(X,X) :- isObject(X,_,'SYSTEM_CONFIGURATION'), !.
getRoot(X,R) :- isObject(X,_,Y), getRoot(Y,R).

isImplementedBy(U,E,X,V,Y) :- isImplementedBy(U,E,X,V,Y,_).

implem(U,E,X,W,Z) :- isImplementedBy(U,E,X,V,Y) -> implem(V,E,Y,W,Z); (W=U, Z=X).

same(A,B) :- isCurrentRoot(R), 
	( pragma_TARGET_LANGUAGE(R,'ada') -> 
		memezTra(A,B);
		A = B ).

diff(A,B) :- isCurrentRoot(R), 
	( pragma_TARGET_LANGUAGE(R,'ada') -> 
		neoKetMemezTra(A,B);
		A \= B ).

reqStdType(T) :- isCurrentRoot(R), 
	( pragma_TARGET_LANGUAGE(R,'ada') -> 
		( requires(_,_,_,T,'TYPE',S,_), memezTra(S,'STANDARD') );
		( requires(_,_,_,T,'TYPE','std',_) ) ).
 
