/*``changes``Tue Mar  7 14:17:53 MET 2000``*/
/* version */
/*-------------------------------------------------
	STOOD v4
	Database checker 
	Main program

	Copyright TNI 2000
	Pierre DISSAUX (pierre.dissaux@tni.fr)
	07.Mar.2000
------------------------------------------------*/
 
/*``Always first loaded``Wed Mar 17 15:00:07 MET 1999``*/
/* go */

go :- 
	$init_sys,
	$getenv('PREDICATS',File),
	$consult(File),
	check, fail.
 
/*``Always first loaded``Tue Mar 25 15:58:27 MET 2003``*/
/* check */

check :- check(N,R,S), memezTra(N,'Scan'), 
	$loadqual(R,0), $tell(S); checkS, fail; $told.
check :- check(N,R,S), memezTra(N,'Hierarchy'), 
	$loadqual(R,0), $tell(S); checkH, fail; $told.
 
/*``Always first loaded``Fri Oct 29 09:04:53 MET 1999``*/
/* i/o */

write(T) :- $writename(T).
write2(T) :- $name(T,L), $member(E,L), $put(E), fail.
write2(T).
print(T) :- $telling(F), $tell('user'), $writename(T), $tell(F).
printlf(T) :- $telling(F), $tell('user'), $writename(T), $nl, $tell(F).
nl :- $nl.
writeTime :- $writename('STOOD check on : '), $system('SHOW TIME'), nl; true.
 
/*``macro``Mon Mar 18 17:03:43 MET 1996``*/
/* counter 1 */

cptRst :- $globalset(cpt(0)).
cptPut(I) :- $globalset(cpt(I)).
cptGet(I) :- cpt(I).
cptInc :- cpt(I), J is I + 1, $globalset(cpt(J)).
cptDec :- cpt(I), J is I - 1, $globalset(cpt(J)).
cptAdd(I) :- cpt(J), K is J + I, $globalset(cpt(K)).
cptSub(I) :- cpt(J), K is J - I, $globalset(cpt(K)).
cptMul(I) :-  cpt(J), K is J * I, $globalset(cpt(K)).
cptDiv(I) :- cpt(J), K is J // I, $globalset(cpt(K)).
cptNeg :- cpt(I), J is -I, $globalset(cpt(J)).

/*``macro``Mon Mar 18 17:25:35 MET 1996``*/
/* counter 2 */

cpt2Rst :- $globalset(cpt2(0)).
cpt2Put(I) :- $globalset(cpt2(I)).
cpt2Get(I) :- cpt2(I).
cpt2Inc :- cpt2(I), J is I + 1, $globalset(cpt2(J)).
cpt2Dec :- cpt2(I), J is I - 1, $globalset(cpt2(J)).
cpt2Add(I) :- cpt2(J), K is J + I, $globalset(cpt2(K)).
cpt2Sub(I) :- cpt2(J), K is J - I, $globalset(cpt2(K)).
cpt2Mul(I) :-  cpt2(J), K is J * I, $globalset(cpt2(K)).
cpt2Div(I) :- cpt2(J), K is J // I, $globalset(cpt2(K)).
cpt2Neg :- cpt2(I), J is -I, $globalset(cpt2(J)).

/*``macro``Mon Mar 18 17:25:03 MET 1996``*/
/* counter 3 */

cpt3Rst :- $globalset(cpt3(0)).
cpt3Put(I) :- $globalset(cpt3(I)).
cpt3Get(I) :- cpt3(I).
cpt3Inc :- cpt3(I), J is I + 1, $globalset(cpt3(J)).
cpt3Dec :- cpt3(I), J is I - 1, $globalset(cpt3(J)).
cpt3Add(I) :- cpt3(J), K is J + I, $globalset(cpt3(K)).
cpt3Sub(I) :- cpt3(J), K is J - I, $globalset(cpt3(K)).
cpt3Mul(I) :-  cpt3(J), K is J * I, $globalset(cpt3(K)).
cpt3Div(I) :- cpt3(J), K is J // I, $globalset(cpt3(K)).
cpt3Neg :- cpt3(I), J is -I, $globalset(cpt3(J)).
 
/*``Always first loaded``Wed Mar 17 15:01:45 MET 1999``*/
/* HOOD interface */

hoodObject(X,T,Z) :- isObject(X,T,Z), 
	X \= 'SYSTEM_DIAGRAM', X \= 'SYSTEM_CONFIGURATION', 
	X \= 'FORMAL_PARAMETERS'.

brothers(X,Y) :- hoodObject(X,_,Z),hoodObject(Y,_,Z), X \= Y.

isNotTerm(Y) :-  hoodObject(Y,_,_), isParent(Y).

isParent(Y) :- hoodObject(_,_,Y), !.

isTerm(Y) :- hoodObject(Y,_,_), not(hoodObject(_,_,Y)).

isNotEnv(X) :- isCurrentRoot(Y), hoodObject(X,_,Z),
	( Z \= 'SYSTEM_CONFIGURATION' -> true; memezTra(Y,X) ).

isNotInst(X) :- not(isInstance(X,_,_)).

hasParameter(U,X) :- return(U,'OPERATION',X,_,_,_), !.
hasParameter(U,X) :- argument(U,'OPERATION',X,_,_,_,_,_,_), !.

return(U,'OPERATION',X,_,_) :- return(U,'OPERATION',X,_,_,_).
argument(U,'OPERATION',X,_,_,_,_,_) :- argument(U,'OPERATION',X,_,_,_,_,_,_).

getRoot(X,X) :- isObject(X,_,'SYSTEM_CONFIGURATION'), !.
getRoot(X,R) :- isObject(X,_,Y), getRoot(Y,R).
 
/*``Always first loaded``Wed Mar 17 15:03:04 MET 1999``*/
/* misc */

memezTra(A,B) :- $name(A,L1), $name(B,L2), id(L1,L2).

id([],[]) :- true.
id([E|L1],[F|L2]) :- ( E =:= F ; E =:= F-32 ; E-32 =:= F ), id(L1,L2).

shortName(F1,F2) :- 
	$name(F1,L1), $reverse(L1,R1), $name(N1,R1),
	$subdelim(1,'/',N2,0,N1,_),
	$name(N2,R2), $reverse(R2,L2), $name(F2,L2).
 
