/*``changes``Thu May 17 15:37:54 MET DST 2001``*/
/* version */
/*-------------------------------------------------
	STOOD v5.0
	HOOD 4 rules checker 
	Include rules: HRM4 p93

	Copyright TNI Europe 2004-2005
	Pierre DISSAUX (pierre.dissaux@tni-world.com)
------------------------------------------------*/
/**** changes ****/
/*------------------------------------------------
HOOD020 (23.Dec.2004) in I11, allowing HRT constraints renaming
HOOD022 (11.Feb.2005) in I11, adding the case of non constrained ops !
------------------------------------------------*/
/**** include relationship rules ****/
/*-----------------------------------------------*/
 
/*``Include``Wed Mar 17 14:53:01 MET 1999``*/
/* HRM 4 rule I1: 
A PARENT is a MODULE that INCLUDEs at least one other MODULE. */

checkI :- printlf('---> rule I1 is a definition.').
 
/*``Include``Tue Jan 26 09:13:05 MET 1999``*/
/* HRM 4 rule I2: 
A CHILD is a MODULE which is INCLUDEd by a PARENT. */

checkI :- printlf('---> rule I2 is a definition.').
 
/*``Include``Thu Jan 28 18:00:16 MET 1999``*/
/* HRM 4 rule I3: 
When a PARENT is broken down into CHILDren, they shall provide 
together the same functionality. */

checkI :- printlf('---> rule I3 is a definition.').
 
/*``Include``Thu Jan 28 18:04:48 MET 1999``*/
/* HRM 4 rule I4: 
A CHILD shall not have more than one PARENT. */

errI4(X,P) :- hoodObject(X,_,Q), P \= Q, !.

checkI :- hoodObject(X,_,P), errI4(X,P), 
	write('ERROR : Child Module : '), write(X), 
	write(' should not have more than one Parent ! (I4) '), nl.
checkI :- printlf('---> rule I4 checked...').
 
/*``Include``Thu Feb 11 09:54:59 MET 1999``*/
/* HRM 4 rule I5: 
A Module shall not INCLUDE itself. */

errI5(X) :- hoodObject(X,_,X).

checkI :- errI5(X),
	write('ERROR : Module : '), write(X),
	write(' should not Include itself ! (I5)'), nl.
checkI :- printlf('---> rule I5 checked...').
 
/*``Include``Thu Feb 11 10:00:22 MET 1999``*/
/* HRM 4 rule I6: 
Each OPERATION provided by a PARENT shall be IMPLEMENTED_BY one 
OPERATION provided by one of its CHILDren. */

errI6(X,U) :- isProvided(U,'OPERATION',X),
	not(isImplementedBy(U,'OPERATION',X,_,_)).

checkI :- isNotTerm(X), errI6(X,U), 
	write('ERROR : Operation : '), write(U),
	write(' provided by not terminal object : '), write(X),
	write(' should be implemented by a child object ! (I6)'), nl.
checkI :- printlf('---> rule I6 checked...').
 
/*``Include``Thu Feb 11 10:50:29 MET 1999``*/
/* HRM 4 rule I7: 
Each TYPE provided by a PARENT shall be IMPLEMENTED_BY one 
TYPE provided by one of its CHILDren. */

errI7(X,U) :- isProvided(U,'TYPE',X),
	not(isImplementedBy(U,'TYPE',X,_,_)).

checkI :- isNotTerm(X), errI7(X,U), 
	write('ERROR : Type : '), write(U),
	write(' provided by not terminal object : '), write(X),
	write(' should be implemented by a child object ! (I7)'), nl.
checkI :- printlf('---> rule I7 checked...').
 
/*``Include``Thu Dec  7 16:49:40 MET 2000``*/
/* HRM 4 rule I8: 
Each CONSTANT provided by a PARENT shall be IMPLEMENTED_BY one 
CONSTANT provided by one of its CHILDren. */

/* Implementation note:
last modified:  07 December 2000 */

errI8(X,U) :- isProvided(U,'CONSTANT',X),
	not(isImplementedBy(U,'CONSTANT',X,_,_)).

checkI :- isNotTerm(X), errI8(X,U), 
	write('ERROR : Constant : '), write(U),
	write(' provided by not terminal object : '), write(X),
	write(' should be implemented by a child object ! (I8)'), nl.
checkI :- printlf('---> rule I8 checked...').
 
/*``Include``Thu Feb 11 10:53:44 MET 1999``*/
/* HRM 4 rule I9: 
Each EXCEPTION provided by a PARENT shall be IMPLEMENTED_BY one 
EXCEPTION provided by one of its CHILDren. */

errI9(X,U) :- isProvided(U,'EXCEPTION',X),
	not(isImplementedBy(U,'EXCEPTION',X,_,_)).

checkI :- isNotTerm(X), errI9(X,U), 
	write('ERROR : Exception : '), write(U),
	write(' provided by not terminal object : '), write(X),
	write(' should be implemented by a child object ! (I9)'), nl.
checkI :- printlf('---> rule I9 checked...').
 
/*``Include``Thu Feb 11 11:06:56 MET 1999``*/
/* HRM 4 rule I10: 
Each non constrained OPERATION provided by a PARENT shall be 
IMPLEMENTED_BY a non constrained OPERATION of a CHILD or by 
an OP_CONTROL. */

errI10(X,U) :- isImplementedBy(U,'OPERATION',X,V,Y),
	not(isConstrained(U,'OPERATION',X,_,_)),
	isConstrained(V,'OPERATION',Y,_,_), not(hoodObject(Y,'OP_CONTROL',X)).

checkI :- isNotTerm(X), errI10(X,U), 
	write('WARNING : Non constrained Operation : '), write(U),
	write(' provided by not terminal object : '), write(X),
	write(' should be implemented by a non constrained Operation or an Op_Control ! (I10)'), nl.
checkI :- printlf('---> rule I10 checked...').
 
/*``Include``Tue Mar 16 10:14:42 MET 1999``*/
/* HRM 4 rule I11: 
Each constrained OPERATION provided by a PARENT shall be 
IMPLEMENTED_BY an OPERATION of a CHILD with the same constraint or by 
an OP_CONTROL.
last modified 11 Feb 2005*/

ruleI11(U,X,V,Y) :- not(isConstrained(U,'OPERATION',X,_,_)), not(isConstrained(V,'OPERATION',Y,_,_)).
ruleI11(U,X,V,Y) :- isConstrained(U,'OPERATION',X,A,B), isConstrained(V,'OPERATION',Y,A,B).
ruleI11(U,X,V,Y) :- isConstrained(U,'OPERATION',X,'ASER',B), isConstrained(V,'OPERATION',Y,'ASATC',B).
ruleI11(U,X,V,Y) :- isConstrained(U,'OPERATION',X,'ASER',B), isConstrained(V,'OPERATION',Y,'PSER',B).
ruleI11(U,X,V,Y) :- isConstrained(U,'OPERATION',X,'ASER',B), isConstrained(V,'OPERATION',Y,'PAER',B).
ruleI11(U,X,V,Y) :- isConstrained(U,'OPERATION',X,'LSER',B), isConstrained(V,'OPERATION',Y,'PSER',B).
ruleI11(U,X,V,Y) :- isConstrained(U,'OPERATION',X,'LSER',B), isConstrained(V,'OPERATION',Y,'LSATC',B).
ruleI11(U,X,V,Y) :- isConstrained(U,'OPERATION',X,'HSER',B), isConstrained(V,'OPERATION',Y,'PSER',B).
ruleI11(U,X,V,Y) :- isConstrained(U,'OPERATION',X,'HSER',B), isConstrained(V,'OPERATION',Y,'HSATC',B).
ruleI11(U,X,V,Y) :- hoodObject(Y,'OP_CONTROL',X).

checkI :- isNotTerm(X), isImplementedBy(U,'OPERATION',X,V,Y), not(ruleI11(U,X,V,Y)), 
	write('WARNING : Implemented_By link for Operation : '), write(U),
	write(' provided by not terminal object : '), write(X),
	write(' does not propagate correctly its constraints ! (I11)'), nl.
checkI :- printlf('---> rule I11 checked...').
 
/*``Include``Tue Mar 16 10:15:29 MET 1999``*/
/* HRM 4 rule I12: 
Each OPERATION_SET provided by a PARENT shall be IMPLEMENTED_BY 
an OPERATION_SET provided by one of its CHILDren. */

errI12(X,U) :- isProvided(U,'OPERATION_SET',X),
	not(isImplementedBy(U,'OPERATION_SET',X,_,_)).

checkI :- isNotTerm(X), errI12(X,U), 
	write('WARNING : Operation_Set : '), write(U),
	write(' provided by not terminal object : '), write(X),
	write(' should be implemented by a child object ! (I12)'), nl.
checkI :- printlf('---> rule I12 checked...').
 
/*``Include``Thu Feb 11 14:48:43 MET 1999``*/
/* HRM 4 rule I13: 
The OBCS of a PARENT shall be IMPLEMENTED_BY one or more OBCS
of its CHILDren.*/

/* Implementation note:
In STOOD v4, I13 is true if I11 is also true. */

checkI :- printlf('---> rule I13 is implicit.').
 
/*``Include``Thu Jul 29 17:01:24 MET DST 1999``*/
/* HRM 4 rule I14: 
A CLASS shall be TERMINAL. */

/* Implementation note:
last modified: 29 Jul 1999*/

checkI :- printlf('---> rule I14 is a definition.').
 
/*``Include``Thu Feb 11 14:49:24 MET 1999``*/
/* HRM 4 rule I15: 
A VIRTUAL_NODE shall only include other VIRTUAL_NODEs. */

errI15(X) :- hoodObject(Y,K,X), K\='VIRTUAL_NODE', !.

checkI :- hoodObject(X,'VIRTUAL_NODE',_), errI15(X), 
	write('ERROR : Virtual_Node : '), write(X),
	write(' should only include other Virtual_Nodes ! (I15)'), nl.
checkI :- printlf('---> rule I15 checked...').
 
