/*``changes``Thu May 17 15:37:22 MET DST 2001``*/
/* version */
/*-------------------------------------------------
	STOOD v4
	HOOD 4 rules checker 
	Provided_Interface rules: HRM4 p95-96

	Copyright TNI 1999
	Pierre DISSAUX (pierre.dissaux@tni.fr)
	17.Mar.99
------------------------------------------------*/
/**** changes ****/
/*------------------------------------------------

------------------------------------------------*/
/**** provided interface rules ****/
/*-----------------------------------------------*/
 
/*``Provided``Wed Mar 17 14:54:36 MET 1999``*/
/* HRM 4 rule P1:
A CLASS shall provide a TYPE with an INHERITANCE ODS field list 
(possibly empty) of its superclasses. This TYPE is called the 
CLASS main TYPE. The main TYPE of a CLASS may have 
the same name as the CLASS or may be named "Instance". */

/* Implementation note:
In STOOD v4, there is no way to define a CLASS without 
defining its main TYPE. "class" toggle for a MODULE is 
directly handled by its main TYPE.*/

checkP :- printlf('---> rule P1 is implicit.').
 
/*``Provided``Thu Feb 25 11:32:03 MET 1999``*/
/* HRM 4 rule P2:
A TYPE provided by a MODULE may be described by an ATTRIBUTES 
internal ODS field containing the list of its data structure elements. */

/* Implementation note:
In STOOD v4 default configuration, 
ATTRIBUTES field of provided TYPES 
is located into provided part of the ODS.*/

checkP :- printlf('---> rule P2 not implemented.').
 
/*``Provided``Wed Mar 17 16:18:04 MET 1999``*/
/* HRM 4 rule P3:
If a CLASS is ABSTRACT, then its main TYPE cannot be instanciated. */

errP3(X,T,Y,I) :-
	requires(I,'CONSTANT',Y,T,'TYPE',X,_);
	requires(I,'DATA',Y,T,'TYPE',X,_);
	attributes(_,Y,I,T,X,_).

checkP :- isAbstract(T,'TYPE',X), errP3(X,T,Y,I), 
	write('ERROR : constant or variable : '), write(I), 
	write(' of Module : '), write(Y), 
	write(' is an instance of abstract Type : '), write(T), 
	write(' of Module : '), write(X), 
	write(' ! (P3)'), nl.
checkP :- printlf('---> rule P3 checked...').
 
/*``Provided``Thu Feb 25 12:17:04 MET 1999``*/
/* HRM 4 rule P4:
The provided interface of a TERMINAL VIRTUAL_NODE 
shall have as many "Message_in" OPERATIONs as communication 
protocols with remote client VIRTUAL_NODEs. */

checkP :- printlf('---> rule P4 not implemented.').
 
