/*``changes``Thu May 17 15:37:03 MET DST 2001``*/
/* version */
/*-------------------------------------------------
	STOOD v4
	HOOD 4 rules checker 
	States & Transitions additional rules (not defined in HRM4)

	Copyright TNI 1999-2000
	Pierre DISSAUX (pierre.dissaux@tni.fr)
	11.Jan.2000
	08.Dec.2000: S3 (created)
------------------------------------------------*/
/**** changes ****/
/*------------------------------------------------

------------------------------------------------*/
/**** states & transitions rules ****/
/*-----------------------------------------------*/
 
/*``Std``Tue Jan 11 18:15:12 MET 2000``*/
/* STOOD 4.1 rule S1:
if several Transitions leave a same State and are triggered by
the same Operation, then a Condition is required. */

errS1(X,T1,S,O) :- isTransition(X,T2,S,_,O), T2\=T1, 
	not(file(T1,'TRANSITION',X,_,'Condition')).

checkS :- isTransition(X,T,S,_,O), errS1(X,T,S,O), 
	write('ERROR : a condition should be defined for Transition: '), write(T), 
	write(' of Module : '), write(X), 
	write(' ! (S1)'), nl.
checkS :- printlf('---> additional rule S1 checked...').
 
/*``Std``Fri Dec  8 18:04:45 MET 2000``*/
/* STOOD 4.1 rule S2:
if a State has no entering Transition, it should be an initial State. */

errS2(X,S,K) :- K =:= 0, not(isTransition(X,_,_,S,_)).

checkS :- isState(X,S,K), errS2(X,S,K), 
	write('ERROR : State: '), write(S), 
	write(' of Module: '), write(X), 
	write(' should be an initial State. ! (S2)'), nl.
checkS :- printlf('---> additional rule S2 checked...').
 
/* STOOD 4.1 rule S3:
if a State Transition model has been defined, all contrained operations
(except ASER), should trigger at least one Transition. */

/* implementation note: created 08 Dec 2000 */

errS3(X,O) :- not(isTransition(X,_,_,_,O)).

checkS :- hasStd(X), isConstrained(O,'OPERATION',X,C,_), 
	( C='HSER'; C='LSER'; C='RWER'; C='ROER' ), errS3(X,O), 
	write('WARNING : Constrained Operation: '), write(O), 
	write(' of Module: '), write(X), 
	write(' should trigger at least one Transition. ! (S3)'), nl.
checkS :- printlf('---> additional rule S3 checked...').

hasStd(X) :- isState(X,_,_), !. 
