/* coverage */
/* (cf. RASTO/00.004) 07 December 2000 */
/* (cf. RASTO/03.015) 14 February 2003 */

coverage :- nl, write('REQUIREMENTS COVERAGE ANALYSIS'), nl, 
	nl, write('1- List of requirements covered by no entity:'), 
	( ( isRequirement(S,_), not( coversRequirement(S,_,_,_) ) ) -> nl; ( tab, write('NONE'), nl ) ),
	isRequirement(R,_), not( coversRequirement(R,_,_,_) ), tab, write(R), nl.
coverage :- nl, write('2- List of derived requirements:'),  
	( isRequirement(_,'D') -> nl; ( tab, write('NONE'), nl ) ), 
	isRequirement(R,'D'), tab, write(R), nl.
coverage :- nl, write('3- List of unknown requirements:'),
	( isRequirement(_,'?') -> nl; ( tab, write('NONE'), nl ) ), 
	isRequirement(R,'?'), tab, write(R), nl.
coverage :- nl, write('4- List of entities covering no requirements:'), nl, 
	hoodObject(X,_,_), isTerm(X), not(env(X)), 
	( not( coversRequirement(_,_,X,_) ) -> ( tab, write('Module: '), write(X), nl );
	( entity(U,E,X), convert(E,_,T,W), not( coversRequirement(_,W,X,U) ), writeEntity(U,T,X) ) ).
	
entity(U,E,X) :- isProvided(U,E,X); isInternal(U,E,X).
entity(U,'STATE',X) :- isState(X,U,_).
entity(U,'TRANSITION',X) :- isTransition(X,U,_,_,_).

writeEntity(U,T,X) :- tab, write(T), sp, write(X), dot, write(U), nl.
 