/*-------------------------------
   Stood 5.0

   Requirements checker
   Operations Coverage Matrix

   Copyright TNI Europe
   Pierre Dissaux
   14 September 2004 
---------------------------------
modifications:
- initial version: 14 September 2004
---------------------------------*/

ocm :- nl, write('REQUIREMENTS-OPERATIONS MATRIX'), nl, nl, 
	writeLine(79,45), nl, 
	sep, writeName('Requirement',23), sep, writeName('Operation',23), 
	sep, writeName('Object',23), sep, nl, 
	writeLine(79,45), nl, 
	isRequirement(R,_), 
	( coversRequirement(R,_,_,_) -> 
		( coversRequirement(R,W,X,U), convert('OPERATION',_,_,W), 
		  sep, writeName(R,23), sep, writeName(U,23), 
		  sep, writeName(X,23), sep, nl ); 
		( sep, writeName(R,23), sep, writeName('NONE',23), 
		  sep, writeName('NONE',23), sep, nl) 
	), fail.
ocm :- writeLine(79,45), nl, fail.
	
ocm :- nl, write('OPERATIONS-REQUIREMENTS MATRIX'), nl, nl, 
	writeLine(79,45), nl, 
	sep, writeName('Object',23), sep, writeName('Operation',23), 
	sep, writeName('Requirement',23), sep, nl, 
	writeLine(79,45), nl, 
	hoodObject(X,_,_), not(env(X)), 
	entity(U,'OPERATION',X), 
	( coversRequirement(_,W,X,U) -> 
		( coversRequirement(R,W,X,U), convert('OPERATION',_,_,W), 
		  sep, writeName(X,23), sep, writeName(U,23), 
		  sep, writeName(R,23), sep, nl); 
		( sep, writeName(X,23), sep, writeName(U,23), 
		  sep, writeName('NONE',23), sep, nl )
	), fail.
ocm :- writeLine(79,45), nl.
	
entity(U,E,X) :- isProvided(U,E,X); isInternal(U,E,X).
entity(U,'STATE',X) :- isState(X,U,_).
entity(U,'TRANSITION',X) :- isTransition(X,U,_,_,_).
entity('NIL','NIL',X).

/*--------------------------------------------------
utilities
--------------------------------------------------*/

writeLine(M,C) :- fillIn(0,M,C).

fillIn(L,M,C) :- L >= M, !.
fillIn(L,M,C) :- $put(C), K is L+1, fillIn(K,M,C).

sp :- $put(32).
sep :- $put(124).

writeTrunc(X,M) :- $name(X,[C|L]), trunc(C,L,1,M).

trunc(C,[],_,_) :- $put(C),!.
trunc(C,L,P,M) :- P > M, !.
trunc(C,[D|L],P,M) :- $put(C), Q is P+1, trunc(D,L,Q,M).

writeName(X,M) :- $conlength(X,L), sp, writeTrunc(X,M), ( L > M -> sp; fillIn(L,M+1,32) ).
