/* output file */
/* (cf. RASTO/03.015) 14 February 2003 */

output :- ( isCurrentRoot(X); ( hoodObject(X,_,P), P \= 'SYSTEM_CONFIGURATION' ) ), 
	writeModule(X).

writeModule(X) :- write('Module '), write(X), nl, 
	( description(X,_,_) -> writeDescription(X); true ),
	( isProvided(_,_,X) -> writeProvided(X); true ), 
	( isInternal(_,_,X) -> writeInternals(X); true ).

writeDescription(X) :- indent, write('Description'), sp, write(X), nl, 
	description(X,_,W), insertReqs(X,W), fail.
writeDescription(X).

writeProvided(X) :- indent, write('Provided_Interface'), nl,
	isProvided(U,E,X), convert(E,_,F,_), indent, indent, write(F), sp, write(U), 
	sp, write(X), nl, insertReqs(U,E,X), fail.
writeProvided(X).

writeInternals(X) :- indent, write('Internals'), nl,
	isInternal(U,E,X), convert(E,_,F,_), indent, indent, write(F), sp, write(U), 
	sp, write(X), nl, insertReqs(U,E,X), fail.
writeInternals(X) :- writeObcs(X).

writeObcs(X) :- indent, indent, write('OBCS'), sp, write(X), nl,
	obcsSection(X,W), insertReqs(X,W), fail.
writeObcs(X).

obcsSection(X,W) :- file(_,_,X,_,W), ( W='StateTxt'; W='TransTxt'; W='ObcsTxt'; W='ObcsBodyTxt' ).

insertReqs(U,E,X) :- covers(R,W,X,U,E), isNotCode(W), 
	indent, indent, indent, write('Covers'), 
	sp, write(R), sp, write('"'), writeSection(W), write('"'), nl, fail.
insertReqs(U,E,X) :- derivedRequirement(R,W,X,U), isNotCode(W), 
	indent, indent, indent, write('Requirement'), 
	sp, write(R), sp, write('"'), writeSection(W), write('"'), nl, fail.
/*
insertReqs(U,'OPERATION',X) :- isTerm(X), 
	indent, indent, indent, write('Requirement CODE-'), write(X), dot, write(U), nl,
	indent, indent, indent, write('Requirement TEST-'), write(X), dot, write(U), nl, fail.
*/
insertReqs(U,E,X).

insertReqs(X,W) :- coversRequirement(R,W,X,'NIL'), 
	indent, indent, write('Covers'), 
	sp, write(R), sp, write('"'), writeSection(W), write('"'), nl, fail.
insertReqs(X,W) :- derivedRequirement(R,W,X,'NIL'), 
	indent, indent, write('Requirement'), 
	sp, write(R), sp, write('"'), writeSection(W), write('"'), nl, fail.
insertReqs(X,W).

isNotCode(W) :- $name(W,L), not($member2(58,L)).

covers(R,W,X,U,E) :- coversRequirement(R,W,X,U).
covers(R,W,X,U,E) :- U \= 'NIL', coversDown(R,W,X,U,E).
covers(R,W,X,U,E) :- U \= 'NIL', coversUp(R,W,X,U,E).

coversDown(R,W,X,U,E) :- isImplementedBy(U,E,X,V,Y,1), coversRequirement(R,W,Y,V).
coversDown(R,W,X,U,E) :- isImplementedBy(U,E,X,V,Y,1), coversDown(R,W,Y,V,E).

coversUp(R,W,X,U,E) :- isImplementedBy(V,E,Y,U,X,1), coversRequirement(R,W,Y,V).
coversUp(R,W,X,U,E) :- isImplementedBy(V,E,Y,U,X,1), coversUp(R,W,Y,V,E).

 