/*-------------------------------
   Stood 5.0

   Requirements checker
   Tabulated Matrix

   Copyright TNI Europe
   Pierre Dissaux
   23 September 2004 
---------------------------------
modifications:
- initial version: 05 August 2004
- REQ001: (13.09.04) multiple coverage not recognized (cf.RASTO/04.018)
- REQ002: (23.09.04) removing word 'OTHERS'
---------------------------------*/

tmx :- nl, write('REQUIREMENTS-ENTITIES MATRIX'), nl, nl, 
	writeLine(79,45), nl, 
	sep, writeName('Requirement',23), sep, writeName('Operation',23), 
	sep, writeName('Object',23), sep, nl, 
	writeLine(79,45), nl, 
	isRequirement(R,_), 
	( coversRequirement(R,_,_,_) -> /*REQ001*/
		writeReqLines(R); 
		writeNoneLine(R) 
	), fail.
tmx :- writeLine(79,45), nl, fail.
	
writeReqLines(R) :- coversRequirement(R,W,X,U), /*REQ001*/
	sep, writeName(R,23), sep, 
	( convert('OPERATION',_,_,W) -> 
		( writeName(U,23), sep, writeName(X,23), sep, nl );
		( writeName('',23), sep, writeName(X,23), sep, nl) ). /*REQ002*/
	
writeNoneLine(R) :- sep, writeName(R,23), sep, /*REQ001*/
	writeName('NONE',23), sep, writeName('NONE',23), sep, nl.

tmx :- nl, write('ENTITIES-REQUIREMENTS MATRIX'), nl, nl, 
	writeLine(79,45), nl, 
	sep, writeName('Object',23), sep, writeName('Operation',23), 
	sep, writeName('Requirement',23), sep, nl, 
	writeLine(79,45), nl, 
	hoodObject(X,_,_), not(env(X)), entity(U,'OPERATION',X), writeOpLines(U,X), fail.
tmx :- writeLine(79,45), nl.
	
writeOpLines(U,X) :- coversRequirement(_,W,X,U) -> /*REQ001*/
	writeRequirements(U,X); 
	writeNoRequirement(U,X).
	
writeNoRequirement(U,X) :- U \= 'NIL', /*REQ001*/
	sep, writeName(X,23), sep, writeName(U,23), sep, writeName('NONE',23), sep, nl.
	
writeRequirements(U,X) :- coversRequirement(R,W,X,U), /*REQ001*/
	( convert('OPERATION',_,_,W) -> 
		( sep, writeName(X,23), sep, writeName(U,23), sep, writeName(R,23), sep, nl );
		( sep, writeName(X,23), sep, writeName('',23), sep, writeName(R,23), sep, nl ) ). /*REQ002*/

entity(U,E,X) :- isProvided(U,E,X); isInternal(U,E,X).
entity(U,'STATE',X) :- isState(X,U,_).
entity(U,'TRANSITION',X) :- isTransition(X,U,_,_,_).
entity('NIL','NIL',X).
entity('NIL','OPERATION',X). /*REQ001*/

/*--------------------------------------------------
utilities
--------------------------------------------------*/

writeLine(M,C) :- fillIn(0,M,C).

fillIn(L,M,C) :- L >= M, !.
fillIn(L,M,C) :- $put(C), K is L+1, fillIn(K,M,C).

sp :- $put(32).
sep :- $put(124).

writeTrunc('',_) :- !. /*REQ002*/
writeTrunc(X,M) :- $name(X,[C|L]), trunc(C,L,1,M).

trunc(C,[],_,_) :- $put(C),!.
trunc(C,L,P,M) :- P > M, !.
trunc(C,[D|L],P,M) :- $put(C), Q is P+1, trunc(D,L,Q,M).

writeName(X,M) :- $conlength(X,L), sp, writeTrunc(X,M), ( L > M -> sp; fillIn(L,M+1,32) ).
