/*-------------------------------------------------
  STOOD 5.0
  Architecture Analysis & Design Language (AADL) 
  code generator

  Copyright TNI Europe & Ellidiss Technologies 2004-2005
  Pierre DISSAUX (pierre.dissaux@tni-world.com)
  10.May.2005
--------------------------------------------------*/
/*---------------------------------------------------
AADL v0.6 generator: 07.05.03
AADL v0.994 generator: 09.07.04
AADL v1.0 generator: 24.03.05
-----------------------------------------------------
AADL001 (10.May.05) fixing bugs for Op_Controls
AADL002 (10.May.05) component unicity within each package
-----------------------------------------------------*/

/*------*/
/* main */
/*------*/

go :- $init_sys, $getenv('PREDICATS',FileName), $consult(FileName), fail.
go :- genAADL, fail.
 
genAADL :- isCurrentRoot(R), openFile(R,'spec'), fail.
genAADL :- isCurrentRoot(R), category(R,'PROCESS'), 
	isSystem(S), genComponent(S,'SYSTEM'), fail.
genAADL :- isObject(X,T,Y),
  X \= 'FORMAL_PARAMETERS', Y \= 'NIL', 
  extract(X), category(X,C), C \= 'NETRA', 
  ( C = 'PACKAGE' -> genPackage(X); genComponent(X,C) ), fail.
genAADL :- closeFile.

category(X,C) :- mapping(X,C) -> true; C='SUBPROGRAM'. 

mapping(Y,C) :- 
  isObject(X,K,P), memezTra(Y,X), ( 
  ( P = 'NIL' ) -> C='SYSTEM'; 
  ( ( K='ACTIVE', P='SYSTEM_CONFIGURATION' );( if_MAIN(_), isCurrentRoot(X) ) ) -> C='PROCESS';
  ( ( K='PASSIVE', P='SYSTEM_CONFIGURATION' ); K='ENVIRONMENT' ) -> 
  	( if_SHARED_DATA(X) -> C='DATA'; C='PACKAGE' );
  ( K='ACTIVE', isParentThread(X) ) -> C='THREAD GROUP'; 
  ( ( K='ACTIVE', isTermThread(X) ); K='CYCLIC'; K='SPORADIC' ) -> C='THREAD'; 
  ( ( K='PASSIVE'; K='PROTECTED' ), isTerm(X), if_SHARED_DATA(X) ) -> C='DATA';
  ( ( K='PASSIVE'; K='PROTECTED' ), isTerm(X), if_PACKAGE(X,P) ) -> C='PACKAGE';
  ( ( K='PASSIVE'; K='PROTECTED' ), isTerm(X), if_NOT_PACKAGE ) -> C='NETRA';
  ( ( K='PASSIVE'; K='PROTECTED'), isParent(X) ) -> C='PACKAGE';
  ( K='OP_CONTROL' ) -> C='SUBPROGRAM' ).

isParentThread(X) :- isObject(Y,_,X), category(Y,C), C \= 'PACKAGE', C \= 'DATA', 
	C \= 'SUBPROGRAM'. /*(cf.AADL001)*/
isTermThread(X) :- isTerm(X); /*(cf.AADL001)*/
	( isObject(Y,_,X), category(Y,C), ( C = 'PACKAGE'; C = 'DATA'; C = 'SUBPROGRAM' ) ).

/*----------*/
/* PACKAGES */
/*----------*/

genPackage(X) :- if_EXPANDED(X), openFile(X,'spec').
genPackage(X) :-  
  insertComment(X,0,'spec'), insertComment(X,0,'body'), 
  write('PACKAGE '), parentPackage(X), writeId(X), nl, 
  write('PUBLIC'), nl, nl, ( packagePubDecl(X,_,_,_) ->   
  ( packagePubDecl(X,Y,C,P), genComponent(Y,C,1,P) ); genComponent('void','DATA',1,'') ).
genPackage(X) :- 
  packagePriDecl(X,_,_,_) -> write('PRIVATE'), nl, nl, 
  packagePriDecl(X,Y,C,P), genComponent(Y,C,1,P).
genPackage(X) :- write('END '), parentPackage(X), writeId(X), sc, nl, nl.
genPackage(X) :- if_EXPANDED(X), closeFile.

packagePubDecl(X,U,'DATA',X) :- isProvided(U,'TYPE',X), not(isImplementedBy(U,'TYPE',X,_,_,_)). 
packagePubDecl(X,U,'SUBPROGRAM',X) :- isProvided(U,'OPERATION',X), not(isImplementedBy(U,'OPERATION',X,_,_,_)). 
packagePubDecl(X,Y,C,'') :- isObject(Y,_,X), isTerm(Y), category(Y,C), C \= 'PACKAGE', C \= 'DATA', C \= 'NETRA'. 
packagePubDecl(X,U,'DATA',Y) :- isObject(Y,_,X), isTerm(Y), if_NOT_PACKAGE, isProvided(U,'TYPE',Y). 
packagePubDecl(X,U,'SUBPROGRAM',Y) :- isObject(Y,_,X), isTerm(Y), if_NOT_PACKAGE, isProvided(U,'OPERATION',Y), 
	is_DATA_SP(Y,U). 

packagePriDecl(X,U,'DATA',X) :- isInternal(U,'TYPE',X). 

parentPackage(X) :- isObject(X,_,Z), Z\='NIL', Z\='SYSTEM_CONFIGURATION', category(Z,'PACKAGE'), 
	parentPackage(Z), writeId(Z), dc, fail.
parentPackage(X).


/*------------*/
/* COMPONENTS */
/*------------*/

genComponent(X,C) :- if_IN_PACKAGE(X,C), !.
genComponent(X,C) :- if_EXPANDED(X), openFile(X,'spec').
genComponent(X,C) :- ( isProvided(X,'OPERATION',P), isOpControl(P,X) ) -> 
	genComponent(X,C,0,P); genComponent(X,C,0,'').
genComponent(X,C) :- ancillaryComponents(X,C,Y,K), genComponent(Y,K,0,X).
genComponent(X,C) :- if_EXPANDED(X), closeFile.

genComponent(X,C,I,P) :- notDone(X,P), genComponentType(X,C,I,P), fail. /*(cf.AADL002)*/
genComponent(X,C,I,P) :- is_IMPNAME(X,C,B,P), notDone(X,B,P), opt_IMPLEMENTATION(X,C,I,P), fail. /*(cf.AADL002)*/
genComponent(X,C,I,P).

ancillaryComponents(X,'PACKAGE',Y,'DATA') :- isProvided(Y,'TYPE',X), 
	not(isImplementedBy(Y,'TYPE',X,_,_,_)). 
ancillaryComponents(X,C,Y,'SUBPROGRAM') :- isProvided(Y,'OPERATION',X), 
	not(isOpControl(X,Y)), 
	( is_SERVER_SP(X,Y); is_DATA_SP(X,Y) ), not(isImplementedBy(Y,'OPERATION',X,_,_,_)).

/*----------------*/
/* Component Type */
/*----------------*/

genComponentType(X,C,I,P) :-  
  insertComment(X,I,'spec'),  
  insertComment(P,I,X,'OpBodyTxt'), 
  insertComment(P,I,X,'TypeTxt'), 
  indent(I), write(C), sp, writeCompName(C,X), 
  opt_EXTENSION(X,C), nl, 
  opt_FEATURES(X,C,I,P), 
  opt_FLOWSPEC(X,I), 
  opt_TYPPROPERTIES(X,C,I,P), 
  opt_TYPANNEX(X,C,I), 
  indent(I), write('END '), writeCompName(C,X), sc, nl, nl.
  
opt_EXTENSION(X,C) :- has_EXTENSION(X,C,P,Y) -> genExtension(X,P,Y); true. 
has_EXTENSION(X,'DATA',P,Y) :- inherits(X,A,Y,B), ( A=B -> P=''; P=B ). 

genExtension(X,P,Y) :- write(' EXTENDS '), writeType(X,P,Y). 

/*--------------------------*/
/* Component Implementation */
/*--------------------------*/

opt_IMPLEMENTATION(X,C,I,P) :- has_IMPLEMENTATION(X,C,B,P) -> genComponentImp(X,C,B,I,P); true.
has_IMPLEMENTATION(X,C,B,P) :- is_IMPNAME(X,C,B,P), ( B \= 'others';  
	has_SUBCOMPONENTS(X,C,P); has_CALLS(X); has_CONNECTIONS(X,C); 
	has_FLOWIMP(X); has_MODES(X); has_IMPANNEX(X,C,_) ).

genComponentImp(X,C,B,I,P) :- 
  insertComment(X,I,'body'), 
  indent(I), write(C), write(' IMPLEMENTATION '), writeCompName(C,X), dot, writeId(B), nl,
  opt_SUBCOMPONENTS(X,C,I,P), 
  opt_CALLS(X,I), 
  opt_CONNECTIONS(X,C,I), 
  opt_FLOWIMP(X,I), 
  opt_MODES(X,I), 
  opt_IMPPROPERTIES(X,C,I,P), 
  opt_IMPANNEX(X,C,I,P), 
  indent(I), write('END '), writeCompName(C,X), dot, writeId(B), sc, nl, nl.
 
 
/*---------------*/
/* SUBCOMPONENTS */
/*---------------*/

opt_SUBCOMPONENTS(X,C,I,P) :- has_SUBCOMPONENTS(X,C,P) -> genSubComponents(X,I+1,P); true. 
has_SUBCOMPONENTS(X,C,P) :- 
	isSystem(X); 
	( C='DATA' -> attributes(X,P,_,_,_,_); 
	( isObject(Y,_,X), category(Y,K), 
	  K \= 'PACKAGE', K \= 'SUBPROGRAM', K \= 'NETRA', 
  	  ( K = 'DATA' -> if_SHARED_DATA(Y); true) ) ). /*(cf.AADL001)*/

genSubComponents(X,I,P) :- indent(I-1), write('SUBCOMPONENTS'), nl, fail.
genSubComponents(X,I,P) :- isSystem(X), if_OS(S), 
  indent(I), writeId(S), write(' : SYSTEM OS.'), writeId(S), sc, nl, fail.
genSubComponents(X,I,P) :- isSystem(X), 
  isObject(R,_,'SYSTEM_CONFIGURATION'), category(R,C), C \= 'PACKAGE',  
  indent(I), writeId(R), write(' : '), write(C), sp, writeId(R), 
  ( ( has_IMPLEMENTATION(R,C,B,_), B \= 'others' ) -> ( dot, write(B) ); true), sc, nl, fail.
genSubComponents(X,I,P) :- isObject(Y,_,X), category(Y,C), 
  C \= 'PACKAGE', C \= 'SUBPROGRAM', C \= 'NETRA', 
  ( C = 'DATA' -> if_SHARED_DATA(Y); true), 
  indent(I), writeId(Y), write(' : '), write(C), sp, insertCompTypeName(Y,C), sc, nl, fail. /*(cf.AADL002)*/
genSubComponents(X,I,P) :- attributes(X,P,A,T,M,_), 
  indent(I), writeId(A), write(' : '), write('DATA'), sp, writeType(X,M,T), sc, nl, fail. 
genSubComponents(X,I,P).

insertCompTypeName(X,C) :- is_TYPNAME(X,N), 
	( ( X = N, fullCompType(X,C,P,T) ) -> writeType(X,P,T); ( writeId(N), /*(cf.AADL002)*/
		( ( has_IMPLEMENTATION(Y,C,B,_), B \= 'others' ) -> ( dot, write(B) ); true) ) ).	

/*----------*/
/* FEATURES */
/*----------*/

opt_FEATURES(X,C,I,P) :- has_FEATURES(X,C,P) -> genFeatures(X,C,I+1,P); true.
has_FEATURES(X,_,_) :- isSystem(X), if_MAIN(_).
has_FEATURES(X,_,'') :- isProvided(O,'OPERATION',X), not(isOpControl(X,O)). 
has_FEATURES(X,_,P) :- isProvided(X,'TYPE',P), isProvided(O,'OPERATION',P), 
	hasParamofType(P,O,X), is_DATA_SP(P,O). 
has_FEATURES(X,C,_) :- C \= 'DATA', isProvided(_,'EXCEPTION',X).	
has_FEATURES(X,_,_) :- isProvided(D,K,X), ( K='DATA'; K='CONSTANT' ), has_PORT(X).
has_FEATURES(X,_,P) :- is_PARAMETER(P,X,_,_,_,_). 
has_FEATURES(X,_,P) :- raisedException(X,'OPERATION',P,_).
has_FEATURES(X,_,_) :- not(isSystem(X)), is_IT(Y,_,V), child(Y,X).

has_FEATURES(X,_,_) :- childRequires(_,_,'OPERATION',X,O,'OPERATION',Y,W), 
	W \= 'OpImpBy', isVisibleFrom(X,Y), is_EVENT(Y,O).
has_FEATURES(X,_,_) :- childRequires(_,_,_,X,C,'CONSTANT',Y,W), 
	W \= 'CoImpBy', isVisibleFrom(X,Y).
has_FEATURES(X,_,_) :- childRequires(_,_,_,X,D,'DATA',Y,W), 
	W \= 'DaImpBy', isVisibleFrom(X,Y).
has_FEATURES(X,_,_) :- childRequires(_,_,'OPERATION',X,O,'EXCEPTION',Y,W), 
	isVisibleFrom(X,Y), is_EVENT(Y,O).
has_FEATURES(X,C,_) :- C \= 'DATA', 
	isObject(Y,_,_), is_ACCESS(X,Y), 
	category(Y,'DATA'), isVisibleFrom(X,Y). 

genFeatures(X,_,I,_) :- indent(I-1), write('FEATURES'), nl, fail.

/*--------------------*/
/* Provided_Interface */
/*--------------------*/

genFeatures(X,_,I,_) :- isSystem(X), if_MAIN(_), genEvent(X,I,'start','IN'), fail.
genFeatures(X,_,I,'') :- isProvided(O,'OPERATION',X), not(isOpControl(X,O)), is_SERVER_SP(X,O), genSubprogram(X,I,O,'SERVER '), fail.
genFeatures(X,_,I,'') :- isProvided(O,'OPERATION',X), not(isOpControl(X,O)), is_DATA_SP(X,O), genSubprogram(X,I,O,''), fail.
genFeatures(X,_,I,'') :- isProvided(O,'OPERATION',X), not(isOpControl(X,O)), is_EVENT(X,O), genEvent(X,I,O,'IN'), fail.
genFeatures(X,_,I,'') :- isProvided(O,'OPERATION',X), is_PORT_OP(X,O,M,A,P,T), genDataPort(X,I,O,M,A,P,T), fail. 
genFeatures(X,_,I,P) :- isProvided(X,'TYPE',P), isProvided(O,'OPERATION',P), 
	hasParamofType(P,O,X), is_DATA_SP(P,O), genSubprogram(X,I,O,''), fail. 
genFeatures(X,C,I,_) :- C \= 'DATA', isProvided(O,'EXCEPTION',X), genEvent(X,I,O,'OUT'), fail.
genFeatures(X,_,I,_) :- isProvided(D,'CONSTANT',X), has_PORT(X), genDataPort(X,I,D,'OUT'), fail.
genFeatures(X,_,I,_) :- isProvided(D,'DATA',X), has_PORT(X), portDir(X,D,M), genDataPort(X,I,D,M), fail.
genFeatures(X,_,I,P) :- is_PARAMETER(P,X,M,A,Y,T), genParameter(P,X,M,A,Y,T,I), fail.
genFeatures(X,_,I,P) :- raisedException(X,'OPERATION',P,E), genEvent(X,I,E,'OUT'), fail.
genFeatures(X,_,I,_) :- not(isSystem(X)), is_IT(Y,_,V), child(Y,X), genEvent(X,I,V,'IN'), fail.

/*--------------------*/
/* Required_Interface */
/*--------------------*/

genFeatures(X,_,I,_) :- childRequires(_,_,'OPERATION',X,O,'OPERATION',Y,W), W \= 'OpImpBy',
	isVisibleFrom(X,Y), is_EVENT(Y,O), genEvent(Y,I,O,'OUT'), fail.
genFeatures(X,_,I,_) :- childRequires(_,_,_,X,C,'CONSTANT',Y,W), W \= 'CoImpBy', 
	isVisibleFrom(X,Y), genDataPort(Y,I,C,'IN'), fail.
genFeatures(X,_,I,_) :- childRequires(_,_,_,X,D,'DATA',Y,W), W \= 'DaImpBy', 
	isVisibleFrom(X,Y), revPortDir(Y,E,M), genDataPort(Y,I,D,M), fail.
genFeatures(X,_,I,_) :- childRequires(_,_,'OPERATION',X,O,'EXCEPTION',Y,W), 
	isVisibleFrom(X,Y), is_EVENT(Y,O), genEvent(Y,I,O,'IN'), fail.
genFeatures(X,C,I,_) :- C \= 'DATA', 
	isObject(Y,_,_), is_ACCESS(X,Y), category(Y,'DATA'), 
	isVisibleFrom(X,Y), genDataAccess(X,I,Y), fail. 
genFeatures(X,_,I,_).

/*-------------*/
/* Subprograms */
/*-------------*/

genSubprogram(X,I,O,M) :- insertComment(X,I,O,'OpTxt'), fail. 
genSubprogram(X,I,O,M) :- indent(I), writeId(O), write(' : '), write(M), write('SUBPROGRAM '), 
	( implem2(O,'OPERATION',X,Q,Y) -> /*(cf.AADL001)*/
		( ( category(Y,'PACKAGE') -> ( writeId(Y), dc ); true ), writeId(Q) ); 
		writeId(O) ), 
	( has_IMPLEMENTATION(O,'SUBPROGRAM',B,_) -> ( dot, write(B) ); true), fail.
genSubprogram(X,I,O,'SERVER ') :- sp, write('{ Compute_Entrypoint => '), writeId(O), write('; }'), fail.
genSubprogram(X,I,O,M) :- sc, nl.

genParameter(P,X,M,A,Y,T,I) :- indent(I), writeId(A), write(' : '), writeMode(M,'IN'), 
	write(' PARAMETER '), writeType(P,Y,T), sc, nl.

/*------------*/
/* Event Port */
/*------------*/

genEvent(X,I,O,M) :- insertComment(X,I,O,'OpTxt'), fail. 
genEvent(X,I,O,M) :- indent(I), writeId(O), write(' : '), 
	write(M), write(' EVENT PORT;'), nl, fail.
genEvent(X,I,O,M).

/*-----------*/
/* Data Port */
/*-----------*/

genDataPort(X,I,D,M) :- insertComment(X,I,D,'OpTxt'), fail. 
genDataPort(X,I,D,M) :- indent(I), writeId(D), write(' : '), write(M), write(' DATA PORT;'), nl.

genDataPort(X,I,O,M,A,P,T) :- insertComment(X,I,O,'OpTxt'), fail. 
genDataPort(X,I,O,M,A,P,T) :- indent(I), writeArg(X,O,A), write(' : '), writeMode(M,'IN'), 
	( is_EVENT_DATA(X,O) -> write(' EVENT DATA PORT '); write(' DATA PORT ') ), 
	writeType(X,P,T), sc, nl. 

portDir(X,D,M) :- 
	isMemberOf(D,'DATA',X,'in_data') -> M='IN';
	isMemberOf(D,'DATA',X,'out_data') -> M='OUT'; M='IN OUT'.
	
revPortDir(X,D,M) :- 
	isMemberOf(D,'DATA',X,'in_data') -> M='OUT';
	isMemberOf(D,'DATA',X,'out_data') -> M='IN'; M='IN OUT'.

/*-------------*/
/* Data Access */
/*-------------*/

genDataAccess(X,I,D) :- indent(I), writeId(D), write(' : REQUIRES DATA ACCESS '), 
	insertCompTypeName(D,'DATA'), sc, nl. /*(cf.AADL002)*/ 


/*-------------*/
/* CONNECTIONS */
/*-------------*/

opt_CONNECTIONS(X,C,I) :- has_CONNECTIONS(X,C) -> genConnections(X,I+1); true. 
has_CONNECTIONS(X,C) :- isImplementedBy(O,'OPERATION',X,P,S,_), is_EVENT(X,O). /*(cf.AADL001)*/
has_CONNECTIONS(X,C) :- isImplementedBy(D,'CONSTANT',X,P,S,_), has_PORT(X). /*(cf.AADL001)*/
has_CONNECTIONS(X,C) :- isImplementedBy(O,'OPERATION',X,P,S,_), is_PORT_OP(X,O,M,A,_,_). /*(cf.AADL001)*/
has_CONNECTIONS(X,C) :- isImplementedBy(E,'EXCEPTION',X,P,S,_). /*(cf.AADL001)*/
has_CONNECTIONS(X,C) :- isSystem(X), ( if_MAIN(_); ( if_OS(_), is_IT(_,_,_) ) ).
has_CONNECTIONS(X,C) :- not(isSystem(X)), is_IT(S,O,V), not(isImplementedBy(_,'OPERATION',_,O,S,_)), child(S,X).
has_CONNECTIONS(X,C) :- isObject(K,T,X), T \= 'OP_CONTROL', C \= 'DATA', 
	childRequires(_,_,_,K,_,_,S,_), K \= S, isVisibleFrom(K,S). /*(cf.AADL001)*/
has_CONNECTIONS(X,C) :- isObject(K,_,X), is_ACCESS(K,S), category(K,'THREAD'), category(S,'DATA'), isVisibleFrom(K,S).
has_CONNECTIONS(X,C) :- isObject(K,T,X), T \= 'OP_CONTROL', isObject(S,U,X), U \= 'OP_CONTROL', 
	uses(K,S,'OPERATION',1), K \= S, isVisibleFrom(K,S). /*(cf.AADL001)*/

genConnections(X,I) :- indent(I-1), write('CONNECTIONS'), nl, fail.

genConnector(O,D,Co,Fo,Ao,Cd,Fd,Ad) :- 
	( Co \= '' -> ( writeId(Co), dot ); true ), 
	( Ao \= '' -> ( writeArg(O,Fo,Ao) ); writeId(Fo) ), 
	write(' -> '), 
	( Cd \= '' -> ( writeId(Cd), dot ); true ), 
	( Ad \= '' -> ( writeArg(D,Fd,Ad) ); writeId(Fd) ), 
	sc, nl.

/*----------------*/
/* implemented_by */
/*----------------*/

genConnections(X,I) :-
	isImplementedBy(O,'OPERATION',X,P,S,_), is_EVENT(X,O), 
	not(argument(O,_,S,_,_,_,_,_,_)), 
	indent(I), write('EVENT PORT '), genConnector(X,S,'',O,'',S,P,''), fail.

genConnections(X,I) :-
	isImplementedBy(O,'OPERATION',X,P,S,_), is_EVENT(X,O), 
	argument(O,_,X,M,A,Y,T,_,_), inParam(M), 
	indent(I), write('EVENT DATA PORT '), genConnector(X,S,'',O,A,S,P,A), fail.

genConnections(X,I) :-
	isImplementedBy(O,'OPERATION',X,P,S,_), is_EVENT(X,O), 
	argument(O,_,X,M,A,Y,T,_,_), outParam(M), 
	indent(I), write('EVENT DATA PORT '), genConnector(S,X,S,P,A,'',O,A), fail.

genConnections(X,I) :-
	isImplementedBy(D,'CONSTANT',X,P,S,_), has_PORT(X), 
	indent(I), write('DATA PORT '), genConnector(S,X,S,P,'','',D,''), fail.

genConnections(X,I) :-
	isImplementedBy(D,'DATA',X,P,S,_), has_PORT(X), portDir(X,D,M), 
	( ( M='OUT'; M='IN OUT' ) -> 
	( indent(I), write('DATA PORT '), genConnector(S,X,S,P,'','',D,'') ); true ), 
	( ( M='IN'; M='IN OUT' ) -> 
	( indent(I), write('DATA PORT '), genConnector(X,S,'',D,'',S,P,'') ) ), fail.
	
genConnections(X,I) :- 
	isImplementedBy(O,'OPERATION',X,P,S,_), is_PORT_OP(X,O,M,A,_,_),  
	( outParam(M) -> ( indent(I), 
	  ( is_EVENT_DATA(S,V) -> write('EVENT DATA PORT '); write('DATA PORT ') ), 
	  genConnector(S,X,S,P,A,'',O,A) ); true ), 
	( inParam(M) -> ( indent(I), 
	  ( is_EVENT_DATA(S,V) -> write('EVENT DATA PORT '); write('DATA PORT ') ), 
	  genConnector(X,S,'',O,A,S,P,A) ) ), fail.

genConnections(X,I) :-
	isImplementedBy(E,'EXCEPTION',X,P,S,_),  
	indent(I), write('EVENT PORT '), genConnector(S,X,S,E,'','',E,''), fail.

genConnections(X,I) :- isSystem(X), isCurrentRoot(R),  
	( if_MAIN(M) -> ( 
	  indent(I), write('EVENT PORT '), genConnector(X,R,'','start','',R,M,'') ); true ), 
	if_OS(S), is_IT(_,_,V), 
	indent(I), write('EVENT PORT '), genConnector(S,R,S,V,'',R,V,''), fail.
	  
genConnections(X,I) :- not(isSystem(X)), 
	is_IT(S,O,V), not(isImplementedBy(_,'OPERATION',_,O,S,_)), child(S,X),  
	indent(I), write('EVENT PORT '), 
	( isObject(S,_,X) -> 
	  genConnector(X,S,'',V,'',S,O,'');
	  genConnector(X,S,'',V,'',S,V,'') ), fail.

/*---------*/
/* require */
/*---------*/

genConnections(X,I) :-
	isObject(C,_,X), childRequires(_,_,'OPERATION',C,O,'OPERATION',S,_), 
	C \= S, isVisibleFrom(C,S), is_EVENT(S,O), 
	not(argument(O,_,S,_,_,_,_,_,_)), 
	indent(I), write('EVENT PORT '), genConnector(C,S,C,O,'',S,O,''), fail.

genConnections(X,I) :-
	isObject(C,_,X), childRequires(_,_,'OPERATION',C,O,'OPERATION',S,_), 
	C \= S, isVisibleFrom(C,S), is_EVENT(S,O), 
	argument(O,_,X,M,A,Y,T,_,_), inParam(M), 
	indent(I), write('EVENT DATA PORT '), genConnector(C,S,C,O,A,S,O,A), fail.

genConnections(X,I) :-
	isObject(C,_,X), childRequires(_,_,'OPERATION',C,O,'OPERATION',S,_), 
	C \= S, isVisibleFrom(C,S), is_EVENT(S,O), 
	argument(O,_,X,M,A,Y,T,_,_), outParam(M), 
	indent(I), write('EVENT DATA PORT '), genConnector(S,C,S,O,A,C,O,A), fail.

genConnections(X,I) :-
	isObject(C,_,X), childRequires(_,_,_,C,D,'CONSTANT',S,_), 
	C \= S, isVisibleFrom(C,S), has_PORT(S), 
	indent(I), write('DATA PORT '), genConnector(S,C,S,D,'',C,D,''), fail.

genConnections(X,I) :-
	isObject(C,_,X), childRequires(_,_,_,C,D,'DATA',S,_), 
	C \= S, isVisibleFrom(C,S), has_PORT(S), portDir(X,D,M), 
	( ( M='OUT'; M='IN OUT' ) ->  
	( indent(I), write('DATA PORT '), genConnector(S,C,S,D,'',C,D,'') ); true ), 
	( ( M='IN'; M='IN OUT' ) ->  
	( indent(I), write('DATA PORT '), genConnector(C,S,C,D,'',S,D,'') ) ), fail.

genConnections(X,I) :-
	isObject(C,_,X), childRequires(_,_,_,C,E,'EXCEPTION',S,_), 
	C \= S, isVisibleFrom(C,S), isProvided(E,'EXCEPTION',S), 
	indent(I), write('EVENT PORT '), genConnector(S,C,S,E,'',C,E,''), fail.

/*-----*/
/* use */
/*-----*/

genConnections(X,I) :-
	isObject(C,_,X), isObject(S,_,X), uses(C,S,'OPERATION',1), 
	C \= S, isVisibleFrom(C,S), 
	isProvided(U,'OPERATION',C), is_PORT_OP(C,U,M,A,P,R), 
	isProvided(V,'OPERATION',S), is_PORT_OP(S,V,N,B,Q,T), 
	matchPort(M,A,P,R,N,B,Q,T), indent(I), 
	( is_EVENT_DATA(S,V) -> write('EVENT DATA PORT '); write('DATA PORT ') ), 
	genConnector(S,C,S,V,A,C,U,B), fail.
	
matchPort(M,A,P,R,N,B,Q,T) :- 
	( M = 'in'; M = 'in out' ), ( N = 'out'; N = 'in out' ), 
	memezTra(A,B), memezTra(P,Q), memezTra(R,T).

genConnections(X,I) :-
	isObject(C,_,X), isObject(S,_,X), uses(C,S,'OPERATION',1), 
	C \= S, isVisibleFrom(C,S), 
	isProvided(E,'OPERATION',C), is_EVENT(C,U), 
	isProvided(E,'EXCEPTION',S), 
	indent(I), write('EVENT PORT '), 
	genConnector(S,C,S,E,_,C,E,_), fail.
	
/*--------*/
/* access */
/*--------*/

genConnections(X,I) :- 
	isObject(C,_,X), category(C,K), ( K='THREAD'; K='PROCESS' ), 
	isObject(S,_,_), category(S,'DATA'), 
	C \= S, is_ACCESS(C,S), isVisibleFrom(C,S), 
	indent(I), write('DATA ACCESS '), genConnector(S,C,'',S,'',C,S,''), fail.
genConnections(X,I).


/*-------*/
/* MODES */
/*-------*/

opt_MODES(X,I) :- has_MODES(X) -> genModes(X,I+1); true.
has_MODES(X) :- isCurrentRoot(X), category(X,'PROCESS'), isState(X,_,_), !.

/* genModes(X,I) */

genModes(X,I) :- indent(I-1), write('MODES'), nl, fail.
genModes(X,I) :- insertComment(X,I,'behaviour'), fail.
genModes(X,I) :- insertComment(X,I,'NIL','ObcsTxt'), fail.
genModes(X,I) :- insertComment(X,I,'NIL','ObcsBodyTxt'), fail.
genModes(X,I) :- isState(X,S,1), indent(I), write(S), write(' : INITIAL MODE;'), nl, fail.
genModes(X,I) :- isState(X,S,0), indent(I), write(S), write(' : MODE;'), nl, fail.
genModes(X,I) :- isTransition(X,T,A,B,E), indent(I), write(A), write(' -[ '), 
	( E \= 'NONE' -> write(E); write(T) ), write(' ]-> '), write(B), sc, nl, fail.
genModes(X,I).


/*------------*/
/* PROPERTIES */
/*------------*/

opt_TYPPROPERTIES(X,C,I,P) :- has_TYPPROPERTIES(X,C,P) -> genProperties(X,C,I+1,P); true.
has_TYPPROPERTIES(X,C,P) :- not(has_IMPLEMENTATION(X,C,_,P)), has_PROPERTIES(X,C,P).

opt_IMPPROPERTIES(X,C,I,P) :- has_IMPPROPERTIES(X,C,P) -> genProperties(X,C,I+1,P); true.
has_IMPPROPERTIES(X,C,P) :- has_IMPLEMENTATION(X,C,_,P), has_PROPERTIES(X,C,P).

has_PROPERTIES(X,'THREAD',P) :- dispatchProtocol(X,_).
has_PROPERTIES(X,'THREAD',P) :- ( hrtPeriod(X,_,_); hrtMinArrivalTime(X,_,_); hrtDeadline(X,_,_) ). 
has_PROPERTIES(X,'THREAD',P) :- isInternal(O,'OPERATION',X), memezTra(O,'thread').
has_PROPERTIES(X,'SUBPROGRAM',P) :- hrtWcet(P,X,_,_).
has_PROPERTIES(X,C,P) :- is_PROPERTY(X,_).

/* genProperties(X,C,I,Y) */

genProperties(X,C,I,Y) :- indent(I-1), write('PROPERTIES'), nl, fail.
genProperties(X,'THREAD',I,Y) :- dispatchProtocol(X,P), indent(I), write('Dispatch_Protocol => '), write(P), sc, nl, fail.
genProperties(X,'THREAD',I,Y) :- hrtPeriod(X,_,P), indent(I), write('Period => '), write(P), sc, nl, fail.
genProperties(X,'THREAD',I,Y) :- hrtMinArrivalTime(X,_,P), indent(I), write('Period => '), write(P), sc, nl, fail.
genProperties(X,'THREAD',I,Y) :- hrtDeadline(X,_,D), indent(I), write('Deadline => '), write(D), sc, nl, fail.
genProperties(X,'THREAD',I,Y) :- isInternal(O,'OPERATION',X), memezTra(O,'thread'), 
	indent(I), write('Compute_Entrypoint => '), write(O), sc, nl, 
	hrtWcet(X,O,_,W), indent(I), write('Compute_Deadline => '), write(W), sc, nl, fail.
genProperties(X,'SUBPROGRAM',I,Y) :- hrtWcet(Y,X,_,W), indent(I), write('Compute_Deadline => '), write(W), sc, nl, fail.
genProperties(X,C,I,Y) :- is_PROPERTY(X,U), insertFile('pseudo',U,'CONSTANT',X,I,'CstDef'), fail.
genProperties(X,C,I,Y).


/*-------*/
/* FLOWS */
/*-------*/

opt_FLOWSPEC(X,I) :- has_FLOWSPEC(X) -> genFlowSpec(X,I+1); true.
has_FLOWSPEC(X) :- fail.
opt_FLOWIMP(X,I) :- has_FLOWIMP(X) -> genFlowImp(X,I+1); true.
has_FLOWIMP(X) :- fail.

/* genFlowSpec(X,I) */

genFlowSpec(X,I) :- indent(I-1), write('FLOWS'), nl, fail.
genFlowSpec(X,I).

/* genFlowImp(X,I) */

genFlowImp(X,I) :- indent(I-1), write('FLOWS'), nl, fail.
genFlowImp(X,I).


/*-------*/
/* CALLS */
/*-------*/

opt_CALLS(X,I) :- has_CALLS(X) -> genCalls(X,I+1); true.
has_CALLS(X) :- remoteCall(X,_,_).

/* genCalls(X,I) */

genCalls(X,I) :- indent(I-1), write('CALLS {'), nl, fail.
genCalls(X,I) :- remoteCall(X,O,Y), insertCall(X,I,O,Y), fail.
genCalls(X,I) :- indent(I-1), write('};'), nl.

remoteCall(X,O,Y) :- 
	isProvided(O,'OPERATION',Y), calledOp(X,O,Y), /*(cf.AADL001)*/
	( is_DATA_SP(Y,O); is_SERVER_SP(Y,O) ).
remoteCall(X,Y,Y) :- 
	uses(X,Y,'OPERATION',1), isObject(Y,'OP_CONTROL',_), X \= Y. /*(cf.AADL001)*/
	
insertCall(X,I,O,Y) :- indent(I), writeId(O), write(' : SUBPROGRAM '), 
	( ( Y \= 'NIL', not(isObject(Y,'OP_CONTROL',_)) ) -> ( write(Y), dot ); true ), writeId(O), sc, nl.
	
calledOp(X,O,Y) :- requires(_,_,'OPERATION',X,O,'OPERATION',Y,'OpDef'), X \= Y, !. /*(cf.AADL001)*/

/*-------*/	
/* ANNEX */
/*-------*/

opt_TYPANNEX(X,C,I).
opt_IMPANNEX(X,C,I,P) :- has_IMPANNEX(X,C,A) -> genAnnex(X,C,I+1,P,A); true.
has_IMPANNEX(X,C,A) :- if_BEHAVIOR(A), 
	( C='THREAD'; C='SUBPROGRAM'; ( C='DATA', if_SHARED_DATA(X) ) ).

/* genAnnex(X,C,I,P,A) */

genAnnex(X,'THREAD',I,_,A) :- insertComment(X,I,'behaviour'), fail.
genAnnex(X,'THREAD',I,_,A) :- write('ANNEX '), write(A), write(' {**'), nl, fail.
genAnnex(X,'THREAD',I,_,A) :- insertComment(X,I,'NIL','ObcsTxt'), fail. 
genAnnex(X,'THREAD',I,_,A) :- insertComment(X,I,'NIL','ObcsBodyTxt'), fail. 
genAnnex(X,'THREAD',I,_,A) :- if_REVERSE, beginReverse(X,I,'NIL','pseudo::obcs'), fail.
genAnnex(X,'THREAD',I,_,A) :- insertFile('pseudo','NIL','NIL',X,I,'obcs'), fail.
genAnnex(X,'THREAD',I,_,A) :- if_REVERSE, endReverse(I), fail.
genAnnex(X,'THREAD',I,_,A) :- insertComment(X,I,'thread','OpBodyTxt'), fail. 
genAnnex(X,'THREAD',I,_,A) :- if_REVERSE, beginReverse(X,I,'thread','pseudo::OpDef'), fail.
genAnnex(X,'THREAD',I,_,A) :- insertFile('pseudo','thread','OPERATION',X,I,'OpDef'), fail.
genAnnex(X,'THREAD',I,_,A) :- if_REVERSE, endReverse(I), fail.
genAnnex(X,'THREAD',I,_,A) :- write('**};'), nl.

genAnnex(O,'SUBPROGRAM',I,X,A) :- write('ANNEX '), write(A), write(' {**'), nl, fail.
genAnnex(O,'SUBPROGRAM',I,X,A) :- insertComment(O,I,X,'OpBodyTxt'), fail. 
genAnnex(O,'SUBPROGRAM',I,X,A) :- if_REVERSE, beginReverse(X,I,O,'pseudo::OpDef'), fail.
genAnnex(O,'SUBPROGRAM',I,X,A) :- insertFile('pseudo',O,'OPERATION',X,I,'OpDef'), fail.
genAnnex(O,'SUBPROGRAM',I,X,A) :- if_REVERSE, endReverse(I), fail.
genAnnex(O,'SUBPROGRAM',I,X,A) :- write('**};'), nl.

genAnnex(X,'DATA',I,_,A) :- write('ANNEX '), write(A), write(' {**'), nl, fail.
genAnnex(X,'DATA',I,_,A) :- insertComment(X,I,'NIL','ObcsTxt'), fail. 
genAnnex(X,'DATA',I,_,A) :- insertComment(X,I,'NIL','ObcsBodyTxt'), fail. 
genAnnex(X,'DATA',I,_,A) :- if_REVERSE, beginReverse(X,I,'NIL','pseudo::obcs'), fail.
genAnnex(X,'DATA',I,_,A) :- insertFile('pseudo','NIL','NIL',X,I,'obcs'), fail.
genAnnex(X,'DATA',I,_,A) :- if_REVERSE, endReverse(I), fail.
genAnnex(X,'DATA',I,_,A) :- write('**};'), nl.


/*********************/
/* U T I L I T I E S */
/*********************/

memezTra('','').
memezTra(A,B) :- A \= '', B \= '', $name(A,L1), $name(B,L2), id(L1,L2).

id([],[]) :- true.
id([E|L1],[F|L2]) :- ( E =:= F ; E =:= F-32 ; E-32 =:= F ), id(L1,L2).

do(X,P) :- done(X,P) -> fail; $assert(done(X,P)). /*(cf.AADL002)*/
do(X,Y,P) :- done(X,Y,P) -> fail; $assert(done(X,Y,P)). /*(cf.AADL002)*/

notDone('void',_) :- !. /*(cf.AADL002)*/
notDone(X,P) :- is_TYPNAME(X,N), do(N,P). /*(cf.AADL002)*/
notDone(X,Y,P) :- is_TYPNAME(X,N), do(N,Y,P). /*(cf.AADL002)*/

implem(U,E,X,V,Y) :-
        isImplementedBy(U,E,X,I,A) ->
        ( implem(I,E,A,J,B) -> (V=J, Y=B); (V=I, Y=A) );
        ( V=U, Y=X ).

implem2(U,E,X,V,Y) :- isImplementedBy(U,E,X,W,Z),
	(isImplementedBy(W,E,Z,_,_) ->
	implem2(W,E,Z,V,Y); (V=W, Y=Z) ).

implem3(U,E,X,V,Y) :- isImplementedBy(U,E,X,W,Z),
	( (W=V, Z=Y) -> true; implem3(W,E,Z,V,Y) ).

childRequires(L,C1,K1,M1,C2,K2,M2,W) :-
	isTerm(M1) ->
		( requires(L,C1,K1,M1,C2,K2,M2,W) );
		( isObject(M,_,_), child(M,M1), requires(L,C1,K1,M,C2,K2,M2,W) ).

childUses(M1,M2,K,V) :-
	isTerm(M1) ->
		( uses(M1,M2,K,V) );
		( isObject(M,_,_), child(M,M1), uses(M,M2,K,V) ).


/*************************************/
/* E X T R A C T I O N   T U N I N G */
/*************************************/

/*---------*/
/* general */
/*---------*/

is_IT(X,O,V) :- isConstrained(O,_,X,'BY_IT',V).
is_SERVER_SP(X,O) :- isConstrained(O,_,X,C,_), ( C='HSER'; C='LSER' ), !.
is_EVENT(X,O) :- ( ( isConstrained(O,_,X,C,_), ( C='ASER'; C='BY_IT'; C='ASATC' ) ); impMain(X,O) ), 
	not(argument(O,_,X,_,_,_,_,_,_)), not(return(O,_,X,_,_,_)), !.
is_EVENT_DATA(X,O) :- ( ( isConstrained(O,_,X,C,_), ( C='ASER'; C='BY_IT'; C='ASATC' ) ); impMain(X,O) ), 
	( argument(O,_,X,_,_,_,_,_,_); return(O,_,X,_,_,_) ), !.
is_DATA_SP(X,O) :- not(is_EVENT(X,O)), not(is_SERVER_SP(X,O)), not(is_PORT_OP(X,O,_,_,_,_)), 
	not(is_EVENT_DATA(X,O)). 
is_PORT_OP(X,O,M,A,P,T) :- has_PORT(X), not(is_SERVER_SP(X,O)), 
	( argument(O,_,X,M,A,P,T,_,_); (return(O,_,X,P,T,_), A=O, M='out') ), !. 
is_ACCESS(C,S) :- childUses(C,S,'OPERATION',1), !.
is_PARAMETER(X,O,M,A,Y,T) :- argument(O,'OPERATION',X,M,A,Y,T,_,_).
is_PARAMETER(X,O,'out','return',Y,T) :- return(O,'OPERATION',X,Y,T,_).

is_IMPNAME(X,C,B,P) :- pragma_implementation_name(X,N) -> B=N; 
	( P \= '', category(P,K), is_IMPNAME(P,K,D,_) ) -> B=D; B='others'.
is_TYPNAME(X,S) :- pragma_type_name(X,N) -> S=N; S=X.
is_PROPERTY(X,U) :- file('pseudo',U,'CONSTANT',X,_,'CstDef'), memezTra(U,'Properties').

has_PORT(X) :- category(X,C), ( C='THREAD'; C='THREAD GROUP'; C='PROCESS'; C='SYSTEM' ).

if_OS(S) :- pragma_os(_,S), !. 
if_MAIN(M) :- pragma_main(_,M), !.
if_EXPANDED(X) :- objectLevel(X,N), N=\=0, N=\=1, not(pragma_compact(_)).
if_NOT_PACKAGE :- not(pragma_more_packages(_)). 
if_PACKAGE(X,P) :- ( pragma_more_packages(_); ( category(P,C), C \= 'PACKAGE' ) ), !.
if_IN_PACKAGE(X,C) :- isObject(X,_,P), category(P,'PACKAGE').
if_IN_PACKAGE(X,'DATA') :- fullCompType(X,'DATA',P,T), isEnvironment(P).
if_SHARED_DATA(X) :- uses(Y,X,'OPERATION',1), category(Y,C), C \= 'DATA', C \= 'PACKAGE', !. 
if_RENAMED(P,R) :- pragma_renames(P,F), convert(P,F,R), !.
if_BEHAVIOR(A) :- pragma_behavior(_,A), !.
if_REVERSE :- pragma_reverse(_), !.

dispatchProtocol(X,'aperiodic') :- isObject(X,'ACTIVE',_), isConstrained(_,_,X,C,_), ( C='HSER'; C='LSER' ), !.
dispatchProtocol(X,'sporadic') :- isObject(X,'ACTIVE',_), isConstrained(_,_,X,C,_), ( C='ASER' ), !.
dispatchProtocol(X,'periodic') :- isObject(X,'CYCLIC',_).
dispatchProtocol(X,'sporadic') :- isObject(X,'SPORADIC',_).

fullCompType(X,'DATA',P,T) :- 
  ( isProvided(X,'OPERATION',X), argument(X,_,X,_,_,P,T,_,_) );
  ( requires(_,X,'DATA',X,T,'TYPE',P,'DataDef') ); 
  ( isProvided(T,'TYPE',X), P = X ).

lineWidth(W) :- pragma_line_width(_,L) -> W is L - 10; W is 70. 

/*----------------*/
/* reserved words */
/*----------------*/

isReserved(X) :- 
	memezTra(X,'AADLBOOLEAN'); 
	memezTra(X,'AADLINTEGER'); 
	memezTra(X,'AADLREAL'); 
	memezTra(X,'AADLSTRING'); 
	memezTra(X,'ACCESS'); 
	memezTra(X,'ALL'); 
	memezTra(X,'AND'); 
	memezTra(X,'ANNEX'); 
	memezTra(X,'APPLIES'); 
	memezTra(X,'BINDING'); 
	memezTra(X,'BUS'); 
	memezTra(X,'CALLS'); 
	memezTra(X,'CLASSIFIER'); 
	memezTra(X,'CONNECTIONS'); 
	memezTra(X,'CONSTANT'); 
	memezTra(X,'DATA'); 
	memezTra(X,'DELTA'); 
	memezTra(X,'DEVICE'); 
	memezTra(X,'END'); 
	memezTra(X,'ENUMERATION'); 
	memezTra(X,'EVENT'); 
	memezTra(X,'EXTENDS'); 
	memezTra(X,'FALSE'); 
	memezTra(X,'FEATURES'); 
	memezTra(X,'FLOW'); 
	memezTra(X,'FLOWS'); 
	memezTra(X,'GROUP'); 
	memezTra(X,'IMPLEMENTATION'); 
	memezTra(X,'IN'); 
	memezTra(X,'INHERIT'); 
	memezTra(X,'INITIAL'); 
	memezTra(X,'INVERSE'); 
	memezTra(X,'IS'); 
	memezTra(X,'LIST'); 
	memezTra(X,'MEMORY'); 
	memezTra(X,'MODE'); 
	memezTra(X,'MODES'); 
	memezTra(X,'NONE'); 
	memezTra(X,'NOT'); 
	memezTra(X,'OF'); 
	memezTra(X,'OR'); 
	memezTra(X,'OUT'); 
	memezTra(X,'PACKAGE'); 
	memezTra(X,'PARAMETER'); 
	memezTra(X,'PATH'); 
	memezTra(X,'PORT'); 
	memezTra(X,'PRIVATE'); 
	memezTra(X,'PROCESS'); 
	memezTra(X,'PROCESSOR'); 
	memezTra(X,'PROPERTIES'); 
	memezTra(X,'PROPERTY'); 
	memezTra(X,'PROVIDES'); 
	memezTra(X,'PUBLIC'); 
	memezTra(X,'RANGE'); 
	memezTra(X,'REFERENCE'); 
	memezTra(X,'REFINED'); 
	memezTra(X,'REFINES'); 
	memezTra(X,'REQUIRES'); 
	memezTra(X,'SERVER'); 
	memezTra(X,'SET'); 
	memezTra(X,'SINK'); 
	memezTra(X,'SOURCE'); 
	memezTra(X,'SUBCOMPONENTS'); 
	memezTra(X,'SUBPROGRAM'); 
	memezTra(X,'SYSTEM'); 
	memezTra(X,'THREAD'); 
	memezTra(X,'TO'); 
	memezTra(X,'TRUE'); 
	memezTra(X,'TYPE'); 
	memezTra(X,'UNIT'); 
	memezTra(X,'VALUE').
	
/*--------------------*/
/* Special Characters */
/*--------------------*/

specialChars([],R,L) :- $reverse(R,L), !.
specialChars([C1|L1],L2,L) :- ( 
	C1 =:= 34 -> C2 is 113; /* " -> q */
	C1 =:= 35 -> C2 is 95;  /* # -> _ */
	C1 =:= 38 -> C2 is 65;  /* & -> A */
	C1 =:= 42 -> C2 is 88;  /* * -> X */
	C1 =:= 43 -> C2 is 80;  /* + -> P */
	C1 =:= 45 -> C2 is 77;  /* - -> M */
	C1 =:= 47 -> C2 is 68;  /* / -> D */
	C1 =:= 60 -> C2 is 76;  /* < -> L */
	C1 =:= 61 -> C2 is 69;  /* = -> E */
	C1 =:= 62 -> C2 is 71;  /* > -> G */
	C2 is C1 ),
	specialChars(L1,[C2|L2],L).

/*---------------*/
/* objects types */
/*---------------*/

isTerm(X) :- not(isObject(_,_,X)).
isParent(X) :- isObject(_,_,X), !.
isGeneric(X) :- isRootObject(X,'GENERIC',_).
isOpControl(X,X) :- isObject(X,'OP_CONTROL',_). /*(cf.AADL001)*/
isRoot(X) :- isRootObject(Y,_,_), isCurrentRoot(X), memezTra(X,Y), !.
isBrother(X,Y) :- isObject(X,_,Z), isObject(Y,_,Z), X \= Y.
isUncle(X,Y) :- isObject(Y,_,Z), isBrother(X,Z).
isEnvironment(X) :- ( objectLevel(X,1); ( isObject(X,_,_), isRootObject(Y,_,_), memezTra(X,Y) ) ), !.
isVisibleFrom(X,Y) :- ( isBrother(Y,X); isUncle(Y,X); isEnvironment(Y) ), !.

/*---------------------------*/
/* objects characteristics : */
/*---------------------------*/

extract(X) :- extract(_,_,X,_,_), !.
hasReq(X) :- requires(_,_,X,_,_,Y,_), Y\=X, !.
hasReq(X,E) :- server(Y), Y\=X, Y\='FORMAL_PARAMETERS', used(E,X,Y), !.
hasProTyDaCo(X) :- (hasProCo(X); hasProTy(X); hasProDa(X)), !.
hasProDaCo(X) :- (hasProCo(X); hasProDa(X)), !.
hasProDa(X) :- isProvided(_,'DATA',X), !.
hasProCo(X) :- isProvided(_,'CONSTANT',X), !.
hasProTy(X) :- isProvided(_,'TYPE',X), !.
hasProOp(X) :- isProvided(_,'OPERATION',X), !.
hasProIn(X) :- isProvided(U,'OPERATION',X), isInline(X,U), !.
hasProNi(X) :- isProvided(U,'OPERATION',X), notInline(X,U), !.
hasProEx(X) :- isProvided(_,'EXCEPTION',X), !.
hasIntTyDaCo(X) :- (hasIntCo(X); hasIntTy(X); hasIntDa(X)), !.
hasIntCo(X) :- isInternal(_,'CONSTANT',X), !.
hasIntTy(X) :- isInternal(_,'TYPE',X), !.
hasIntDa(X) :- isInternal(_,'DATA',X), !.
hasIntOp(X) :- isInternal(_,'OPERATION',X), !.

/*---------------------------------*/
/* child objects characteristics : */
/*---------------------------------*/

implements(Y,X) :- isObject(Y,_,X), imp(X,Y).
imp(X,Y) :- isImplementedBy(_,_,X,_,Y), !.
impMain(X,U) :- if_MAIN(M), isCurrentRoot(R), implem3(M,'OPERATION',R,U,X).
child(C,P) :- isObject(C,_,P), !.
child(C,P) :- isObject(C,_,X), child(X,P).

/*----------------------------*/
/* operation characteristics */
/*----------------------------*/

hasParam(X,O) :- ( argument(O,_,X,_,_,_,_,_,_); return(O,_,X,_,_,_) ), !.
hasParamofType(X,O,T) :- ( argument(O,_,X,_,_,_,T,_,_); return(O,_,X,_,T,_) ), !. 

writeMode(M,'IN') :-
	M='in' -> write('IN');
	M='out' -> write('OUT');
	M='in out' -> write('IN OUT');
	M='inout' -> write('IN OUT').

writeMode(M,'OUT') :-
	M='in' -> write('OUT');
	M='out' -> write('IN');
	M='in out' -> true;
	M='inout' -> true.
	
writeArg(X,O,A) :- 
	( ( argument(P,_,X,_,A,_,_,_,_), P \= O ) -> 
	( writeId(O), write('_'), write(A) ); writeId(A) ).

writeType(X,P,T) :- ( P = ''; P = 'NIL' ), 
	( ( isProvided(U,'TYPE',Y), memezTra(T,U), category(Y,'PACKAGE'), isVisibleFrom(X,Y) ) -> 
	( writeId(Y), dc ); true ), writeId(T), 
	((  has_IMPLEMENTATION(T,'DATA',B,_), B \= 'others' ) -> ( dot, write(B) ); true ), !. 
	
writeType(X,P,T) :- P \= '', P \= 'NIL', ( category(P,'PACKAGE') -> 
	( ( if_RENAMED(P,R) -> writeId(R); writeId(P) ), dc ); true ), writeId(T), 
	( ( has_IMPLEMENTATION(T,'DATA',B,_), B \= 'others' ) -> ( dot, write(B) ); true ). 
		
inParam('in').
inParam('in out').
inParam('inout').
outParam('out').
outParam('in out').
outParam('inout').


/*********************/
/* I / O   R U L E S */
/*********************/

write(T) :- $writename(T).

writeId('').
writeId(X) :- X \= '', filter(X,Y), write(Y), ( isReserved(Y) -> write('_0'); true ). 

writeCompName(C,X) :- ( C = 'DATA', if_SHARED_DATA(X), isProvided(T,'TYPE',X) ) -> 
	writeId(T); ( is_TYPNAME(X,N), writeId(N) ).

filter(X,Y) :- $name(X,L1), specialChars(L1,[],L2), $name(Y,L2). 

print(T) :- $telling(F), $tell('user'), $writename(T), $tell(F).
print(A,B) :- $telling(F), $tell('user'),
	 $writename(A),$writename(B),nl, $tell(F).
print(A,B,C,D) :- $telling(F), $tell('user'),
	 $writename(A),$writename(B),
	 $writename(C),$writename(D),nl, $tell(F).
	 
convert(P,'',P).
convert(P,A,B) :- A \= '', $name(A,L1), dot2dc(L1,[],L2), $name(B,L2).

dot2dc([],R,L) :- $reverse(R,L), !.
dot2dc([C|L1],L2,L) :- C =:= 46 -> dot2dc(L1,[58,58|L2],L); dot2dc(L1,[C|L2],L).

nl :- $put(10).
tab :- $put(9).
sp :- $put(32).
dot :- $put(46).
sc :- $put(59). /* semi colon */
dc :- $put(58), $put(58). /* double colon */

begCom :- write('-- ').
endCom :- nl.

beginReverse(X,I,O,W) :- 
	indent(I), begCom, write('<begin '), write(W), sp, write(X), 
	( O='NIL' -> true; ( sp, write(O) ) ), write('>'), nl.
	
endReverse(I) :-
	indent(I), begCom, write('<end>'), nl.

none(I) :- indent(I), write('NONE;'), nl.

indent(N) :- pragma_no_indent(_) -> true; 
  ( ( pragma_indent_width(_,W) -> I is W; I is 2 ), T is N * I, $tab(T) ).

openFile(X,S) :- extract(_,_,X,S,F),
	( $tell(F) -> true; message('*** cannot open : ',F) ).

closeFile :- $told.

insertFile(L,U,E,X,I,W) :- file(L,U,E,X,F,W), $see(F), indent(I), readFile(I), nl.

readFile(I) :-
	$get0(N),		/* read one char, and */
	(  N =\= -1 -> 		/* is it not end of file ? */
		(  
		   $put(N),	/* if not eof then write char, and */
		   ( N =:= 10 -> indent(I); true), 
		   readFile(I)	/* read next char */
		);		/* or */
		$seen		/* if eof then close input file */
	).
	
insertCom(U,E,X,I,W) :- comment(U,E,X,F,W) -> 
	( $see(F), indent(I), begCom, $globalset(w(I)), readComFile(I), nl ); true.

insertCom(X,I,W) :- description(X,F,W) -> 
	( $see(F), indent(I), begCom, $globalset(w(I)), readComFile(I), nl ); true.

readComFile(I) :- 
	$get0(N),			/* read one char, and */
	(  N =\= -1 -> 			/* is it not end of file ? */
	   (  w(K), lineWidth(W),	/* if not eof then get counter value */
	      ( (K > W, N =:= 32) ->	/* is counter at max width and char space ? */
		newComLine(I) ;		/* if mw then create new line */
		( L is K+1, 		/* if not mw then increment counter */
		  $globalset(w(L))	/* and store its value */
		)			
	      ),			/* and */
	      ( N =:= 10 -> 		/* is it new line ? */
		newComLine(I) ;		/* if nl then write end of line, and */
		$put(N)			/* if not nl then write char, and */
	      ),			/* and */
	      readComFile(I)		/* read next char */
	   );				/* or */
	   $seen			/* if eof then close input file */
	).

newComLine(I) :- endCom, indent(I), begCom, $globalset(w(I)).

message(A) :- $telling(X),
	 $tell('user'), write(A), nl,
	 $tell(X).

message(A,B) :-
        $telling(X), $tell('user'),
        write(A), write(B), nl,
        $tell(X).

message(A,B,C,D) :-
         $telling(X), $tell('user'),
         write(A), write(B), write(C), write(D),  nl,
         $tell(X).

message(A,B,C,D,E,F) :-
        $telling(X), $tell('user'),
        write(A), write(B), write(C), write(D), write(E), write(F), nl,
        $tell(X).

insertComment(X,I,'spec') :- insertCom(X,I,'DOC11'). 
insertComment(X,I,'body') :- insertCom(X,I,'DOC21'). 
insertComment(X,I,'behaviour') :- insertCom(X,I,'DOC241').
insertComment(X,I,F,W) :- insertCom(F,_,X,I,W). 

