/*``comments``Wed Jul  2 10:45:29 MET DST 2003``*/
/* version */
/*-------------------------------------------------
	STOOD v5.0
	Ada code generator 

	Copyright TNI Europe & Ellidiss Technologies 2004-2005
	Pierre DISSAUX, 
	stood@tni-world.com
	07.Jan.2005
-------------------------------------------------*/
/**** local requirements ****/
/*-------------------------------------------------
last changes:
ADA099 (25.07.97) bug in constrained ops : "entry" instead of "procedure"
ADA100 (01.08.97) finds correct type for implemented_by constants.
ADA101 (01.08.97) indent(2) wraps constants, enum elem and exception renaming
ADA102 (04.08.97) write2(X) may print more than 80 chars (used for filenames)
ADA103 (05.08.97) introduces pragma rename_constants 
ADA104 (05.08.97) changes in scan.lex to best manage address clauses
ADA105 (08.08.97) various changes about constrained operations and OBCS
ADA106 (03.11.97) adds indentation and "" to Rcs_Id
ADA107 (03.11.97) new pragma "no_constraints"
ADA108 (03.11.97) new pragma "operator" (cf.RASTO/01.004)
ADA109 (03.11.97) enables OpDefExt insertion even when no pragma "interface"
ADA110 (03.11.97) new pragma "data_page" for TARTAN compiler
ADA111 (03.11.97) fixes bug in type record elements insertion
ADA112 (12.11.97) first version of trace file for OTB/Skipper
ADA113 (18.12.97) improvements for constrained ops of classes (ELCAD study)
ADA114 (03.12.97) removes abnormal warnings about op-sets dependencies
ADA115 (05.12.97) pragma "hide_IT" to hide ASER BY_IT in body
ADA116 (03.02.98) pragma "discriminant" and automatic discriminant insertion
ADA117 (03.02.98) now, 'me' may also be written  'ME', 'Me' or 'mE'
ADA118 (03.02.98) pragma 'skipper' to enable trace file generation (ADA112)
ADA119 (03.02.98) pragma package_OBCS didn't work since ADA113 (fixed)
ADA120 (03.02.98) no more child units when pragma no_Ada95
ADA121 (03.02.98) pragma line_width to control comment lines length
ADA122 (03.02.98) a few changes in protected types management
ADA123 (11.02.98) fixes a bug for dependencies with attributes types
ADA124 (11.02.98) no more bodies for inherited operations
-- CD-Rom #1 (May 1998)
ADA125 (22.05.98) -I flag for gnatmake
ADA126 (22.05.98) OBCS stub now at the end of package body
ADA127 (22.05.98) keeps receiver inside op bodies
ADA128 (04.06.98) fixes a bug when copying parameters in OBCS
ADA129 (04.06.98) fixes a bug when inserting a discriminant (ADA116)
ADA130 (05.06.98) includes context clauses required for init bloc
ADA131 (05.06.98) fixes a bug when renaming generic packages
ADA132 (08.06.98) apse=aonix to support ObjectAda
ADA133 (12.06.98) substitutes //C by C: for PCs
ADA134 (05.08.98) fixes a bug when requiring internal types in private spec
ADA135 (05.08.98) fixes a bug when renaming packages in separate units
ADA136 (15.09.98) new code generation scheme for OP_CONTROLs
ADA137 (25.09.98) no more assignment renaming for enum when use type
ADA138 (25.09.98) non terminal modules are no more child units
ADA139 (19.10.98) wildcard now allowed for pragma interface
ADA140 (19.10.98) with clause for formal objets in generics spec
-- CD-Rom #2 (November 1998)
ADA141 (30.10.98) overloaded operators now allowed
ADA142 (10.11.98) fixes a bug in dependencies rules for address clauses
ADA143 (10.11.98) new pragma task_type
ADA144 (25.11.98) fixes a bug in implemented_by for inherited operations
-- CD-Rom #3 (May 1999)
ADA145 (29.04.99) inserts components even when illegal dependency
ADA146 (30.04.99) pragma interface parameters now not case sensitive
ADA147 (30.04.99) new pragma separate_op
ADA148 (30.04.99) new pragma sep_lines for comments
ADA149 (30.07.99) new pragmas extension et generic for operations decl.
ADA150 (30.07.99) new pragma indent_width
ADA151 (30.07.99) new pragma subtyping for implemented_by of classes
ADA152 (30.07.99) allows internal op to be inserted inside private spec
ADA153 (30.09.99) managing child units within formal operations of generics
ADA154 (30.09.99) fixes a side effect of ADA145 when type attributes have no type
ADA155 (30.09.99) takes OpDefExt into accounts for int dependencies
ADA156 (11.01.00) new pragma verbose
-- CD-Rom #4 (March 2000)
ADA157 (15.06.00) fixes pb with attributes with '' parameter
ADA158 (10.07.00) fixes a pb for private types decl in non term modules (cf.RASTO/00.002)
ADA159 (19.07.00) fixes a pb for constants renaming
ADA160 (13.09.00) fixes a pb with pragma cut_line
ADA161 (14.09.00) now inserts spec header for instances_of generic
-- CD-Rom #5 (November 2000)
ADA162 (17.01.01) pragma const_enum may now be set at terminal level (cf.RASTO/01.008)
ADA163 (17.01.01) pragma const_enum now takes into account pragma renames_constant (cf.RASTO/01.008)
ADA164 (21.02.01) removes ADA_INCLUDE_PATH and ADA_LIBRARY_PATH in GNAT command file
ADA165 (15.05.01) new pragma priority (cf.RASTO/01.027)
ADA166 (12.06.01) faster algorithm for declarations ordering
ADA167 (13.06.01) removing explicit reference to Standard package in constants renaming
ADA168 (13.06.01) managing untyped constants renaming
ADA169 (18.07.01) new code for state & transitions
ADA170 (18.12.01) adding DataDef2 for body dependency (Airbus config)
-- CD-Rom #6 (December 2001)
ADA171 (10.04.02) Ada Ravenscar generation from HRT-HOOD patterns (cf.SEE/02.200)
ADA172 (07.05.02) managing /cygdrive/L/ syntax on windows
ADA173 (04.12.02) automatic insert of enumeration elements for types
ADA174 (18.12.02) pragma reverse (without parameter), compiler (same as apse), no_subunit.
ADA175 (18.12.02) no separate subunit for OPCS_ and overloaded operations
-- CD-Rom #6 (December 2002)
ADA176 (14.02.03) new pragma more_headers (cf.RASTO/03.020)
ADA177 (27.03.03) fix pb missing with if pragma separate_op for Op_Control (cf.RASTO/03.037)
ADA178 (09.04.03) fix pb multiple insertion with "nesting" + "visible_children" (cf.RASTO/03.042)
ADA179 (19.05.03) when nesting default is now "visible_children" and no child units  (cf.RASTO/03.042)
ADA180 (20.05.03) new pragma "instance_op" for subprograms and new name for pragma "generic" (cf.RASTO/03.064)
ADA181 (20.05.03) managing empty body for functions (cf.RASTO/03.063)
ADA182 (21.05.03) changing makefile and managing gnat.adc file (cf.RASTO/03.066)
ADA183 (21.05.03) fix pb missing context clause when inside OPCS (cf.RASTO/03.067)
ADA184 (26.05.03) new pragma "with" (cf.RASTO/03.068)
ADA185 (26.06.03) fix pb missing renaming of enum elements (cf.RASTO/03.071)
ADA186 (02.07.03) fix pb missing operation code extension (cf.RASTO/03.072)
ADA187 (30.10.03) improvement of ADA185 and fixing pb ordering prov types (cf.RASTO/03.096)
ADA188 (04.10.04) avoiding package body when only abstract or inherited operations
ADA189 (07.01.05) add some missing preconditions in automatas
-------------------------------------------------*/
/**** S T A R T U P ****/
/*``startup``Tue May 15 16:55:28 MET DST 2001``*/
/* go */

go :- $init_sys,$getenv('PREDICATS',FileName),$consult(FileName), fail.
go :- templateOBCS, genOBCS, fail.
go :- fullExtraction, genAda, fail.
go :- fullExtraction, createMakeFile, fail.
go :- fullExtraction, ifSkipper, createTrace,fail. /*(cf.ADA112)(cf.ADA118)*/
 
/*``startup``Tue May 15 16:55:11 MET DST 2001``*/
/* genada */

genAda :-
	isObject(X,T,Y),
	not(opControl(X,Y,_,_)), /*(cf.ADA136)*/
	X \= 'SYSTEM_CONFIGURATION',
	X \= 'FORMAL_PARAMETERS',
	libUnit(X), libUnitPack(X), fail.
 
/*``startup``jeudi, 14 novembre 1996, 09:35:58 MET``*/
/* genOBCS */

genOBCS :- extractObcs(X,F), $tell(F), oBCSBody(X,0), fail.
genOBCS :- $told.
 
/*``Ada units``Fri Apr  5 16:24:22 MET DST 2002``*/
/* libUnitPack(X) */

libUnitPack(X) :- inst(X), libInstPack(X).
libUnitPack(X) :- isHRT, rtattPack(X,0). /*(cf.ADA171)*/
libUnitPack(X) :- notInst(X), packSpec(X,0).
libUnitPack(X) :- notInst(X), hasBody(X), packBody(X,0).
/* libUnitPack(X) :- openHHD, listHHD(X), closeHHD. */
 
/*``comments``jeudi,  5 dcembre 1996, 16:41:42 MET``*/
/*************************************/
/**** S P E C I F I C A T I O N S ****/
/*************************************/
 
/*``packSpec(X,N)``Tue Sep 15 16:54:07 MET DST 1998``*/
/* ANCILLARY LIB UNITS : */
/*--------------------------------------*/

/* for PRAGMA ANCILLARY : */
packSpec(X,N) :- ancillary(X,_,Y), ancillarySpec(X,Y).

/* for TYPES_OUT scheme : */
packSpec(X,N) :- libTypes(X,Y), libTypesSpec(X,Y).
 
/*``packSpec(X,N)``Thu Jul 10 18:17:51 MET DST 1997``*/
/* OPEN SPECIFICATION FILE : */
/*---------------------------*/

packSpec(X,N) :- libUnit(X), not(openFile(X,'spec')), !.
packSpec(X,N) :- libUnit(X), insertCom('NIL',_,X,N,'HeaderTxt'), lf0.
packSpec(X,N) :- insertFile('NIL',_,X,N,'SpecHeader'), lf0.
 
/*``packSpec(X,N)``Thu Jul 10 16:55:21 MET DST 1997``*/
/* REQUIRED INTERFACE : */
/*----------------------*/

packSpec(X,N) :- ifCom, info(N,112), insertReqInt(X,N).
packSpec(X,N) :- ifCom, lf0.
 
/*``packSpec(X,N)``Mon Apr  8 16:32:47 MET DST 2002``*/
/* VISIBILITY FOR SPEC : */
/*------------------------------------------*/

packSpec(X,N) :- libSpec(X), info(N,102), needs('SPEC',X,Y), withes(X,N,Y).
packSpec(X,N) :- libSpec(X), lf0.
/* (cf.ADA171) */
packSpec(X,N) :- isCyclic(X), withForCyclicSpec(X,N). 
packSpec(X,N) :- isSporadic(X), withForSporadicSpec(X,N). 
packSpec(X,N) :- isProtected(X), withForProtectedSpec(X,N).
 
/*``packSpec(X,N)``Thu Jul 10 17:02:29 MET DST 1997``*/
/* VISIBILITY FOR NESTED SPEC : */
/*------------------------------------------*/

packSpec(X,N) :- libSpec(X), isNesting(X), info(N,114), 
	childInSpec(X), isDescendant(Y,X), ( inst(Y) -> 
		( needs('INSTANCE',Y,Z), withes(X,N,Z) );
		( needs('SPEC',Y,Z), withes(X,N,Z) ) ).
packSpec(X,N) :- libSpec(X), isNesting(X), lf0.
 
/*``packSpec(X,N)``Thu Apr 10 12:18:52 MET DST 2003``*/
/* VISIBILITY ON INCLUDED MODULES : */
/*----------------------------------*/

packSpec(X,N) :- libSpec(X), notNesting(X), isParent(X), info(N,103), 
	implements('SPEC',Y,X), withes(X,N,Y).
packSpec(X,N) :- libSpec(X), notNesting(X), isParent(X), lf0.
packSpec(X,N) :- libSpec(X), isNesting(X), 
	implements('LIB_UNIT_TYPES',Y,X), withes(X,N,Y), lf0.
 
/*``packSpec(X,N)``Fri Apr  5 12:04:30 MET DST 2002``*/
/* VISIBILITY ON ANCILLARIES AND TYPES_OUT : */
/*----------------------------------*/

packSpec(X,N) :- libSpec(X), ( libTypes(X,_);ancillary(X,_,_) ), info(N,100).
packSpec(X,N) :- libSpec(X), ( libTypes(X,Y);ancillary(X,_,Y) ), withes(X,N,Y).
packSpec(X,N) :- libSpec(X), isNesting(X), isChild(Z,X), 
	( libTypes(Z,Y);ancillary(Z,_,Y) ), withes(X,N,Y).
packSpec(X,N) :- libSpec(X), ( libTypes(X,_);ancillary(X,_,_) ), lf0.
 
/*``packSpec(X,N)``Fri Apr  5 16:24:41 MET DST 2002``*/
/* VISIBILITY ON REAL_TIME ATTRIBUTES : */
/*----------------------------------*/
/* (cf.ADA171) */

packSpec(X,N) :- isHRT, info(N,300).
packSpec(X,N) :- isHRT, indent(N), write('with '), write(X), write('_RTATT;'), nl, lf0.
 
/*``packSpec(X,N)``Tue Jul 17 15:14:30 MET DST 2001``*/
/* ODS DESCRIPTION  : */
/*-------------------*/

packSpec(X,N) :- ifV1, /*(cf.ADA156)*/
	insertDescr(X,N,'DOC11'), 
	insertDescr(X,N,'DOC132'), 
	insertDescr(X,N,'DOC133'), 
	dashLine(N), lf0.
 
/*``packSpec(X,N)``mercredi, 27 novembre 1996, 11:00:07 MET``*/
/* GENERIC : */
/*-----------------*/

packSpec(X,N) :- isGeneric(X), needs('SPEC','FORMAL_PARAMETERS',Y), 
	withes(X,N,Y).
packSpec(X,N) :- isGeneric(X), insert(X,N,'GENERIC').
packSpec(X,N) :- formTyCo(X,N).
packSpec(X,N) :- formalParameter(U,'OPERATION',X), insertFormOp(X,N+1,U).
 
/*``packSpec(X,N)``Mon Apr  8 18:00:06 MET DST 2002``*/
/* SPECIFICATION HEADER : */
/*------------------------*/

packSpec(X,N) :- childUnit(X,L) -> insert(X,L,N,'BEGIN_SPEC'); insert(X,N,'BEGIN_SPEC').
packSpec(X,N) :- isCyclic(X), indent(N+1), write('pragma Elaborate_Body;'), lf1. /*(cf.ADA171)*/
 
/*``packSpec(X,N)``Fri Aug  8 14:10:27 MET DST 1997``*/
/* USED PARENT UNIT RENAMING */
/*------------------------*/

packSpec(X,N) :- renameUnits(X,N+1).
 
 
/*``packSpec(X,N)``jeudi, 14 novembre 1996, 11:18:55 MET``*/
/* NESTED CHILD SPEC */
/*-------------------*/

packSpec(X,N) :- childInSpec(X), childSpecs(X,N).
 
/*``packSpec(X,N)``vendredi, 15 novembre 1996, 17:55:17 MET``*/
/* PROVIDED TYPES AND CONSTANTS : */
/*--------------------------------*/

packSpec(X,N) :- isNesting2(X), nestTypes(X), nestTyCo(X,N).
packSpec(X,N) :- isNesting1(X), nestTypes(X), provTyCo(X,N).
packSpec(X,N) :- notNesting(X), nestTypes(X), provTyCo(X,N).
packSpec(X,N) :- libTypes(X,_), privTyCo(X,N).
 
/*``packSpec(X,N)``Wed Apr 10 14:59:44 MET DST 2002``*/
/* PROVIDED UNCONSTRAINED OPERATIONS SPECIFICATION : */
/*---------------------------------------------------*/

packSpec(X,N) :- notNesting(X), isProvided(U,'OPERATION',X), 
	notInit(X,U), uncstrOp(X,U), notAnc(U,X), insertUncstrOper(X,N+1,U).
 
/*``packSpec(X,N)``jeudi, 14 novembre 1996, 11:19:16 MET``*/
/* PROVIDED EXCEPTIONS : */
/*-----------------------*/

packSpec(X,N) :- notNested(X), isProvided(U,'EXCEPTION',X), 
	notAnc(U,X), insertEx(X,N+1,U).
packSpec(X,N) :- nestChild(_,X), notInst(X), isProvided(U,'EXCEPTION',X), 
	not(isImplementedBy(_,'EXCEPTION',_,U,X)),
	implem(U,'EXCEPTION',X,V,Y), notAnc(V,Y), insertEx(Y,N+1,V).
 
/*``packSpec(X,N)``Wed Apr 10 14:24:35 MET DST 2002``*/
/* OBCS SPECIFICATION : */
/*----------------------*/

packSpec(X,N) :- isTerm(X), oBCSInSpec(X), oBCSSpec(X,N+1).
packSpec(X,N) :- isTerm(X), oBCSInSpec(X), 
	isProvided(U,'OPERATION',X), notInit(X,U), constrOp(X,U), 
	notAnc(U,X), insertConstrOper(X,N+1,U).
packSpec(X,N) :- isTerm(X), oBCSInBody(X), 
	isProvided(U,'OPERATION',X), notInit(X,U), constrOp(X,U), 
	notAnc(U,X), insertEntranceProc(X,N+1,U).
packSpec(X,N) :- isParent(X), notNesting(X), 
	isProvided(U,'OPERATION',X), notInit(X,U), constrOp(X,U), 
	notAnc(U,X), notHidden(X,U), insertConstrOper(X,N+1,U).
packSpec(X,N) :- isTerm(X), isProvided(T,'TYPE',X), ( /*(cf.ADA105)(cf.ADA113)*/
	( isTask(T,'TYPE',X), taskTypeOpers(X,T,O) );
	( isProtected(T,'TYPE',X), publicProtOpers(X,T,O) ) ), 
	insertEntryDecl(X,N+1,O).
 /* (cf.ADA171) */
packSpec(X,N) :- isSporadic(X), insertSporadicSpec(X,N+1).
packSpec(X,N) :- isStart(X,U), insertConstrOper(X,N+1,U).
packSpec(X,N) :- isProtected(X), insertProtectedSpec(X,N+1).
packSpec(X,N) :- isProtectedOp(X,U,_), insertConstrOper(X,N+1,U).
 
/*``packSpec(X,N)``Fri Jul 11 09:34:31 MET DST 1997``*/
/* TLD CONDITIONAL COMPILATION : */
/*--------------------------------*/

packSpec(X,N) :- isTerm(X), hasIf(X), info(N,117).
packSpec(X,N) :- isTerm(X), isInternal(U,'DATA',X), 
	if(X,O,U), insertDaOption(X,N,U,O).
packSpec(X,N) :- isTerm(X), isInternal(U,'OPERATION',X), notInit(X,U), 
	if(X,O,U), insertOpOption(X,N,U,O).
 
/*``packSpec(X,N)``Fri Jul 11 09:35:04 MET DST 1997``*/
/* NESTED CHILD OPERATIONS CALL : */
/*--------------------------------*/

packSpec(X,N) :- childInBody(X), isProvided(U,'OPERATION',X), 
	notInit(X,U), insertEntranceProc(X,N+1,U).
packSpec(X,N) :- childInSpec(X), isProvided(U,'OPERATION',X), 
	notInit(X,U), insertNestedOp(X,N+1,U).
 
/*``packSpec(X,N)``lundi, 18 novembre 1996, 11:41:54 MET``*/
/* PRIVATE PART : */
/*----------------*/

packSpec(X,N) :- notNesting(X), hasPrivate(X), insert(X,N,'PRIVATE_SPEC').
packSpec(X,N) :- notNesting(X), privTyCo(X,N).
packSpec(X,N) :- isNesting2(X), notInst(X), hasNestedPrivate(X), 
	insert(X,N,'PRIVATE_SPEC').
packSpec(X,N) :- isNesting2(X), notInst(X), nestPrivTyCo(X,N).
 
/*``packSpec(X,N)``Tue Jul 17 17:10:06 MET DST 2001``*/
/* SPECIFICATION FOOTER : */
/*------------------------*/

packSpec(X,N) :- childUnit(X,L) -> insert(X,L,N,'END_SPEC'); insert(X,N,'END_SPEC').
packSpec(X,N) :- dataPage(X,P), insertDataPage(X,N,P). /*(cf.ADA110)*/
 
/*``packSpec(X,N)``jeudi, 14 novembre 1996, 11:19:48 MET``*/
/* CLOSE SPECIFICATION FILE : */
/*----------------------------*/

packSpec(X,N) :- libUnit(X), closeFile.
 
/*``comments``jeudi,  5 dcembre 1996, 16:41:48 MET``*/
/*****************/
/**** B O D Y ****/
/*****************/
 
/*``packBody(X,N)``Tue May 15 17:02:58 MET DST 2001``*/
/* OPEN BODY FILE : */
/*------------------*/

packBody(X,N,F) :- packBody(X,N).
packBody(X,N,F) :- $tell(F,1).

packBody(X,N) :- libUnitBody(X), not(openFile(X,'body')), !. /*(cf.ADA136)*/
packBody(X,N) :- insertCom('NIL',_,X,N,'HeaderTxt'), lf0.
packBody(X,N) :- insertFile('NIL',_,X,N,'BodyHeader'), lf0.
 
/*``packBody(X,N)``Fri Apr 11 12:04:43 MET DST 1997``*/
/* MAIN */
/*------*/

packBody(X,N) :- main(X,_,_), info(N,110).
packBody(X,N) :- main(X,U,M), insertMain(X,N,U,M), !.
 
/*``packBody(X,N)``Mon Apr  8 16:32:34 MET DST 2002``*/
/* VISIBILITY FOR BODY : */
/*------------------------------------------*/

packBody(X,N) :- libBody(X), info(N,102), needs('BODY',X,Y), withes(X,N,Y).
packBody(X,N) :- libBody(X), lf0.
/* (cf.ADA171) */
packBody(X,N) :- isCyclic(X), withForCyclicBody(X,N). 
packBody(X,N) :- isSporadic(X), withForSporadicBody(X,N). 
packBody(X,N) :- isProtected(X), withForProtectedBody(X,N).
 
/*``packBody(X,N)``Thu Jul 10 17:04:56 MET DST 1997``*/
/* VISIBILITY FOR NESTED SPEC : */
/*------------------------------------------*/

packBody(X,N) :- libBody(X), isNesting(X), info(N,114).
packBody(X,N) :- libBody(X), nestingIns(X), childInBody(X), isDescendant(Y,X), 
	( inst(Y) -> 
		( needs('INSTANCE',Y,Z), withes(X,N,Z) );
		( needs('SPEC',Y,Z), withes(X,N,Z) ) ).
packBody(X,N) :- libBody(X), nestingSep(X), childInBody(X), isObject(Y,_,X), 
	( inst(Y) -> 
		( needs('INSTANCE',Y,Z), withes(X,N,Z) );
		( needs('SPEC',Y,Z), withes(X,N,Z) ) ).
packBody(X,N) :- libBody(X), isNesting(X), lf0.
 
/*``packBody(X,N)``Thu Jul 10 17:05:19 MET DST 1997``*/
/* VISIBILITY FOR NESTED BODIES : */
/*------------------------------------------*/

packBody(X,N) :- libBody(X), isNesting(X), info(N,115), 
	insChild(X,Y), needs('BODY',Y,Z), withes(X,N,Z).
packBody(X,N) :- libBody(X), isNesting(X), lf0.
 
/*``packBody(X,N)``Wed May 21 14:16:29 MET DST 2003``*/
/* VISIBILITY FOR INCLUDED OPCS : */
/*------------------------------------------*/

packBody(X,N) :- libBody(X), insProvOp(X,U), /*(cf.ADA183)*/
	needs('OPERATION',U,X,Y), withes(X,N,Y).
packBody(X,N) :- libBody(X), insIntOp(X,U), 
	needs('OPERATION',U,X,Y), withes(X,N,Y).
packBody(X,N) :- libBody(X), insProvOp(X,U), opControl(X,Y,U,V), 
	needs('OPERATION',V,Y,Z), withes(X,N,Z).
packBody(X,N) :- libBody(X), lf0.
 
/*``packBody(X,N)``Wed Dec 22 18:19:48 MET 1999``*/
/* VISIBILITY FOR INCLUDED OBCS BODY : */
/*------------------------------------------*/

packBody(X,N) :- libBody(X), insOBCS(X), needs('OBCS',X,Y), withes(X,N,Y).
packBody(X,N) :- libBody(X), insOBCS(X), lf0.
 
/*``packBody(X,N)``Tue May 15 17:03:33 MET DST 2001``*/
/* ODS DESCRIPTION  : */
/*-------------------*/

packBody(X,N) :- ifV1, /*(cf.ADA156)*/
	( childInBody(X) -> true;
		( insertDescr(X,N,'DOC11'), 
		  insertDescr(X,N,'DOC132'), 
		  insertDescr(X,N,'DOC133') ) ), 
	insertDescr(X,N,'DOC21'), 
	insertDescr(X,N,'DOC241'), 
	dashLine(N), lf0.
 
/*``packBody(X,N)``mardi, 23 juillet 1996, 11:50:04 MET DST``*/
/* BODY HEADER : */
/*---------------*/

packBody(X,N) :- sepChild(Z,X), isNesting(Z), insert(Z,N,'SEPARATE').
packBody(X,N) :- childUnit(X,L) -> insert(X,L,N,'BEGIN_BODY'); insert(X,N,'BEGIN_BODY').
 
/*``packBody(X,N)``Fri Aug  8 14:10:07 MET DST 1997``*/
/* USED PARENT UNIT RENAMING */
/*------------------------*/

packBody(X,N) :- renameUnits(X,N+1).
 
/*``packBody(X,N)``jeudi, 14 novembre 1996, 11:20:58 MET``*/
/* NESTED CHILD SPEC : */
/*---------------------*/

packBody(X,N) :- childInBody(X), childSpecs(X,N).
 
/*``packBody(X,N)``Mon Nov  3 16:50:31 MET 1997``*/
/* INTERNAL TYPES, CONSTANTS, OPS AND DATA : */
/*--------------------------------------*/

packBody(X,N) :- isTerm(X), intTyCoDaOp(X,N).
packBody(X,N) :- isTerm(X), rcs_Id(I), I \= '', insertRcsId(X,N+1,I).
 
/*``packBody(X,N)``jeudi, 14 novembre 1996, 15:16:04 MET``*/
/* INTERNAL EXCEPTIONS : */
/*-----------------------*/

packBody(X,N) :- isTerm(X), isInternal(U,'EXCEPTION',X), insertEx(X,N+1,U).
 
/*``packBody(X,N)``Mon Apr  8 18:40:54 MET DST 2002``*/
/* OBCS SPECIFICATION : */
/*----------------------*/

packBody(X,N) :- isTerm(X), oBCSInBody(X), oBCSSpec(X,N+1).
 /* (cf.ADA171) */
packBody(X,N) :- isCyclic(X), insertCyclicSpec(X,N+1).
packBody(X,N) :- isSporadic(X), insertSporadicSpec2(X,N+1).
 
/*``packBody(X,N)``Fri Jul 11 09:35:47 MET DST 1997``*/
/* TLD CONDITIONAL COMPILATION : */
/*--------------------------------*/

packBody(X,N) :- isTerm(X), hasIfOrIfOp(X), info(N,117).
packBody(X,N) :- isTerm(X), isInternal(U,'DATA',X), 
	if(X,O,U), insertDaOption2(X,N,U,O).
packBody(X,N) :- isTerm(X), isInternal(U,'OPERATION',X), notInit(X,U), 
	ifOp(X,O,U), insertOpOption2(X,N,U,O).
 
/*``packBody(X,N)``Tue May 15 17:05:47 MET DST 2001``*/
/* SEPARATE OPERATIONS BODY STUB : */
/*---------------------------------*/

packBody(X,N) :- isTerm(X), sepProvOp(X,U), hasBody(X,U), insertOperStub(X,N+1,U).
packBody(X,N) :- isTerm(X), sepIntOp(X,U), hasBody(X,U), insertOperStub(X,N+1,U). /*(cf.ADA126)*/
packBody(X,N) :- opControl(X,_,U,_), sepProvOp(X,U), insertOperStub(X,N+1,U). /*(cf.ADA136)*/
 
/*``packBody(X,N)``Tue May 15 17:43:29 MET DST 2001``*/
/* INSIDE OPERATIONS BODY : */
/*--------------------------*/

packBody(X,N) :- isTerm(X), insProvOp(X,U), hasBody(X,U), insertOperBody(X,N+1,U).
packBody(X,N) :- isTerm(X), insIntOp(X,U), hasBody(X,U), insertOperBody(X,N+1,U).
packBody(X,N) :- opControl(X,_,U,_), insProvOp(X,U), insertOperBody(X,N+1,U). /*(cf.ADA136)*/
packBody(X,N) :- isTerm(X), (isProvided(U,'TYPE',X);isInternal(U,'TYPE',X)), 
	isProtected(U,'TYPE',X), protectedOperBody(X,N+1,U).
packBody(X,N) :- isTerm(X), (isProvided(U,'TYPE',X);isInternal(U,'TYPE',X)), 
	isTask(U,'TYPE',X), taskTypeBody(X,N+1,U).
packBody(X,N) :- isTerm(X), isProvided(T,'TYPE',X), (
	( isTask(T,'TYPE',X), taskTypeOpers(X,T,O) );
	( isProtected(T,'TYPE',X), publicProtOpers(X,T,O) ) ),
	insertEntryCall(X,N+1,O,T). /*(cf.ADA105)(cf.ADA113)(cf.ADA147)*/
 
/*``packBody(X,N)``Tue Apr  9 14:06:16 MET DST 2002``*/
/* OBCS BODY : */
/*-------------*/

packBody(X,N) :- isTerm(X), sepOBCS(X), insertOBCSStub(X,N+1). /*(cf.ADA126)*/
packBody(X,N) :- isTerm(X), insOBCS(X), oBCSBody(X,N+1).
packBody(X,N) :- isTerm(X), oBCSInBody(X), isProvided(U,'OPERATION',X), 
	notInit(X,U), constrOp(X,U), oBCSEntrProcBody(X,N+1,U).
/* (cf.ADA171) */
packBody(X,N) :- isCyclic(X), insertCyclicBody(X,N+1).
packBody(X,N) :- isSporadic(X), insertSporadicBody(X,N+1).
packBody(X,N) :- isProtected(X), insertProtectedBody(X,N+1).
 
/*``packBody(X,N)``Tue May 15 17:44:20 MET DST 2001``*/
/* NESTED CHILD BODY : */
/*---------------------*/

packBody(X,N) :- isNesting(X), sepChild(X,Y), insertPackStub(X,N+1,Y).
packBody(X,N) :- isNesting(X), insChild(X,Y), $telling(F), packBody(Y,N+1,F).
packBody(X,N) :- isNesting(X), childInBody(X), isProvided(U,'OPERATION',X), 
	notInit(X,U), not(opControl(X,_,U,_)), entrProcBody(X,N+1,U). /*(cf.ADA136)*/
 
/*``packBody(X,N)``Tue Jul 17 17:09:52 MET DST 2001``*/
/* BODY FOOTER : */
/*---------------*/

packBody(X,N) :- ifTrace, listAll(X).
packBody(X,N) :- insertInitBloc(X,N).
packBody(X,N) :- childUnit(X,L) -> insert(X,L,N,'END_BODY'); insert(X,N,'END_BODY').
 
 
/*``packBody(X,N)``Tue May 15 17:44:41 MET DST 2001``*/
/* CLOSE BODY FILE : */
/*-------------------*/

packBody(X,N) :- libUnitBody(X), closeFile. /*(cf.ADA136)*/
 
/*``packBody(X,N)``Tue May 15 17:45:04 MET DST 2001``*/
/* SEPARATE SUBUNITS : */
/*---------------------*/

packBody(X,N) :- isTerm(X), sepProvOp(X,U), hasBody(X,U), sepOperBody(X,U).
packBody(X,N) :- isTerm(X), sepIntOp(X,U), hasBody(X,U), sepOperBody(X,U).
packBody(X,N) :- opControl(X,_,U,_), sepProvOp(X,U), sepOperBody(X,U). /*(cf.ADA136)*/
packBody(X,N) :- isTerm(X), sepOBCS(X), sepOBCSBody(X).
packBody(X,N) :- isNesting(X), sepChild(X,Y), packBody(Y,0).
 
/*``comments``jeudi,  5 dcembre 1996, 16:41:54 MET``*/
/***********************************************/
/**** P R O V   T Y P E S   L I B   U N I T ****/
/***********************************************/
 
/*``Ada units``Fri Aug  8 14:10:43 MET DST 1997``*/
/* libTypesSpec(X,Y) */

libTypesSpec(X,Y) :- not(openFile(X,'provided')), !.
libTypesSpec(X,Y) :- insertCom('NIL',_,X,0,'HeaderTxt').
libTypesSpec(X,Y) :- info(0,102), needs('TYPES',X,Z), withes(Y,0,Z).
libTypesSpec(X,Y) :- notNesting(X), isParent(X), info(0,103), implements('TYPES',Z,X), withes(Y,0,Z).
libTypesSpec(X,Y) :- info(0,106), insert(Y,0,'BEGIN_SPEC').
libTypesSpec(X,Y) :- renameUnit(X,1).
libTypesSpec(X,Y) :- libTyCo(X).
libTypesSpec(X,Y) :- insert(Y,0,'END_SPEC').
libTypesSpec(X,Y) :- closeFile.
 
/*``comments``jeudi,  5 dcembre 1996, 16:42:00 MET``*/
/*******************************************/
/**** I N S T A N C E   L I B   U N I T ****/
/*******************************************/
 
/*``Ada units``Fri Aug  8 14:10:54 MET DST 1997``*/
/* ancillarySpec(X,Y) */

ancillarySpec(X,Y) :- not(openFile(X,'provided')), !.
ancillarySpec(X,Y) :- insertCom('NIL',_,X,0,'HeaderTxt').
ancillarySpec(X,Y) :- info(0,102), needs('ANCILLARY',X,Z), withes(Y,0,Z).
ancillarySpec(X,Y) :- notNesting(X), isParent(X), info(0,103), implements('ANCILLARY',Z,X), withes(Y,0,Z).
ancillarySpec(X,Y) :- info(0,106), insert(Y,0,'BEGIN_SPEC').
ancillarySpec(X,Y) :- renameUnit(X,1).
ancillarySpec(X,Y) :- ancillaryTyCo(X,Y).
ancillarySpec(X,Y) :- ancillaryEx(X,U,Y), insertEx(X,1,U).
ancillarySpec(X,Y) :- ancillaryCoOp(X,U,Y), insertConstrOper(X,1,U).
ancillarySpec(X,Y) :- ancillaryUnOp(X,U,Y), insertUncstrOper(X,1,U).
ancillarySpec(X,Y) :- insert(Y,0,'END_SPEC').
ancillarySpec(X,Y) :- closeFile.
 
/*``Ada units``Tue May 15 16:55:00 MET DST 2001``*/
/* libInstPack(X) */

libInstPack(X) :- not(openFile(X,'spec')), !.
libInstPack(X) :- insertCom('NIL',_,X,0,'HeaderTxt'), lf0.
libInstPack(X) :- insertFile('NIL',_,X,0,'SpecHeader'), lf0. /*(cf.ADA161)*/
libInstPack(X) :- isInstance(X,I,C), instancePackage(X,I,C).
libInstPack(X) :- closeFile.
 
/*``Ada units``Thu Jul 10 15:23:38 MET DST 1997``*/
/* instancePackage(X,I,C) */

instancePackage(X,I,C) :- info(0,102), needs('INSTANCE',X,Y), withes(X,0,Y).
instancePackage(X,I,C) :- info(0,107), instanceSpec(X,0,I,C).
 
/*``comments``jeudi,  5 dcembre 1996, 16:42:05 MET``*/
/*******************************************/
/**** S E P A R A T E   S U B U N I T S ****/
/*******************************************/
 
/*``Ada units``Thu Mar 27 11:53:12 MET 2003``*/
/* sepOperBody(X,U) */

sepOperBody(X,U) :- not(openFile(X,'operations',U)), !.	
sepOperBody(X,U) :- insertCom('NIL',_,X,0,'HeaderTxt').
sepOperBody(X,U) :- insertFile(U,_,X,0,'SepHeader').
sepOperBody(X,U) :- info(0,102), 
	( opControl(X,Y,U,V) -> needs('OPERATION',V,Y,Z); needs('OPERATION',U,X,Z) ),
	withes(X,U,0,Z). /*(cf.ADA177)*/
sepOperBody(X,U) :- info(0,108), childUnit(X,L) -> /*(cf.ADA105)*/
	insert(X,L,0,'SEPARATE'); insert(X,0,'SEPARATE').
sepOperBody(X,U) :- insertOperBody(X,0,U).
sepOperBody(X,U) :- closeFile.
 
 
/*``Ada units``Thu Jul 10 15:25:23 MET DST 1997``*/
/* sepOBCSBody(X) */

sepOBCSBody(X) :- not(openFile(X,'obcs')), !.
sepOBCSBody(X) :- insertCom('NIL',_,X,0,'HeaderTxt').
sepOBCSBody(X) :- insertFile('NIL',_,X,0,'SepObcsHeader').
sepOBCSBody(X) :- info(0,102), needs('OBCS',X,Y), withes(X,'OBCS',0,Y).
sepOBCSBody(X) :- info(0,109), childUnit(X,L) -> 
	insert(X,L,0,'SEPARATE'); insert(X,0,'SEPARATE').
sepOBCSBody(X) :- oBCSBody(X,0).
sepOBCSBody(X) :- closeFile.
 
/*``comments``jeudi,  5 dcembre 1996, 16:42:16 MET``*/
/*****************/
/**** O B C S ****/
/*****************/
 
/*``OBCS``Tue Jul 17 17:10:21 MET DST 2001``*/
/* oBCSSpec(X,N) */

oBCSSpec(X,N) :- /*(cf.ADA169)*/
	( ifV1 ->  ( insertDescr(X,N,'NIL','ObcsTxt'), dashLine(N) ); 
	( ifCom -> insertCom('NIL',_,X,N,'ObcsTxt'); true ) ),
	( packageOBCS(X) -> packOBCSSpec(X,N); taskOBCSSpec(X,N) ).
 
/*``OBCS``Fri Feb 14 08:28:05 MET 2003``*/
/* oBCSBody(X,N) */

oBCSBody(X,N) :- /*(cf.ADA169), (cf.ADA176)*/
	( ( ifMoreHeaders, insOBCS(X) ) -> insertFile('NIL',_,X,N,'SepObcsHeader'); true ), 
	( ifV1 ->  ( insertDescr(X,N,'NIL','ObcsBodyTxt'), dashLine(N) );
	( ifCom -> insertCom('NIL',_,X,N,'ObcsTxt'); true ) ),
	( ifPseudo -> insertPseudo('NIL',_,X,N,'obcs'); true),
	( packageOBCS(X) -> packOBCSBody(X,N); taskOBCSBody(X,N) ).
 
/*``OBCS``Tue Jul 17 14:07:45 MET DST 2001``*/
/* packOBCSSpec(X,N) */

packOBCSSpec(X,N) :- /*(cf.ADA169)*/
	indent(N), write('package OBCS'), write(' is'), lf1, 
	isProvided(U,'OPERATION',X), notInit(X,U), 
	constrOp(X,U), insertEntranceProc(X,N+1,U).
packOBCSSpec(X,N) :- 
	indent(N), write('end OBCS'), write(';'), nl.
 
/*``OBCS``Tue Jul 17 14:08:02 MET DST 2001``*/
/* taskOBCSSpec(X,N) */

taskOBCSSpec(X,N) :- /*(cf.ADA143)*/
	storage(X,T,_,_) -> taskSpec(X,N,T); taskSpec(X,N,'OBCS').
taskOBCSSpec(X,N) :- storage(X,T,S,D), taskDecl(N,T,S,D).
taskOBCSSpec(X,N) :- servTask(X,Y), taskSpec(X,N,Y).
 
/*``OBCS``Tue May 15 17:46:25 MET DST 2001``*/
/* taskDecl(N,T,S,D) */

taskDecl(N,T,S,D) :- /*(cf.ADA143)*/
	( S \= 'no' -> 
		( indent(N), write('for '), write(T), write('''storage_size use '), write(S), write(';'), nl ); 
		true ),
	indent(N), write(D), write(' : '), write(T), write(';'), nl.
 
/*``OBCS``Tue Jul 17 14:08:24 MET DST 2001``*/
/* packOBCSBody(X,N) */

packOBCSBody(X,N) :- /*(cf.ADA135)(cf.ADA169)*/
	indent(N), write('package body OBCS'), write(' is'), lf1, 
	renameUnits(X,'OBCS',N+1),
	( keep('NIL','NIL',X,'obcs' ) ->
		insertFile('NIL','NIL',X,N+1,'obcs');
		insertCalls(X,N) ), lf0,
	indent(N), write('end OBCS'), write(';'), nl.
 
insertCalls(X,N) :-
	beginEmptyReverse(X,N,'NIL','obcs','ada::'),
	isProvided(U,'OPERATION',X), notInit(X,U),
	constrOp(X,U), insertOPCSCall(X,N+1,U), fail.
insertCalls(X,N) :-
	endEmptyReverse(N).
 
/*``OBCS``Tue Jul 17 14:09:13 MET DST 2001``*/
/* taskOBCSBody(X,N) */

taskOBCSBody(X,N) :- (storage(X,T,_,_) -> taskBody(X,N,T); taskBody(X,N,'OBCS')).
taskOBCSBody(X,N) :- servTask(X,Y), taskBody(X,N,Y). /*(cf.ADA143)*/
 
/*``comments``jeudi,  5 dcembre 1996, 16:42:42 MET``*/
/*****************************************/
/**** V I S I B I L I T Y   R U L E S ****/
/*****************************************/
 
/*``visibility``Mon Feb  2 19:24:29 MET 1998``*/
/* memezTra(A,B) */

memezTra(A,B) :- $name(A,L1), $name(B,L2), id(L1,L2).

notMemezTra(A,B) :- $name(A,L1), $name(B,L2), not(id(L1,L2)).

id([],[]) :- true.
id([E|L1],[F|L2]) :- ( E =:= F ; E =:= F-32 ; E-32 =:= F ), id(L1,L2).
 
/*``visibility``Tue May 15 18:23:05 MET DST 2001``*/
/* itIsMe(P) - notMe(P) */


notMe(P) :- P\='me', P\='Me', P\='mE', P\='ME'. /*(cf.ADA117)*/
itIsMe(P) :- memezTra(P,'me'). /*(cf.ADA117)*/
 
/*``visibility``mercredi, 27 novembre 1996, 11:01:02 MET``*/
/* modName(S,Y) */

modName(S,Y) :- $name(S,L), $reverse(L,R), findDot(R,Y).

findDot([46|R],Y) :- $reverse(R,L), $name(Y,L), !.
findDot([A|R],Y) :- findDot(R,Y).
 
/*``visibility``jeudi, 28 novembre 1996, 11:21:34 MET``*/
/* allReqs(U,X,Y,W) */

allReqs(U,X,Y,W) :- 
	requires(U,_,X,_,_,Y,W); 
	specialrequires(U,_,X,_,'to be withed',Y,W);
	specialrequires(U,_,X,Y,'to be withed','NIL',W);
	specialrequires(U,_,X,_,'enumeration',Y,W);
	otherReq(U,X,Y,W).

/*``visibility``Tue May 15 18:25:55 MET DST 2001``*/
/* otherReq(U,X,'SYSTEM',W) */

otherReq(U,X,'SYSTEM',W) :- isTerm(X),
	( address(X,U,V); interVect(X,U,V) ),
	not(requires(V,'CONSTANT',X,_,_,'SYSTEM',_)),
	( W='OpDecl'; W='DataDef' ).
 
/* otherReq(U,X,Y,_) */

otherReq(U,X,Y,_) :- attributes(U,X,_,_,Y,_); inherits(U,X,_,Y). /*(cf.ADA123)*/
 
/*``visibility``Tue Jul 17 15:19:08 MET DST 2001``*/
/* needs('SPEC',X,Y) */
/*-------------------------------------------------------*/
/* Visibility requirements for main unit specification : */
/*-------------------------------------------------------*/ 
/* (cf.ADA100), (cf.ADA140), (cf.ADA143), (cf.ADA149), (cf.ADA165) */

needs('SPEC',X,Y) :- allReqs(U,X,Y,W), (
	( isProvided(U,E,X), notAnc(U,X), nestTypes(X), 
		( W='TypeDecl'; W='TypeDef'; W='CstDecl'; W='CstDef'; 
		  W='OpDecl'; W='OpDefExt' ) );
	( isProvided(U,E,X), notAnc(U,X), libTypes(X,_),
		( W='TypeDef'; W='CstDef'; W='OpDecl'; W='OpDefExt' ) );
	( isInternal(U,E,X), neededForPrivate(U,E,X,[]), 
		( W='TypeDef2'; W='CstDef2' ) ) ).

needs('SPEC',X,Y) :- isNesting2(X), isProvided(U,_,X),
	implem(U,_,X,V,Z), allReqs(V,Z,Y,W), notAnc(U,X), nestTypes(X),
	(W='TypeDef'; W='CstDef'; (W='TypeDecl') ).

needs('SPEC',X,Y) :- storage(X,_,S,_), modName(S,Y).

needs('SPEC',X,Y) :- isProvided(U,'CONSTANT',X), 
	isImplementedBy(U,'CONSTANT',X,W,Z), 
	whichType(U,'CONSTANT',X,W,Z,Y,_).

needs('SPEC',X,'SYSTEM') :- priority(X,_). /*(cf.ADA165)*/
 
/*``visibility``Wed May 21 14:15:13 MET DST 2003``*/
/* needs('BODY',X,Y) */
/*----------------------------------------------*/
/* Visibility requirements for main unit body : */
/*----------------------------------------------*/
/* (cf.ADA130), (cf.ADA149) (cf.ADA170) (cf.ADA183) */
 
needs('BODY',X,Y) :- allReqs(U,X,Y,W), (
	( isInternal(U,_,X), 
		( W='TypeDef2'; W='CstDef2'; W='DataDef'; W='DataDef2'; 
		  W='OpDecl2'; W='OpDefExt' ) );
	( isInternal(U,'OPERATION',X), ifInit(X,U), W='OpDef' ) ).
 
/*``visibility``Wed Jul 18 10:50:19 MET DST 2001``*/
/* needs('OBCS',X,Y) */
/*----------------------------------------------*/
/* Visibility requirements for obcs unit body : */
/*----------------------------------------------*/
 
needs('OBCS',X,Y) :- allReqs(U,X,Y,W), /*(cf.ADA169)*/
	(W='SetState'; W='GetState'; W='Condition'; W='Exception'; W='obcs').
 
/*``visibility``vendredi, 15 novembre 1996, 14:33:01 MET``*/
/* needs('TYPES',X,Y) */
/*-------------------------------------------------------*/
/* Visibility requirements for type unit specification : */
/*-------------------------------------------------------*/
 
needs('TYPES',X,Y) :- allReqs(U,X,Y,W),
	isProvided(U,_,X), (W='TypeDef'; W='CstDef';
	(W='TypeDecl') ).
 
/*``visibility``Wed May 21 14:05:55 MET DST 2003``*/
/* needs('OPERATION',U,X,Y) */
/*--------------------------------------------------------*/
/* Visibility requirements for separate operations body : */
/*--------------------------------------------------------*/

needs('OPERATION',U,X,Y) :- allReqs(U,X,Y,'OpDef'). /*(cf.ADA183)*/
 
/*``visibility``vendredi, 15 novembre 1996, 17:14:15 MET``*/
/* needs('INSTANCE',X,Y) */
/*-----------------------------------------------------------*/
/* Visibility requirements for instance unit specification : */
/*-----------------------------------------------------------*/ 

needs('INSTANCE',X,Y) :- allReqs(_,X,Y,'InstPars'); isInstance(X,_,Y).
 
/*``visibility``vendredi, 15 novembre 1996, 17:15:11 MET``*/
/* needs('ANCILLARY',X,Y) */
/*-------------------------------------------------------*/
/* Visibility requirements for ancillary unit specification : */
/*-------------------------------------------------------*/ 

needs('ANCILLARY',X,Y) :- allReqs(U,X,Y,W),
	isProvided(U,E,X), ancillary(X,U,_), 
	(W='TypeDef'; W='CstDef'; W='OpDecl';
	(W='TypeDecl') ).
 
/*``visibility``jeudi, 28 novembre 1996, 18:24:50 MET``*/
/* implements(T,Y,X) */
/*-------------------------------*/
/* Visibility on child objects : */
/*-------------------------------*/

implements('SPEC',Y,X) :- isObject(Y,_,X), nestTypes(X), nestTypes(Y), imp1(X,Y).
implements('SPEC',Y,X) :- isObject(Y,_,X), libTypes(X,_), nestTypes(Y), imp2(X,Y).
implements('SPEC',Y,X) :- childObject(Y,X), nestTypes(X), libTypes(Y,_), imp2(X,Y).
implements('SPEC',Z,X) :- childObject(Y,X), nestTypes(X), libTypes(Y,Z), imp3(X,Y).
implements('SPEC',Y,X) :- childObject(Y,X), libTypes(X,_), libTypes(Y,_), imp2(X,Y).

implements('TYPES',Y,X) :- childObject(Y,X), nestTypes(Y), imp3(X,Y).
implements('TYPES',Z,X) :- childObject(Y,X), libTypes(Y,Z), imp3(X,Y).

implements('LIB_UNIT_TYPES',Z,X) :- childObject(Y,X), libTypes(Y,Z), imp3(X,Y).

implements('ANCILLARY',Y,X) :- childObject(Y,X), nestTypes(Y), imp3(X,Y).
implements('ANCILLARY',Y,X) :- childObject(Y,X), libTypes(Y,Z), imp3(X,Y).

imp1(X,T) :- isImplementedBy(U,_,X,V,Y), notHidden(X,U), ifAnc(U,X,V,Y,T).
imp2(X,T) :- isImplementedBy(U,E,X,V,Y), E\='TYPE', E\='CONSTANT', ifAnc(U,X,V,Y,T).
imp3(X,T) :- isImplementedBy(U,E,X,V,Y), (E='TYPE'; E='CONSTANT'), ifAnc(U,X,V,Y,T).

ifAnc(U,X,V,Y,T) :- notAnc(U,X), (ancillary(Y,V,Z) -> T=Z; T=Y).
 
/*``visibility``vendredi, 15 novembre 1996, 17:56:03 MET``*/
/* neededForPrivate(U,E,X,L) */

neededForPrivate(U,E,X,L) :- 
	requires(V,_,X,U,E,X,_), isPrivate(V,_,X), !.
neededForPrivate(U,E,X,L) :- 
	requires(V,F,X,U,E,X,_), isInternal(V,F,X),
	U\=V, not($member(V,L)), 
	neededForPrivate(V,F,X,[U|L]), !.

notInPrivSpec(U,E,X) :- not( neededForPrivate(U,E,X,[]) ).
 
/*``visibility``Tue Jul 17 15:20:11 MET DST 2001``*/
/* whichType(U,'CONSTANT',X,V,Y,O,T) */
/* (cf.ADA100), (cf.ADA159), (cf.ADA168) */

whichType(U,'CONSTANT',X,V,Y,O,T) :- 
	isImplementedBy(V,'CONSTANT',Y,W,Z) ->
		whichType(U,'CONSTANT',X,W,Z,O,T) ;
		( requires(V,'CONSTANT',Y,R,'TYPE',A,'CstDef') -> 
			( getType(R,A,Ob,Ty,X) -> ( O=Ob, T=Ty ); ( O=A, T=R) );
			( O='?', T='' ) ).

getType(R,Y,O,T,X) :- isImplementedBy(S,'TYPE',Z,R,Y) -> 
	( (Z=X) -> ( O=Z, T=S ); getType(S,Z,O,T,X) );
	( T=R, O=Y ).
 
/*``visibility``vendredi, 15 novembre 1996, 17:34:55 MET``*/
/* implem(U,E,X,V,Y) */
/*-----------------------------------*/
/* recursive implemented_by link */
/*-----------------------------------*/

implem(U,E,X,V,Y) :- 
	isImplementedBy(U,E,X,I,A) ->
	( implem(I,E,A,J,B) -> (V=J, Y=B); (V=I, Y=A) );
	( V=U, Y=X ).
 
/*``visibility``Tue Jul 17 15:20:48 MET DST 2001``*/
/* nestPrivTyCo(X,N) */
/*----------------------------*/
/* nested private types dependencies */
/*----------------------------*/
/* (cf.ADA123), (cf.ADA145), (cf.ADA154), (cf.ADA166) */

nestPrivTyCo(X,N) :- 
	isProvided(U,E,X), notAnc(U,X), not(inNestPr(U,X)), implem(U,E,X,V,Y),
	isPrivate(V,_,Y),
 	( U = V ->
		putNestPrTyCo(V,Y,N,X);
		message('*** component : ',U,' of : ',X,' should not be renamed (INCLUDE scheme)') ).

putNestPrTyCo(U,X,N,P) :- $assert(inNestPr(U,P)), hasNestPrReq(U,X,V,Y,P),
	( ifTrace -> ( begCom, write(U), tab, write(V), endCom ); true ),
	putNestPrTyCo(V,Y,N,P).
putNestPrTyCo(U,X,N,P) :- 
	( ifTrace -> ( begCom, write(U), endCom ); true ),
	( 
	  ( isInternal(U,'TYPE',X); isPrivate(U,'TYPE',X) ) -> insertType(X,N+1,U);
	  ( isInternal(U,'CONSTANT',X); isPrivate(U,'CONSTANT',X) ) -> insertConst(X,N+1,U)
	).

hasNestPrReq(U,X,V,Y,P) :- 
	(
		( requires(U,_,X,V,F,Y,W), (F='TYPE';F='CONSTANT'), (W='TypeDef';W='TypeDef2';W='CstDef';W='CstDef2') );
		( ( attributes(U,X,_,T,Y,_); inherits(U,X,T,Y) ), T \= '', isProvided(V,'TYPE',Y), memezTra(T,V) )
	),
	isChild(Y,P), notInst(Y), notAnc(V,X), U\=V, not(inNest(V,P)), not(inNestPr(V,P)).
 
/*``visibility``Tue Jul 17 15:21:17 MET DST 2001``*/
/* nestTyCo(X,N) */
/*-------------------------------------------*/
/* nested types and constants dependencies */
/*-------------------------------------------*/
/* (cf.ADA123), (cf.ADA145), (cf.ADA154), (cf.ADA166) */

nestTyCo(X,N) :- 
	isProvided(U,E,X), notAnc(U,X), not(inNest(U,X)), implem(U,E,X,V,Y),
	( U = V ->
		putNestTyCo(V,Y,N,X);
		message('*** component : ',U,' of : ',X,' should not be renamed (INCLUDE scheme)') ).

putNestTyCo(U,X,N,P) :- $assert(inNest(U,P)), hasNestReq(U,X,V,Y,P),
	( ifTrace -> ( begCom, write(U), tab, write(V), endCom ); true ),
	putNestTyCo(V,Y,N,P).
putNestTyCo(U,X,N,P) :- 
	( ifTrace -> ( begCom, write(U), endCom ); true ),
	(
	  isPrivate(U,'TYPE',X) -> insertTypeDecl(X,N+1,U);
	  isVisible(U,'TYPE',X) -> insertType(X,N+1,U);
	  isPrivate(U,'CONSTANT',X) -> insertConstDecl(X,N+1,U);
	  isVisible(U,'CONSTANT',X) -> insertConst(X,N+1,U) 
	).

hasNestReq(U,X,V,Y,P) :- 
	( 
	  ( requires(U,_,X,V,F,Y,W), (F='TYPE';F='CONSTANT'), (W='TypeDecl';W='CstDecl';W='TypeDef';W='CstDef') );
	  ( ( attributes(U,X,_,T,Y,_); inherits(U,X,T,Y) ), T \= '', isProvided(V,'TYPE',Y), memezTra(T,V) )
	),
	isChild(Y,P), notInst(Y), notAnc(V,X), U\=V, not(inNest(V,P)).
 
/*``visibility``Tue Jul 17 15:21:47 MET DST 2001``*/
/* ancillaryTyCo(X,Y) */
/*-------------------------------------------*/
/* ancillary types and constants dependencies */
/*-------------------------------------------*/
/* (cf.ADA123), (cf.ADA145), (cf.ADA154), (cf.ADA166) */

ancillaryTyCo(X,Y) :- 
	isProvided(U,E,X), ancillary(X,U,Y), not(inAnc(U,Y)), (E='TYPE';E='CONSTANT'),
	putAncTyCo(U,X,Y).

putAncTyCo(U,X,Y) :- $assert(inAnc(U,Y)), hasAncReq(U,X,V,Y),
	( ifTrace -> ( begCom, write(U), tab, write(V), endCom ); true ),
	putAncTyCo(V,X,Y).
putAncTyCo(U,X,Y) :- 
	( ifTrace -> ( begCom, write(U), endCom ); true ),
	( 
	  isVisible(U,'TYPE',X) -> insertType(X,1,U);
	  isVisible(U,'CONSTANT',X) -> insertConst(X,1,U) 
	).

hasAncReq(U,X,V,Y) :- 
	( 
	  ( requires(U,_,X,V,F,X,W), (F='TYPE';F='CONSTANT'), (W='TypeDecl';W='CstDecl';W='TypeDef';W='CstDef') );
	  ( ( attributes(U,X,_,T,'NIL',_); inherits(U,X,T,'NIL') ), T \= '', isProvided(V,'TYPE',X), memezTra(T,V) ) 
	),
	isProvided(V,_,X), ancillary(X,V,Y), not(inAnc(V,Y)), U\=V.
 
/*``visibility``Tue Jul 17 15:22:21 MET DST 2001``*/
/* libTyCo(X) */
/*-------------------------------------------*/
/* library unit types and constants dependencies */
/*-------------------------------------------*/
/* (cf.ADA123), (cf.ADA145), (cf.ADA154), (cf.ADA166) */

libTyCo(X) :- 
	isProvided(U,E,X), notAnc(U,X), not(inLib(U,X)), (E='TYPE';E='CONSTANT'),
	putLibTyCo(U,X).

putLibTyCo(U,X) :- $assert(inLib(U,X)), hasLibReq(U,X,V),
	( ifTrace -> ( begCom, write(U), tab, write(V), endCom ); true ),
	putLibTyCo(V,X).
putLibTyCo(U,X) :- 
	( ifTrace -> ( begCom, write(U), endCom ); true ),
	(
	  isVisible(U,'TYPE',X) -> insertType(X,1,U);
	  isVisible(U,'CONSTANT',X) -> insertConst(X,1,U)
	).

hasLibReq(U,X,V) :- 
	( 
	  ( requires(U,_,X,V,F,X,W), (F='TYPE';F='CONSTANT'), (W='TypeDecl';W='CstDecl';W='TypeDef';W='CstDef') );
	  ( ( attributes(U,X,_,T,'NIL',_); inherits(U,X,T,'NIL') ), T \= '', isProvided(V,'TYPE',X), memezTra(T,V) ) 
	),
	notAnc(V,X), U\=V, not(inLib(V,X)).
 
/*``visibility``Tue Jul 17 15:22:58 MET DST 2001``*/
/* provTyCo(X,N) */
/*-------------------------------------------*/
/* provided types and constants dependencies */
/*-------------------------------------------*/
/* (cf.ADA123), (cf.ADA142), (cf.ADA145), (cf.ADA154), (cf.ADA166), (cf.ADA187) */

provTyCo(X,N) :- 
	isProvided(U,E,X), notAnc(U,X), not(inSpec(U,X)), (E='TYPE';E='CONSTANT'),
	putProvTyCo(U,X,N).

putProvTyCo(U,X,N) :- $assert(inSpec(U,X)), hasProvReq(U,X,V), 
	( ifTrace -> ( begCom, write(U), tab, write(V), endCom ); true ),
	putProvTyCo(V,X,N).
putProvTyCo(U,X,N) :- 
	( ifTrace -> ( begCom, write(U), endCom ); true ),
	(
	  isPrivate(U,'TYPE',X) -> insertTypeDecl(X,N+1,U);
	  isVisible(U,'TYPE',X) -> insertType(X,N+1,U);
	  isPrivate(U,'CONSTANT',X) -> insertConstDecl(X,N+1,U);
	  isVisible(U,'CONSTANT',X) -> insertConst(X,N+1,U)
	 ).

hasProvReq(U,X,V) :- 
	( 
		( requires(U,_,X,V,F,X,W), (F='TYPE';F='CONSTANT'), 
			( isPrivate(U,_,X) ->  (W='CstDecl';W='TypeDecl'); (W='TypeDef';W='CstDef') ) );
	 	( ( ( isVisible(U,'TYPE',X), attributes(U,X,_,T,'NIL',_) ); inherits(U,X,T,'NIL') ), 
	 		T \= '', isProvided(V,'TYPE',X), memezTra(T,V) );
	 	( ( interVect(X,O,V); address(X,O,V) ), taskTypeOpers(X,U,O) ) 
	),
	notAnc(V,X), U\=V, not(inSpec(V,X)).
 
/*``visibility``Tue Jul 17 15:23:47 MET DST 2001``*/
/* privTyCo(X,N) */
/*----------------------------*/
/* private types dependencies */
/*----------------------------*/
/* (cf.ADA123), (cf.ADA134), (cf.ADA145), (cf.ADA152), (cf.ADA154), (cf.ADA166) */

privTyCo(X,N) :-
        isPrivate(U,_,X), not(inPriv(U,X)), putPrivTyCo(U,X,N).

putPrivTyCo(U,X,N) :- $assert(inPriv(U,X)), hasPrivReq(U,X,V),
	( ifTrace -> ( begCom, write(U), tab, write(V), endCom ); true ),
	putPrivTyCo(V,X,N).
putPrivTyCo(U,X,N) :- 
	( ifTrace -> ( begCom, write(U), endCom ); true ),
	( 
	  ( isInternal(U,'TYPE',X); isPrivate(U,'TYPE',X) ) ->  insertType(X,N+1,U) ;
	  ( isInternal(U,'CONSTANT',X); isPrivate(U,'CONSTANT',X) ) ->  insertConst(X,N+1,U);
	  isInternal(U,'OPERATION',X) -> insertUncstrOper(X,N+1,U)
	).

hasPrivReq(U,X,V) :- 
	( 
		( requires(U,_,X,V,F,X,W), (F='TYPE';F='CONSTANT';F='OPERATION'), 
			(W='TypeDef';W='TypeDef2';W='CstDef';W='CstDef2';W='OpDecl2') );
		( ( attributes(U,X,_,T,'NIL',_); inherits(U,X,T,'NIL') ), T \= '', 
			( isPrivate(V,'TYPE',X); isInternal(V,'TYPE',X) ), memezTra(T,V) )
	),
	notAnc(V,X), U\=V, not(inSpec(V,X)), not(inPriv(V,X)).
 
/*``visibility``Tue Jul 17 15:24:15 MET DST 2001``*/
/* intTyCo(X,N) */
/*-------------------------------------------*/
/* internal types and constants dependencies */
/*-------------------------------------------*/
/* (cf.ADA123), (cf.ADA145), (cf.ADA154), (cf.ADA166) */

intTyCo(X,N) :-
      isInternal(U,E,X), not(inPriv(U,X)), not(inInt(U,X)), (E='TYPE';E='CONSTANT'),
	putIntTyCo(U,X,N).

putIntTyCo(U,X,N) :- $assert(inInt(U,X)), hasIntReq(U,X,V),
	( ifTrace -> ( begCom, write(U), tab, write(V), endCom ); true ),
	putIntTyCo(V,X,N).
putIntTyCo(U,X,N) :- 
	( ifTrace -> ( begCom, write(U), endCom ); true ),
	(
	  isInternal(U,'TYPE',X) -> insertType(X,N+1,U);
	  isInternal(U,'CONSTANT',X) -> insertConst(X,N+1,U) 
	).

hasIntReq(U,X,V) :- 
	( 
		( requires(U,_,X,V,F,X,W), (F='TYPE';F='CONSTANT'), (W='TypeDef2';W='CstDef2'; (W='TypeDef'; W='CstDef') ) );
		( ( attributes(U,X,_,T,'NIL',_); inherits(U,X,T,'NIL') ), T \= '', isInternal(V,'TYPE',X), memezTra(T,V), F='TYPE' )
	),	
	notAnc(V,X), U\=V, not(isProvided(V,F,X)), not(inInt(V,X)).
 
/*``visibility``Fri Apr  5 17:59:17 MET DST 2002``*/
/* intTyCoDaOp(X,N) */
/*-------------------------------------------*/
/* internal types, constants, data and operations dependencies */
/*-------------------------------------------*/
/* (cf.ADA114), (cf.ADA115), (cf.ADA123), (cf.ADA145), (cf.ADA154), 
(cf.ADA155), (cf.ADA166) (cf.ADA171) */

intTyCoDaOp(X,N) :- ( hidden(X,U);
	( isInternal(U,E,X), not(inPriv(U,X)), not(inInt(U,X)), 
	(E='TYPE';E='CONSTANT';E='OPERATION';E='DATA'), 
	notInProtType(X,U), notInit(X,U), isNotThread(X,U) )), 
	putIntTyCoDaOp(U,X,N).

putIntTyCoDaOp(U,X,N) :- $assert(inInt(U,X)), hasIntReq2(U,X,V), 
	( ifTrace -> ( begCom, write(U), tab, write(V), endCom ); true ),
	putIntTyCoDaOp(V,X,N).
putIntTyCoDaOp(U,X,N) :- 
	( ifTrace -> ( begCom, write(U), endCom ); true ),
	( 
	  isInternal(U,'TYPE',X) -> insertType(X,N+1,U);
	  isInternal(U,'CONSTANT',X) -> insertConst(X,N+1,U);
	  isInternal(U,'DATA',X) -> insertData(X,N+1,U);
	  isInternal(U,'OPERATION',X) -> insertUncstrOper(X,N+1,U);
	  hidden(X,U) ->  insertUncstrOper(X,N+1,U)
	).

hasIntReq2(U,X,V) :- 
	( 
		( requires(U,_,X,V,F,X,W), (F='TYPE';F='CONSTANT';F='OPERATION';F='DATA'), 
		( W='CstDef2';W='DataDef';W='TypeDef2';W='OpDecl2';W='OpDefExt'; /* comp v3 : */ W='TypeDef';W='CstDef' ) );
	  	( ( attributes(U,X,_,T,'NIL',_); inherits(U,X,T,'NIL') ), T \= '', isInternal(V,'TYPE',X), memezTra(T,V), F='TYPE' ) 
	),	
	notAnc(V,X), U\=V, not(isProvided(V,F,X)), not(inInt(V,X)), not(inPriv(V,X)),
	notInProtType(X,V), notInit(X,V).
 
/*``visibility``Tue Jul 17 15:25:10 MET DST 2001``*/
/* formTyCo(X,N) */
/*-------------------------------------------*/
/* formal types and constants dependencies */
/*-------------------------------------------*/
/* (cf.ADA166) */

formTyCo(X,N) :-
	formalParameter(U,E,X), not(inForm(U,X)), (E='TYPE';E='CONSTANT'),
	putFormTyCo(U,X,N).

putFormTyCo(U,X,N) :- $assert(inForm(U,X)), hasFormReq(U,X,V),
	( ifTrace -> ( begCom, write(U), tab, write(V), endCom ); true ),
	putFormTyCo(V,X,N).
putFormTyCo(U,X,N) :- 
	( ifTrace -> ( begCom, write(U), endCom ); true ),
	( 
	  formalParameter(U,'TYPE',X) -> insertFormType(X,N+1,U);
	  formalParameter(U,'CONSTANT',X) -> insertFormConst(X,N+1,U) 
	).

hasFormReq(U,X,V) :- requires(U,_,'FORMAL_PARAMETERS',V,F,'FORMAL_PARAMETERS',W), 
	U\=V, (F='TYPE';F='CONSTANT'), 
	not(inForm(V,X)), (W='TypeDef';W='CstDef'; (W='TypeDecl';W='CstDef1') ).
 
/*``visibility``Tue Jul 17 15:25:24 MET DST 2001``*/
/* listAll(X) */
/* (cf.ADA166) */

listAll(X) :- write('-- in public Spec:'), nl, inSpec(U,X), tab, begCom, write(U), endCom.
listAll(X) :- write('-- in private Spec:'), nl, inPriv(U,X), tab, begCom, write(U), endCom.
listAll(X) :- write('-- in Body:'), nl, inInt(U,X), tab, begCom, write(U), endCom.
 
/*``visibility``Wed Apr  9 18:12:03 MET DST 2003``*/
/* childSpecs(X,N) */
/*-----------------------------------*/
/* nested child specs dependencies */
/*-----------------------------------*/
/* (cf.ADA166) */

childSpecs(X,N) :- nestChild(X,Y), not(inParent(X,Y)), insertChild(X,N,Y).

insertChild(X,N,Y) :- $assert(inParent(X,Y)), hasReqChild(X,Y,Z), 
	( ifTrace -> ( begCom, write(Y), tab, write(Z), endCom ); true ),
	insertChild(X,N,Z).
insertChild(X,N,Y) :- 
	( ifTrace -> ( begCom, write(Y), endCom ); true ),
	insertPackSpec(Y,N).

hasReqChild(X,Y,Z) :- nestChild(X,Z), Y\=Z, not(inParent(X,Z)), reqChild(Y,Z).

reqChild(Y,Z) :- ( needs('SPEC',Y,Z); needs('INSTANCE',Y,Z) ), !. /*(cf.ADA178)*/
 
/*``Ada units``Thu Apr  4 12:26:39 MET DST 2002``*/
/* insertPackSpec(X,N) */

insertPackSpec(X,N) :- ( inst(X) ->
	( isInstance(X,I,C), instanceSpec(X,N+1,I,C) );
	( packSpec(X,N+1) ) ), fail.
insertPackSpec(X,N).
 
/*``Ada units``Wed Apr 10 16:37:52 MET DST 2002``*/
/* rtattPack(X,N) */
/* (cf.ADA171) */

rtattPack(X,N) :- not(openFile(X,'rtatt')), !.
rtattPack(X,N) :- insertCom('NIL',_,X,N,'HeaderTxt').
rtattPack(X,N) :- 
	write('with SYSTEM; use SYSTEM;'), nl, 
	write('with RTA; use RTA;'), nl, 
	write('with Ada.Real_Time; use Ada.Real_Time;'), nl, 
 	write('package '), write(X), write('_RTATT is'), nl, 
	( isProvided(O,'OPERATION',X); isInternal(O,'OPERATION',X ) ), O \= 'thread', 
	indent(N+1), write(O), write(' : constant array(SYSTEM_WIDE_MODE) of OPERATION_ATTRIBUTES := '), nl, 
	indent(N+2), write('( others => ( '), nl, 
	indent(N+3), write('BUDGET => To_Time_Span('), ( hrtBudget(X,O,_,B) -> writeDuration(B); write('0.0') ), write('),'), nl, 
	indent(N+3), write('WCET => To_Time_Span('), ( hrtWcet(X,O,_,W) -> writeDuration(W); write('0.0') ), write(') ) );'), nl, fail.
rtattPack(X,N) :- ( isCyclic(X); isSporadic(X); isProtected(X) ),
	indent(N+1), write('CEILING : constant array(SYSTEM_WIDE_MODE) of PRIORITY := '), nl, 
	indent(N+2), write('( others => '), ( hrtCeilingPriority(X,_,C) -> write(C); write('0') ), write(' );'), nl, 
	indent(N+1), write('INITIAL_CEILING_PRIORITY : constant PRIORITY := CEILING(START_MODE);'), nl, fail.
rtattPack(X,N) :- ( isCyclic(X); isSporadic(X) ),
	indent(N+1), write('THREAD : constant array(SYSTEM_WIDE_MODE) of THREAD_ATTRIBUTES := '), nl, 
	indent(N+2), write('( others => ( '), nl, 
	indent(N+3), write('PRI => '), ( hrtPriority(X,_,P) -> write(P); write('0') ), write(','), nl, 
	indent(N+3), write('TRANS => To_Time_Span('), ( hrtTransformation(X,_,T) -> writeDuration(T); write('0.0') ), write('),'), nl, 
	indent(N+3), write('IMP => '), ( hrtImportance(X,_,I) -> write(I); write('soft') ), write(','), nl,
	indent(N+3), write('DEADLINE => To_Time_Span('), ( hrtDeadline(X,_,D) -> writeDuration(D); write('0.0') ), write('),'), nl, 
	indent(N+3), write('BUDGET => To_Time_Span('), ( hrtBudget(X,'thread',_,B) -> writeDuration(B); write('0.0') ), write('),'), nl, 
	indent(N+3), write('WCET => To_Time_Span('), ( hrtWcet(X,'thread',_,W) -> writeDuration(W); write('0.0') ), write(') ) );'), nl, 
	indent(N+1), write('INITIAL_THREAD_PRIORITY : constant PRIORITY := THREAD(START_MODE).PRI;'), nl, fail.
rtattPack(X,N) :- isCyclic(X),
	indent(N+1), write('PERIOD : constant array(SYSTEM_WIDE_MODE) of TIME_SPAN := '), nl, 
	indent(N+2), write('( others => To_Time_Span('), ( hrtPeriod(X,_,Q) -> writeDuration(Q); write('0.0') ), write(') );'), nl, 
	indent(N+1), write('OFFSET : constant array(SYSTEM_WIDE_MODE) of TIME_SPAN := '), nl, 
	indent(N+2), write('( others => To_Time_Span('), ( hrtOffset(X,_,O) -> writeDuration(O); write('0.0') ), write(') );'), nl, fail.
rtattPack(X,N) :- isSporadic(X),
	indent(N+1), write('MAT : constant array(SYSTEM_WIDE_MODE) of TIME_SPAN := '), nl, 
	indent(N+2), write('( others => To_Time_Span('), ( hrtMinArrivalTime(X,_,M) -> writeDuration(M); write('0.0') ), write(') );'), nl, 
	indent(N+1), write('MAF : constant array(SYSTEM_WIDE_MODE) of FREQUENCY := '), nl, 
	indent(N+2), write('( others => ( '), nl, 
	indent(N+3), write('NUMBER => '), ( hrtMaxArrivalFrequency(X,_,N) -> write(N); write('1') ), write(','), nl, 
	indent(N+3), write('IN_PERIOD => To_Time_Span('), ( hrtMinArrivalTime(X,_,M) -> writeDuration(M); write('1.0') ), write(') ) );'), nl, fail.
rtattPack(X,N) :- write('end '), write(X), write('_RTATT;'), nl, fail.
rtattPack(X,N) :- closeFile.
 
/*``visibility``jeudi, 21 novembre 1996, 16:46:52 MET``*/
/* insertReqInt(X,N) */
/*--------------------*/
/* required interface */
/*--------------------*/

insertReqInt(X,N) :- reqInt(X,N,'OPERATION').
insertReqInt(X,N) :- reqInt(X,N,'EXCEPTION').
insertReqInt(X,N) :- reqInt(X,N,'TYPE').
insertReqInt(X,N) :- reqInt(X,N,'CONSTANT').
insertReqInt(X,N) :- reqInt(X,N,'DATA').

reqInt(X,N,E) :- begCom, indent(N+1), write('Required '), write(E), write(' :'),
	( requires(_,_,X,_,E,Y,_), Y\=X ) -> endCom; ( write(' NONE'), endCom ).
reqInt(X,N,E) :- isProvided(U,E,Y), reqs(X,U,E,Y), insertReq(X,N,U,E,Y).

reqs(X,U,E,Y) :- requires(_,_,X,U,E,Y,_), not(memezTra(X,Y)), !.

insertReq(X,N,U,E,Y) :- begCom, indent(N+2), write(E), write(' : '), 
	write(U), write(' of object : '), write(Y), endCom, !.
/*``comments``jeudi,  5 dcembre 1996, 16:42:49 MET``*/
/*******************************************/
/**** E X T R A C T I O N   T U N I N G ****/
/*******************************************/
 
/*``tuning``Fri Feb 14 08:29:12 MET 2003``*/
/* general characteristics */
/* (cf.ADA110), (cf.ADA118), (cf.ADA121), (cf.ADA150), (cf.ADA156) */

fullExtraction :- not(extractObcs(_,_)).
templateOBCS :- ( extractObcs(_,_); extractObcs(_,_,_,_,_) ), !.
keep(U,E,X,W) :- file(U,E,X,_,W), 
	not(pragma_overwrite(X,U)), 
	not(pragma_overwrite(X,'*')),
	not(pragma_overwrite(X,'obcs')).
ifCom :- pragma_comment(_), !.
ifV1 :- pragma_verbose(_,1), !.
indent(N) :- pragma_no_indent(_) -> true; 
	( ( pragma_indent_width(_,W) -> I is W; I is 2 ), T is N * I, $tab(T) ).
lineWidth(W) :- pragma_line_width(_,L) -> W is L - 10; W is 70.
ifPseudo :- pragma_insert_pseudo(_), !.
cutLine(X,N,U) :- 
	( pragma_cut_line(X,U);  pragma_cut_line(X,'*') ) -> 
	( nl, indent(N+1) ); true.
lf0 :- pragma_line_feed(_,1) -> nl; true.
lf1 :- nl, lf0.
lf2(N) :- pragma_line_feed(_,2) -> ( nl, indent(N) ); true.
ifEnd :- not(pragma_no_end_op(_)).
ifBeg :- not(extractObcs(_,_)), not(pragma_no_begin(_)).
ifGnat(O) :- ( pragma_apse(_,A,O); pragma_compiler(_,A,O) ), memezTra(A,'gnat'), !. /*(cf.ADA174)*/
ifAlsys(O) :- ( pragma_apse(_,A,O); pragma_compiler(_,A,O) ), memezTra(A,'alsys'), !. /*(cf.ADA174)*/
ifApex(O) :- ( pragma_apse(_,A,O); pragma_compiler(_,A,O) ), memezTra(A,'apex'), !. /*(cf.ADA174)*/
ifTld(O) :- ( pragma_apse(_,A,O); pragma_compiler(_,A,O) ), memezTra(A,'tld'), !. /*(cf.ADA174)*/
ifAonix(O) :- ( pragma_apse(_,A,O); pragma_compiler(_,A,O) ), memezTra(A,'aonix'), !. /*(cf.ADA174)*/
ifTartan(O) :- ( pragma_apse(_,A,O); pragma_compiler(_,A,O) ), memezTra(A,'tartan'), !. /*(cf.ADA174)*/
ifLowerCase :- pragma_lower_case(_), !.
ifTrace :- pragma_trace(_), !.
hasIf(X) :- pragma_if(X,_,_), !.
hasIfOrIfOp(X) :- ( pragma_if(X,_,_); pragma_if_op(X,_,_) ), !.
if(X,O,U) :- ( pragma_if(X,O,U); pragma_if(X,O,'*') ),!.
ifOp(X,O,U) :- ( pragma_if_op(X,O,U); pragma_if_op(X,O,'*') ),!.
address(X,U,V) :- pragma_address_clause(X,U,V).
if95 :- not(pragma_no_Ada95(_)).
reverseOption(1) :- pragma_reverse(_), !. /*(cf.ADA174)*/
reverseOption(2) :- pragma_reverse(_), !. /*(cf.ADA174)*/
reverseOption(V) :- pragma_reverse(_,V), !.
ifInit(X,U) :- pragma_init_bloc(X,O), memezTra(U,O), !.
notInit(X,U) :- not(ifInit(X,U)).
dataPage(X,P) :- pragma_data_page(X,P) -> true; ( ifTartan(_), P='NO_PAGE' ).
ifSkipper :- pragma_skipper(_), !.
noSep :- pragma_no_subunits(_), !. /*(cf.ADA174)*/
ifMoreHeaders :- pragma_more_headers(_), !. /*(cf.ADA176)*/
 
/*``tuning``Fri Apr  5 16:27:17 MET DST 2002``*/
/* objects types */
/* (cf.ADA113) */

isTerm(X) :- not(isObject(_,_,X)).
isParent(X) :- isObject(_,_,X), !.
isChild(C,P) :- ( isObject(C,_,P), ! ); ( isObject(C,_,D), isChild(D,P) ).
childObject(X,Y) :- isObject(X,T,Y), T\='OP_CONTROL'.
isGeneric(X) :- ( 
	isRootObject(Y,'CLASS') /* HOOD3 */;
	isRootObject(Y,'GENERIC',_) /* HOOD4 */ ), memezTra(X,Y), !.
opControl(X,Y,U,V) :- isObject(Y,'OP_CONTROL',X), 
	isImplementedBy(U,'OPERATION',X,V,Y,1).
inst(X) :- isInstance(X,_,_), !.
notInst(X) :- not(isInstance(X,_,_)).
isRoot(X) :- isRootObject(Y,_), memezTra(X,Y), !.
isDescendant(Y,X) :- isObject(Y,_,_), isChild(Y,X).
isActive(X) :- (
	isObject(X,'ACTIVE',_); 
	isConstrained(_,'OPERATION',X,'HSER',_);
	isConstrained(_,'OPERATION',X,'LSER',_);
	isConstrained(_,'OPERATION',X,'ASER',_) ), !.

/* (cf.ADA171) */
isHRT :- isObject(_,K,_),
	( K='CYCLIC'; K='SPORADIC'; K='PROTECTED' ), !.
isCyclic(X) :- isObject(X,'CYCLIC',_), isTerm(X).
isSporadic(X) :- isObject(X,'SPORADIC',_), isTerm(X).
isProtected(X) :- isObject(X,'PROTECTED',_), isTerm(X).
 
/*``tuning``Mon May 26 09:13:19 MET DST 2003``*/
/* objects characteristics : */
/* (cf.ADA105), (cf.ADA107), (cf.ADA115), (cf.ADA120), (cf.ADA136), (cf.ADA138) */

libUnit(X) :- extract(_,_,X,_,_), libSpec(X), not(pragma_except(X)), !. /*(cf.ADA188)*/
libUnitBody(X) :- extract(_,_,X,_,_), libBody(X), not(pragma_except(X)), !. /*(cf.ADA188)*/

hasBody(X) :- ( ( isTerm(X), notInst(X), notEmptyBody(X) ); isNesting(X); main(X,_,_); opControl(X,_,_,_) ), !.
notEmptyBody(X) :- ( isInternal(_,_,X); 
	( isProvided(U,'OPERATION',X), not(isAbstract(U,'OPERATION',X)), not(isInherited(U,X)) ) ), !.

hasOBCS(X) :- 
	isConstrained(U,_,X,C,_), 
	not(pragma_no_constraints(X)),
	notHidden(X,U), 	
	not(hasTaskType(X)),
	not(hasProtectedType(X)), 
	/* (cf.ADA171) */
	not(isCyclic(X)), 
	not(isSporadic(X)),
	not(isProtected(X)), !.

hasTaskType(X) :- 
	( isProvided(U,'TYPE',X); isInternal(U,'TYPE',X) ),
	isTask(U,'TYPE',X), !.

hasProtectedType(X) :-
	( isProvided(U,'TYPE',X); isInternal(U,'TYPE',X) ),
	isProtected(U,'TYPE',X), !.

hasPrivate(X) :- isPrivate(_,_,X), !.
hasNestedPrivate(X) :- isProvided(U,E,X), implem(U,E,X,V,Y), 
	isPrivate(V,E,Y), !.
nestTypes(X) :- not(pragma_lib_unit_types(X,_)).
libTypes(X,Y) :- pragma_lib_unit_types(X,Y).
main(X,U,M) :- isCurrentRoot(X), pragma_main(X,U,M), !.

parent(X,Y) :- not(pragma_not_child_unit(X)), 
	( ( inherits(_,X,V,Z), Z\='NIL', implem(V,'TYPE',Z,_,T) ) -> 
		Y=T;
		 uses(X,Y,'TYPE',2) ).
childUnit(X,L) :- isTerm(X), if95, notNested(X), parent(X,Y), superClasses(Y,[Y],L). /*(cf.ADA179)*/
superClasses(Y,L1,L2) :- parent(Y,Z) -> superClasses(Z,[Z|L1],L2); L2=L1.

/* (cf.ADA184) */
renames(X,U,[W]) :- pragma_with(X,U,W), 
	notMemezTra(X,U), notMemezTra(U,W), U \='no', W \='no', !.
renames(X,[Y]) :- pragma_renames(X,Y).

use(X,Y) :- pragma_used(Y); pragma_using(X,Y).

ancillary(X,U,Y) :- pragma_ancillary(X,U,Y), !.
notAnc(U,X) :- not(pragma_ancillary(X,U,_)).
ancillaryTy(X,U,Y) :- isProvided(U,'TYPE',X),
	pragma_ancillary(X,U,Y).
ancillaryCo(X,U,Y) :- isProvided(U,'CONSTANT',X),
	pragma_ancillary(X,U,Y).
ancillaryCoOp(X,U,Y) :- isProvided(U,'OPERATION',X), 
	isConstrained(U,'OPERATION',X,_,_), ancillary(X,U,Y).
ancillaryUnOp(X,U,Y) :- isProvided(U,'OPERATION',X), 
	not(isConstrained(U,'OPERATION',X,_,_)), ancillary(X,U,Y).
ancillaryEx(X,U,Y) :- isProvided(U,'EXCEPTION',X),
	pragma_ancillary(X,U,Y).
 
/*``tuning``Mon Nov 14 16:44:16 MET 1994``*/
/* parent objects characteristics : */

/* use of pragma nesting : */
isNesting1(X) :- isParent(X), 
	( pragma_nesting(X,_); ( isObject(X,_,Y), isNesting1(Y) ) ), !. 
 /* use of scheme INCLUDE  : */
isNesting2(X) :- isParent(X), 
	( scheme(X,'INCLUDE'); ( isObject(X,_,Y), isNesting2(Y) ) ), !.
isNesting(X) :-  ( isNesting1(X); isNesting2(X) ), !.
notNesting(X) :- not(isNesting(X)).
nestingIns(X) :- pragma_nesting(X,'INSIDE').
nestingSep(X) :- not(pragma_nesting(X,'INSIDE')).

/*``tuning``Thu Apr 10 14:21:41 MET DST 2003``*/
/* child objects characteristics : */
/* (cf.ADA136) */

nestChild1(X,Y) :- isObject(Y,T,X), isNesting1(X), not(opControl(X,Y,_,_)).
nestChild2(X,Y) :- isObject(Y,T,X), isNesting2(X), not(opControl(X,Y,_,_)).
nestChild(X,Y) :- isObject(Y,T,X), isNesting(X), not(opControl(X,Y,_,_)).
notNested(Y) :- isObject(Y,T,X), notNesting(X).
insChild(X,Y) :- isObject(Y,T,X), nestingIns(X), notInst(Y), not(opControl(X,Y,_,_)).
sepChild(X,Y) :- isObject(Y,T,X), nestingSep(X), notInst(Y), not(opControl(X,Y,_,_)).
nestInst(X,Y) :- inst(Y), isNesting(X).
/* childInBody(X) :- isNesting(X), not(pragma_visible_children(X)). */
/* childInSpec(X) :- isNesting(X), pragma_visible_children(X). */
childInBody(X) :- fail.
childInSpec(X) :- isNesting(X). /*(cf.ADA179)*/
hasBodyFile(X) :- isObject(X,T,Z), T \= 'OP_CONTROL', not(nestingIns(Z)).
libSpec(X) :- isObject(X,_,Y), notNesting(Y).
libBody(X) :- hasBodyFile(X).
asc(X,Y) :- isObject(X,_,Y).
asc(X,Y) :- isObject(X,_,Z), asc(Z,Y).
/*``tuning``Tue Jul 17 15:29:09 MET DST 2001``*/
/* types & constants characteristics : */
/* (cf.ADA103), (cf.ADA105), (cf.ADA116), (cf.ADA117), (cf.ADA120), (cf.ADA129), 
(cf.ADA144), (cf.ADA151), (cf.ADA158), (cf.ADA162) */

isPrivate(U,E,X) :- isProvided(U,E,X), isTerm(X), file(U,E,X,_,W), (W='TypeDecl'; W='CstDecl').
isVisible(U,'TYPE',X) :- isProvided(U,'TYPE',X), ( not(file(U,'TYPE',X,_,'TypeDecl')); isParent(X) ), !.
isVisible(U,'CONSTANT',X) :- isProvided(U,'CONSTANT',X), ( not(file(U,'CONSTANT',X,_,'CstDecl')); isParent(X) ), !.

discriminant(U,X,A,T,Y,V) :- attributes(U,X,A,T,Y,V), pragma_discriminant(X,U,A).

enumAsConst(X,U) :- implem(U,E,X,V,Y), /*ADA162*/
	( pragma_const_enum(Y,V); pragma_const_enum(Y,'all_ty'); pragma_const_enum(Y,'*')),!.
enumAsConst(X,U) :- 
	( pragma_const_enum(X,U); pragma_const_enum(X,'all_ty'); pragma_const_enum(X,'*')),!.

isTagged(X,U) :- implem(U,'TYPE',X,V,Y), isClass(V,Y).
useType(T,Y) :- not(pragma_no_use_type(Y,T)), not(pragma_no_use_type(Y,'*')).

derived(X,U) :- ( 
	( isTagged(X,U), not(pragma_subtyping(X,U)), not(pragma_subtyping(X,'*')) ); 
	pragma_derived_typing(X,U); 
	pragma_derived_typing(X,'*') ), !.

isProtected(U,'TYPE',X) :- if95, 
	argument(O,'OPERATION',X,_,P,'NIL',T,_,_), itIsMe(P),
	memezTra(U,T), isProtected(O,'OPERATION',X), !.

notProt(U,'TYPE',X) :- not(isProtected(U,'TYPE',X)).

isTask(U,'TYPE',X) :- isActive(X), 
	argument(O,'OPERATION',X,_,P,'NIL',T,_,_), itIsMe(P),
	memezTra(U,T), isTaskEntry(O,'OPERATION',X), !.

notTask(U,'TYPE',X) :- not(isTask(U,'TYPE',X)).

renameCst :- pragma_rename_constants(_), !.

recInherits(T1,T) :- inherits(T1,_,T2,_),
	( inherits(T2,_,T3,_) -> recInherits(T2,T); T=T2 ).
 
/*``tuning``Wed Apr 10 10:59:40 MET DST 2002``*/
/* provided operations characteristics : */
/* (cf.ADA105), (cf.ADA107), (cf.ADA115), (cf.ADA117), (cf.ADA122), (cf.ADA147) */

uncstrOp(X,U) :- not(constrOp(X,U)), notHidden(X,U).
constrOp(X,U) :- isConstrained(U,'OPERATION',X,_,_), 
	notHidden(X,U), not(pragma_no_constraints(X)), !.

publicProtOpers(X,T,O) :- 
	isProvided(O,'OPERATION',X), 
	isProtected(O,'OPERATION',X),
	argument(O,'OPERATION',X,_,P,'NIL',U,_,_), 
	itIsMe(P), memezTra(T,U).

taskTypeOpers(X,T,O) :-
	isProvided(O,'OPERATION',X), 
	isTaskEntry(O,'OPERATION',X),
	argument(O,'OPERATION',X,_,P,'NIL',U,_,_),
	itIsMe(P), memezTra(T,U).

isProtected(U,'OPERATION',X) :-
	isConstrained(U,'OPERATION',X,C,_),
	notInit(X,U), ( C = 'ROER'; C = 'RWER' ), !.

hasPrivProt(X,U) :- 
	( attributes(U,X,_,_,_,_); privateProtOpers(X,U,_) ), !.

notInProtType(X,U) :- 
	not( inProtType(X,U) ).

inProtType(X,U) :- if95, 
	isConstrained(U,'OPERATION',X,C,_),
	( C='RWER'; C='ROER' ),
	argument(U,'OPERATION',X,_,P,'NIL',_,_,_), itIsMe(P).

notProt(U,'OPERATION',X) :- 
	not( isProtected(U,'OPERATION',X)  ).

isTaskEntry(U,'OPERATION',X) :- notInit(X,U), 
	isConstrained(U,'OPERATION',X,C,_),
	( C='HSER'; C='LSER'; C='ASER' ),
	not(isConstrained(U,'OPERATION',X,'ROER',_)), 
	not(isConstrained(U,'OPERATION',X,'RWER',_)), !.

/* (cf.ADA171) */
isOBCSEntry(U,'OPERATION',X) :- notInit(X,U), 
	isConstrained(U,'OPERATION',X,C,_),
	notHidden(X,U),
	not(pragma_no_constraints(X)), 
	notInProtType(X,U), 
	not(hrtConstr(X,U)), !.
isOBCSEntry(U,'OPERATION',X) :- isThread(X,U).
isOBCSEntry(U,'OPERATION',X) :- isStart(X,U).
isOBCSEntry(U,'OPERATION',X) :- isProtectedOp(X,U,_).

isProtectedEntry(X,U) :- isProtected(U,'OPERATION',X),
	not(return(U,'OPERATION',X,_,_,_)), 
	isConstrained(U,'OPERATION',X,'STATE',_), 
	argument(U,'OPERATION',X,_,P,'NIL',_,_,_), itIsMe(P),	
	isState(X,S,_), not(isTransition(X,_,S,_,U)), !.

notTaskEntry(U,'OPERATION',X) :- not(isTaskEntry(U,'OPERATION',X)).

sepProvOp(X,U) :- isProvided(U,'OPERATION',X), notInit(X,U), 
	notInProtType(X,U), notHidden(X,U), not(insOp(X,U)). /*(cf.ADA147)*/
insProvOp(X,U) :- isProvided(U,'OPERATION',X), notInit(X,U), 
	notInProtType(X,U), notHidden(X,U), insOp(X,U). /*(cf.ADA147)*/
 
/*``tuning``Fri Apr  5 18:04:39 MET DST 2002``*/
/* internal operations characteristics : */
/* (cf.ADA115), (cf.ADA117), (cf.ADA147) */

sepIntOp(X,U) :- ( hidden(X,U);
	( isInternal(U,'OPERATION',X), notInit(X,U), notInProtType(X,U) )),
	not(insOp(X,U)). /*(cf.ADA147)*/
insIntOp(X,U) :- ( hidden(X,U);
	( isInternal(U,'OPERATION',X), notInit(X,U) )), 
	notInProtType(X,U), insOp(X,U). /*(cf.ADA147)*/

privateProtOpers(X,T,O) :- 
	isInternal(O,'OPERATION',X), 
	isProtected(O,'OPERATION',X),
	argument(O,'OPERATION',X,_,P,'NIL',U,_,_), 
	itIsMe(P), memezTra(T,U).

 
/*``tuning``Wed Jul  2 10:53:34 MET DST 2003``*/
/* other operations characteristics : */
/* (cf.ADA105), (cf.ADA108), (cf.ADA109), (cf.ADA117), (cf.ADA124), (cf.ADA127), (cf.ADA136), 
(cf.ADA139), (cf.ADA144), (cf.ADA146), (cf.ADA147), (cf.ADA149) */

protectedOpers(X,T,O) :- 
	( isProvided(O,'OPERATION',X); isInternal(O,'OPERATION',X) ), 
	isProtected(O,'OPERATION',X),
	argument(O,'OPERATION',X,_,P,'NIL',U,_,_), 
	itIsMe(P), memezTra(T,U).

taskTypeOper(X,T,O) :-
	( isProvided(O,'OPERATION',X); isInternal(O,'OPERATION',X) ), 
	isTaskEntry(O,'OPERATION',X),
	argument(O,'OPERATION',X,_,P,'NIL',U,_,_), 
	itIsMe(P), memezTra(T,U).

implicitReceiver(X,O) :- 
	argument(O,'OPERATION',X,_,P,'NIL',U,_,_), itIsMe(P),
	( isProtected(O,'OPERATION',X); isTaskEntry(O,'OPERATION',X) ).

isFunction(X,U) :- return(U,'OPERATION',X,_,_,_).
hasFac(X,U) :- isConstrained(U,'OPERATION',X,'STATE',_). /*(cf.ADA171)*/

isAbstract(X,U) :- isAbstract(U,'OPERATION',X).
notAbstract(X,U) :- ( not(isAbstract(U,'OPERATION',X)); isConstrained(U,'OPERATION',X,_,_) ), !.

isPrimitive(X,U,T) :- isProvided(T,'TYPE',X), derived(X,T),
	( (argument(U,'OPERATION',X,_,P,'NIL',T,_,_), itIsMe(P)); return(U,'OPERATION',X,_,T,_)), !.

inheritedOp(X,U,T) :- isParent(X), isProvided(U,'OPERATION',X), notInit(X,U), isPrimitive(X,U,T).
inheritedOp(X,U,T) :- isInherited(U,X), isPrimitive(X,U,V), recInherits(V,T).

notInherited(X,U) :- not(isInherited(U,X)).

hasExtension(X,U) :- file(U,'OPERATION',X,_,'OpDefExt'), !.
preExtension(X,U) :- hasExtension(X,U), ( pragma_generic(X,V); pragma_generic_op(X,V) ), memezTra(U,V), !.
contExtension(X,U) :- hasExtension(X,U), pragma_extension(X,V), memezTra(U,V), !.
instExtension(X,U) :- hasExtension(X,U), pragma_instance_op(X,V), memezTra(U,V), !. /*(cf.ADA180)*/
postExtension(X,U) :- hasExtension(X,U), not(preExtension(X,U)). /*(cf.ADA186)*/

noBody(X,U) :- /*(cf.ADA146)(cf.ADA180)*/
	isInherited(U,X); 
	isAbstract(U,'OPERATION',X); 
	pragma_interface(X,'*'); 
	( pragma_interface(X,V), memezTra(U,V) );
	( pragma_instance_op(X,V), memezTra(U,V) ).
hasBody(X,U) :- not(noBody(X,U)).

nullBody(C) :- pragma_null(_,C), !.

isOperator(X,U) :- pragma_operator(X,U), !.

isOverloaded(X,U) :- $name(U,L), $member(35,L), !.

insOp(X,U) :- /*(cf.ADA147) (cf.ADA174) (cf.ADA175) (cf.ADA178)*/
	( ( pragma_separate_op(X,V), memezTra(U,V) ) -> fail; true ),
	( noSep; ( pragma_inside_op(X,W), memezTra(U,W) ); pragma_inside_op(X,'*'); 
	  ( isOBCSEntry(U,'OPERATION',X), not(isObject(X,'OP_CONTROL',_)) );
	  isOverloaded(X,U); insChild(_,X) ), !.

/* (cf.ADA171) */

isNotThread(X,U) :- not(isThread(X,U)).
isThread(X,U) :- ( isCyclic(X); isSporadic(X) ), isInternal(U,'OPERATION',X), memezTra(U,'thread').
isNotStart(X,U) :- not(isStart(X,U)).
isStart(X,U) :- isSporadic(X), isProvided(U,'OPERATION',X), memezTra(U,'start').
hrtConstr(X,U) :- isConstrained(U,'OPERATION',X,C,_), 
	( C='HSATC'; C='LSATC'; C='ASATC'; C='PAER'; C='PSER'  ).
isProtectedOp(X,U,C) :- isProtected(X), isConstrained(U,'OPERATION',X,C,_), ( C='PAER'; C='PSER'  ).
 
/*``tuning``Wed May 21 15:24:38 MET DST 2003``*/
/* obcs characteristics : */
/* (cf.ADA113), (cf.ADA115), (cf.ADA119) */

packageOBCS(X) :- not(taskOBCS(X)).
taskOBCS(X) :- isActive(X), not(pragma_package_OBCS(X)).
insOBCS(X) :- hasOBCS(X), ( pragma_inside_OBCS(X); noSep; insChild(_,X) ). /*(cf.ADA174)(cf.ADA178)*/
sepOBCS(X) :- hasOBCS(X), not(pragma_inside_OBCS(X)), not(noSep), not(insChild(_,X)). /*(cf.ADA174)(cf.ADA178)*/
oBCSInBody(X) :- hasOBCS(X), pragma_hidden_OBCS(X).
oBCSInSpec(X) :- hasOBCS(X), not(pragma_hidden_OBCS(X)).
interVect(X,U,V) :- pragma_interrupt_vector(_), 
	isConstrained(U,'OPERATION',X,'BY_IT',V), !.
hidden(X,U) :- pragma_hide_IT(_),
	isConstrained(U,'OPERATION',X,'BY_IT',_), !.
notHidden(X,U) :- not(hidden(X,U)).
 
/*``tuning``Tue Jul 17 15:33:55 MET DST 2001``*/
/* tasks characteristics : */
/* (cf.ADA115), (cf.ADA143), (cf.ADA165) */

servTask(X,S) :- pragma_server_task(X,_,S,_), !.

entryTask(X,U,'OBCS','OPCS',C,P) :- 
	isConstrained(U,'OPERATION',X,C,P), !,
	notHidden(X,U), 
	not(pragma_server_task(X,U,_,'OPCS')).
entryTask(X,U,T,'OPCS',C,P) :-
	isConstrained(U,'OPERATION',X,C,P), !,
	notHidden(X,U), 
	storage(X,T,_,_), not(pragma_server_task(X,U,_,'OPCS')).
entryTask(X,U,S,T,C,P) :- 
	isConstrained(U,'OPERATION',X,C,P), !,
	notHidden(X,U), 
	pragma_server_task(X,U,S,T).

storage(X,T,V,'OBCS') :- pragma_storage_size(X,T,V), !.
storage(X,T,V,D) :- pragma_task_type(X,T,V,D), !.

priority(X,E) :- pragma_priority(X,E), !. /*(cf.ADA165)*/
 
/*``comments``jeudi,  5 dcembre 1996, 16:43:06 MET``*/
/***************************/
/**** I / O   R U L E S ****/
/***************************/
 
/*``i/o``Mon Apr  8 14:34:40 MET DST 2002``*/
/* text output */
/* (cf.ADA102) */

write(T) :- $writename(T).
write2(S) :- $name(S,L), $member(E,L), $put(E), fail.
write2(S).
print(T) :- $telling(F), $told, $tell('user'), $writename(T), $tell(F,1).
nl :- $put(10).
tab :- $put(9).
sp :- $put(32).
dot :- $put(46).

/* (cf.ADA171) */
writeDuration(D) :-  E is D * 1.0, write(E).
 
/*``i/o``Fri Jul 30 15:31:11 MET DST 1999``*/
/* reverse coding tags */

beginReverse(X,N,U,F,W,L) :- 
	reverseOption(1) -> ( indent(N), begCom, write('<begin '), write(L), write(W), sp, write(X), 
		( U='NIL' -> true; ( sp, write(U) ) ), write('>'), nl );
	reverseOption(3) -> ( indent(N), begCom, write('<HMG '), write(F), nl );
	true.

endReverse(N) :-
	reverseOption(1) -> ( indent(N), begCom, write('<end>'), nl );
	reverseOption(3) -> ( indent(N), begCom, write(' HMG>'), nl );
	true.

beginEmptyReverse(X,N,U,W,L) :- 
	reverseOption(2) -> ( indent(N), begCom, write('<begin '), write(L), write(W), sp, write(X),
		( U='NIL' -> true; ( sp, write(U) ) ), write('>'), nl );
	true.

endEmptyReverse(N) :-
	reverseOption(2) -> ( indent(N), begCom, write('<end>'), nl );
	true.
 
/*``i/o``Fri Jul 30 15:31:27 MET DST 1999``*/
/* insertFile(U,E,X,N,W) */

insertFile(U,E,X,N,W) :- file(U,E,X,F,W) -> 
	( $see(F), beginReverse(X,N,U,F,W,'ada::'), indent(N), readFile(N), nl, endReverse(N) );
	( beginEmptyReverse(X,N,U,W,'ada::'),
	( ( W ?= 'SpecHeader'; W?= 'BodyHeader'; W ?= 'SepHeader'; W ?= 'SepObcsHeader'; W ?='OpExt';W ?='Init') -> true;
	( message('*** unknown file for : ',U,' (',W,') of object : ',X), (W ?= 'OpDef' -> defaultOperBody(X,N,U); true)  ) ), 
	endEmptyReverse(N) ).
 
/*``i/o``Tue Jun 10 17:14:00 MET DST 1997``*/
/* insertText(U,E,X,N,W) */

insertText(U,E,X,N,W) :- 
	file(U,E,X,F,W) -> ( $see(F), readFile(N) );
	message('*** unknown file for : ',U,' (',W,') of object : ',X).
 
/*``i/o``Tue Jul 17 15:34:28 MET DST 2001``*/
/* insertCom(U,E,X,N,W) */
/* (cf.ADA148) */

insertCom(U,E,X,N,W) :- comment(U,E,X,F,W) -> 
	( $see(F), sepline, beginReverse(X,N,U,F,W,''), 
		( pragma_sep_lines(_) -> true; indent(N) ), 
		begCom, $globalset(w(N)), readComFile(N), nl, 
		endReverse(N), sepline  );
	( beginEmptyReverse(X,N,U,W,''), ( 
	W ?= 'ObcsTxt' -> message('*** no textual description for : OBCS spec of object : ',X);
      W ?= 'ObcsBodyTxt' -> message('*** no textual description for : OBCS body of object : ',X);
	W ?= 'HeaderTxt' -> true;
	message('*** no textual description for : ',E,' ',U,' of object : ',X) ),
	endEmptyReverse(N) ).

sepline :- pragma_sep_lines(_) ->
	( write('--------------------------------------------------'), nl ); true.
 
/*``i/o``Tue Jul 17 16:21:34 MET DST 2001``*/
/* insertDescr(X,N,L) */
/* (cf.ADA156) */
 
insertDescr(X,N,L) :- description(X,F,L) -> insertDescrFile(F,N,L); true.

insertDescr(X,N,O,L) :- comment(O,_,X,F,L) ->  insertDescrFile(F,N,L); true.

insertDescrFile(F,N,L) :- $see(F) ->
		( dashLine(N),
		  indent(N), begCom, label(L), write(' :'), nl,
		  indent(N), begCom, underline(L), nl,
		  indent(N), begCom, nl,
		  indent(N), begCom, $globalset(w(N)), readComFile(N), nl  );
		true.

dashLine(N) :- indent(N), write('--------------------------------------------------'), nl.

label('DOC11') :- write('Statement of the Problem').
label('DOC132') :- write('Functional Requirements').
label('DOC133') :- write('Behavioural Requirements').
label('DOC21') :- write('General Strategy').
label('DOC241') :- write('Identification of Local Behaviour').
label('OpTxt') :- write('Operation Specification Description').
label('OpBodyTxt') :- write('Operation Body Description').
label('Op2Txt') :- write('Operation Specification Description').
label('ObcsTxt') :- write('OBCS Specification Description'). /*(cf.ADA169)*/
label('ObcsBodyTxt') :- write('OBCS Body Description'). /*(cf.ADA169)*/

underline('DOC11') :- write('========================').
underline('DOC132') :- write('=======================').
underline('DOC133') :- write('========================').
underline('DOC21') :- write('================').
underline('DOC241') :- write('=================================').
underline('OpTxt') :- write('===================================').
underline('OpBodyTxt') :- write('==========================').
underline('Op2Txt') :- write('===================================').
underline('ObcsTxt') :- write('==========================').
underline('ObcsBodyTxt') :- write('===================================').
 
/*``i/o``Fri Jul 30 15:32:01 MET DST 1999``*/
/* insertPseudo(U,E,X,N,W) */

insertPseudo(U,E,X,N,W) :-
	file(U,E,X,F,W), findPseudo(F,G), $see(G), beginReverse(X,N,U,F,W,'pseudo::'),
	indent(N), begCom, $globalset(w(N)), readComFile(N), nl, endReverse(N).

findPseudo(F1,F2) :- 
	$name(F1,L1), $reverse(L1,[117|R]), $reverse([112|R],L2), $name(F2,L2).
 
/*``i/o``Tue May 20 16:58:38 MET DST 2003``*/
/* open & close File */

openFile(X,S) :- openFile(X,S,_).
openFile(X,S,U) :- extract(U,_,X,S,F), 
	( ifTrace -> message('--- openning : ',F); true), 
      ( $tell(F) -> $assert(modified(X,U,S,F)); message('*** cannot open : ',F) ). /*(cf.ADA182)*/

closeFile :- $telling(F), 
	( ifTrace -> message('--- closing : ',F); true), $told.
/*``i/o``Tue May 20 17:59:23 MET DST 2003``*/
/* file names conversions */
/* (cf.ADA102) */

filetConvert(F1,F2) :- $name(F1,L1), $reverse(L1,R1), 
	toLowerCase(R1,R2), $name(F2,R2).

toLowerCase([ ],[ ]).
toLowerCase([H|T],R) :- convert1(T,R,[H]).

convert1([ ],R,R).
convert1([H|T],R,L) :-
	H =:= 47 -> copy(T,R,[H|L]);
	( H > 64, H < 91 ) -> ( C is H + 32, convert1(T,R,[C|L]) );
	convert1(T,R,[H|L]).

copy([ ],R,R).
copy([H|T],R,L) :- copy(T,R,[H|L]).

unitConvert(U1,U2) :- $name(U1,L1), $reverse(L1,R1), 
	minusToDot(R1,R2), $name(U2,R2).

minusToDot([ ],[ ]).
minusToDot([H|T],R) :- convert2(T,R,[H]).

convert2([ ],R,R).
convert2([H|T],R,L) :-
	( H =:= 95, T = [95|U] ) -> convert2(U,R,[46|L]) ;
	convert2(T,R,[H|L]).

shortName(F1,F2) :- 
	$name(F1,L1), $reverse(L1,R1), $name(N1,R1), 
	$subdelim(1,'/',N2,0,N1,_), 
	$name(N2,R2), $reverse(R2,L2), $name(F2,L2).

writeFileName(X,F1) :- shortName(F1,F2), write(F2).

unitList(L) :- $member(Y,L), write(Y), write('-'), fail.
unitList(L).

/*(cf.ADA182)*/
unitDotList(L) :- $member(Y,L), write(Y), dot, fail.
unitDotList(L).

writeDir(F) :- $name(F,[46,47|L]) -> ( $name(P,L), write2(P) ); write2(F).
 
/*``i/o``jeudi, 31 octobre 1996, 18:17:34 MET``*/
/* HHD file */

openHHD :- extract(_,_,_,'HHD',F) -> $tell(F,1); $tell('HHD',1).

closeHHD :- $told.

listHHD(X) :- writeHHD(X,[X]), fail.
listHHD(X) :- scheme(X,'INCLUDE'), findPath(X,[X],[Y|L]), writeHHD(Y,[Y|L]), fail.
listHHD(X).

writeHHD(X,L) :- write(X), sp, writeFullName(L), nl, fail.
writeHHD(X,_) :- ancillary(X,U,Y), write(U), sp, write(Y), dot, write(U), nl, fail.
writeHHD(X,_) :- isObject(X,'ACTIVE',_), write('OBCS'), sp, write(X), dot, write('OBCS'), nl, fail.
writeHHD(X,_) :- isProvided(U,_,X), constrOp(X,U), write(U), sp, write(X), dot, write('OPCS_'), write(U), nl, fail.
writeHHD(X,_).

findPath(X,L,L) :- isTerm(X).
findPath(X,L,R) :- isObject(Y,_,X), findPath(Y,[Y|L],R).

writeFullName(L) :- $reverse(L,[V|R]), write(V), $member(U,R), dot, write(U), fail.
writeFullName(L).
 
/*``i/o``Wed May 21 14:20:24 MET DST 2003``*/
/* MakeFile i/o */
/* (cf.ADA102), (cf.ADA110), (cf.ADA125), (cf.ADA132), (cf.ADA133) */

openMakeFile :- 
	( extract(_,_,_,'make',F) -> $tell(F,1); $tell('Stood.out',1) ).

closeMakeFile :- $told.

/*(cf.ADA164)(cf.ADA182)*/
createMakeFile :- ifGnat(O), genGnatAdc(O).
createMakeFile :- openMakeFile, 
	ifGnat(O) -> ( main(X,_,M) -> gnatMake(X,M,O); orderedFiles );
	ifTld(_) -> orderedFiles;
	ifAlsys(_) -> orderedFiles;
	ifTartan(_) -> orderedFiles;
	ifAonix(O) -> oaMakeFile(O);	
	( modified(_,_,_,F), write('# '), winFile(F,F2), write2(F2), nl ).
createMakeFile :- closeMakeFile.

usedAllEnv(X,Y) :- 
	( requires(_,_,_,_,_,Z,_); specialrequires(_,_,_,Z,'to be withed',_,_); specialrequires(_,_,_,_,'to be withed',Z,_) ), 	remove(X,Y), memezTra(Y,Z), !.
usedAllEnv(X,Y) :- isInstance(_,_,Z), memezTra(Y,Z), !.

usedEnv(X,Y) :- 
	( requires(_,_,X,_,_,Z,_); specialrequires(_,_,X,Z,'to be withed',_,_); specialrequires(_,_,X,_,'to be withed',Z,_) ), 	remove(X,Y), memezTra(Y,Z), !.
usedEnv(X,Y) :- isInstance(X,_,Z), memezTra(Y,Z), !.

remove(X,Y) :- not(memezTra(Y,X)), not(memezTra(Y,'standard')), not(memezTra(Y,'text_io')), not(memezTra(Y,'system')).

winFile(F1,F2) :- /*(cf.ADA172)*/
	$name(F1,[47|[99|[121|[103|[100|[114|[105|[118|[101|[47|[B|[47|L0]]]]]]]]]]]]) -> /* /cygdrive/L/... */
	$name(F2,[B|[58|[47|L0]]]) ; /* L:/... */
	$name(F1,[47|[47|[C|[47|L1]]]]) -> /* //L/... */
	$name(F2,[C|[58|[47|L1]]]); /* L:/... */
	F2=F1.
 
/*``i/o``Fri May 30 15:41:26 MET DST 2003``*/
/* GNAT */
/* (cf.ADA182) */

gnatMake(X,M,O) :- write('mv '), write(X), write('.adb '), write(M), write('.adb'), nl, write('gnatmake ').
gnatMake(X,M,O) :- isRootObject(Y,_,F), remove(X,Y), write('-I'), winFile(F,F2), write2(F2), write('/_ada ').
gnatMake(X,M,O) :- write(O), sp, write(M), nl.

gnatComp(X,F,O) :- write('gcc -c '), write(O), sp.
gnatComp(X,F,O) :- isRootObject(Y,_,F1), remove(X,Y), write('-I'), winFile(F1,F2), write2(F2), write('/_ada ').
gnatComp(X,F,O) :- winFile(F,F2), write2(F2), nl.

genGnatAdc(O) :- thisFile(D,_), $name(D,L1), 
	$name('gnat.adc',L2), $append(L1,L2,L), $name(F,L), $tell(F).
genGnatAdc(O) :- modified(X,U,S,F), 
	write('pragma Source_File_Name('), 
	( ( main(X,_,M), S='body' ) -> 
	( write(M), write(','), nl, indent(1), write('Body_File_Name => "'), write(M), write('.adb");'), nl );
	( ( ( sepChild(Y,X), isNesting(Y) ) -> ( write(Y), dot ); 
	( childUnit(X,L) -> unitDotList(L); true ) ), 
	write(X), 
	( ( sepProvOp(X,U); sepIntOp(X,U); opControl(X,_,U,_) ) -> ( dot, write(U) );
	( S='obcs' -> ( dot, write('obcs') ); 
	( S='rtatt' -> write('_RTATT'); true ) ) ),
	write(','), nl, indent(1), 
	( ( S='spec'; S='provided'; S='rtatt' ) -> write('Spec_File_Name => "'); write('Body_File_Name => "') ),
	shortName(F,G), write(G), write('");'), nl ) ).
genGnatAdc(O) :- $told. 
 
/*``i/o``Wed May 21 14:20:51 MET DST 2003``*/
/* Object Ada */
/*(cf.ADA182)*/

oaMakeFile(_) :- write('# used environment:'), nl,
	isRootObject(Y,_,F), isCurrentRoot(X), 
	remove(X,Y), write('adaopts -v -p '), winFile(F,F2), write2(F2), write('/_ada'), nl.
oaMakeFile(_) :- write('# modified files:'), nl, 
	modified(_,_,_,F), write('adareg '), winFile(F,F2), write2(F2), nl.
oaMakeFile(O) :- main(X,_,M) ->
	( write('# build main unit:'), nl, 
	  write('adabuild '), write(O), sp, write2(M), nl );
	( write('# compile units:'), nl,
	  modified(_,_,_,F), write('adacomp '), winFile(F,F2), write2(F2), nl ).
 
/*``i/o``Tue May 20 17:01:07 MET DST 2003``*/
/* orderedFiles */
/* (cf.ADA102), (cf.ADA133) (cf.ADA182) */

orderedFiles :- modified(X,_,_,_), not(inMake(X)), putOrdered([X]).

putOrdered([X|L]) :- hasCompReq(X,L,Y),
	( ifTrace -> ( write('# '), write(X), tab, write(Y), nl ); true ),
	putOrdered([Y,X|L]), fail.
putOrdered([X|L]) :- not(hasCompReq(X,L,_)),
	( ifTrace -> ( write('# '), write(X), nl ); true ), 
	$assert(inMake(X)), modified(X,_,_,F),  
	( ifGnat(O) -> gnatComp(X,F,O);
	( ifTld(O) -> ( write('adatld '), write(O), sp, winFile(F,F2), write2(F2), nl ); 
	( ifAlsys(O) -> ( write('ada "COMPILE (LIBRARY => '), write(O), 
		write(', SOURCE => '), winFile(F,F2), write2(F2), write(')"'), nl );
		( write('# '), write2(F), nl ) ) ) ).

hasCompReq(X,L,Y) :- modified(Y,_,_,_), 
	( requires(_,_,X,_,_,Y,_); isImplementedBy(_,_,X,_,Y,_) ), Y\=X, not(inMake(Y)), 
	( $memberchk(Y,L) -> 
		( message('# warning ! cyclic dependency between : ',X,' and : ',Y,'',''), fail );
	  	  true ).
 
/*``i/o``Tue Jul 17 15:43:02 MET DST 2001``*/
/* createTrace */
/* (cf.ADA112) */

createTrace :- thisFile(D,_), 
	$name(D,L1), $name('trace.dat',L2), 
	$append(L1,L2,L3), $name(F,L3),
	$tell(F), fail.
createTrace :- 
	write('CQL'), tab, write('VIEW'), nl,
	write('COLUMNS'), tab, write('7'), nl,
	write('path1'), tab, write('type1'), tab, write('position1'), tab, write('role2'), tab, 
	write('path2'), tab, write('type2'), tab, write('position2'), nl,
	write('DATA'), nl,
	extract(U,_,X,'operations',F1), shortName(F1,F2), writeOpTrace(X,U,F2), fail.
createTrace :- $told.

writeOpTrace(X,U,F) :- 
	write('"Stood.dg"'), tab, 
	write('"STOOD"'), tab, 
	write('"'), write(X), write('/'), write(U), write('"'), tab,
	write('"OperToCodeDest"'), tab,
	write('"_ada/'), write(F), write('"'), tab,
	write('"undef"'), tab,
	write('"undef"'), nl.
 
/*``i/o``jeudi, 21 novembre 1996, 17:12:10 MET``*/
/* readFile(I) */

readFile(I) :- 
	$get0(N),			/* read one char, and */
	(  N =\= -1 -> 			/* is it not end of file ? */
		(  $put(N),		/* if not eof then write char, and */
			(  N =:= 10 -> 	/* is it new line ? */
			   indent(I);	/* if nl then indent line, or */
			   true		/* if not nl then do nothing */
			),		/* and */
		   readFile(I)	/* read next char */
		);			/* or */
		$seen			/* if eof then close input file */
	).
/*``i/o``jeudi, 21 novembre 1996, 17:13:08 MET``*/
/* readComFile(I) */

readComFile(I) :-
	$get0(N),			/* read one char, and */
	(  N =\= -1 -> 			/* is it not end of file ? */
	   (  w(K), lineWidth(W),	/* if not eof then get counter value */
	      ( (K > W, N =:= 32) ->	/* is counter at max width and char space ? */
		newComLine(I) ;	/* if mw then create new line */
		( L is K+1, 		/* if not mw then increment counter */
		  $globalset(w(L))	/* and store its value */
		)			
	      ),			/* and */
	      ( N =:= 10 -> 		/* is it new line ? */
		newComLine(I) ;	/* if nl then write end of line, and */
		$put(N)			/* if not nl then write char, and */
	      ),			/* and */
	      readComFile(I)		/* read next char */
	   );				/* or */
	   $seen			/* if eof then close input file */
	).

newComLine(I) :- endCom, indent(I), begCom, $globalset(w(I)).
 
/*``i/o``Fri Apr  5 12:06:02 MET DST 2002``*/
/* informations */
/* (cf.ADA169) */

info(N,100) :- indent(N), begCom, write(' visibility on ancillary or types_out specs : '), nl.
info(N,101) :- indent(N), begCom, write(' visibility on class : '), nl.
info(N,102) :- indent(N), begCom, write(' visibility on required modules : '), nl.
info(N,103) :- indent(N), begCom, write(' visibility on implementing modules : '), nl.
info(N,104) :- indent(N), begCom, write(' specification : '), nl.
info(N,105) :- indent(N), begCom, write(' body : '), nl.
info(N,106) :- indent(N), begCom, write(' provided types and constants : '), nl.
info(N,107) :- indent(N), begCom, write(' instance specification : '), nl.
info(N,108) :- indent(N), begCom, write(' separate operation : '), nl.
info(N,109) :- indent(N), begCom, write(' separate object control structure : '), nl.
info(N,110) :- indent(N), begCom, write(' main procedure : '), nl.
info(N,112) :- indent(N), begCom, write(' required interface : '), nl.
info(N,113).
info(N,114) :- indent(N), begCom, write(' visibility on objects required by nested specs : '), nl.
info(N,115) :- indent(N), begCom, write(' visibility on objects required by nested bodies : '), nl.
info(N,116) :- indent(N), begCom, write(' visibility on objects required by nested operation bodies : '), nl.
info(N,117) :- indent(N), begCom, write(' additional code for TLD conditional compilation : '), nl.
info(N,200) :- indent(N), begCom, write(' local copy of entry parameters : '), nl.
info(N,201) :- indent(N), begCom, write(' local variables to handle entry guards : '), nl.
info(N,202) :- indent(N), begCom, write(' update entry guards value : '), nl.
info(N,203) :- indent(N), begCom, write(' accepted event : '), nl.
info(N,204) :- indent(N), begCom, write(' refused event : '), nl.
info(N,300) :- indent(N), begCom, write(' visibility on real_time attributes : '), nl.





 
/*``i/o``Wed Jul  2 15:27:08 MET DST 1997``*/
/* warnings */

message(A) :- $telling(X), $told, $tell('user'), write(A), nl, $tell(X,1).
message(A,B) :- 
	$telling(X), $told, $tell('user'), 
	write(A), write(B), nl, 
	$tell(X,1).
message(A,B,C,D) :- 
	$telling(X), $told, $tell('user'), 
	write(A), write(B), write(C), write(D), nl, 
	$tell(X,1).
message(A,B,C,D,E,F) :- 
	$telling(X), $told, $tell('user'),
	write(A), write(B), write(C), write(D), write(E), write(F), nl,
	$tell(X,1).
 
/*``comments``jeudi,  5 dcembre 1996, 16:43:12 MET``*/
/***************************************/
/**** A D A   E X P R E S S I O N S ****/
/***************************************/
 
/*``ada``Thu Jul 10 14:53:51 MET DST 1997``*/
/* ada comments */

begCom :- write('-- ').
endCom :- nl.
/*``ada``Tue Jul 17 14:14:59 MET DST 2001``*/
/* packaging keywords */
/* (cf.ADA169) */

insert(X,N,'BEGIN_SPEC') :-  indent(N), write('package '), write(X), write(' is'), lf1.
insert(X,N,'PRIVATE_SPEC') :- indent(N), write('private'), lf1.
insert(X,N,'END_SPEC') :- indent(N), write('end '), write(X), write(';'), nl.
insert(X,N,'BEGIN_BODY') :- indent(N), write('package body '), write(X), write(' is'), lf1.
insert(X,N,'END_BODY') :- indent(N), write('end '), write(X), write(';'), nl.
insert(X,N,'SEPARATE') :- indent(N), write('separate('), findTop(X), write(X), write(')'), lf1.
insert(X,N,'END_SEPARATE') :- true.
insert(X,N,'GENERIC') :-  indent(N), write('generic'), lf1.

insert(X,L,N,'BEGIN_SPEC') :-  indent(N), write('package '), dottedList(L), write(X), write(' is'), lf1.
insert(X,L,N,'END_SPEC') :- indent(N), write('end '), dottedList(L), write(X), write(';'), nl.
insert(X,L,N,'BEGIN_BODY') :- indent(N), write('package body '), dottedList(L), write(X), write(' is'), lf1.
insert(X,L,N,'END_BODY') :- indent(N), write('end '), dottedList(L), write(X), write(';'), nl.
insert(X,L,N,'SEPARATE') :- indent(N), write('separate('), dottedList(L), write(X), write(')'), lf1.
 
/*``ada``Tue Jul 17 14:53:18 MET DST 2001``*/
/* misc */
/* (cf.ADA110) */

dottedList(L) :- $member(Y,L), write(Y), dot, fail.
dottedList(L).

dottedList2([X|L]) :- write(X), $member(Y,L), dot, write(Y), fail.
dottedList2([X|L]).

findTop(X) :- libUnit(X) -> true; ( isObject(X,_,Y), findTop(Y), write(Y), dot ).

insertDataPage(X,N,P) :- 
	indent(N), write('pragma DATA_PAGE('), write(X), write(','), write(P), write(');'), lf1.
 
/*``OBCS``Tue May 15 17:48:48 MET DST 2001``*/
/* copyParam(X,N,U) */

copyParam(X,N,U) :- argument(U,'OPERATION',X,_,P,Y,T,_,_), 
	indent(N+2), write(U), write('_'), write(P), 
	write(' := '), write(P), write(';'), nl, fail.
copyParam(X,N,U). /*(cf.ADA105)*/

copyParam2(X,N,U) :- argument(U,'OPERATION',X,_,P,Y,T,_,_), notMe(P), 
	indent(N+2), write(U), write('_'), write(P), 
	write(' := '), write(P), write(';'), nl, fail.
copyParam2(X,N,U). /*(cf.ADA117)*/
 
/*``OBCS``Tue Jul 17 09:48:40 MET DST 2001``*/
/* declareParam(X,N,U) */

declareParam(X,N,U) :- argument(U,'OPERATION',X,_,P,Y,T,_,_), 
	indent(N), write(U), write('_'), write(P), write(' : '), 
	( Y = 'NIL' -> true; ( write(Y), dot ) ), 
	write(T), write(';'), nl, fail.
declareParam(X,N,U). /*(cf.ADA117)(cf.ADA128)*/

declareParam2(X,N,U) :- argument(U,'OPERATION',X,_,P,Y,T,_,_), notMe(P), 
	indent(N), write(U), write('_'), write(P), write(' : '), 
	( Y = 'NIL' -> true; ( write(Y), dot ) ), 
	write(T), write(';'), nl, fail.
declareParam2(X,N,U). /*(cf.ADA105)*/
 
/*``OBCS``Tue Jul 17 12:01:35 MET DST 2001``*/
/* declare & update Guards */
/* (cf.ADA169) */

declareGuards(X,N,U) :- indent(N), write(U), write('_accepted : boolean := false;'), nl.
 
updateGuards(X,N,U) :-
	indent(N), write(U), write('_accepted := '), 
	( isTransition(X,T1,S1,_,U) -> insertPreCond(X,T1,S1,U); write('true') ), 
	isTransition(X,Tn,Sn,_,U), Tn \= T1, nl, indent(N+2), write('or '), insertPreCond(X,Tn,Sn,U), fail.
updateGuards(X,N,U) :- write(';'), nl.
 
/*``OBCS``Mon Nov 14 11:51:54 MET 1994``*/
/* entryKind(C,T) */

entryKind(C,1) :- 
	memezTra(C,'ASER');
	memezTra(C,'LSER').
entryKind(C,2) :- 
	memezTra(C,'HSER');
	memezTra(C,'LSER_TOER');
	memezTra(C,'HSER_TOER');
	memezTra(C,'NIL').

/*``ada``Wed Dec  1 17:42:48 MET 1993``*/
/* callType(T) */

callType('OBCS') :- write('OBCS.').
callType('OPCS') :- write('OPCS_').
callType(T) :- T \= 'OBCS', T \= 'OPCS', write(T).

/*``comments``jeudi,  5 dcembre 1996, 16:43:17 MET``*/
/*--------------------------*/
/* CONSTANTS TYPES AND DATA */
/*--------------------------*/
 
/*``ada``Thu Oct 16 11:55:50 MET 1997``*/
/* insertRcsId(X,N,I) */

insertRcsId(X,N,I) :-
	indent(N), write('Rcs_Id : CONSTANT STRING := "'), write(I), write('";'), lf1.
 
/*``ada``Tue Jul 17 14:53:32 MET DST 2001``*/
/* insertConst(X,N,U) */
/* (cf.ADA159) */

insertConst(X,N,U) :- 
	( ifCom -> 
		( isProvided(U,'CONSTANT',X) -> 
			insertCom(U,'CONSTANT',X,N,'CstTxt'); 
			insertCom(U,'CONSTANT',X,N,'Cst2Txt') ); 
		true ),
	( isImplementedBy(U,'CONSTANT',X,V,Y) ->
		( ( libTypes(Y,L) -> Z=L; Z=Y ),
			( renameCst ->
				renameConst(U,X,V,Z,N);
				redeclareConst(U,X,V,Z,N) ) );
		( isProvided(U,'CONSTANT',X) -> 
			insertFile(U,'CONSTANT',X,N,'CstDef');
			insertFile(U,'CONSTANT',X,N,'CstDef2') ) ), lf0.
 
/*``ada``Tue Jul 17 14:52:18 MET DST 2001``*/
/* renameConst(U,X,V,Y,N) */
/* (cf.ADA101), (cf.ADA159), (cf.ADA167), (cf.ADA168) */

renameConst(U,X,V,Y,N) :-  
	indent(N), write(U), write(' : '),
	whichType(U,'CONSTANT',X,V,Y,O,T),
	( ( O=X; O='?'; memezTra(O,'STANDARD') ) -> true; ( write(O), dot ) ), 
	( T \= '' -> write(T); write('unknown_type') ), lf2(N+1), 
	write(' renames '), write(Y), dot, write(V), write(';'), nl.
 
/*``ada``Tue Jul 17 14:52:58 MET DST 2001``*/
/* redeclareConst(U,X,V,Y,N) */
/* (cf.ADA100), (cf.ADA101), (cf.ADA159), (cf.ADA167), (cf.ADA168) */

redeclareConst(U,X,V,Y,N) :- 
	indent(N), write(U), write(' : constant '),
	whichType(U,'CONSTANT',X,V,Y,O,T),
	( ( O=X; O='?'; memezTra(O,'STANDARD') ) -> true; ( write(O), dot ) ), 
	write(T), lf2(N+1), write(' := '),
	( (  T = ''; memezTra(O,'STANDARD') ) -> 
		( write(Y), dot, write(V), write(';') ); 
		( ( ( O=X; O='?' ) -> true; ( write(O), dot ) ), write(T), write('('), write(Y), dot, write(V), write(');') ) ), nl.
 
/*``ada``Thu Jul 10 17:50:31 MET DST 1997``*/
/* insertConstDecl(X,N,U) */

insertConstDecl(X,N,U) :- insertFile(U,'CONSTANT',X,N,'CstDecl'), lf0.
 
/*``ada``Thu Jul 10 17:50:49 MET DST 1997``*/
/* insertFormConst(X,N,U) */

insertFormConst(X,N,U) :- 
	( ifCom -> insertCom(U,'CONSTANT','FORMAL_PARAMETERS',N,'CstTxt'); true ),
	insertFile(U,'CONSTANT','FORMAL_PARAMETERS',N,'CstDecl'), lf0.
 
/*``ada``Thu Jul 10 17:51:40 MET DST 1997``*/
/* insertFormType(X,N,U) */

insertFormType(X,N,U) :- 
	( ifCom -> insertCom(U,'TYPE','FORMAL_PARAMETERS',N,'TypeTxt'); true ),
	insertFile(U,'TYPE','FORMAL_PARAMETERS',N,'TypeDecl'), lf0.
 
/*``ada``Tue Jul 17 14:53:52 MET DST 2001``*/
/* subTyping(X,N,U,Z,Y,V) */
/* (cf.ADA137) */

subTyping(X,N,U,Z,Y,V) :- 
	indent(N), write('subtype '), write(U), write(' is '), write(Z), dot, write(V), write(';'), nl,
	ifEnum(V,Y), indent(N), begCom, write(' renaming enumeration elements : '), endCom,
	( ( if95, useType(V,Z) ) -> true; renameEqual(X,N,U,Z,V) ),
	ifEnum(V,Y,E), insertElem(X,N,U,Z,E).
/*``ada``jeudi, 21 novembre 1996, 16:52:19 MET``*/
/* deriving(X,N,U,Z,Y,V) */

deriving(X,N,U,Z,Y,V) :- indent(N), write('type '), write(U), write(' is new '), 
	write(Z), dot, write(V),  
	( isTagged(X,U) -> write(' with null record'); true),
	write(';'), nl.
/*``ada``Fri Jul 18 09:28:21 MET DST 1997``*/
/* insertType(X,N,U) */

insertType(X,N,U) :- 
	( ifCom -> ( isProvided(U,'TYPE',X) -> 
		insertCom(U,'TYPE',X,N,'TypeTxt'); 
		insertCom(U,'TYPE',X,N,'Type2Txt') ); true),
	( isImplementedBy(U,'TYPE',X,V,Y) ->
		( ( (libTypes(Y,L); ancillaryTy(Y,V,L) ) -> 
			Z=L; Z=Y), 
	  	  ( derived(X,U) -> 
			deriving(X,N,U,Z,Y,V); 
			subTyping(X,N,U,Z,Y,V) ) );
		( keep(U,'TYPE',X,'TypeDef') -> insertFile(U,'TYPE',X,N,'TypeDef');
		  keep(U,'TYPE',X,'TypeDef2') -> insertFile(U,'TYPE',X,N,'TypeDef2');
		  insertTypeDef(X,N,U) ) ), lf0.
 
/*``ada``Thu Jul 17 10:43:41 MET DST 1997``*/
/* insertTypeDecl(X,N,U) */

insertTypeDecl(X,N,U) :- insertFile(U,'TYPE',X,N,'TypeDecl'), lf0.
 
/*``ada``Wed Dec  4 18:26:49 MET 2002``*/
/* insertTypeDef(X,N,U) */
/*(cf.ADA111), (cf.ADA120), (cf.ADA122), (cf.ADA173) */

insertTypeDef(X,N,U) :- 	
 	( isProtected(U,'TYPE',X) -> 
		( beginEmptyReverse(X,N,U,'TypeDef','ada::'),
		  indent(N), write('protected type '), write(U), 
		  insertDiscriminant(X,U), write(' is '), lf1,
		  publicProtOperSpec(X,N+1,U),
		  ( hasPrivProt(X,U) ->
			( indent(N), write('private'), nl,
		  	  privateProtOperSpec(X,N+1,U),
		  	  insertAttributes(X,N+1,U) ); true ),
		  indent(N), write('end '), write(U), write(';'), nl, 
		  endEmptyReverse(N) );
	( isTask(U,'TYPE',X) -> 
		( indent(N), write('task type '), write(U), 
		  insertDiscriminant(X,U), write(' is '), lf1,
		  taskOperSpec(X,N+1,U),
		  indent(N), write('end '), write(U), write(';'), nl );
	( /* else */
		( beginEmptyReverse(X,N,U,'TypeDef','ada::'),
		  indent(N), write('type '), write(U), 
		  insertDiscriminant(X,U), write(' is '),  
		( if95 ->
			( isAbstract(U,'TYPE',X) -> write('abstract '); true ),
			( inherits(U,X,V,Y) -> 
				( write('new '), scName(X,V,Y), write(' with ') ); 
				( isClass(U,X)  -> write('tagged '); true ) ); true ),
		( attributes(U,X,_,_,_,_) ->
		  	( nl, indent(N), write('record '), nl,
		  	  insertAttributes(X,N+1,U),
		  	  indent(N), write('end record;') );
		( enumeration(U,X,_,_) -> 
			insertEnumeration(X,N+1,U);
		( if95 -> write('null record;'); write(';') ) ) ), nl, 
		endEmptyReverse(N) ) ) ) ). 
 
/*``ada``Wed Dec  4 18:06:39 MET 2002``*/
/* insertAttributes(X,N,U) */
/* (cf.ADA111), (cf.ADA117) */

insertAttributes(X,N,U) :- attributes(U,X,A,T,Y,V), 
	notMe(A), not(discriminant(U,X,A,T,Y,V)), 
	indent(N), write(A), write(' : '), 
	( T='' -> write('UNDEFINED'); dottedName(T,Y) ), 
	( V='' -> true; ( write(' := '), write(V) ) ),
	write(';'), nl, fail.
insertAttributes(X,N,U).
 
/*``ada``Wed Dec  4 18:30:07 MET 2002``*/
/* insertEnumeration(X,N,U) */
/* (cf.ADA173) */

insertEnumeration(X,N,U) :- write('('), nl, 
	enumeration(U,X,E,_) -> ( indent(N), write(E), otherEnum(X,N,U,E) ).
insertEnumeration(X,N,U) :- write(');').

otherEnum(X,N,U,E) :- enumeration(U,X,F,_), F \= E, write(','), nl, indent(N), write(F), fail.
 
/*``ada``Tue Jul 17 14:54:56 MET DST 2001``*/
/* insertDiscriminant(X,U) */
/* (cf.ADA116) */

insertDiscriminant(X,U) :- discriminant(U,X,_,_,_,_) -> write(' ('), fail.
insertDiscriminant(X,U) :-	
	discriminant(U,X,A,T,Y,V), write(A), write(' : '), 
	( T='' -> write('UNDEFINED'); dottedName(T,Y) ), 
	( V='' -> true; ( write(' := '), write(V) ) ), fail.
insertDiscriminant(X,U) :- discriminant(U,X,_,_,_,_) -> write(') '); true.
 
/*``ada``Mon May 19 17:23:01 MET DST 2003``*/
/* dottedName(U,X) */

dottedName(U,X) :- ( ( X\='NIL', X\='' ) -> ( write(X), dot ); true ), write(U).
 
/* scName(X,C,Y) */

scName(X,C,Y) :- /*(cf.ADA179)*/
	( ( ( pragma_not_child_unit(X); nestChild(_,X) ), Y\='NIL', Y\='' ) -> 
		( write(Y), dot ); true ), write(C).
 
/*``ada``Thu Jun 26 17:40:06 MET DST 2003``*/
/* ifEnum(V,Y,E) */

ifEnum(V,Y,E) :- isImplementedBy(V,'TYPE',Y,W,Z) ->
	ifEnum(W,Z,E);
	( keep(V,'TYPE',Y,_) -> 
		specialrequires(V,'TYPE',Y,E,'enumeration',_,'TypeDef'); /*(cf.ADA185)*/
	  	enumeration(V,Y,E,_) ). /*(cf.ADA187)*/

ifEnum(V,Y) :- ifEnum(V,Y,_), !.
 
/*``ada``Tue Jul 17 14:55:11 MET DST 2001``*/
/* renameEqual(X,N,U,O,V) */
/* (cf.ADA101) */

renameEqual(X,N,U,O,V) :- indent(N), 
	write('function "="(left : in '), write(U), 
	write('; right : in '), write(U), write(')'), lf2(N+1), 
	write(' return STANDARD.BOOLEAN renames '), 
	write(O), dot, write('"=";'), lf1.
/*``ada``Tue Jul 17 15:44:35 MET DST 2001``*/
/* insertElem(X,N,U,O,E) */
/* (cf.ADA101), (cf.ADA163) */

insertElem(X,N,U,O,E) :- enumAsConst(X,U) ->
	insertElem1(X,N,U,O,E);
	insertElem2(X,N,U,O,E).

insertElem1(X,N,U,O,E) :- indent(N), write(E), write(' : '), ( renameCst -> /*(cf.ADA163)*/
	( write(U), write(' renames '), write(U), write('('), write(O), dot, write(E), write(')') );
	( write('constant '), write(U), lf2(N+1), write(' := '), write(O), dot, write(E) ) ), write(';'), nl.

insertElem2(X,N,U,O,E) :- indent(N), write('function '), write(E),
	write(' return '), write(U), lf2(N+1), write(' renames '), write(O),
	dot, write(E), write(';'), nl.
/*``ada``Thu Jul 10 17:53:54 MET DST 1997``*/
/* insertData(X,N,U) */

insertData(X,N,U) :-  
	( ifCom -> insertCom(U,'DATA',X,N,'DataTxt'); true ),
	insertFile(U,'DATA',X,N,'DataDef'),
	( address(X,U,V) -> insertAddress(N,U,V); true ), lf0.
 
/*``ada``lundi,  2 dcembre 1996, 14:56:46 MET``*/
/* insertDaOption(X,N,U,O) */

insertDaOption(X,N,U,O) :- 
	indent(N), write('pragma if ( compilation.'), write(O), write(' );'), lf1,
	indent(N+1), write('function TU_'), write(U), write(' return '), writeDataType(X,U), write(';'), lf1,
	indent(N+1), write('procedure TU_WRITE_'), write(U), write(' ( value : '), writeDataType(X,U), write(' );'), lf1,
	indent(N), write('pragma end;'), lf1.
  
writeDataType(X,U) :- requires(U,'DATA',X,T,'TYPE',Y,'DataDef') -> ( write(Y), dot, write(T) ); write('INTEGER').
 
/*``ada``Fri Dec  6 11:21:57 MET 1996``*/
/* insertDaOption2(X,N,U,O) */

insertDaOption2(X,N,U,O) :- 
	indent(N), write('pragma if ( compilation.'), write(O), write(' );'), lf1,
	indent(N+1), write('function TU_'), write(U), write(' return '), writeDataType(X,U), write(' is'), lf1,
	indent(N+1), write('begin'), lf1,
	indent(N+2), write('return '), write(U), write(';'), lf1,
	indent(N+1), write('end TU_'), write(U), write(';'), lf1,
	indent(N+1), write('procedure TU_WRITE_'), write(U), write(' ( value : '), writeDataType(X,U), write(' ) is'), lf1,
	indent(N+1), write('begin'), lf1,
	indent(N+2), write(U), write(' := value;'), lf1,
	indent(N+1), write('end TU_WRITE_'), write(U), write(';'), lf1,
	indent(N), write('pragma end;'), lf1.
 
/*``comments``jeudi,  5 dcembre 1996, 16:43:22 MET``*/
/*-----------------------------*/
/*  OPERATION SPECIFICATION :  */
/*-----------------------------*/
 
/*``ada``Wed Jul  9 15:00:13 MET DST 1997``*/
/* operDecl(X,N,U) */

operDecl(X,N,U) :- indent(N), opType(X,U), opName(X,U), opDescr(X,N,U).
 
/*``ada``Tue Jul 17 14:55:52 MET DST 2001``*/
/* protected & task OperSpec(X,N,T) */
/* (cf.ADA105) */

publicProtOperSpec(X,N,T) :- publicProtOpers(X,T,O), insertOperSpec(X,N,O), fail.
publicProtOperSpec(X,N,T).

privateProtOperSpec(X,N,T) :- privateProtOpers(X,T,O), insertOperSpec(X,N,O), fail.
privateProtOperSpec(X,N,T).

taskOperSpec(X,N,T) :- taskTypeOpers(X,T,O), 
	( isFunction(X,O) ->
		message('*** error : function : ', O,' of : ',X,' may not be a task entry','');
		insertEntrySpec(X,N,O) ) , fail.
taskOperSpec(X,N,T).
 
/*``ada``Tue May 20 09:26:55 MET DST 2003``*/
/* insertOperSpec(X,N,U) */
/* (cf.ADA149) (cf.ADA180) */

insertOperSpec(X,N,U) :- 
	( ifCom -> insertCom(U,'OPERATION',X,N,'OpTxt'); true ),
	( preExtension(X,U) -> insertFile(U,'OPERATION',X,N,'OpDefExt'); true ),	
	indent(N), opType(X,U), opName(X,U), 
	( instExtension(X,U) -> true; ( opDescr2(X,N,U), 
		( contExtension(X,U) -> true; write(';') ) ) ), nl, 
	( postExtension(X,U) -> insertFile(U,'OPERATION',X,N+1,'OpDefExt'); true ), lf0.
 
/*``ada``Tue Jul 17 14:56:14 MET DST 2001``*/
/* protectedOperBody(X,N,T) */
/* (cf.ADA105) */

protectedOperBody(X,N,T) :- indent(N), write('protected body '), write(T), write(' is '), lf1.
protectedOperBody(X,N,T) :- protectedOpers(X,T,O), hasBody(X,O), insertOperBody(X,N+1,O).
protectedOperBody(X,N,T) :- indent(N), write('end '), write(T), write(';'), lf1.
 
/*``OBCS``Wed Jul 18 10:12:58 MET DST 2001``*/
/* taskTypeBody(X,N,T) */

taskTypeBody(X,N,T) :-  /*(cf.ADA169)*/
	( ifV1 ->  ( insertDescr(X,N,U,'ObcsBodyTxt'), dashLine(N) );
	( ifCom -> insertCom('NIL',_,X,N,'ObcsTxt'); true ) ),
	( ifPseudo -> insertPseudo('NIL',_,X,N,'obcs'); true),
	beginEmptyReverse(X,N,T,'TypeDef','ada::'),
	indent(N), write('task body '), write(T), write(' is '), lf1,
	insertAttributes(X,N+1,T), lf0,
	endEmptyReverse(N), 
	( keep('NIL','NIL',X,'obcs') -> 
		insertFile('NIL','NIL',X,N+1,'obcs');
		insertLoop(X,N,T) ), lf0,
	indent(N), write('end '), write(T), write(';'), lf1.

insertLoop(X,N,U) :-  /*(cf.ADA169)*/
	beginEmptyReverse(X,N,'NIL','obcs','ada::'),
	( ifV1 ->  info(N+1,200); true ), 
	taskTypeOpers(X,U,O), not(isFunction(X,O)), 
	entryTask(X,O,'OBCS',T,C,_), not(entryKind(C,2)), declareParam2(X,N+1,O), fail.
insertLoop(X,N,U) :-
	( ifV1 ->  info(N+1,201); true ), 
	taskTypeOpers(X,U,O), not(isFunction(X,O)),
	entryTask(X,O,'OBCS',_,_,_), ( isTransition(X,_,_,_,O) -> declareGuards(X,N+1,O) ), fail.
insertLoop(X,N,U) :- 	
	indent(N), write('begin'), nl,
	indent(N+1), write('loop'), nl, fail.
insertLoop(X,N,U) :-
	( ifV1 ->  info(N+2,202); true ),
 	taskTypeOpers(X,U,O), not(isFunction(X,O)),
	entryTask(X,O,'OBCS',_,_,_), ( isTransition(X,_,_,_,O) -> updateGuards(X,N+2,O) ), fail.
insertLoop(X,N,U) :- 	
	indent(N+2), write('select'), nl, 
	taskTypeOpers(X,U,O), not(isFunction(X,O)), 
	entryTask(X,O,'OBCS',T,C,_), insertEntryBody(X,N+2,O,T,C), fail.
insertLoop(X,N,U) :-	
	indent(N+3), write('terminate;'), nl,
	indent(N+2), write('end select;'), nl,
	indent(N+1), write('end loop;'), nl,
	endEmptyReverse(N).
 
/*``ada``Tue May 20 11:23:00 MET DST 2003``*/
/* insertUncstrOper(X,N,U) */
/* (cf.ADA136), (cf.ADA149), (cf.ADA156) (cf.ADA180) */

insertUncstrOper(X,N,U) :- 
	( ifV1 -> 
		( isProvided(U,'OPERATION',X) ->
			( insertDescr(X,N,U,'OpTxt'), dashLine(N) ); 
			( insertDescr(X,N,U,'Op2Txt'), dashLine(N) ) ); 
		( ifCom -> 
			( isProvided(U,'OPERATION',X) ->
				insertCom(U,'OPERATION',X,N,'OpTxt'); 
				insertCom(U,'OPERATION',X,N,'Op2Txt') ) ); 
			true ),
	( inheritedOp(X,U,T) -> 
		( begCom, write(' Subprogram : '), write(U), 
		  write(' is inherited from : '), write(T), endCom );	
	( isImplementedBy(U,'OPERATION',X,V,Y) -> 
		( operDecl(X,N,U), lf2(N+1),  
		  ( isObject(Y,'OP_CONTROL',X) -> true; 
			( write(' renames '), write(Y), dot, opName(Y,V) ) ), 
		  write(';'), nl );
	( isAbstract(X,U) -> 
		( operDecl(X,N,U), write(' is abstract'), write(';'), nl );
	/* else */  
		( 
			( preExtension(X,U) -> insertFile(U,'OPERATION',X,N,'OpDefExt'); true ),
			( instExtension(X,U) -> true; beginReverse(X,N,U,'none','OpDecl','') ), 
			indent(N), opType(X,U), opName(X,U), 
			( instExtension(X,U) -> true; ( opDescr(X,N,U), 
				( contExtension(X,U) -> true; write(';') ) ) ), nl,
			( instExtension(X,U) -> true; endReverse(N) ),
			( postExtension(X,U) -> insertFile(U,'OPERATION',X,N+1,'OpDefExt'); true )
		) ) ) ), lf0.
 
/*``ada``Tue May 20 09:45:38 MET DST 2003``*/
/* insertConstrOper(X,N,U) */
/* (cf.ADA149), (cf.ADA156) (cf.ADA180)*/

insertConstrOper(X,N,U) :-
	( ifV1 -> 
		( isProvided(U,'OPERATION',X) ->
			( insertDescr(X,N,U,'OpTxt'), dashLine(N) ); 
			( insertDescr(X,N,U,'Op2Txt'), dashLine(N) ) ); 
		( ifCom -> 
			( isProvided(U,'OPERATION',X) ->
				insertCom(U,'OPERATION',X,N,'OpTxt'); 
				insertCom(U,'OPERATION',X,N,'Op2Txt') ) ); 
			true ),
	( inheritedOp(X,U,T) -> 
		( begCom, write(' Subprogram : '), write(U), 
		  write(' is inherited from : '), write(T), endCom );	
	( isImplementedBy(U,'OPERATION',X,V,Y) -> 
		( operDecl(X,N,U), lf2(N+1),  
		  ( isObject(Y,'OP_CONTROL',X) -> true; 
			( write(' renames '), write(Y), dot, opName(Y,V) ) ), 
		  write(';'), nl );
	( isAbstract(X,U) -> 
		( operDecl(X,N,U), write(' is abstract'), write(';'), nl );
	/* else */  
		( 
			( preExtension(X,U) -> insertFile(U,'OPERATION',X,N,'OpDefExt'); true ),
			indent(N), opType(X,U), opName(X,U), 
			( instExtension(X,U) -> true; ( opDescr(X,N,U), lf2(N+1), 
				( contExtension(X,U) -> true; 
					( write(' renames '), taskName(X,U,S), write(S), dot, opName(X,U), write(';') ) ) ) ), nl,
			( postExtension(X,U) -> insertFile(U,'OPERATION',X,N+1,'OpDefExt'); true )
		) ) ) ), lf0.
 
/*``ada``lundi,  2 dcembre 1996, 15:04:50 MET``*/
/* insertOpOption(X,N,U,O) */

insertOpOption(X,N,U,O) :- 
	indent(N), write('pragma if ( compilation.'), write(O), write(' );'), lf1,
	indent(N+1), opType(X,U), opName(X,U), opDescr(X,N+1,U), write(';'), lf1,
	indent(N), write('pragma end;'), lf1.
 
/*``ada``lundi,  2 dcembre 1996, 15:29:03 MET``*/
/* insertOpOption2(X,N,U,O) */

insertOpOption2(X,N,U,O) :- 
	indent(N), write('pragma if ( compilation.'), write(O), write(' );'), lf1,
	indent(N+1), opType(X,U), write('TU_'), opName(X,U), opDescr(X,N+1,U), 
		( sepIntOp(X,U) -> ( write(' is separate;') ); ( lf1, 
			indent(N+1), write('begin'), lf1, 
			indent(N+2), write('null;'), lf1, 
			indent(N+1), write('end TU_'), opName(X,U), write(';') ) ), lf1,
	indent(N), write('pragma end;'), lf1.
 
/*``ada``Thu Jan 13 18:00:43 MET 1994``*/
/* insertNestedOp(X,N,U) */

insertNestedOp(X,N,U) :- insertUncstrOper(X,N,U).

/*``ada``Thu Jul 10 18:04:57 MET DST 1997``*/
/* insertFormOp(X,N,U) */

insertFormOp(X,N,U) :- 
	( ifCom -> insertCom(U,'OPERATION','FORMAL_PARAMETERS',N,'OpTxt'); true ),
	indent(N), write('with '),
	opType('FORMAL_PARAMETERS',U),
	opName('FORMAL_PARAMETERS',U), 
	opDescr('FORMAL_PARAMETERS',N,U), write(';'), lf1.
 
/*``OBCS``Tue May 15 17:50:19 MET DST 2001``*/
/* taskName(X,U,T) */

taskName(X,U,T) :- /*(cf.ADA143)*/
 	( entryTask(X,U,S,_,_,_), S\='OBCS', 
	taskOBCS(X), not(storage(X,S,_,_)) ) ->
		T=S;
		( storage(X,_,_,D) -> T=D; T='OBCS' ).
 
/*``comments``jeudi,  5 dcembre 1996, 16:43:26 MET``*/
/*------------------*/
/* OPERATION BODY : */
/*------------------*/
 
/*``ada``Fri Feb 14 08:27:39 MET 2003``*/
/* insertOperBody(X,N,U) */
/* (cf.ADA105), (cf.ADA135), (cf.ADA136), (cf.ADA156), (cf.ADA176) */

insertOperBody(X,N,U) :- 
	( ( ifMoreHeaders, insOp(X,U) ) -> insertFile(U,_,X,N,'SepHeader'); true ),
	( ifV1 ->  ( insertDescr(X,N,U,'OpBodyTxt'), dashLine(N) );
	( ifCom -> insertCom(U,'OPERATION',X,N,'OpBodyTxt'); true ) ),
	( ifPseudo -> insertPseudo(U,'OPERATION',X,N,'OpDef'); true ),
	indent(N), opType(X,U), oPCSPrefix(X,U), opName(X,U), 
	( implicitReceiver(X,U) -> 
		opDescr2(X,N,U); 
		opDescr(X,N,U) ), 
	( ( isProtectedEntry(X,U), isTransition(X,T,S,_,U) ) -> 
		( write(' when '), insertPreCond(X,T,S,U) ); 
		true ),
	write(' is'), 
	( isAbstract(X,U) -> 
		( write(' abstract;'), nl );
		( nl, renameUnits(X,U,N+1),
		  ( opControl(X,Y,U,V) ->
		  		insertFile(V,'OPERATION',Y,N,'OpDef');
				insertFile(U,'OPERATION',X,N,'OpDef') ),
		  ( ifEnd -> 
			( indent(N), write('end '), oPCSPrefix(X,U), 
		  	  opName(X,U), write(';'), nl );
			true ) ) ), lf0.
 
/*``OBCS``Tue Jul 17 11:38:26 MET DST 2001``*/
/* Pre & Post Conditions */

insertPreCond(X,T,S,U) :-  /*(cf.ADA105)*/
		( both(X,T,S) -> write('( '); true ),
		( file(S,'STATE',X,F1,'GetState') -> ( $see(F1), readFile(0) ); true ),
		( both(X,T,S) -> write(' ) and ( '); true),
		( file(T,'TRANSITION',X,F2,'Condition') -> ( $see(F2), readFile(0) ); true),
		( both(X,T,S) -> write(' )'); true ),
		( none(X,T,S) -> write('True'); true ).

both(X,T,S) :- file(S,'STATE',X,_,'GetState'), file(T,'TRANSITION',X,_,'Condition').
none(X,T,S) :- not(file(S,'STATE',X,_,'GetState')), not(file(T,'TRANSITION',X,_,'Condition')).

insertPostCond(X,S,U) :- 
	file(S,'STATE',X,F,'SetState') -> ( $see(F), readFile(0) ); true.

insertRefused(X,T,U) :- /*(cf.ADA169)*/
	( isTransition(X,T,_,_,U), file(T,'TRANSITION',X,F,'Exception') ) -> ( $see(F), readFile(0) ); write('null;'). 

moreThanOneDestState(X,S1,U) :- isTransition(X,_,_,S2,U), S1 \= S2. /*(cf.ADA169)*/
 
/*``OBCS``Tue Jul 17 17:50:35 MET DST 2001``*/
/* change State */
/* (cf.ADA169) */

changeState(X,N,U) :-
	isTransition(X,T,S0,S1,U), not( moreThanOneDestState(X,S1,U) ), 
	( ifCom -> insertCom(S0,'STATE',X,N,'StateTxt'); true ),
	( ifCom -> insertCom(T,'TRANSITION',X,N,'TransTxt'); true ),
	indent(N), insertPostCond(X,S1,U), nl, !.
changeState(X,N,U) :- 
	( isTransition(X,Tr1,Si1,So1,U) ->  
		( ( ifCom -> insertCom(Si1,'STATE',X,N,'StateTxt'); true ),
		  indent(N), write('if '), insertPreCond(X,Tr1,Si1,U), write(' then'), nl,
		  ( ifCom -> insertCom(Tr1,'TRANSITION',X,N+1,'TransTxt'); true ),
		  indent(N+1), insertPostCond(X,So1,U), nl ); 
		( indent(N), write('if false then null;'), nl ) ),
	isTransition(X,Trn,Sin,Son,U), Trn \= Tr1, 
	( ifCom -> insertCom(Sin,'STATE',X,N,'StateTxt'); true ),
	indent(N), write('elsif '), insertPreCond(X,Trn,Sin,U), write(' then'), nl,
	( ifCom -> insertCom(Trn,'TRANSITION',X,N+1,'TransTxt'); true ),
	indent(N+1), insertPostCond(X,Son,U), nl, fail.
changeState(X,N,U) :-
	indent(N), write('end if;'), nl.

callAndChangeState(X,N,U) :-
	isTransition(X,T,S0,S1,U), not( moreThanOneDestState(X,S1,U) ), 
	( ifCom -> insertCom(S0,'STATE',X,N,'StateTxt'); true ),
	indent(N), write('if '), insertPreCond(X,T,S0,U), write(' then'), nl, /*(cf.ADA189)*/
	( ifCom -> insertCom(T,'TRANSITION',X,N+1,'TransTxt'); true ),
	oPCSCall(X,N+1,U),
	indent(N), insertPostCond(X,S1,U), nl,
	indent(N), write('else '), nl, /*(cf.ADA189)*/
	indent(N+1), insertRefused(X,_,U), nl, /*(cf.ADA189)*/
	indent(N), write('end if;'), nl, !. /*(cf.ADA189)*/
callAndChangeState(X,N,U) :-
	( isTransition(X,Tr1,Si1,So1,U) ->  
		( ( ifCom -> insertCom(Si1,'STATE',X,N,'StateTxt'); true ),
		  indent(N), write('if '), insertPreCond(X,Tr1,Si1,U), write(' then'), nl,
		  ( ifCom -> insertCom(Tr1,'TRANSITION',X,N+1,'TransTxt'); true ),
		  oPCSCall(X,N+1,U),
		  indent(N+1), insertPostCond(X,So1,U), nl ); 
		( indent(N), write('if false then null;'), nl ) ),
	isTransition(X,Trn,Sin,Son,U), Trn \= Tr1, 
	( ifCom -> insertCom(Sin,'STATE',X,N,'StateTxt'); true ),
	indent(N), write('elsif '), insertPreCond(X,Trn,Sin,U), write(' then'), nl,
	( ifCom -> insertCom(Trn,'TRANSITION',X,N+1,'TransTxt'); true ),
	oPCSCall(X,N+1,U),
	indent(N+1), insertPostCond(X,Son,U), nl, fail.
callAndChangeState(X,N,U) :-
	indent(N), write('else '), nl, 
	indent(N+1), insertRefused(X,_,U), nl,
	indent(N), write('end if;'), nl.
 
/*``ada``Tue May 20 14:44:37 MET DST 2003``*/
/* defaultOperBody(X,N,U) */
/* (cf.ADA181) */

defaultOperBody(X,N,U) :- return(U,'OPERATION',X,Y,T,_) -> 
	( indent(N+1), write('void : '), 
	  ( ( Y \= 'NIL', Y \= X ) -> ( write(Y), dot ); true ), 
	  write(T), write(';'), nl, 
	  indent(N), write('begin'), nl, 
	  indent(N+1), write('return void;'), nl );
	( indent(N), write('begin'), nl, 
	  indent(N+1), ( nullBody(C) -> write(C); write('null;') ), nl ).
 
/*``ada``Fri Apr 11 14:51:01 MET DST 1997``*/
/* insertMain(X,N,U,M) */

insertMain(X,N,U,M) :- 
	write('with '), write(X), write(';'), nl,
	write('procedure '), write(M), write(' is'), nl,
	write('begin'), nl,
	indent(1), write(X), dot, opName(X,U), write(';'), nl,
	write('end '), write(M), write(';'), lf1.
 
/*``comments``jeudi,  5 dcembre 1996, 16:43:31 MET``*/
/*----------------------*/
/* ENTRANCE PROCEDURE : */
/*----------------------*/
 
/*``ada``Tue Jul 17 14:57:57 MET DST 2001``*/
/* insertEntranceProc(X,N,U) */
/* (cf.ADA156) */

insertEntranceProc(X,N,U) :- 
	( ifV1 -> 
		( isProvided(U,'OPERATION',X) ->
			( insertDescr(X,N,U,'OpTxt'), dashLine(N) ); 
			( insertDescr(X,N,U,'Op2Txt'), dashLine(N) ) ); 
		( ifCom -> 
			( isProvided(U,'OPERATION',X) ->
				insertCom(U,'OPERATION',X,N,'OpTxt'); 
				insertCom(U,'OPERATION',X,N,'Op2Txt') ) ); 
			true ),
	indent(N), opType(X,U), opName(X,U), opDescr(X,N,U), write(';'), lf1.
 
/*``ada``jeudi, 21 novembre 1996, 16:56:31 MET``*/
/* entrProcBody(X,N,U) */

entrProcBody(X,N,U) :- 
	indent(N), opType(X,U), opName(X,U), opDescr(X,N,U), write(' is'), nl,
	indent(N), write('begin'), nl,
	isImplementedBy(U,'OPERATION',X,V,Y), indent(N+1),
	( isFunction(X,U) -> write('return '); true ), 
	( isObject(Y,'OP_CONTROL',X) -> true; (write(Y), dot) ),
	opCall(Y,N,V), write(';'), nl,
	indent(N), write('end '), opName(X,U), write(';'), lf1.
 
/*``ada``jeudi, 21 novembre 1996, 16:56:53 MET``*/
/* oBCSEntrProcBody(X,N,U) */

oBCSEntrProcBody(X,N,U) :- 
	indent(N), opType(X,U), opName(X,U), opDescr(X,N,U), write(' is'), nl,
	indent(N), write('begin'), nl,
	indent(N+1), write('OBCS.'), opCall(X,N+1,U), write(';'), nl,
	indent(N), write('end '), opName(X,U), write(';'), lf1.
 
/*``OBCS``Tue Jul 17 15:17:02 MET DST 2001``*/
/* insertOPCSCall(X,N,U) */
/* (cf.ADA169) */

insertOPCSCall(X,N,U) :-
	indent(N), opType(X,U), opName(X,U), opDescr(X,N,U), write(' is'), nl,
      indent(N), write('begin'), nl,
	( isTransition(X,_,_,_,U) -> callAndChangeState(X,N+1,U); oPCSCall(X,N+1,U) ),
      indent(N), write('end '), opName(X,U), write(';'), lf1.
 
oPCSCall(X,N,U) :-
      indent(N), ( isFunction(X,U) -> write('return '); true),
		write('OPCS_'), opCall(X,N,U), write(';'), nl.
 
/*``ada``Tue Jul 17 14:58:12 MET DST 2001``*/
/* insertEntryDecl(X,N,O) */
/* (cf.ADA113) */

insertEntryDecl(X,N,O) :- 
	indent(N), write('procedure '), opName(X,O), opDescr(X,N,O), write(';'), lf1.
 
/*``ada``Tue Jul 17 14:58:23 MET DST 2001``*/
/* insertEntryCall(X,N,O,T) */
/* (cf.ADA113) */

insertEntryCall(X,N,O,T) :- 
	indent(N), write('procedure '), opName(X,O), opDescr(X,N,O), write(' is'), nl,
	indent(N), write('begin'), nl,
	indent(N+1), write('me'), dot, opCall2(X,N,O), write(';'), nl,
	indent(N), write('end '), opName(X,O), write(';'), lf1.
 
/*``comments``jeudi,  5 dcembre 1996, 16:43:35 MET``*/
/*-----------------------*/
/* OPERATION ARGUMENTS : */
/*-----------------------*/
 
/*``ada``Tue Jul 17 14:58:41 MET DST 2001``*/
/* opDescr(X,N,U) */
/* (cf.ADA117), (cf.ADA153) */

opDescr(X,N,U) :- 
	( argument(U,'OPERATION',X,M,A,Y,T,V,K) -> 
	( write(' ('), insertArg(X,N,U,M,A,Y,T,V,K) ) ), fail.
opDescr(X,N,U) :- 
	( argument(U,_,X,_,_,_,_,_,_) -> write(')'); true ),
	( return(U,'OPERATION',X,Y,T,_) -> ( lf2(N+1), write(' return '), 
		( (Y \= 'NIL', Y \= X) -> ( typePackage(X,Y), dot ); true ), 
		write(T) ); true ).

opDescr2(X,N,U) :- 
	( ( argument(U,'OPERATION',X,M,A,Y,T,V,K), notMe(A) ) -> 
	( write(' ('), insertArg2(X,N,U,M,A,Y,T,V,K) )), fail.
opDescr2(X,N,U) :- 
	( ( argument(U,_,X,_,A,_,_,_,_), notMe(A) ) -> write(')'); true ),
	( return(U,'OPERATION',X,Y,T,_) -> ( lf2(N+1), write(' return '), 
		( (Y \= 'NIL', Y \= X) -> ( typePackage(X,Y), dot ); true ), 
		write(T) ); true ).
 
/*``ada``Tue Jul 17 14:58:53 MET DST 2001``*/
/* opCall(X,N,U) */
/* (cf.ADA117) */

opCall(X,N,U) :- opName(X,U), argument(U,'OPERATION',X,_,A,_,_,_,_) ->
        ( write(' ('), insertArg(X,N,U,A), fail ).
opCall(X,N,U) :- argument(U,'OPERATION',X,_,A,_,_,_,_) -> write(' )'); true.

opCall2(X,N,U) :- opName(X,U), 
	( argument(U,'OPERATION',X,_,A,_,_,_,_), notMe(A) ) ->
      ( write(' ('), insertArg2(X,N,U,A), fail ).
opCall2(X,N,U) :- 
	( argument(U,'OPERATION',X,_,A,_,_,_,_), notMe(A) ) -> 
	write(' )'); true.

opCall3(X,N,U) :- opName(X,U), 
	( argument(U,'OPERATION',X,_,A,_,_,_,_), notMe(A) ) ->
      ( write(' ('), insertArg3(X,N,U,A), fail ).
opCall3(X,N,U) :- 
	( argument(U,'OPERATION',X,_,A,_,_,_,_), notMe(A) ) -> 
	write(' )'); true.
 
/*``ada``Tue Jul 17 14:59:16 MET DST 2001``*/
/* insertArg(X,N,U,M,A,Y,T,V,K) */
/* (cf.ADA117), (cf.ADA153), (cf.ADA160) */

insertArg(X,N,U,M1,A1,Y1,T1,V1,K1) :- writeArg(X,N,U,M1,A1,Y1,T1,V1,K1), 
	argument(U,'OPERATION',X,M2,A2,Y2,T2,V2,K2),
	A2 \= A1, write('; '), writeArg(X,N,U,M2,A2,Y2,T2,V2,K2).

insertArg2(X,N,U,M1,A1,Y1,T1,V1,K1) :- writeArg(X,N,U,M1,A1,Y1,T1,V1,K1), 
	argument(U,'OPERATION',X,M2,A2,Y2,T2,V2,K2),
	notMe(A2), A2 \= A1, write('; '), writeArg(X,N,U,M2,A2,Y2,T2,V2,K2).

writeArg(X,N,U,M,A,Y,T,V,K) :- lf2(N+1), write(A), write(' : '), writeMode(M,K), 
	( (Y \= 'NIL',  Y \= X) -> ( typePackage(X,Y), dot ); true ), cutLine(X,N,U), write(T), 
	( V \= '' -> ( write(' := '), write(V) ); true).

typePackage(X,Y) :- 
	( X='FORMAL_PARAMETERS', renames(A,[Z]), memezTra(A,Y) ) ->
	write(Z); write(Y).
 
/*``ada``Tue Jul 17 14:59:27 MET DST 2001``*/
/* insertArg(X,N,U,A) */
/* (cf.ADA117) */

insertArg(X,N,U,A) :- write(A), 
	argument(U,'OPERATION',X,_,B,_,_,_,_), A\=B, 
	write(', '), cutLine(X,N,U), write(B).

insertArg2(X,N,U,A) :- write(A), 
	argument(U,'OPERATION',X,_,B,_,_,_,_), 
	A\=B, notMe(B), write(', '), cutLine(X,N,U), write(B).

insertArg3(X,N,U,A) :- write(U), write('_'), write(A),  
	argument(U,'OPERATION',X,_,B,_,_,_,_), 
	A\=B, notMe(B), write(', '), cutLine(X,N,U), 
	write(U), write('_'), write(B).
 
/*``ada``Wed Apr 10 15:04:34 MET DST 2002``*/
/* opType(X,U) */
/* (cf.ADA105) */

opType(X,U) :-  
	isFunction(X,U) -> write('function '); 
	isProtectedEntry(X,U) -> write('entry ');
	write('procedure ').

/* (cf.ADA171) */
opType2(X,U) :-  
	isFunction(X,U) -> write('function '); 
	isProtectedEntry(X,U) -> write('entry ');
	( isProtectedOp(X,U,_), hasFac(X,U) ) -> write('entry ');
	write('procedure ').
  
/*``ada``Tue Jul 17 14:59:56 MET DST 2001``*/
/* opName(X,U) */
/* (cf.ADA108), (cf.ADA141) */

opName(X,U) :- 
	( $name(U,L), $memberchk(35,L) ) -> ( $reverse(L,R),strip(R) ); 
	( isOperator(X,U) -> ( write('"'), write(U), write('"') ); write(U) ).

strip([35|R]) :- $reverse(R,L), $name(U,L), 
	( isOperator(X,U) -> ( write('"'), write(U), write('"') ); write(U) ), !.
strip([X|R]) :- strip(R).
/*``ada``Tue Jul 17 15:00:06 MET DST 2001``*/
/* oPCSPrefix(X,U) */
/* (cf.ADA105) */

oPCSPrefix(X,U) :- 
	( isOBCSEntry(U,'OPERATION',X), not(isObject(X,'OP_CONTROL',_)) ) -> 
	write('OPCS_'); true.
 
/*``ada``Fri Aug  8 10:32:19 MET DST 1997``*/
/* writeMode(M,K) */

writeMode(M,K) :- 
	M='in' -> ( K\='NIL' -> 
		( ifLowerCase -> write('access '); write('ACCESS ') );
		( ifLowerCase -> write('in '); write('IN ') ) );
	M='out' -> ( ifLowerCase -> write('out '); write('OUT ') );
	M='in out' -> ( ifLowerCase -> write('in out '); write('IN OUT ') );
	M='inout' -> ( ifLowerCase -> write('in out '); write('IN OUT ') ).
 
/*``comments``jeudi,  5 dcembre 1996, 16:43:40 MET``*/
/*------------*/
/* EXCEPTIONS */
/*------------*/
 
/*``ada``Tue Jul 17 15:00:19 MET DST 2001``*/
/* insertEx(X,N,U) */
/* (cf.ADA101) */

insertEx(X,N,U) :- 
	( ifCom -> insertCom(U,'EXCEPTION',X,N,'ExcTxt'); true ),
	indent(N), write(U), write(' : exception'),	
	( isImplementedBy(U,'EXCEPTION',X,V,Y) -> 
		( lf2(N+1), write(' renames '), write(Y), dot, write(V) );
		true ),
	write(';'), lf1.
 
/*``comments``jeudi,  5 dcembre 1996, 16:43:44 MET``*/
/*-------*/
/* TASKS */
/*-------*/
 
/*``OBCS``Tue Jul 17 13:56:31 MET DST 2001``*/
/* taskSpec(X,N,Y) */

taskSpec(X,N,Y) :- 	
	indent(N), write('task '), 
	( storage(X,Y,_,_) -> write('type '); true ), write(Y), write(' is'), nl, /*(cf.ADA143)*/
	( priority(X,E) ->  ( indent(N+1), write('pragma priority('), write(E), write(');'), nl ); true ). /*(cf.ADA165)*/
taskSpec(X,N,Y) :- isProvided(U,'OPERATION',X), notInit(X,U), 
	entryTask(X,U,Y,_,_,_), insertEntrySpec(X,N+1,U).
taskSpec(X,N,Y) :- indent(N), write('end '), write(Y), write(';'), nl.
 
/*``OBCS``Tue Jul 17 15:17:35 MET DST 2001``*/
/* taskBody(X,N,Y) */

taskBody(X,N,Y) :- 	
	indent(N), write('task body '), write(Y), write(' is'), lf1,
	renameUnits(X,'OBCS',N+1), /*(cf.ADA135)*/
	( keep('NIL','NIL',X,'obcs' ) ->
		insertFile('NIL','NIL',X,N+1,'obcs');
		insertLoop2(X,N,Y) ), lf0,
	indent(N), write('end '), write(Y), write(';'), lf1.

insertLoop2(X,N,Y) :- /*(cf.ADA169)*/
	beginEmptyReverse(X,N,'NIL','obcs','ada::'), 
	( ifV1 ->  info(N+1,200); true ), 
	isProvided(O,'OPERATION',X), notInit(X,O), 
	entryTask(X,O,Y,_,C,_), not(entryKind(C,2)), declareParam2(X,N+1,O), fail.
insertLoop2(X,N,Y) :-
	( ifV1 ->  info(N+1,201); true ), 
	isProvided(O,'OPERATION',X), notInit(X,O),
	entryTask(X,O,Y,_,_,_), ( isTransition(X,_,_,_,O) -> declareGuards(X,N+1,O) ), fail.
insertLoop2(X,N,Y) :-	
	indent(N), write('begin'), nl,
	indent(N+1), write('loop'), nl, fail.
insertLoop2(X,N,Y) :-
	( ifV1 ->  info(N+2,202); true ), 
	isProvided(O,'OPERATION',X), notInit(X,O),
	entryTask(X,O,Y,_,_,_), ( isTransition(X,_,_,_,O) -> updateGuards(X,N+2,O) ), fail.
insertLoop2(X,N,Y) :-
	indent(N+2), write('select'), nl,
	isProvided(O,'OPERATION',X), notInit(X,O), 
	entryTask(X,O,Y,T,C,_), 	insertEntryBody(X,N+2,O,T,C), fail.
insertLoop2(X,N,Y) :- 	
	indent(N+3), write('terminate;'), nl,
	indent(N+2), write('end select;'), nl,
	indent(N+1), write('end loop;'), nl,
	endEmptyReverse(N).
  
/*``OBCS``Tue May 15 17:52:41 MET DST 2001``*/
/* insertEntrySpec(X,N,U) */

insertEntrySpec(X,N,U) :- /*(cf.ADA105)*/
	(interVect(X,U,V) -> (indent(N), write('pragma INTERRUPT_HANDLER;'), nl); true),
	indent(N), write('entry '), opName(X,U), opDescr2(X,N,U), write(';'), nl,
	( ( interVect(X,U,V) ; address(X,U,V) ) ->  insertAddress(N,U,V); true ).
 
/*``OBCS``Tue Jul 17 15:18:00 MET DST 2001``*/
/* insertEntryBody(X,N,O,T,C) */
/* (cf.ADA169) */

insertEntryBody(X,N,O,T,C) :- 
	indent(N+1), write('-- '), write(C), nl, 
	( isTransition(X,_,_,_,O) -> ( 
		( ifV1 -> info(N+1,203); true ),
		indent(N+1), write('when '), write(O), write('_accepted =>'), nl ); true ),
	indent(N+1), write('accept '), opName(X,O), opDescr2(X,N+1,O),
	( entryKind(C,2) -> syncCall(X,N,O,T); asyncCall(X,N,O,T) ),
	indent(N), write('or'), nl,
	isTransition(X,_,_,_,O) -> ( 
		( ifV1 -> info(N+1,204); true ), 
		indent(N+1), write('when not '), write(O), write('_accepted =>'), nl,
		indent(N+1), write('accept '), opName(X,O), opDescr2(X,N+1,O), write(';'), nl, 
		indent(N+1), insertRefused(X,_,O), nl, 
		indent(N), write('or'), nl ).
 
/*``OBCS``Tue Jul 17 11:58:58 MET DST 2001``*/
/* syncCall(X,N,U,T) */
/* (cf.ADA169) */

syncCall(X,N,U,T) :-
	write(' do'), nl,
	indent(N+2), write('begin'), nl, 
	indent(N+3), callType(T), opCall2(X,0,U), write(';'), nl,
	( isTransition(X,_,_,_,U) -> changeState(X,N+3,U); true ),
	indent(N+2), write('exception'), nl,
	indent(N+3), write('when others =>'), nl,
	indent(N+4), write('raise;'), nl,
	indent(N+2), write('end;'), nl, 
	indent(N+1), write('end '), opName(X,U), write(';'), nl.
 
/*``OBCS``Fri Apr  5 18:23:44 MET DST 2002``*/
/* asyncCall(X,N,U,T) */
/* (cf.ADA169) */

asyncCall(X,N,U,T) :-
	( ( argument(U,'OPERATION',X,_,P,_,_,_,_), notMe(P) ) ->
		( write(' do'), nl, copyParam2(X,N,U),
		  indent(N+1), write('end '), opName(X,U), write(';'), nl );
		( write(';'), nl ) ),
	indent(N+1), write('begin'), nl,
	indent(N+2), callType(T), opCall3(X,0,U), write(';'), nl,
	( isTransition(X,_,_,_,U) -> changeState(X,N+2,U); true ),
	indent(N+1), write('exception'), nl,
	indent(N+2), write('when others =>'), nl,
	indent(N+3), write('raise;'), nl,
	indent(N+1), write('end;'), nl.

/*``OBCS``Mon Apr  8 17:59:10 MET DST 2002``*/
/* insertCyclicSpec(X,N) */
/* (cf.ADA171) */

withForCyclicSpec(X,N).

insertCyclicSpec(X,N) :- 
	indent(N), write('task THREAD is'), nl, 
	indent(N+1), write('pragma PRIORITY('), write(X), write('_RTATT.INITIAL_THREAD_PRIORITY);'), nl, 
	indent(N), write('end THREAD;'), lf1.
 
/*``OBCS``Wed Apr 10 16:38:14 MET DST 2002``*/
/* insertSporadicSpec(X,N) */
/* (cf.ADA171) */

withForSporadicSpec(X,N) :-
	indent(N), write('with Ada.Real_Time; use Ada.Real_Time;'), nl, 
	indent(N), write('with RTA; use RTA;'), nl.

insertSporadicSpec(X,N) :- 
	indent(N), write('protected OBCS is'), nl, 
	indent(N+1), write('pragma PRIORITY('), write(X), write('_RTATT.INITIAL_CEILING_PRIORITY);'), nl, 
	indent(N+1), write('procedure Start;'), nl, 
	indent(N+1), write('entry WAIT_START;'), nl, 
	indent(N), write('private'), nl, 
	indent(N+1), write('STARTED : BOOLEAN := FALSE;'), nl, 
	indent(N), write('end OBCS;'), lf1.
 
/*``OBCS``Wed Apr 10 16:38:25 MET DST 2002``*/
/* insertProtectedSpec(X,N) */
/* (cf.ADA171) */

withForProtectedSpec(X,N) :-
	indent(N), write('with Ada.Real_Time; use Ada.Real_Time;'), nl, 
	indent(N), write('with RTA; use RTA;'), nl.

insertProtectedSpec(X,N) :- 
	indent(N), write('protected OBCS is'), nl, 
	indent(N+1), write('pragma PRIORITY('), write(X), write('_RTATT.INITIAL_CEILING_PRIORITY);'), nl, 
	isProtectedOp(X,U,_),  
	indent(N+1), opType2(X,U), opName(X,U), opDescr2(X,N+1,U), write(';'), nl, fail.
insertProtectedSpec(X,N) :- 
	indent(N), write('private'), nl, 
	isProtectedOp(X,U,_), hasFac(X,U), 
	indent(N+1), write(U), write('_FAC : BOOLEAN := FALSE;'), nl, fail.
insertProtectedSpec(X,N) :- 
	indent(N), write('end OBCS;'), lf1.
 
/*``OBCS``Wed Apr 10 12:09:57 MET DST 2002``*/
/* insertCyclicBody(X,N) */
/* (cf.ADA171) */

withForCyclicBody(X,N) :- 
	indent(N), write('with Ada.Real_Time; use Ada.Real_Time;'), nl, 
	indent(N), write('with RTA; use RTA;'), nl.

insertCyclicBody(X,N) :- 
	indent(N), write('task body THREAD is'), nl, 
	indent(N+1), write('T : Ada.Real_Time.TIME := Ada.Real_Time.CLOCK;'), nl, 
	indent(N), write('begin'), nl, 
	indent(N+1), write('if T < RTA.SYSTEM_START_UP_TIME then'), nl, 
	indent(N+2), write('T := RTA.SYSTEM_START_UP_TIME;'), nl, 
	indent(N+1), write('end if;'), nl, 
	indent(N+1), write('T := T + '), write(X), write('_RTATT.OFFSET(RTA.START_MODE);'), nl, 
	indent(N+1), write('loop'), nl, 
	indent(N+2), write('delay until T;'), nl, 
	indent(N+2), isThread(X,U), write('OPCS_'), opCall2(X,N+2,U), write(';'), nl, 
	indent(N+2), write('T := T + '), write(X), write('_RTATT.PERIOD(RTA.CURRENT_MODE);'), nl, 
	indent(N+1), write('end loop;'), nl, 
	indent(N), write('end THREAD;'), lf1.
 
/*``OBCS``Wed Apr 10 14:29:05 MET DST 2002``*/
/* insertSporadicBody(X,N) */
/* (cf.ADA171) */

withForSporadicBody(X,N).

insertSporadicSpec2(X,N) :- 
	indent(N), write('task THREAD is'), nl, 
	indent(N+1), write('pragma PRIORITY('), write(X), write('_RTATT.INITIAL_THREAD_PRIORITY);'), nl, 
	indent(N), write('end THREAD;'), lf1.

insertSporadicBody(X,N) :- 
	indent(N), write('task body THREAD is'), nl, 
	indent(N), write('begin'), nl, 
	indent(N+1), write('loop'), nl, 
	indent(N+2), write('OBCS.WAIT_START;'), nl, 
	indent(N+2), isStart(X,U), write('OPCS_'), opCall2(X,N+2,U), write(';'), nl, 
	indent(N+1), write('end loop;'), nl, 
	indent(N), write('end THREAD;'), lf1, 

	indent(N), write('protected body OBCS is'), nl, 
	indent(N+1), opType(X,U), opName(X,U), opDescr2(X,N+1,U), write(' is'), nl, 
	indent(N+1), write('begin'), nl,
	indent(N+2), write('if not STARTED then'), nl, 
	indent(N+3), write('STARTED := TRUE;'), nl, 
	indent(N+2), write('end if;'), nl, 
	indent(N+1), write('end '), write(U), write(';'), nl, 
	indent(N+1), write('entry WAIT_START when STARTED is'), nl, 
	indent(N+1), write('begin'), nl, 
	indent(N+2), write('STARTED := FALSE;'), nl, 
	indent(N+1), write('end WAIT_START;'), nl, 
	indent(N), write('end OBCS;'), lf1.
 
/*``OBCS``Wed Apr 10 17:20:29 MET DST 2002``*/
/* insertProtectedBody(X,N) */
/* (cf.ADA171) */

withForProtectedBody(X,N).

insertProtectedBody(X,N) :- 
	indent(N), write('protected body OBCS is'), nl, 
	isProtectedOp(X,U,_), 
	indent(N+1), opType2(X,U), opName(X,U), opDescr2(X,N+1,U), 
	( hasFac(X,U) -> ( write(' when '), write(U), write('_FAC is') ); write(' is') ), nl, 
	indent(N+1), write('begin'), nl, 
	( hasFac(X,U) -> 
		( indent(N+2), write(U), write('_FAC := FALSE;'), nl );
		( hasFac(X,_) -> 
			( hasFac(X,V), indent(N+2), write(V), write('_FAC := TRUE;'), nl ); true ) ),
	indent(N+2), ( isFunction(X,U) -> write('return '); true ), 
		write('OPCS_'), opCall2(X,N+2,U), write(';'), nl, 
	indent(N+1), write('end '), write(U), write(';'), nl,  fail.
insertProtectedBody(X,N) :- 
	indent(N), write('end OBCS;'), lf1.
 
/*``comments``jeudi,  5 dcembre 1996, 16:43:49 MET``*/
/*-------*/
/* STUBS */
/*-------*/
 
/*``ada``Tue Jul 17 15:00:29 MET DST 2001``*/
/* insertOperStub(X,N,U) */
/* (cf.ADA105) */

insertOperStub(X,N,U) :- 
	indent(N), opType(X,U), oPCSPrefix(X,U), opName(X,U), 
	( implicitReceiver(X,U) -> 
		opDescr2(X,N,U); 
		opDescr(X,N,U) ), 
	lf2(N+1), write(' is separate;'), lf1.
 
/*``ada``Tue Jul 17 15:00:40 MET DST 2001``*/
/* insertOBCSStub(X,N) */
/* (cf.ADA143) */

insertOBCSStub(X,N) :- packageOBCS(X) ->
	( indent(N), write('package body OBCS is separate;'), lf1 );
	( indent(N), write('task body '), 
	  ( storage(X,T,_,_) -> write(T); write('OBCS') ),
	  write(' is separate;'), lf1,
	  servTask(X,S), indent(N), write('task body '), write(S), 
	  write(' is separate;'), lf1 ).
 
/*``ada``jeudi, 21 novembre 1996, 16:58:35 MET``*/
/* insertPackStub(X,N,Y) */

insertPackStub(X,N,Y) :- indent(N), write('package body '), 
	write(Y), write(' is separate;'), lf1.
 
/*``ada``Fri Jul 11 14:13:20 MET DST 1997``*/
/* insertInitBloc(X,N) */

insertInitBloc(X,N) :- 
	( ( ( isProvided(U,'OPERATION',X); isInternal(U,'OPERATION',X) ), ifInit(X,U) ) -> 
		insertFile(U,'OPERATION',X,N,'OpDef');
		insertFile(_,_,X,N,'Init') ), lf0.
 
/*``comments``jeudi,  5 dcembre 1996, 16:43:54 MET``*/
/*------------------------*/
/* INSTANCE DECLARATION : */
/*------------------------*/
 
/*``ada``Fri May 23 11:52:52 MET DST 2003``*/
/* instanceSpec(X,N,I,C) */
/* (cf.ADA110) (cf.ADA184) */

instanceSpec(X,N,I,C) :- indent(N), write('package '), 
	write(I), write(' is new '), 
	( ( ( ( renames(X,Z,[Y]); renames(Z,[Y]) ), memezTra(Z,C) ) -> 
		( write(Y), ( alreadyWritten(Y,C) -> true; ( dot, write(C) ) ) ) ); write(C) ), 
	instPar(X,N,I,C).
instanceSpec(X,N,I,C) :- write(';'), lf1.
instanceSpec(X,N,I,C) :- dataPage(X,P), insertDataPage(I,N,P).

alreadyWritten(Y,C) :- $name(Y,L1), $name(C,L2), $reverse(L1,L3), $reverse(L2,L4), compare(L3,L4).

compare([46|_],[]) :-  !.
compare([C1|L1],[C2|L2]) :- ( C1 =:= C2; C1 =:= C2 + 32; C1 =:= C2 - 32 ), 
	L1 \= [], compare(L1,L2).
 
/*``ada``jeudi, 28 novembre 1996, 10:48:19 MET``*/
/* instPar(X,N,I,C) */

instPar(X,N,I,C) :- actualParameter(F,_,X,A) -> 
	( write(' ('), insActPar(F,X,N,A), fail ).
instPar(X,N,I,C) :- actualParameter(F,_,X,A) ->
	write(' )').

insActPar(F,X,N,A) :- writePar(F,X,N,A), otherPar(F,X,N,A).
writePar(F,X,N,A) :- lf2(N+1), write(F), write(' => '), write(A).
otherPar(F,X,N,A) :- actualParameter(G,_,X,B), G\=F, write(', '), writePar(G,X,N,B).
 
/*``ada``Wed Apr  9 16:38:16 MET DST 1997``*/
/* insertAddress(N,U,V) */

insertAddress(N,U,V) :- indent(N), write('for '), write(U), write(' use at '), write(V), write(';'), lf1.
 
/*``ada``Thu Apr 10 12:19:21 MET DST 2003``*/
/* withes(X,N,Y) */
/* (cf.ADA123), (cf.ADA136) */

with(X,N,Y) :- notToWith(X,Y) -> fail; 
	( indent(N), write('with '), unitRef(X,Y), write(';'), nl ).

notToWith(X,Y) :- withed(X,Y); filter(X,Y);
	( withed(X,Z), memezTra(Y,Z) );
	( isNesting(X), isChild(Y,X) ); 
	( isChild(X,Z), isNesting(Z), ( withed(Z,Y);isChild(Y,Z) ) );
	( childUnit(X,L), $member(Y,L) ).

filter(X,Y) :- memezTra(X,Y); memezTra(Y,'FORMAL_PARAMETERS'); memezTra(Y,'STANDARD');
	memezTra(Y,'NIL'); Y='?'; opControl(X,Y,_,_).
 
withes(X,N,Y) :- with(X,N,Y), $assert(withed(X,Y)), use(X,N,Y).
	
withes(X,O,N,Y) :- not(withed(X,O,Y)), with(X,N,Y), $assert(withed(X,O,Y)), use(X,N,Y).

use(X,N,Y) :- 
	( ( use(X,Z); libTypes(_,Z); ancillary(_,_,Z) ), memezTra(Y,Z) ) -> 
		( indent(N), write(' use '), unitRef(Y), write(';'), nl );
		( if95, isProvided(T,'TYPE',Y), reqType(X,T,Y), useType(T,Y),
		  indent(N), write('use type '), unitRef(Y), dot, write(T), write(';'), nl ).

reqType(X,T,Y) :- 
	( requires(_,_,X,T,'TYPE',Y,_); isImplementedBy(_,'TYPE',X,T,Y); 
	( ( attributes(_,X,_,R,Z,_); inherits(_,X,R,Z) ), R\='', memezTra(T,R), memezTra(Y,Z) ) ), !. /*(cf.ADA157)*/
/*``ada``Thu May 22 11:41:41 MET DST 2003``*/
/* renameUnits(X,N) */
/* (cf.ADA131), (cf.ADA135) */

renameUnits(X,N) :- renameIt(X,Y,L), 
	( renamed(X,Y) -> true;
		( indent(N), 
		  ( isGeneric(Y) -> write('generic '); true ),
		  write('package '), write(Y), 
		  write(' renames '), unitRef(X,Y,L), write(';'), nl,
		  $assert(renamed(X,Y)) ) ), fail.
renameUnits(X,N).

renameUnits(X,O,N) :- withed(X,O,Y), renameIt(X,Y,L),
	( renamed(X,Y) -> true;
		( indent(N), 
		( isGeneric(Y) -> write('generic '); true ),
		  write('package '), write(Y), 
		  write(' renames '), unitRef(X,Y,L), write(';'), nl ) ), fail.
renameUnits(X,O,N).

unitRef(X,Y,L) :- 
	( renames(Z,[P]), memezTra(Z,Y) ) -> 
		write(P);
		( dottedList(L), write(Y) ).

unitRef(X,Y) :- /*(cf.ADA184)*/
	( ( renames(X,Z,[P]); renames(Z,[P]) ), memezTra(Z,Y) ) -> ( addRenameIt(X,Y,[P]), write(P) );
	childUnit(Y,L) -> ( addRenameIt(X,Y,L), dottedList(L), write(Y) ); 
	write(Y). 
	
unitRef(Y) :- /*(cf.ADA184)*/
	( ( renames(X,Z,[P]); renames(Z,[P]) ), memezTra(Z,Y) ) -> write(P);
	childUnit(Y,L) -> ( dottedList(L), write(Y) );
	write(Y).

addRenameIt(X,Y,L) :- renameIt(X,Y,_) -> true; $assert(renameIt(X,Y,L)).
 
