/*-------------------------------------------------
  STOOD 5.0
  C code generator

  Copyright TNI Europe & Ellidiss Technologies 2004-2005
  Pierre DISSAUX (pierre.dissaux@tni-world.com)
  01.Feb.2005
--------------------------------------------------*/
/*--------------------------------------------------
changes:
Version : 1.1 (14.Dec.1999) extensions for Real-Time Operating Systems.
C001 (17.04.00) fixing a bug in pragma line_width.
C002 (17.04.00) new pragma full_prototypes.
C003 (17.04.00) fixing a bug when reversing State constrained Ops.
C004 (20.04.00) new pragma substitute_header.
C005 (09.05.00) decorative changes in operation prototypes.
C006 (18.05.00) main recognition in a terminal root.
C007 (18.05.00) default value 0 for GetState
C008 (18.05.00) declare OPCS before STATE only op body
C009 (18.05.00) no accept code for STATE only op in OBCS
C010 (05.07.00) modified pragam reverse to add a personalized string in comments
C011 (06.07.00) new pragma prefix_all (op bodies)
C012 (06.07.00) new pragma append_header
C013 (07.07.00) handles const for provided constants
C014 (07.07.00) new messages for missing exceptions
C015 (18.07.00) pragma no_define for non term consts, types and ops
C016 (18.07.00) new management of  #include statements
C017 (18.07.00) pragma presentation: no_line_feed et indent_param
C018 (18.07.00) changes in STATE only operation code
C019 (19.07.00) fixes bugs related to C015
C020 (19.07.00) new management of required interface description
C021 (20.07.00) fixes a bug in #define constants detection
C022 (04.08.00) new pragma inline_def
C023 (19.09.00) ref. STOOD-C-CNES-1 : bug in accept rule for generic
C024 (19.09.00) ref. STOOD-C-CNES-2 : unneeded OBCS when ASER only
C025 (20.09.00) ref. STOOD-C-CNES-3 : new rules for ASER constraint
C026 (27.09.00) ref. STOOD-C-CNES-4 : adding call_ dummy parameter
C027 (27.09.00) ref. STOOD-C-CNES-5 : no main if no pragma_main
C028 (27.09.00) ref. STOOD-C-CNES-6 : new pragma prefix_none
C029 (27.09.00) new pragma storage to include parameters pointer keywords
C030 (05.10.00) ref. STOOD-C-CNES-7 : major changes to OBCS code
C031 (05.10.00) ref. STOOD-C-CNES-8 : cyclic tasks when aser by_it constraint
C032 (13.10.00) fixes a bug in operation declaration parameter types (cf C028)
C033 (13.10.00) new pragma no_command_line to control arguments of main function
-- CD-Rom #5 (November 2000)
C034 (20.10.00) ref. STOOD-C-CNES-9 : fixes a few problems in main functions
C035 (20.10.00) allows inline for internal operations
C036 (25.10.00) removes the semi colon too many in some constants declarations
C037 (04.12.00) ref. STOOD-C-CNES-10 : fixes a pb for STATE only constrained ops (cf C031)
C038 (04.12.00) ref. STOOD-C-CNES-11 : using pragma pointer for channels message
C039 (04.12.00) ref. STOOD-C-CNES-12 : fixes a pb for BY_IT constraints (cyclic tasks)
C040 (04.12.00) ref. STOOD-C-CNES-13 : avoids task management for non term modules
C041 (04.12.00) ref. STOOD-C-CNES-14 : fixes a lack of break statement in OBCS
C042 (05.12.00) ref. STOOD-C-CNES-15 : changes in OBCS stop procedure
C043 (06.12.00) ref. STOOD-C-CNES-16 : new pragma target_param(stack_address,_)
C044 (06.12.00) ref. STOOD-C-CNES-17 : completing ASER server tasks
C045 (11.12.00) makefile: change in pragma location and new pragma ldflags
C046 (17.10.01) change in the truncation mode for long comments lines
C047 (30.11.01) ref. CS-1001-DC : const qualifier for in parameters
-- CD-Rom #6 (December 2001)
C048 (06.03.02) ref. MSAT/02.010 : default is now full prototypes, else use pragma incomplete_prototypes
C049 (07.03.02) ref. MSAT/02.040 : new value "microsat" for pragma presentation, flag ifPres1
C050 (08.03.02) ref. MSAT/02.050 : new style for #ifndef/#define/#endif of header files for microsat
C051 (08.03.02) ref. MSAT/02.060 : default contents for file headers
C052 (08.03.02) ref. MSAT/02.110 : default contents for operation headers for microsat
C053 (08.03.02) ref. MSAT/02.180 : inserting modification (ObModifTxt) for microsat
C054 (11.03.02) ref. RASTO/01.109 : new pragma static for controled access to internals
C055 (11.03.02) automatic generation of a struct type when attributes are defined
C056 (12.03.02) ref. RASTO/02.011 : improving detection of #define constants
C057 (14.03.02) ref. RASTO/02.012 : using #include <...> instead of #include "..." for microsat
C058 (26.04.02) ref. CS-1600-DC : fixing pb with use of pragma "reverse" without "comment"
C059 (26.04.02) ref. MSAT/02.500 : fixing various pb. supporting microsat coding rules
C060 (18.06.02) ref. MSAT/DM-05-02 : add empty line before DESCRIPTION and FUNCTION list
C061 (18.06.02) ref. MSAT/DM-05-02 : add Module name for provided operations
C062 (18.06.02) ref. MSAT/DM-05-02 : add Module name for provided operations into module header
C063 (18.06.02) ref. MSAT/DM-05-02 : add star line after function def
C064 (18.06.02) ref. MSAT/RA-05-02 : fixing C file header genrated with H file name
C065 (18.06.02) ref. MSAT/RA-05-02 : take in account tab in comment
C066 (18.06.02) ref. MSAT/RA-05-02 : Cut comment line at the first banck after 68 char
C067 (22.07.02) ref. MSAT/RA-05-02 : No 'static' word with pre-processor directives
C068 (22.07.02) ref. MSAT/RA-05-02 : No 'static' word when data is already static
C069 (22.07.02) ref. MSAT/RA-05-02 : No 'extern' word with pre-processor directives
C070 (22.07.02) ref. MSAT/RA-05-02 : Take in account #ifdef with const definition
C071 (02.08.02) ref. MSAT/RA-05-02 : Add extraction date
C072 (06.08.02) ref. MSAT/RA-08-02 : Add Conf Manager data for C and H files ' $Id$ '
C073 (06.08.02) ref. MSAT/RA-08-02 CS-2003-DC : Supp extern when declaration file is empty
C074 (06.08.02) ref. MSAT/RA-08-02 CS-2004-DC : Supp static when declaration file is empty
C075 (06.08.02) ref. MSAT/RA-08-02 CS-2006-DC : Move * line after <END> balise
C076 (07.10.02) ref. MSAT/FA/020917_1 : 'Extern' word before function declaration into .h files
C077 (07.10.02) ref. MSAT/FA/020917_2 : No 'static' key word without entity declaration
C078 (07.10.02) ref. MSAT/FA/020917_4 : modif define/type/const/data decl order
C079 (26.10.02) ref. MSAT/FA/021011_1 : add extern before ope with given type ( not void)
C080 (26.10.02) ref. MSAT/FA/021011_1 : take in account #ifdef and static data
C081 (26.10.02) ref. MSAT/FA/021024_2 : move op spec before data
C082 (04.12.02) : no more default value in typedef struct generation !
C083 (05.12.02) : default enum type generation when enum elements have been defined.
C084 (18.12.02) : extern for all op prototypes except static
C085 (19.12.02) : various decorative changes
-- CD-Rom #7 (December 2002)
C086 (16.01.03) : fixing abnormal const qualifier for funtion type
C087 (12.02.03) : always includes children for implemented_by
C088 (04.03.03) : ref. CSSI : D.Chabal sharpPP ##PP, and id
C089 (04.03.03) : ref. CSSI : D.Chabal  add 'return 0' at end of 'main'
C091 (07.03.03) : ref. RASTO/03.025 : No C file generated if no internal component
-- Stood 5.0 (March 2004)
C100 (19.03.04)	: ref. RASTO/04.007 : removing default values for function parameters
C101 (19.03.04) : ref. RASTO/04.007 : only the first enum element could have a value
C102 (19.03.04) : ref. RASTO/04.007 : avoiding reverse tags for the main arg list
C103 (19.03.04) : ref. RASTO/04.007 : removing extern keyword when constant def is empty
C104 (19.03.04) : ref. RASTO/04.007 : fixing a bug to accept pragma pointer for in out params
C105 (19.03.04) : ref. RASTO/04.007 : adding static keyword to generated OPCS functions
C106 (19.03.04) : ref. RASTO/04.007 : adding reversor management to protocol automata
C107 (25.03.04) : ref. RASTO/04.007 : avoiding .h generation for body only option
C108 (29.03.04) : ref. RASTO/04.007 : formatting reverse tags for constrained op declaration
C109 (30.03.04) : ref. RASTO/04.007 : fixing a bug with joint pragmas not_ANSI and storage
C110 (17.09.04)	: fixing pb with pragma no_define
C111 (24.09.04) : fixing pb with pragma lice (missing op_code for OBCS)
C112 (04.10.04) : always generate a default type when TypeDef is empty
C113 (04.10.04) : add #include for attributes when TypeDef is empty
C114 (24.11.04) : ref. RASTO/04.024 : put static outside reverse tags for internal operations
C115 (24.11.04) : ref. RASTO/04.024 : remove additional blanks in comments when not microsat
C116 (24.11.04) : ref. RASTO/04.024 : all in params are now const (only in pointers for microsat)
C117 (01.02.05) : ref. RASTO/04.024 : avoid additional blank lines when reversing comments twice
--------------------------------------------------*/
/*******************************************/
/**** S T R U C T U R I N G   R U L E S ****/
/*******************************************/
/*``structure``Wed Dec  8 17:33:57 MET 1999``*/
/* go */

go :- $init_sys, $getenv('PREDICATS',FileName), $consult(FileName), fail.
go :- ifLice(F), initLice(F), fail.
go :- initMakeFile, fail.
go :- genC, fail.
go :- endMakeFile, fail.

/*``structure``Mon May 19 11:10:11 MET DST 2003``Tue Apr 15 09:12:15 2003 `*/
/* genC */

genC :-
	message('Stood 5.0 - C code generator - November 2004'),
	isObject(X,T,Y),
	T \= 'OP_CONTROL',
	X \= 'SYSTEM_CONFIGURATION',
	X \= 'FORMAL_PARAMETERS',
	extract(X), 
	( isTerm(X) -> termModule(X); parentModule(X) ).
				
/*``structure``Thu Dec  5 15:25:48 MET 2002``29 10 02 `*/
/* parentModule(X) */

/*******************************************/
/* N O T   T E R M I N A L   M O D U L E S */
/*******************************************/

parentModule(X) :- parentSpec(X). /*C107*/
parentModule(X) :- main(X,U), parentBody(X,U). 
parentModule(X) :- hasBody(X), parentBody(X). /*(cf.C110)*/

/*---------------*/
/* HEADER FILE : */
/*---------------*/

parentSpec(X) :- not(openFile(X,'spec')), !. /*C107*/
parentSpec(X) :- insertCom(_,_,X,'HeaderTxt').
parentSpec(X) :- insert(X,'BEGIN_SPEC'), insertHeaderFile(X,'SpecHeader'). /*C004*/
parentSpec(X) :- ifPres1, insertConfData. /*C088*/
parentSpec(X) :- ifPres1, insertCom3('NIL','NIL',X,'ObModifTxt'). /*C053*/
parentSpec(X) :- ifCom, notPres1, hasReq(X), info(112), insertReqInt(X). /*C049*/
parentSpec(X) :- hasReq(X,'spec'), info(102), usedObjects('spec',X).
parentSpec(X) :- info(103), implementingObjects(X).
parentSpec(X) :- lf. /*C017*/

parentSpec(X) :- hasProDefCo(X), info(09), isProvided(U,'CONSTANT',X), isDefine(X,U), insertConstDefine(X,U). /*C078, C085*/
parentSpec(X) :- hasProTy(X), info(11), isProvided(U,'TYPE',X), insertType(X,U). /*C078*/
parentSpec(X) :- hasProConstCo(X), info(10), isProvided(U,'CONSTANT',X), isConst(X,U), insertConstNotDefine(X,U). /*C078, C085*/
parentSpec(X) :- hasProDa(X), info(14), isProvided(U,'DATA',X), insertData(X,U). /*C078*/
parentSpec(X) :- hasProOp(X), info(12), isProvided(U,'OPERATION',X), insertOpSpec(X,U).
parentSpec(X) :- hasProEx(X), info(30), isProvided(U,'EXCEPTION',X), insertEx(X,U).
parentSpec(X) :- lf. /*C017*/

parentSpec(X) :- insert(X,'END_SPEC'), closeFile.

/*---------------*/
/* SOURCE FILE : */
/*---------------*/

parentBody(X,_) :- not(openFile(X,'body')), !. /*C107*/
parentBody(X,_) :- insertCom(_,_,X,'HeaderTxt').
parentBody(X,_) :- insertHeaderFile(X,'BodyHeader'). /*C004*/
parentBody(X,_) :- ifPres1, insertCom3('NIL','NIL',X,'ObModifTxt'). /*C053*/
parentBody(X,_) :- ifStatic(K,C), K \= 'static', C \='no', insertStaticDef(K,C). /*C054*/
parentBody(X,_) :- info(101), with(X,X). /*C016*/

parentBody(X,_) :- target(T), info(200), includeFiles(X,0,T).
parentBody(X,_) :- target(T), info(201), insertDecl(X,T).
parentBody(X,_) :- target(T), info(202), insertInit(X,T).
parentBody(X,_) :- target(T), info(215), insertTerm(X,T).

parentBody(X,_) :- lf. /*C017*/
parentBody(X,U) :- info(25), insertMain(X,U).
parentBody(X,U) :- noDef, info(37), insertOpImpBy(X,U). /*(cf.C110)*/

parentBody(X,_) :- closeFile.

/* source file to manage implemented_by with pragma no_define */
/*(cf.C110)*/

parentBody(X) :- not(openFile(X,'body')), !. /*C107*/
parentBody(X) :- insertCom(_,_,X,'HeaderTxt').
parentBody(X) :- insert(X,'BEGIN_BODY'), insertHeaderFile(X,'BodyHeader'). /*C004*/
parentBody(X) :- insertConfData.
parentBody(X) :- ifPres1, insertCom3('NIL','NIL',X,'ObModifTxt'). /*C053*/
parentBody(X) :- ifStatic(K,C), K \= 'static', C \='no', insertStaticDef(K,C). /*C054*/
parentBody(X) :- info(101), with(X,X). /*C016*/
parentBody(X) :- hasReq(X,'body'), info(102), usedObjects('body',X).
parentBody(X) :- lf. /*C017*/

parentBody(X) :- hasProConstCo(X), info(35), isProvided(U,'CONSTANT',X), isConst(X,U), insertConstImpBy(X,U). /*(cf.C110)*/
parentBody(X) :- hasProDa(X), info(36), isProvided(U,'DATA',X), insertDataImpBy(X,U). /*(cf.C110)*/
parentBody(X) :- hasProNi(X), info(37), isProvided(U,'OPERATION',X), notInline(X,U), insertOpImpBy(X,U). /*(cf.C110)*/
parentBody(X) :- lf. /*C017*/

parentBody(X) :- insert(X,'END_BODY'), closeFile.

/*``structure``Mon May 19 10:27:46 MET DST 2003``Tue Apr 15 09:12:15 2003 `*/
/* termModule(X) */

/***********************************/
/* T E R M I N A L   M O D U L E S */
/***********************************/

termModule(X) :- termSpec(X). /*C107*/
termModule(X) :- hasInternals(X), termBody(X). /*C091*/

/*---------------*/
/* HEADER FILE : */
/*---------------*/

termSpec(X) :- not(openFile(X,'spec')), !. /*C107*/
termSpec(X) :- insertCom(_,_,X,'HeaderTxt').
termSpec(X) :- insert(X,'BEGIN_SPEC'), insertHeaderFile(X,'SpecHeader'). /*C004*/
termSpec(X) :- insertConfData. /*C072*/
termSpec(X) :- ifPres1, insertCom3('NIL','NIL',X,'ObModifTxt'). /*C053*/
termSpec(X) :- hasReq(X), ifCom, notPres1, info(112), insertReqInt(X). /*C049*/
termSpec(X) :- hasReq(X,'spec'), info(102), usedObjects('spec',X).
termSpec(X) :- hasObcs(X), target(T), info(200), includeFiles(X,0,T).
termSpec(X) :- lf. /*C017*/

termSpec(X) :- hasProDefCo(X), info(17), isProvided(U,'CONSTANT',X), isDefine(X,U), insertConstDefine(X,U). /*C078, C085*/
termSpec(X) :- hasProTy(X), info(13), isProvided(U,'TYPE',X), insertType(X,U). /*C078*/
termSpec(X) :- hasProConstCo(X), info(18), isProvided(U,'CONSTANT',X), isConst(X,U), insertConstNotDefine(X,U). /*C078, C085*/
termSpec(X) :- hasProDa(X), info(14), isProvided(U,'DATA',X), insertData(X,U). /*C078*/
termSpec(X) :- hasProNi(X), info(26), isProvided(U,'OPERATION',X), notInline(X,U), insertOpSpec(X,U).
termSpec(X) :- hasObcs(X), info(28), insertOBCSSpec(X).
termSpec(X) :- hasProEx(X), info(30), isProvided(U,'EXCEPTION',X), insertEx(X,U).
termSpec(X) :- hasProIn(X), info(16), isProvided(U,'OPERATION',X), isInline(X,U), insertOpBody(X,U). /*C022, C035*/
termSpec(X) :- lf. /*C017*/

termSpec(X) :- insert(X,'END_SPEC'), closeFile.

/*---------------*/
/* SOURCE FILE : */
/*---------------*/

termBody(X) :- not(openFile(X,'body')), !. /*C107*/
termBody(X) :- insertCom(_,_,X,'HeaderTxt').
termBody(X) :- insert(X,'BEGIN_BODY'), insertHeaderFile(X,'BodyHeader'). /*C004*/
termBody(X) :- insertConfData.
termBody(X) :- ifPres1, insertCom3('NIL','NIL',X,'ObModifTxt'). /*C053*/
termBody(X) :- ifStatic(K,C), K \= 'static', C \='no', insertStaticDef(K,C). /*C054*/
termBody(X) :- info(101), with(X,X). /*C016*/
termBody(X) :- hasReq(X,'body'), info(102), usedObjects('body',X).
termBody(X) :- lf. /*C017*/

termBody(X) :- hasProConstCo(X), info(15), isProvided(U,'CONSTANT',X), isConst(X,U), insertConstBody(X,U). /*C013, C085*/
termBody(X) :- hasProDa(X), info(20), isProvided(U,'DATA',X), insertDataBody(X,U). /*(cf.C110)*/
termBody(X) :- hasIntDefCo(X), info(33), isInternal(U,'CONSTANT',X), isDefine(X,U), insertConstDefine(X,U). /*C085*/
termBody(X) :- hasIntTy(X), info(19), isInternal(U,'TYPE',X), insertType(X,U).
termBody(X) :- hasIntConstCo(X), info(34), isInternal(U,'CONSTANT',X), isConst(X,U), insertConstNotDefine(X,U). /*C085*/
termBody(X) :- hasIntOp(X), info(27), isInternal(U,'OPERATION',X), insertOpSpec(X,U). /*C081*/
termBody(X) :- hasIntDa(X), info(21), isInternal(U,'DATA',X), insertData(X,U).
termBody(X) :- hasProNi(X), info(23), isProvided(U,'OPERATION',X), notInline(X,U), insertOpBody(X,U).
termBody(X) :- hasIntOp(X), info(24), isInternal(U,'OPERATION',X), insertOpBody(X,U).
termBody(X) :- hasObcs(X), info(29), insertOBCSBody(X).
termBody(X) :- main(X,U), info(25), insertMain(X,U). /*C006*/
termBody(X) :- lf. /*C017*/

termBody(X) :- insert(X,'END_BODY'), closeFile.

/*``visibility``Tue Jul 18 15:46:56 MET DST 2000``*/
/* needs */

/*****************************************/
/**** V I S I B I L I T Y   R U L E S ****/
/*****************************************/
/* C016 */

usedObjects(E,X) :- used(E,X,Y), not(withed(X,Y)), with(X,Y). /*C113*/

implementingObjects(X) :- implements(Y,X), with(X,Y).

used(E,X,Y) :- requires(U,_,X,V,_,Y,W), /*C113*/
	/* write('-1- '), write(V), sp, write(Y), sp, write(W), nl, */
	Y \= X, Y \= 'std', Y \= 'FORMAL_PARAMETERS',
	W \= 'OpImpBy', W \= 'TyImpBy', W \= 'CoImpBy', W \= 'ExImpBy', W \= 'DaImpBy',
	not(isDescendant(Y,X)), using(E,U,X,W),
	( isObject(Y,_,_) -> true; message('*** unknown module: ', Y,' included into: ',X) ).
	/* write('-2- '), write(V), sp, write(Y), sp, write(W), nl */
used(E,X,Y) :- attributes(_,X,_,_,Y,_), Y \= 'NIL'. /*C113*/

memezTra(A,B) :- $name(A,L1), $name(B,L2), id(L1,L2).
neoKetMemezTra(A,B) :- $name(A,L1), $name(B,L2), not(id(L1,L2)).

id([],[]) :- true.
id([E|L1],[F|L2]) :- ( E =:= F ; E =:= F-32 ; E-32 =:= F ), id(L1,L2).

/*``visibility``Tue Jul 20 10:15:12 MET DST 1999``*/
/* using */
/*-------------------------------------------*/
/* Visibility requirements for header file : */
/*-------------------------------------------*/

using('spec',U,X,W) :- isProvided(U,_,X),
        (W='TypeDecl'; W='TypeDef'; W='CstDef';
         W='OpDecl'; (isInline(X,U), W='OpDef')).

/*-------------------------------------------*/
/* Visibility requirements for source file : */
/*-------------------------------------------*/

using('body',U,X,W) :-
        ( isInternal(U,_,X),
                (W='TypeDef'; W='CstDef'; W='DataDef';
                 W='OpDecl2'; W='OpDef') );
        ( isProvided(U,_,X), notInline(X,U), W='OpDef' ).

/*``visibility``Wed Jul 19 15:55:58 MET DST 2000``*/
/* types&constants */
/*----------------------------------*/
/* types and constants dependencies */
/*----------------------------------*/
/* C015, C110 */

whichType(U,K,X,V,Y,O,T) :- isImplementedBy(V,K,Y,W,Z) ->
        whichType(U,K,X,W,Z,O,T) ;
        ( requires(V,K,Y,R,'TYPE',A,'CstDef'), ( getType(R,A,Ob,Ty,X) -> ( O=Ob, T=Ty ); ( O=A, T=R) ) ).

getType(R,Y,O,T,X) :- isImplementedBy(S,'TYPE',Z,R,Y) ->
        ( (Z=X) -> ( O=Z, T=S ); getType(S,Z,O,T,X) );
        ( T=R, O=Y ).
        
whichValue(U,K,X,V,Y) :- isImplementedBy(V,K,Y,W,Z) ->
        whichValue(U,K,X,W,Z);
        getValue(V,K,Y).

getValue(U,K,X) :- insertRestOfFile(U,K,X,'CstDef',61).


/*``visibility``Thu Mar  7 17:50:47 MET 2002``*/
/* required interface */
/*--------------------*/
/* required interface */
/*--------------------*/
/* C020 */

insertReqInt(X) :- reqInt(X,'OPERATION').
insertReqInt(X) :- reqInt(X,'EXCEPTION').
insertReqInt(X) :- reqInt(X,'TYPE').
insertReqInt(X) :- reqInt(X,'CONSTANT').
insertReqInt(X) :- reqInt(X,'DATA').

reqInt(X,E) :- lineWidth(M), $conlength(E,L), indent(1,T), /*C049*/
	L1 is L + T, L2 is L1 + 17, L3 is L1 + 22,
	begCom, indent(1), write('Required '), write(E), write(' :'),
	( reqs(X,E,Y) ->  ( fillIn(L2,M,32), endCom ); ( write(' NONE'), fillIn(L3,M,32), endCom ) ).
reqInt(X,E) :- reqs(X,V,E,Y), isProvided(V,E,Y), insertReq(V,E,Y). /*C049*/

reqs(X,E,Y) :- isImplementedBy(_,E,X,_,Y);
	( requires(_,_,X,_,E,Y,_), Y \= X, Y \= 'std', Y \= 'FORMAL_PARAMETERS',
	not(isDescendant(Y,X)) ).

reqs(X,V,E,Y) :- ( isImplementedBy(_,E,X,V,Y);
	( requires(_,_,X,V,E,Y,_), Y \= X, Y \= 'std', Y \= 'FORMAL_PARAMETERS',
	not(isDescendant(Y,X)) ) ), !.

insertReq(U,E,Y) :- lineWidth(M), $conlength(E,A1), indent(2,T), /*C049*/
	$conlength(U,A2), $conlength(Y,A3),
	L1 is A1 + T, L2 is L1 + A2, L3 is L2 + A3, L4 is L3 + 22,
	begCom, indent(2), write(E), write(' : '),
      write(U), write(' of module : '), write(Y), fillIn(L4,M,32), endCom.

/*``tuning``Thu Mar 14 08:26:22 MET 2002``*/
/* general */
/*******************************************/
/**** E X T R A C T I O N   T U N I N G ****/
/*******************************************/

lineCut(C) :- C is 65.
widthTab(T) :- pragma_tabulation(X) -> T is X; T is 4. 			/*C065*/
notANSI :- pragma_not_ANSI(_), !.
fullProto :- not( pragma_incomplete_prototypes(_) ). /*C002, C048*/
indent(N) :- pragma_no_indent(_) -> true;
	( ( pragma_indent_width(_,W) -> I is W; I is 2 ), T is N * I, $tab(T) ).
indent(N,T) :- pragma_no_indent(_) -> T is 0; /*C049*/
	( ( pragma_indent_width(_,W) -> I is W; I is 2 ), T is N * I ).
indent2(N) :- reverseOption(_,_) -> true; indent(N). /*C106*/
ifCom :- pragma_comment(_), !.
lineWidth(W) :- pragma_line_width(_,L) -> W is L; W is 80. /*C001, C046*/
fullNames :- pragma_full_file_names(_), !.
remote(X,P,E) :- pragma_location(X,P,E). /*C045*/
remote(X,P,'.o') :- pragma_location(X,P). /*for upwards compatibility*/
ifPseudo :- pragma_insert_pseudo(_), !.
ifStd(X) :- ( pragma_std_file(X); ifPres1 ), !. /*C057*/
cFlags(F) :- pragma_cflags(_,F), !.
ldFlags(F) :- pragma_ldflags(_,F), !. /*C045*/
cc(C) :- pragma_cc(_,C), !.
reverseOption(V,C) :- pragma_reverse(_,V,C), !.
lf :- pragma_presentation(_,'no_line_feed') -> true; nl. /*C017*/
indent_param :- pragma_presentation(_,'indent_param'), !. /*C017*/
substitute(W,H) :- pragma_substitute_header(_,W,H), !. /*C004*/
append(W,H) :- pragma_append_header(_,W,H), !. /*C011*/
addPrefix :- pragma_prefix_all(_), !. /*C012*/
prefix :- not(pragma_prefix_none(_)). /*C028*/ 
ifDef :- not(pragma_no_define(_)). /*C015*/
noDef :- pragma_no_define(_), !. /*C015*/
ifPres1 :- pragma_presentation(_,'microsat'), !. /*C049*/
notPres1 :- not(pragma_presentation(_,'microsat')). /*C049*/
ifStatic(K,C) :- pragma_static(_,K,C), !. /*C054*/

target(T) :- pragma_target(_,T,_), !, T \= 'none'.
priority(X,P) :- pragma_target_param(X,'priority',P), !. /*C030*/
wsize(X,S) :- pragma_target_param(X,'wsize',V) -> S=V; S=0. /*C030*/
stack(X,A) :- pragma_target_param(X,'stack_address',A), !. /*C043*/
targetDir(D1,D2) :- pragma_target(_,_,D2), !,
	( $getenv('INCLUDE_DIR',Dir) ->  ( $name(Dir,L), $name(D1,L) ); D1='' ).
bufferSize(V) :- pragma_target_param(_,'buffer_size',V) -> true; V=1.
loopDelay(D) :- pragma_target_param(_,'loop_delay',D) -> true; D=1000.
ifLice(F) :- pragma_LICE(_,F), !.

/*``tuning``Wed Jun 30 15:44:59 MET DST 1999``*/
/* module types */

isTerm(X) :- not(isObject(_,_,X)).
isParent(X) :- isObject(_,_,X), !.
isGeneric(X) :- isRootObject(X,'CLASS').
opControl(X,U) :- isObject(Y,'OP_CONTROL',X), isProvided(U,'OPERATION',Y).
isRoot(X) :- isRootObject(Y,_), memezTra(X,Y), !.

/*``tuning``Mon May 19 10:31:04 MET DST 2003``Tue Apr 15 09:12:15 2003 `*/
/* module characteristics : */

extract(X) :- extract(_,_,X,_,_), not(pragma_except(X)), !.
main(X,U) :- isCurrentRoot(X), pragma_main(X,U), !. /*C027*/
comLine :- not(pragma_no_command_line(_)). /*C033*/
hasReq(X) :- requires(_,_,X,_,_,Y,W), Y\=X,
  W\='OpImpBy', W\='TyImpBy', W\='CoImpBy', W\='ExImpBy', W\='DaImpBy', !.
hasReq(X,E) :- used(E,X,Y), !. /*C016*/
hasProTyCo(X) :- ( hasProCo(X); hasProTy(X) ), !.
hasProCo(X) :- isProvided(_,'CONSTANT',X), !.
hasProDefCo(X) :- isProvided(U,'CONSTANT',X), isDefine(X,U), !. /*C085*/
hasProConstCo(X) :-  isProvided(U,'CONSTANT',X), isConst(X,U), !. /*C013, C085*/
hasProTy(X) :- isProvided(_,'TYPE',X), !.
hasProDa(X) :- isProvided(_,'DATA',X), !.
hasProOp(X) :- isProvided(_,'OPERATION',X), !.
hasProIn(X) :- isProvided(U,'OPERATION',X), isInline(X,U), !.
hasProNi(X) :- isProvided(U,'OPERATION',X), notInline(X,U), !.
hasProEx(X) :- isProvided(_,'EXCEPTION',X), !.
hasIntTyCo(X) :- ( hasIntCo(X); hasIntTy(X) ), !.
hasIntCo(X) :- isInternal(_,'CONSTANT',X), !.
hasIntDefCo(X) :- isInternal(U,'CONSTANT',X), isDefine(X,U), !. /*C085*/
hasIntConstCo(X) :-  isInternal(U,'CONSTANT',X), isConst(X,U), !. /*C085*/
hasIntTy(X) :- isInternal(_,'TYPE',X), !.
hasIntDa(X) :- isInternal(_,'DATA',X), !.
hasIntOp(X) :- isInternal(_,'OPERATION',X), !.
hasIntIn(X) :- isInternal(U,'OPERATION',X), isInline(X,U), !. /*C035*/
hasIntNi(X) :- isInternal(U,'OPERATION',X), notInline(X,U), !. /*C035*/
hasObcs(X) :- isTerm(X), isConstrained(_,'OPERATION',X,C,_),
	(C='HSER';C='LSER';C='ASER';C='BY_IT'), !. /*C039, C040*/
hasStd(X) :- isConstrained(_,'OPERATION',X,'STATE',_), !.
hasInternals(X) :- ( /*C091*/
	isProvided(_,'OPERATION',X);
	isInternal(_,'OPERATION',X);
	isInternal(_,'DATA',X);
	isInternal(_,'TYPE',X);
	isInternal(_,'CONSTANT',X) ), !.
hasBody(X) :- noDef, not(main(X,_)), (hasProConstCo(X); hasProNi(X)), !. /*(cf.C110)*/
 
/*``tuning``Mon May 19 09:48:26 MET DST 2003``Tue Apr 15 09:12:15 2003 `*/
/* child module characteristics : */
/* C016, C028, C087 */

implements(Y,X) :- isObject(Y,_,X), imp(X,Y).

imp(X,Y) :- isImplementedBy(_,_,X,_,Y), !. /*C028, C087*/

imp(U,X,V) :- ( prefix; U \= V ), !. /*C028*/

implem(U,E,X,V,Y) :- isImplementedBy(U,E,X,I,A) ->
	( implem(I,E,A,J,B) -> (V=J, Y=B); (V=I, Y=A) );
	( V=U, Y=X ).

implem2(U,E,X,V,Y) :- isImplementedBy(U,E,X,W,Z),
	( isImplementedBy(W,E,Z,_,_) -> implem2(W,E,Z,V,Y); (V=W, Y=Z) ).

implem3(U,E,X,V,Y) :- isImplementedBy(U,E,X,W,Z),
	( (W=V, Z=Y) -> true; implem3(W,E,Z,V,Y) ).

isDescendant(Y,X) :- isObject(Y,_,X).
isDescendant(Y,X) :- isObject(Y,_,Z), isDescendant(Z,X).

/*``tuning``Thu Jan 16 09:17:18 MET 2003``29 10 02 `*/
/* operation characteristics : */

isInline(X,U) :- pragma_inline(X,U).
notInline(X,U) :- not(pragma_inline(X,U)).
writeInline :- pragma_inline_def(_,V) -> ( write(V), sp, revNl ); true. /*C022, C034*/
writeInline2 :- pragma_inline_def(_,V) -> ( write(V), sp ); true. /*(cf.C108)*/
byPointer('in') :- pragma_pointer(_,'in_mode'), !.
byPointer('out') :- pragma_pointer(_,'out_mode'), !.
byPointer('inout') :- pragma_pointer(_,'inout_mode'), !.
byPointer('in out') :- pragma_pointer(_,'inout_mode'), !. /*C104*/
constrainedOp(X,O,C,P,D) :-
	isConstrained(O,'OPERATION',X,C,P), (C='HSER';C='LSER';C='ASER';C='BY_IT'), /*C039*/
	( isConstrained(O,'OPERATION',X,'TO',V) -> D=V; D=0 ), !.
isFunction(X,O) :- return(O,'OPERATION',X,_,_,_).
impMain(X,U) :- main(X,U), !. /*C006*/
impMain(X,U) :- main(Y,V), implem3(V,'OPERATION',Y,U,X).
notASER(X,O) :- isConstrained(O,'OPERATION',X,C,_), (C='HSER';C='LSER'), !. /*C031*/
isSTATE(X,O) :- isConstrained(O,'OPERATION',X,'STATE',_), /*C031, C037*/
	not(isConstrained(O,_,X,'HSER',_)), not(isConstrained(O,_,X,'LSER',_)),
	not(isConstrained(O,_,X,'ASER',_)), not(isConstrained(O,_,X,'BY_IT',_)).
hasException(X,O,T) :- isTransition(X,T,_,_,O), hasExc(X,T), !.
storage(X,U,E,S) :- pragma_storage(X,U,E,S), !. /*C029*/
isGuarded(X,O) :- isTransition(X,_,_,_,O), !. /*C044*/
returnConst(X,U) :- pragma_return_const(X,U). /*C047, C086*/

/*``tuning``Mon Dec  4 15:42:51 MET 2000``*/
/* obcs characteristics : */

hasObcsFile(X) :- file('NIL','NIL',X,_,'obcs').
hasObcsTask(X) :- isTerm(X), isConstrained(_,_,X,C,_), (C='HSER';C='LSER';C='BY_IT'), !. /*C031, C040*/
hasServerTask(X) :- isTerm(X), isConstrained(U,_,X,'ASER',_), not(isConstrained(U,_,X,'BY_IT',_)), !. /*C024, C031, C040*/
hasCyclicTask(X,O,P) :- isConstrained(O,'OPERATION',X,'BY_IT',P), !. /*C031*/
hasCond(X,T) :- file(T,'TRANSITION',X,_,'Condition').
hasExc(X,T) :- file(T,'TRANSITION',X,_,'Exception').
hasGet(X,S) :- file(S,'STATE',X,_,'GetState'). /*C007*/
hasSet(X,S) :- file(S,'STATE',X,_,'SetState'). /*C007*/

/*``tuning``Mon May 19 10:12:32 MET DST 2003``Tue Apr 15 09:12:15 2003 `*/
/* type and constants characteristics : */
/* C013, C015, C019, C021, C056 */

hasTypeDef(X,U) :- file(U,'TYPE',X,_,'TypeDef').

isDefine(X,U) :- isProvided(U,'CONSTANT',X), file(U,'CONSTANT',X,F,'CstDef'), $see(F),
	( isDecl -> $see(F), findDefine; true ). /*C085*/ /*C077*/
isDefine(X,U) :- isInternal(U,'CONSTANT',X), file(U,'CONSTANT',X,F,'CstDef2'), $see(F),
	( isDecl -> $see(F), findDefine; true ). /*C085*/ /*C077*/
isDecl :- $globalset(findDecl(0)), searchDecl, findDecl(1). /*C077*/

isConst(X,U) :- not( isDefine(X,U) ). /*C085*/
isElsifDirective(X,U) :- (file(U,'CONSTANT',X,F,_);file(U,'DATA',X,F,_)),
							$see(F),findElsifDirective.  /* C070 */

noStaticNeeded(X,U,F) :- $see(F), findSharpPP.	/*C088*/

alreadyStatic(X,U,F) :- $see(F), findStatic.			/*C068*/

detect(S) :- $get0(N),
	( ( N =\= -1, ( N =:= 9 ; N =:= 32) ) -> detect(S); ( $seen, N = S ) ).

nextChar(N) :- $get0(N), ( N =\= -1 -> true; ( $seen, fail ) ).

searchDecl :-  /*C077*/
	nextChar(C1),
	( ( C1 =:= 9; C1 =:= 32; C1 =:= 10 ) -> searchDecl; true ),
	nextChar(C2),
	( ( C1 =:= 47, C2 =:= 42 ) -> commentSection5;
					$globalset(findDecl(1)),$seen ).

findSharpPP :- /*C088*/
       nextChar(C1),  (
       ( C1 =:= 9; C1 =:= 32; C1 =:= 10 ) -> findSharpPP; ( nextChar(C2), (
       ( C1 =:= 47, C2 =:= 42 ) -> commentSection6;
       ( C1 =:= 35, C2 =:= 35, nextChar(80), nextChar(80) ) -> $seen;
       ( C1 =:= -1 -> $seen; $seen, fail  ) ) ) ).

findStatic :-									/*C068*/
	nextChar(C1),
	( ( C1 =:= 9; C1 =:= 32; C1 =:= 10 ) -> findStatic; true ),
	nextChar(C2),
	( ( C1 =:= 47, C2 =:= 42 ) -> commentSection2; true ),
	( C1 =:= 115, C2 =:= 116, nextChar(97), nextChar(116),nextChar(105),
	  nextChar(99), nextChar(C), ( C =:= 32 ; C =:= 9 ) ) -> $seen; ( $seen, fail ).

findDefine :-
	nextChar(C1),
	( ( C1 =:= 9; C1 =:= 32; C1 =:= 10 ) -> findDefine; true ),
	nextChar(C2),
	( ( C1 =:= 47, C2 =:= 42 ) -> commentSection; true ),
	( C1 =:= 35, C2 =:= 100, nextChar(101), nextChar(102), nextChar(105),
	  nextChar(110), nextChar(101) ) -> $seen; ( $seen, fail ).

findElsifDirective :-
	nextChar(C1),
	( ( C1 =:= 9; C1 =:= 32; C1 =:= 10 ) -> findElsifDirective; true ),
	nextChar(C2),
	( ( C1 =:= 47, C2 =:= 42 ) -> commentSection3; true ),
	( C1 =:= 35, C2 =:= 105 ) -> $seen; ( $seen, fail ).

commentSection :-
	( nextChar(42), nextChar(47) ) -> findDefine; commentSection.

commentSection2 :-
	( nextChar(42), nextChar(47) ) -> findStatic; commentSection2.

commentSection3 :-
	( nextChar(42), nextChar(47) ) -> findElsifDirective; commentSection3.

commentSection4 :-
	( nextChar(42), nextChar(47) ) -> findIfdef; commentSection4.

commentSection5 :- /*C077*/
	( nextChar(42), nextChar(47) ) -> searchDecl; commentSection5.

commentSection6 :- /*C088*/
       ( nextChar(42), nextChar(47) ) -> findSharpPP; commentSection6.
       
/*``i/o``Wed Mar  6 12:17:00 MET 2002``*/
/* basic i/o */

/***************************/
/**** I / O   R U L E S ****/
/***************************/

write(T) :- $writename(T).
print(T) :- $telling(F), $tell('user'), $writename(T), $tell(F).
nl :- $put(10).
revNl :- reverseOption(_,_) -> nl; true.
tab :- $put(9).
sp :- $put(32).
dot :- $put(46).
name1(X,U) :- ( ( X \= 'NIL', X \= 'std', prefix ) ->
	( write(X), write('__') ); true ), write(U). /*C015, C028*/
name2(X,U) :- write(X), write('__'), write(U). /*C028*/

/*``i/o``Thu Dec 19 11:17:48 MET 2002``29 10 02 `*/
/* reverse coding tags */

beginReverse(X,N,U,F,W,L) :- lineWidth(M), indent(N,T), ( /*C049*/
	reverseOption(1,C) ->
		( indent(N), begCom,
		$conlength(L,A1), $conlength(W,A2), $conlength(X,A3),
		L1 is T + A1, L2 is L1 + A2, L3 is L2 + A3,
		( C\='no' -> ( write(C), $conlength(C,S) ); S is 0 ),
		L4 is L3 + S, L5 is L4 + 15,
		write('<begin '), write(L), write(W), sp, write(X),
		( U='NIL' -> L6 is 0; ( sp, write(U), $conlength(U,A4), L6 is A4 + 1 ) ), write('>'),
		L7 is L5 + L6, fillIn(L7,M,32), endCom );
	reverseOption(3,C) ->
		( indent(N), begCom,
		$conlength(F,A5), L1 is T + A5,
		( C\='no' -> ( write(C), $conlength(C,S) ); S is 0 ),
		L2 is L1 + S, L3 is L2 + 11,
		write('<HMG '), write(F), fillIn(L3,M,32), endCom );
	true ).

endReverse(N) :- lineWidth(M), indent(N,T), ( /*C049*/
	reverseOption(1,C) ->
		( indent(N), begCom,
		( C\='no' -> ( write(C), $conlength(C,S) ); S is 0 ),
		write('<end>'), L1 is T + S, L2 is L1 + 11, fillIn(L2,M,32), endCom );
	reverseOption(3,C) ->
		( indent(N), begCom,
		( C\='no' -> ( write(C), $conlength(C,S) ); S is 0 ),
		write(' HMG>'), L1 is T + S, L2 is L1 + 11, fillIn(L2,M,32), endCom );
	true ).

beginComReverse(X,N,U,F,W,L) :- ( ifPres1-> true; (  /*C049*/
	reverseOption(1,C) ->
		( indent(N), begCom,
		( C\='no' -> write(C); true ),
		write('<begin '), write(L), write(W), sp, write(X),
		( U='NIL' -> true; ( sp, write(U) ) ), write('>'), nl );
	reverseOption(3,C) ->
		( indent(N), begCom,
		( C\='no' -> write(C); true ),
		write('<HMG '), write(F), nl );
	( F='none' -> true; ( indent(N), begCom, nl ) ) ) ).

endComReverse(N,F) :- lineWidth(M), indent(N,T), ( ifPres1-> true; (  /*C049*/
	reverseOption(1,C) ->
		( indent(N),
		( C\='no' -> ( write(C), $conlength(C,S) ); S is 0 ),
		write('<end>'), L1 is T + S, L2 is L1 + 8, fillIn(L2,M,32), endCom );
	reverseOption(3,C) ->
		( indent(N),
		( C\='no' -> ( write(C), $conlength(C,S) ); S is 0 ),
		write(' HMG>'), L1 is T + S, L2 is L1 + 8, fillIn(L2,M,32), endCom );
	( F='none' -> true; ( nl, indent(N), endCom2 ) ) ) ).
	
/*``i/o``Thu Dec 19 11:00:58 MET 2002``29 10 02 `*/
/* insert files */
/* C004, C011, C013, C014 */

insertHeaderFile(X,W) :-
	( append(W,H) -> ( insertDescr(X,H), insertFile(_,_,X,W) );
	( substitute(W,H) -> insertDescr(X,H); insertFile(_,_,X,W) ) ).

insertFile(U,E,X,W) :-
	file(U,E,X,F,W) ->                                             		/*C063*/
		( $see(F), beginReverse(X,0,U,F,W,'c::'), readFile(X), nl, endReverse(0) );	/*C075*/
		(
		  beginReverse(X,0,U,'none',W,'c::'), ( 						/*C051*/
			( W ?= 'SpecHeader'; W ?= 'BodyHeader' ) -> defaultFileHeader(X,W);
			( W ?= 'OpDef' ) -> defaultOpDef(X,U);
			( ( W ?= 'TypeDef'; W ?= 'TypeDef2' )
			/*, ( attributes(U,X,_,_,_,_); enumeration(U,X,_,_) ) C112*/
			) -> defaultTypeDef(X,U); /*C055, C083*/
			( isProvided(U,'CONSTANT',X), W='CstDef2' ) -> true;
			( message('*** unknown file for : ',U,' (',W,') of module : ',X) ) ),
		  endReverse(0),
		  ( ( ifPres1, W = 'OpDef' ) -> ( lineWidth(M), write('/*'), fillIn(4,M,42), write('*/'), nl ); true )  /*C063*/
		).

insertTruncFile(U,E,X,W,S) :- file(U,E,X,F,W), $see(F), readTruncFile(X,S).

insertRestOfFile(U,E,X,W,S) :- file(U,E,X,F,W), $see(F), readRestOfFile(X,S). /*(cf.C110)*/

insertText(U,E,X,W) :- file(U,E,X,F,W) -> /*C106*/
	( $see(F), revNl, beginReverse(X,0,U,F,W,'c::'), readFile(X), revNl, endReverse(0) );
	( revNl, beginReverse(X,0,U,'none',W,'c::'), (
		( W ?= 'GetState' ) -> defaultGetState;
		( message('*** unknown file for : ',U,' (',W,') of module : ',X) ) ),
	revNl, endReverse(0) ).

insertText2(U,E,X,W) :- file(U,E,X,F,W) ->
	( $see(F), readFile(X) );
	( message('*** unknown file for : ',U,' (',W,') of module : ',X) ).

insertCom(U,E,X,W) :- lineWidth(L), comment(U,E,X,F,W) ->
	( $see(F), beginComReverse(X,0,U,F,W,''),
	  ( ifPres1 -> ( M is L - 5, O = 'Pres1', begCom ); ( M is L + 1, O = 'Std' ) ),
	  $globalset(w(1)), readComFile(X,M,O), ( ifPres1 -> true; revNl ), /*C049*/
	  endComReverse(0,F) );
	( beginComReverse(X,0,U,'none',W,''), (
	W ?= 'ObcsTxt' -> message('*** no textual description for : OBCS spec of module : ',X);
 	W ?= 'ObcsBodyTxt' -> message('*** no textual description for : OBCS body of module : ',X);
 	( W ?= 'ExcTxt'; W ?= 'Exc2Txt'; W ?= 'HeaderTxt'; W ?= 'ObModifTxt' ) -> true;
	message('*** no textual description for : ',U,' (',W,') of module : ',X) ),
	endComReverse(0,'none') ).

insertCom2(U,E,X,W) :- lineWidth(L), comment(U,E,X,F,W) ->
	( $see(F), begCom, $globalset(w(1)), readComFile(X,L,'Std'), endCom );
	(
	W ?= 'ObcsTxt' -> message('*** no textual description for : OBCS spec of module : ',X);
 	W ?= 'ObcsBodyTxt' -> message('*** no textual description for : OBCS body of module : ',X);
 	W ?= 'HeaderTxt' -> true;
	message('*** no textual description (',W,') for : ',E,' ',U,' of module : ',X) ).

insertCom3(U,E,X,W) :- lineWidth(L), comment(U,E,X,F,W) -> /*C052*/
	( $see(F), beginComReverse(X,0,U,F,W,''), M is L - 5,
	  begCom, $globalset(w(1)), readComFile(X,M,'Pres1'),
	  write('/*'), fillIn(4,L,42), write('*/'), nl, endComReverse(0,F) ); /*C059*/
	( beginComReverse(X,0,U,'none',W,''), (
	W ?= 'ObModifTxt' -> true;
	message('*** no textual description for : ',U,' (',W,') of module : ',X) ),
	endComReverse(0,'none') ).

insertDescr(X,H) :- lineWidth(L), description(X,F,H) ->
	( $see(F), beginComReverse(X,0,'NIL',F,H,''),
	  ( ifPres1 -> ( M is L - 5, O = 'Pres1', begCom ); ( M is L + 1, O = 'Std' ) ),
	  $globalset(w(1)), readComFile(X,M,O), ( ifPres1 -> true; revNl ), /*C049*/
	  endComReverse(0,F) );
	( beginComReverse(X,0,'NIL','none',H,''),
	message('*** no description (',H,') for module : ',X,'',''),
	endComReverse(0,'none') ).

insertDescr2(X,H) :- lineWidth(L), ( description(X,F,H) -> /*C051*/
	( $see(F), M is L - 5, begCom, $globalset(w(1)), readComFile(X,M,'Pres1') );
	message('*** no description (',H,') for module : ',X,'','') ).

insertPseudo(U,E,X,W) :- lineWidth(L), file('pseudo',U,E,X,F,W) ->
	( $see(F), beginComReverse(X,0,U,F,W,'pseudo::'),
	  ( ifPres1 -> ( M is L - 5, O = 'Pres1', begCom ); ( M is L + 1, O = 'Std' ) ),
	  $globalset(w(1)), readComFile(X,M,O), ( ifPres1 -> true; revNl ), /*C049*/
	  endComReverse(0,F) );
	( beginComReverse(X,0,U,'none',W,'pseudo::'),
	message('*** no pseudo code (',W,') for : ',E,' ',U,' of module : ',X),
	endComReverse(0,'none') ).

findPseudo(F1,F2) :-
        $name(F1,L1), $reverse(L1,[99|R]), $reverse([112|R],L2), $name(F2,L2).

openFile(X,S) :- extract(_,_,X,S,F),
	openMakeFile(G), writeFileName(X,F), write(' : '), closeMakeFile(G),
	( $tell(F) -> true; message('*** cannot open : ',F) ).

closeFile :- $told,
	openMakeFile(G), nl, tab, write('touch $@'), nl, closeMakeFile(G).
	
/*``i/o``Mon Dec 11 12:05:22 MET 2000``*/
/* makefile */

openMakeFile(G) :- $telling(G),
	( extract(_,_,_,'make',F) ->  $tell(F); $tell('Stood.out') ).

closeMakeFile(G) :- $tell(G).

initMakeFile :-
	openMakeFile(G),
	write('SRC='), insertSources,
	write('OBJ='), insertObj,
	write('CC='), insertCc, nl,
	write('CFLAGS='), insertCFlags, nl,
	write('LDFLAGS='), insertLdFlags, nl,
	isCurrentRoot(X), write(X), write(' : $(SRC:.c=.o)'), nl,
	tab, ( main(X,_) -> /*C027*/
		write('$(LINK.c) -o $@ $(LDFLAGS) $(SRC:.c=.o) $(OBJ)'); /*C045*/
		true ), nl,
	closeMakeFile(G).

insertSources :- main(X,_), extract(_,_,X,'body',F), writeFileName(X,F), sp, fail. /*C027*/
insertSources :- isObject(X,_,_), isTerm(X), not(remote(X,_,_)), /*C045*/
	extract(_,_,X,'body',F), writeFileName(X,F), sp, fail.
insertSources :- isObject(X,_,_), isParent(X), hasBody(X), /*(cf.C110)*/
	extract(_,_,X,'body',F), writeFileName(X,F), sp, fail. 
insertSources :- nl.

insertObj :- remote(X,P,E), writeObjFileName(X,P,E), sp, fail. /*C045*/
insertObj :- nl.

insertCc :- cc(C) -> write(C); write('cc').

insertCFlags :- targetDir(D1,D2), D2 \= '', write('-I'), /*C045*/
	( D1='' -> true; ( write(D1), write('/') ) ), write(D2), sp, fail.
insertCFlags :- cFlags(F) -> write(F); write('-g').

insertLdFlags :- ldFlags(F) -> write(F); true. /*C045*/

endMakeFile :- openMakeFile(_), $told.

/*``i/o``Fri Mar  8 14:14:47 MET 2002``*/
/* read files */
/* C013 */

readFile(X) :-
	$get0(N),			/* read one char, and */
	(  N =\= -1 -> 		/* is it not end of file ? */
		(  $put(N),		/* if not eof then write char, and */
		   readFile(X)	/* read next char */
		);				/* or */
		$seen			/* if eof then close input file */
	).

readTruncFile(X,S) :- /*C036*/
	$get0(N),			/* read one char, and */
	(  ( N =\= -1, N =\= S, N =\= 59 ) -> 	/* is it not end of file ? */
		(  $put(N),		/* if not eof then write char, and */
		   readTruncFile(X,S)		/* read next char */
		);			/* or */
		$seen			/* if eof then close input file */
	).

readRestOfFile(X,S) :- /*(cf.C110)*/
	$get0(N), (		
	( N =\= -1, N =\= 59, N =\= S ) -> readRestOfFile(X,S);
	( N =:= S ) -> readEndOfFile(X);
	$seen ).
	
readEndOfFile(X) :- /*(cf.C110)*/
	$get0(N), (
	( N =\= -1, N =\= 59 ) -> ( $put(N), readEndOfFile(X) ); $seen ).

readComFile(X,M,O) :- /*C046, C049, C065, C066*/
	$get0(N), w(K), lineCut(C),
	( N =:= 09 -> ( widthTab(T), tab2Space(T), L is K+T ); true ), 
	( ( N =:= 32, K >= C ) -> ( ( O = 'Pres1' -> fillIn(K+1,M,32); true ), L is M ); L is K+1 ), 
	$globalset(w(L)), 
	( N =\= -1 -> (	/*(cf.C115)*/
		( isEndOfLine(N,L,M) ->
			 newComLine(N,L,M,O) ;
			( N =:= 09 -> true; $put(N) )
		), readComFile(X,M,O) ); 
		( O = 'Pres1' -> ( sp, fillIn(L,M,32), endCom ); true ), $seen ).

tab2Space(T) :- 0 >= T, !.
tab2Space(T) :- T1 is T-1, write(' '), tab2Space(T1).

isEndOfLine(10,_,_) :- !. /*C049*/
isEndOfLine(_,L,M) :- (L >= M -> true; fail).
isEndOfLine(_,M,M).

fillIn(L,M,C) :- L >= M, !. /*C049*/
fillIn(L,M,C) :- $put(C), K is L+1, fillIn(K,M,C).

newComLine(N,L,M,O) :- O = 'Pres1' ->  /*C049*/
	( ( N =:= 10 -> sp; $put(N) ), fillIn(L,M,32), endCom, $globalset(w(1)), begCom );
	( ( ( N =:= 10; N =:= 32 ) -> true; $put(N) ), nl, $globalset(w(1)) ). /*(cf.C117)*/

/*``i/o``Mon Dec 11 09:37:44 MET 2000``*/
/* file names */

writeFileName(X,F1) :- remote(X,P,_) -> /*C045*/
	( write(P), write('/'), write(F1) );
	( fullNames ->
		( write(F1) );
		( $name(F1,L1), $reverse(L1,R1), $name(N1,R1),
		  $subdelim(1,'/',N2,0,N1,_),
		  $name(N2,R2), $reverse(R2,L2), $name(F2,L2),
		  write(F2) ) ).

writeEnvFileName(X) :-
	  ( remote(X,P,_) -> ( write(P), write('/') ); true ), /*C045*/
	  write(X), write('.h').

writeObjFileName(X,P,E) :- write(P), write('/'), write(X), write(E). /*C045*/

/*``i/o``Thu Mar  7 17:33:08 MET 2002``*/
/* info */
/* C049 */
info(09) :- lineWidth(M), begCom, write('---------- implemented_by define constants: '), fillIn(50,M,45), endCom.
info(10) :- lineWidth(M), begCom, write('---------- implemented_by const constants: '), fillIn(49,M,45), endCom.
info(11) :- lineWidth(M), begCom, write('---------- implemented_by types: '), fillIn(39,M,45), endCom.
info(12) :- lineWidth(M), begCom, write('---------- implemented_by operations: '), fillIn(44,M,45), endCom.
info(13) :- lineWidth(M), begCom, write('---------- provided types: '), fillIn(33,M,45), endCom.
info(14) :- lineWidth(M), begCom, write('---------- provided data: '), fillIn(32,M,45), endCom.
info(15) :- lineWidth(M), begCom, write('---------- provided constant bodies: '), fillIn(43,M,45), endCom. /*C013*/
info(16) :- lineWidth(M), begCom, write('---------- provided inline operation bodies: '), fillIn(51,M,45), endCom.
info(17) :- lineWidth(M), begCom, write('---------- provided define constants: '), fillIn(44,M,45), endCom.
info(18) :- lineWidth(M), begCom, write('---------- provided const constants: '), fillIn(43,M,45), endCom.
info(19) :- lineWidth(M), begCom, write('---------- internal types: '), fillIn(33,M,45), endCom.
info(20) :- lineWidth(M), begCom, write('---------- provided data body: '), fillIn(37,M,45), endCom. /*(cf.C110)*/
info(21) :- lineWidth(M), begCom, write('---------- internal data: '), fillIn(32,M,45), endCom.
info(23) :- lineWidth(M), begCom, write('---------- provided operation bodies: '), fillIn(44,M,45), endCom.
info(24) :- lineWidth(M), begCom, write('---------- internal operation bodies: '), fillIn(44,M,45), endCom.
info(25) :- lineWidth(M), begCom, write('---------- main entry point: '), fillIn(35,M,45), endCom.
info(26) :- lineWidth(M), begCom, write('---------- provided operations: '), fillIn(38,M,45), endCom.
info(27) :- lineWidth(M), begCom, write('---------- internal operations: '), fillIn(38,M,45), endCom.
info(28) :- lineWidth(M), begCom, write('---------- obcs specification: '), fillIn(37,M,45), endCom.
info(29) :- lineWidth(M), begCom, write('---------- obcs body: '), fillIn(28,M,45), endCom.
info(30) :- lineWidth(M), begCom, write('---------- provided exceptions: '), fillIn(38,M,45), endCom.
info(31) :- lineWidth(M), begCom, write('---------- provided types and constants: '), fillIn(47,M,45), endCom.
info(32) :- lineWidth(M), begCom, write('---------- internal types and constants: '), fillIn(47,M,45), endCom.
info(33) :- lineWidth(M), begCom, write('---------- internal define constants: '), fillIn(44,M,45), endCom.
info(34) :- lineWidth(M), begCom, write('---------- internal const constants: '), fillIn(43,M,45), endCom.
info(35) :- lineWidth(M), begCom, write('---------- provided constants implementation: '), fillIn(52,M,45), endCom. /*(cf.C110)*/
info(36) :- lineWidth(M), begCom, write('---------- provided data implementation: '), fillIn(47,M,45), endCom. /*(cf.C110)*/
info(37) :- lineWidth(M), begCom, write('---------- provided operations implementation: '), fillIn(53,M,45), endCom. /*(cf.C110)*/

info(101) :- lineWidth(M), begCom, write('---------- include provided interface: '), fillIn(45,M,45), endCom.
info(102) :- lineWidth(M), begCom, write('---------- include required interface: '), fillIn(45,M,45), endCom.
info(103) :- lineWidth(M), begCom, write('---------- include children: '), fillIn(35,M,45), endCom.
info(112) :- lineWidth(M), begCom, write('---------- required interface details: '), fillIn(45,M,45), endCom.
info(120) :- lineWidth(M), begCom, write('---------- local renaming: '), fillIn(33,M,45), endCom.
info(200) :- lineWidth(M), begCom, write('---------- include real-time libraries: '), fillIn(46,M,45), endCom.
info(201) :- lineWidth(M), begCom, write('---------- global real-time declarations: '), fillIn(48,M,45), endCom.
info(202) :- lineWidth(M), begCom, write('---------- tasks and communications initialisation: '), fillIn(58,M,45), endCom.
info(203) :- lineWidth(M), begCom, write(' OBCS main task: '), fillIn(23,M,32), endCom.
info(204) :- lineWidth(M), begCom, write(' ASER operations Server Tasks: '), fillIn(37,M,32), endCom.
info(205) :- lineWidth(M), begCom, write(' input and output channels: '), fillIn(34,M,32), endCom.
info(206) :- lineWidth(M), begCom, write(' OBCS init, exec and termination procedures: '), fillIn(51,M,32), endCom.
info(207) :- lineWidth(M), begCom, write(' Server Tasks init, exec and termination procedures: '), fillIn(59,M,32), endCom.
info(208) :- lineWidth(M), begCom, write(' channels messages: '), fillIn(26,M,32), endCom.
info(209) :- lineWidth(M), begCom, write(' OBCS execution procedure: '), fillIn(33,M,32), endCom.
info(210) :- lineWidth(M), begCom, write(' Server Task execution procedure: '), fillIn(40,M,32), endCom.
info(211) :- lineWidth(M), begCom, write(' OBCS termination procedure: '), fillIn(35,M,32), endCom.
info(212) :- lineWidth(M), begCom, write(' Server Tasks termination procedure: '), fillIn(43,M,32), endCom.
info(213) :- lineWidth(M), begCom, write(' constrained operation calling procedure: '), fillIn(48,M,32), endCom.
info(214) :- lineWidth(M), begCom, write(' constrained operation OPCS: '), fillIn(35,M,32), endCom.
info(215) :- lineWidth(M), begCom, write('---------- tasks and communications finalization: '), fillIn(58,M,45), endCom.
info(216) :- lineWidth(M), begCom, write(' OBCS stop channel: '), fillIn(26,M,32), endCom.
info(217) :- lineWidth(M), begCom, write(' OBCS initialization procedure: '), fillIn(38,M,32), endCom.
info(218) :- lineWidth(M), begCom, write(' Server Tasks initialization procedure: '), fillIn(46,M,32), endCom.
info(219) :- lineWidth(M), begCom, write(' OBCS stop procedure: '), fillIn(28,M,32), endCom.
info(220) :- lineWidth(M), begCom, write(' Server Tasks stop channels: '), fillIn(35,M,32), endCom.
info(221) :- lineWidth(M), begCom, write(' Server Task stop procedure: '), fillIn(35,M,32), endCom.

/*``i/o``Wed Dec  8 13:42:26 MET 1999``*/
/* messages */

message(A) :- $telling(X), $tell('user'), write(A), nl, $tell(X).
message(A,B) :-
	$telling(X), $tell('user'),
	write(A), write(B), nl,
	$tell(X).
message(A,B,C,D,E,F) :-
	$telling(X), $tell('user'),
	write(A), write(B), write(C), write(D), write(E), write(F), nl,
	$tell(X).
message(A,B,C,D,E,F,G,H) :-
	$telling(X), $tell('user'),
	write(A), write(B), write(C), write(D), write(E), write(F), write(G), write(H), nl,
	$tell(X).

/*``i/o``Tue Dec  5 09:43:00 MET 2000``*/
/* lice interface */

initLice(F) :- $tell(F).
initLice(_) :- write('=== begin LICE encoding '), nl, $globalset(nbob(0)).
initLice(_) :- liceAction(_,_,A,V), writeLiceAction(A,V).
initLice(_) :- write('----------------------------------'), nl.
initLice(_) :- liceObject(X), createObCode(X,D1), $globalset(nbop(0)),
	createOpCode(X,'OBCS',D3), writeLiceValue(X,'OBCS',D1,D3), /*(cf.C111)*/
	isProvided(O,'OPERATION',X), createOpCode(X,O,D2), writeLiceValue(X,O,D1,D2).
initLice(_) :- write('=== end LICE encoding '), nl, $told.

liceObject(X) :- isObject(X,_,_),
	X \= 'std', X \= 'stdio', X \= 'standard',
	X \= 'SYSTEM_CONFIGURATION'.

liceAction('HSER',0,'call HSER op.','41').
liceAction('HSER',1,'exit HSER op.','42').
liceAction('LSER',0,'call LSER op.','43').
liceAction('LSER',1,'exit LSER op.','44').
liceAction('ASER',0,'call ASER op.','45').
liceAction('ASER',1,'exit ASER op.','46').
liceAction('STOP',0,'call stop task.','47'). /*C042*/
liceAction('STOP',1,'exit stop task.','48'). /*C042*/

createObCode(X,D) :- nbob(I), D is I+1, $globalset(nbob(D)), $assert(obCode(X,D)).
createOpCode(X,O,D) :- nbop(I), D is I+1, $globalset(nbop(D)), $assert(opCode(X,O,D)).

writeLiceAction(A,V) :- write('0x'), write(V), tab, write(A), nl.
writeLiceValue(X,O,D1,D2) :-
	decToHex(D1,H11,H10), decToHex(D2,H21,H20),
	write('0x0000'), write(H11), write(H10), write(H21), write(H20),
	tab, write(X), dot, write(O), nl.

decToHex(D,H1,H0) :- H1 is D // 16, H0 is D mod 16.

liceTrace(X,I,O,C,M) :- ifLice(_) -> (
	indent(I), write('liceTrace(0x'),
	liceAction(C,M,_,A), write(A), write(',0x0000'),
	obCode(X,D1), decToHex(D1,H11,H10), write(H11), write(H10),
	opCode(X,O,D2), decToHex(D2,H21,H20), write(H21), write(H20),
	write(');'), nl ); true.

/*``C``Fri Apr 26 09:29:31 MET DST 2002``*/
/* comments */
/***********************************/
/**** C   E X P R E S S I O N S ****/
/***********************************/

begCom :- write('/* ').
endCom :- write(' */'), nl.
endCom2 :- write('*/'), nl.

insert(X,'BEGIN_SPEC') :- /*C049*/
	lineWidth(M), $conlength(X,L), K is L+20,
	( ifPres1 -> true; /*C059*/
		( begCom, write('Begin Spec of '), write(X), fillIn(K,M,32), endCom ) ),
	( ifPres1 -> /*C050*/
		( write('#ifndef '), write(X), write('_H'), nl,
		  write('#define '), write(X), write('_H'), nl );
		( write('#ifndef INCLUDE_'), write(X), nl,
		  write('#define INCLUDE_'), write(X), nl ) ).

insert(X,'END_SPEC') :- /*C049, C059*/
	lineWidth(M), $conlength(X,L), K is L+18,
	( ifPres1 -> true;
		( begCom, write('End Spec of '), write(X), fillIn(K,M,32), endCom ) ),
	write('#endif'), nl.

insert(X,'BEGIN_BODY') :- /*C049*/
	lineWidth(M), $conlength(X,L), K is L+20,
	( ifPres1 -> true; /*C059*/
		( begCom, write('Begin Body of '), write(X), fillIn(K,M,32), endCom ) ).

insert(X,'END_BODY') :- /*C049*/
	lineWidth(M), $conlength(X,L), K is L+18,
	( ifPres1 -> true; /*C059*/
		( begCom, write('End Body of '), write(X), fillIn(K,M,32), endCom ) ).

locVisi(X,U) :- removeSuffix(U,V), not(defined(X,V)), write('#define '), write(V), sp,
	opName(X,U), nl, $assert(defined(X,V)).

/*``C``Thu Dec 19 11:50:57 MET 2002``29 10 02 `*/
/* default file header */
/* C051, C059 */

defaultFileHeader(X,W) :- ifCom, lineWidth(M),
	write('/*'), fillIn(4,M,42), write('*/'), nl,
	begCom, ( ifPres1 -> write('PROJET          : '); write('PROJECT         : ') ),
		( $getenv('PROJECT',P) ->
			( $name(P,A), $name(Q,A), write(Q), $conlength(P,L1) ); L1 is 0 ),
		L2 is L1 + 24, fillIn(L2,M,32), endCom,
	begCom, ( ifPres1 -> write('SOCIETE         : '); write('COMPANY         : ') ),
		( $getenv('COMPANY',C) ->
			( $name(C,B), $name(D,B), write(D), $conlength(C,L3) ); L3 is 0 ),
		L4 is L3 + 24, fillIn(L4,M,32), endCom,
	begCom, ( ifPres1 -> write('NOM DU FICHIER  : '); write('FILENAME        : ') ),
		write(X), $conlength(X,L5), L6 is L5 + 26,
		( W ?= 'SpecHeader' -> write('.h'); W ?= 'BodyHeader' -> write('.c'); true ),     /*C064*/
		fillIn(L6,M,32), endCom,
	begCom, ( ifPres1 -> write('NOM DU SYSTEME  : '); write('DESIGN NAME     : ') ),
		isCurrentRoot(R), $conlength(R,L7), write(R),
		L8 is L7 + 24, fillIn(L8,M,32), endCom,
	begCom, ( ifPres1 -> write('NOM DU MODULE   : '); write('MODULE NAME     : ') ),
		write(X), L9 is L5 + 24, fillIn(L9,M,32), endCom,
	( ifPres1 -> (begCom, fillIn(6,M,32), endCom);true),	                               /*C060*/
	begCom, ( ifPres1 -> write('DESCRIPTION     : '); write('DESCRIPTION     : ') ),
		fillIn(24,M,32), endCom, insertDescr2(X,'DOC11'),
	begCom, ( ifPres1 ->
		( fillIn(6,M,32), endCom, begCom,           	                                   /*C060*/
		  write('LISTE DES FONCTIONS : '), fillIn(28,M,32) );
		( write('FUNCTION NAMES  : '), fillIn(24,M,32) ) ), endCom,
		isProvided(O,'OPERATION',X), begCom,
		write(X), write('__'), write(O), $conlength(O,L10), $conlength(X,L12),    /*C062*/
		L11 is L10 + 8, L13 is L11 + L12, fillIn(L13,M,32), endCom, fail.

defaultFileHeader(X,W) :- ifCom, lineWidth(M),
	write('/*'), fillIn(4,M,42), write('*/'), nl,
	( $getenv('DATEPROJ',D1) ->											/* C071 */
			( $name(D1,D2), $name(D3,D2), $conlength(D1,L14) );
			( L14 is 0 ) ),
	begCom, ( ifPres1 ->
		( write('Date de creation (MM/JJ/AA): '),
			write(D3), L15 is L14 + 35, fillIn(L15,M,32) );
		( write('Creation date (MM/JJ/AA): '),
			write(D3), L15 is L14 + 32, fillIn(L15,M,32) ) ),
	endCom,
	write('/*'), fillIn(4,M,42), write('*/'), nl, fail.

defaultFileHeader(X,W). /*C058*/

insertConfData :- ifPres1, write('/* $Id$ */'), nl.		/* C072 */

insertStaticDef(K,C) :- /*C054*/
	write('#ifndef '), write(C), nl,
	write('  #define '), write(K), write(' static'), nl,
	write('#else'), nl,
	write('  #define '), write(K), nl,
	write('#endif'), nl.
	
/*``C``Fri Apr 26 10:25:33 MET DST 2002``*/
/* default op header */
/* C052, C059 */

defaultOpHeader(O,X,W) :- ifCom, lineWidth(M),
	write('/*'), fillIn(4,M,42), write('*/'), nl,
	begCom, write('PROCEDURE    : '),
		( isProvided(O,'OPERATION',X) -> (write(X), $conlength(X,L2), write('__'));
										 L2 = -2),			/*C061*/
		write(O), $conlength(O,L1),
		L3 is L1 + 23, L4 is L3 + L2, fillIn(L4,M,32), endCom,
	( comment(O,'OPERATION',X,_,W) ->
		insertCom3(O,_,X,W);
	  	( write('/*'), fillIn(4,M,42), write('*/'), nl ) ), fail.
defaultOpHeader(O,X,W).

/*``C``Thu Dec 19 10:32:15 MET 2002``29 10 02 `*/
/* constants */
/*--------------------------*/
/* CONSTANTS TYPES AND DATA */
/*--------------------------*/
/* C013, C015, C017, C019, C021, C028, C054, C085 */

insertConstDefine(X,U) :- isProvided(U,'CONSTANT',X),
	( ifCom -> insertCom(U,'CONSTANT',X,'CstTxt'); true ),
	( isImplementedBy(U,'CONSTANT',X,V,Y) ->
		( imp(U,X,V), write('#define '), name1(X,U), sp, name1(Y,V), nl );
		( insertFile(U,'CONSTANT',X,'CstDef') )
	), lf.

insertConstNotDefine(X,U) :- isProvided(U,'CONSTANT',X),
	( ifCom -> insertCom(U,'CONSTANT',X,'CstTxt'); true ),
	( isImplementedBy(U,'CONSTANT',X,V,Y) ->
		( ifDef ->
			( imp(U,X,V), write('#define '), name1(X,U), sp, name1(Y,V), nl );
			( imp(U,X,V), write('extern const '), /*(cf.C110)*/
			  ( whichType(U,'CONSTANT',X,V,Y,O,T) -> ( name1(O,T), sp ); true ),
			  name1(X,U), write(';'), nl ) ); /*(cf.C110)*/
		( insertConstDecl(X,U), /*C103*/
		  ( isElsifDirective(X,U) -> ( write('#endif') ); true ) )	/* C070 */
	), lf.
	
insertConstDecl(X,U) :- file(U,'CONSTANT',X,_,'CstDef') -> /*C103*/
	( write('extern '), insertTruncFile(U,'CONSTANT',X,'CstDef',61), write(';'), nl );
	true.

insertConstDefine(X,U) :- isInternal(U,'CONSTANT',X),
	( ifCom -> insertCom(U,'CONSTANT',X,'Cst2Txt'); true),
	insertFile(U,'CONSTANT',X,'CstDef2'), lf.

insertConstNotDefine(X,U) :- isInternal(U,'CONSTANT',X),
	( ifCom -> insertCom(U,'CONSTANT',X,'Cst2Txt'); true ),
	file(U,'CONSTANT',X,F,'CstDef2'), /*C068*/
	( ( ifStatic(K,_), not(alreadyStatic(X,U,F)), not(noStaticNeeded(X,U,F)) ) -> /*C088*/
		( write(K), sp, revNl ); true ), /*C076*//*C068*/
	insertFile(U,'CONSTANT',X,'CstDef2'), lf.

insertConstBody(X,U) :- insertFile(U,'CONSTANT',X,'CstDef'), lf.

insertConstImpBy(X,U) :- isImplementedBy(U,'CONSTANT',X,V,Y), imp(U,X,V), /*(cf.C110)*/
	write('const '), 
	( whichType(U,'CONSTANT',X,V,Y,O,T) -> ( name1(O,T), sp ); true ),
	name1(X,U), write(' = '), 
	whichValue(U,'CONSTANT',X,V,Y), write(';'), nl, lf.

/*``C``Thu Dec 19 10:32:28 MET 2002``29 10 02 `*/
/* types */
/* C015, C017, C019, C028 */

insertType(X,U) :- isProvided(U,'TYPE',X),
	( ifCom -> insertCom(U,'TYPE',X,'TypeTxt'); true ),
	( isImplementedBy(U,'TYPE',X,V,Y) ->
		( ifDef ->
			( imp(U,X,V), write('#define '), name1(X,U), sp, name1(Y,V), nl );
			( imp(U,X,V), write('typedef '), name1(Y,V), sp, name1(X,U), write(';'), nl ) );
		( insertFile(U,'TYPE',X,'TypeDef') ) ), lf.

insertType(X,U) :- isInternal(U,'TYPE',X),
	( ifCom -> insertCom(U,'TYPE',X,'Type2Txt'); true ),
	insertFile(U,'TYPE',X,'TypeDef2'), lf.

/*``C``Thu Dec 19 10:37:27 MET 2002``29 10 02 `*/
/* defaultTypeDef(X,U) */

defaultTypeDef(X,U) :- enumeration(U,X,_,_) -> 
	defaultTypeDefEnum(X,U);defaultTypeDefStruct(X,U). /*C083, C112*/

defaultTypeDefStruct(X,U) :- write('typedef struct { '), nl, /*C055, C082*/
	attributes(U,X,A,T,M,V), sp, sp, name1(M,T), sp, write(A), write(';'), nl, fail.
defaultTypeDefStruct(X,U) :- write('} '), name1(X,U), write(';'), nl.

defaultTypeDefEnum(X,U) :- write('typedef enum { '), nl, /*C083*/
	enumeration(U,X,E,V) -> ( sp, sp, write(E), ( V \= '' -> ( write(' = '), write(V) ); true ), 
							  otherEnum(X,U,E) ). /*C101*/
defaultTypeDefEnum(X,U) :- nl, write('} '), name1(X,U), write(';'), nl.

otherEnum(X,U,E) :- enumeration(U,X,F,V), F \= E, write(','), nl, sp,sp, write(F), /*C101*/
	( V \= '' -> ( write(' = '), write(V) ); true ), fail.

/*``C``Thu Dec 19 10:33:02 MET 2002``29 10 02 `*/
/* data */
/* C015, C017, C028, C054 */

insertData(X,U) :- isProvided(U,'DATA',X),
	( ifCom -> insertCom(U,'DATA',X,'Data0Txt'); true ),
	( isImplementedBy(U,'DATA',X,V,Y) ->
		( ifDef ->
			( imp(U,X,V), write('#define '), name1(X,U), sp, name1(Y,V), nl );
			( imp(U,X,V), write('extern '),
			  ( whichType(U,'DATA',X,V,Y,O,T) -> ( name1(O,T), sp); true ),
			  name1(X,U), write(';'), nl ) ); /*(cf.C110)*/
		insertDataDecl(X,U) ), lf.

insertDataDecl(X,U) :- file(U,'DATA',X,_,'DataDef0') -> /*(cf.C110)*/
	( write('extern '), insertTruncFile(U,'DATA',X,'CstDef',61), write(';'), nl );
	true.

insertData(X,U) :- not(ifStatic(K,_)), isInternal(U,'DATA',X), 	/*C068*/
	( ifCom -> insertCom(U,'DATA',X,'DataTxt'); true ),
	insertFile(U,'DATA',X,'DataDef'), lf.

insertData(X,U) :- ifStatic(K,_), isInternal(U,'DATA',X), 		/*C068*/
	( ifCom -> insertCom(U,'DATA',X,'DataTxt'); true ),
	( file(U,'DATA',X,F,'DataDef'), not(alreadyStatic(X,U,F)), not(noStaticNeeded(X,U,F))  -> /*C088*//*C074*/
		( ifStatic(K,_),
		(isElsifDirective(X,U)-> nl; write(K)), /*C080*/
		 sp, revNl ); true ),
	insertFile(U,'DATA',X,'DataDef'), lf.

insertDataBody(X,U) :- insertFile(U,'DATA',X,'DataDef0'), lf. /*(cf.C110)*/

insertDataImpBy(X,U) :- isImplementedBy(U,'DATA',X,V,Y), imp(U,X,V), /*(cf.C110)*/
	( whichType(U,'DATA',X,V,Y,O,T) -> ( name1(O,T), sp ); true ),
	name1(X,U), write(' = '), 
	whichValue(U,'DATA',X,V,Y), write(';'), nl, lf.

/*``C``Thu Dec 19 10:17:25 MET 2002``29 10 02 `*/
/* operations spec */
/*-----------------------------*/
/*  OPERATION SPECIFICATION :  */
/*-----------------------------*/
/* C002, C005, C015, C017, C022, C028, C029, C035, C037, C052 */

insertOpSpec(X,U) :- ifCom, ( isProvided(U,'OPERATION',X) ->
	( ifPres1 -> defaultOpHeader(U,X,'OpTxt'); insertCom(U,'OPERATION',X,'OpTxt') );
	( ifPres1 -> defaultOpHeader(U,X,'Op2Txt'); insertCom(U,'OPERATION',X,'Op2Txt') ) ).
insertOpSpec(X,U) :- ( isImplementedBy(U,'OPERATION',X,V,Y) ->
	( ifDef ->
		( imp(U,X,V), write('#define '), opName(X,U), sp, opName(Y,V), nl );
		( imp(U,X,V), 
		  ( isInline(X,U) -> 
			( writeInline2, callingProc(X,U,Y,V) );
			( write('extern '), opType(X,U), opName(X,U), 
			  ( notANSI -> opDescr1(X,U);
				( fullProto -> opProto2(X,U); opProto1(X,U) ) 
			  ), write(';'), nl
			) 
		   ) 
		 )
	); /*(cf.C108)(cf.C110)*/
	(  ( storage(X,U,E,S) -> (
			write('#ifdef '), write(E), nl,
			opType(X,U,S), opName(X,U), ( notANSI -> opDescr1(X,U); /*(cf.C109)*/
			( fullProto -> opProto2(X,U,S); opProto1(X,U,S) ) ), write(';'), nl,
			write('#else'), nl ); true ),
		( isInline(X,U) -> writeInline; writeExtern(X,U) ), /*(cf.C084)*/
		writeStatic(X,U), /*(cf.C054)(cf.C114)*/
		( ( target(T), constrainedOp(X,U,_,_,_)  ) -> beginReverse(X,0,U,'','OpDecl',''); true ),
			opType(X,U), opName(X,U), ( notANSI -> opDescr1(X,U);
			( fullProto -> opProto2(X,U); opProto1(X,U) ) ), write(';'), nl,
		( ( target(T), constrainedOp(X,U,_,_,_)  ) -> endReverse(0); true ),
		( storage(X,U,E,S) -> ( write('#endif'), nl ); true )
	) ), lf.
	
insertOpImpBy(X,U) :- isImplementedBy(U,'OPERATION',X,V,Y), imp(U,X,V), /*(cf.C110)*/
	callingProc(X,U,Y,V), lf. 
	
/*``C``Thu Dec 19 10:01:41 MET 2002``29 10 02 `*/
/* operations body */
/*------------------*/
/* OPERATION BODY : */
/*------------------*/
/* C005, C008, C017, C028, C029, C035, C037, C052 */

insertOpBody(X,U) :-
	( ( ifCom, notPres1 ) -> insertCom(U,'OPERATION',X,'OpBodyTxt'); true ),
	( ifPseudo -> insertPseudo(U,'OPERATION',X,'OpDef'); true ),
	( ( ( target(T), constrainedOp(X,U,_,_,_)); isSTATE(X,U)  ) ->
		( info(214), write('static '), opType(X,U), write('OPCS_'), /*C105*/
			removeSuffix(U,V), write(V),( notANSI -> opDescr2(X,U); opProto2(X,U) ), nl );
		(  ( storage(X,U,E,S) -> (
				write('#ifdef '), write(E), nl,
				opType(X,U,S), opName(X,U), ( notANSI -> opDescr2(X,U,S); opProto2(X,U,S) ), nl,
				write('#else'), nl ); true ),
			( isInline(X,U) -> writeInline; true),
			writeStatic(X,U), /*(cf.C054)(cf.C114)*/
			( impMain(X,U) -> true; beginReverse(X,0,U,'','OpDecl','') ), /*C102*/
			opType(X,U), opName(X,U), ( notANSI -> opDescr2(X,U); opProto2(X,U) ), nl,
			( impMain(X,U) -> true; endReverse(0) ), /*C102*/
			( storage(X,U,E,S) -> ( write('#endif'), nl ); true )
		) ) ,
	( ( ifCom, ifPres1 ) -> ( isProvided(U,_,X) ->
		defaultOpHeader(U,X,'OpTxt'); defaultOpHeader(U,X,'Op2Txt') ); true ),
	insertFile(U,'OPERATION',X,'OpDef'), lf, /*C106*/
	( isSTATE(X,U) -> insertOpStd(X,U); true).

/*``C``Thu Dec 19 10:37:34 MET 2002``29 10 02 `*/
/* defaultOpDef(X,U) */

defaultOpDef(X,U) :- write('{ }'), nl.

/*``C``Thu Dec 19 10:33:17 MET 2002``29 10 02 `*/
/* main */
/*C027, C028, C030, C033, C034*/

insertMain(X,U) :-
	( comLine -> write('int main'); ( notANSI -> write('main'); write('int main') ) ),
	( notANSI -> opDescr2(X,U); opProto2(X,U) ), nl,
	write('{'), nl,
	( target(L) -> (
		indent(1), write('int status;'), nl,
		indent(1), write('pList = malloc((TaskNumber+1)*sizeof('), taskType(L), write('*));'), nl,
		indent(1), write('status = '), name2(X,'init();'), nl,
		indent(1), write('if (status != 1) exit(EXIT_FAILURE);'), nl
	); true ),
	indent(1),
	( comLine -> ( target(_) -> write('status = '); write('return ') ); true ), /*C034*/
	( ( isProvided(O,'OPERATION',X), memezTra(O,U) ) -> opName(X,U); write('no_main') ),
	( comLine -> ( notANSI -> write('(argc, argv);'); write('(argc, &argv[0]);') ); write('();') ), nl,
	( target(L) -> (
		indent(1), joinTask(L), write('(pList);'), nl,
		indent(1), name2(X,'term();'), nl,
		indent(1), write('free(pList);'), nl,
		indent(1), write('exit(EXIT_SUCCESS);'), nl
	); true ),
	( comLine -> true; (indent(1), write('return 0;'), nl) ), /*C089*/
	write('}'), nl, lf.

/*``OBCS``Mon Dec  4 15:40:45 MET 2000``*/
/* global declarations */

insertDecl(X,T) :- program(X,0,T).

nbTasks(X,N) :- $globalset(nbt(0)), fail.
nbTasks(X,N) :- isObject(Y,_,_), hasObcsTask(Y), nbt(I), J is I+1, $globalset(nbt(J)), fail. /*C024*/
nbTasks(X,N) :- isObject(Y,_,_), hasServerTask(Y), nbt(I), J is I+1, $globalset(nbt(J)), fail. /*C031, C040*/
nbTasks(X,N) :- nbt(N).

/*``OBCS``Wed Dec  6 17:40:22 MET 2000``*/
/* elaboration */
/* C016, C028, C030, C03, C034, C040, C043 */

insertInit(X,T) :- isObject(Y,_,_), hasObcs(Y), with(X,Y).
insertInit(X,T) :-
	write('int '), name2(X,'init(void)'), nl,
	write('{'), nl,
	indent(1), write('int cpt = 0;'), nl,
	( stack(_,_) ->
		( indent(1), write('static int ws['), stackSize(V), write(V), write('];'), nl ); true ).
insertInit(X,T) :- isObject(Y,_,_), hasObcsTask(Y), callInit(Y,'OBCS').
insertInit(X,T) :- isConstrained(O,'OPERATION',Y,'ASER',_),
	not(isConstrained(O,'OPERATION',Y,'BY_IT',_)), isTerm(Y), callInit(Y,O).
insertInit(X,T) :-
	indent(1), write('pList[cpt] = NULL;'), nl,
	indent(1), write('return 1;'), nl,
	write('}'), nl.

stackSize(V) :- $globalset(stk(0)), fail.
stackSize(V) :- isObject(Y,_,_), wsize(Y,S), stk(I), J is I + S, $globalset(stk(J)), fail.
stackSize(V) :- stk(I), V is I // 4.

callInit(X,P) :-
	indent(1), write('pList[cpt] = '), name2(X,P), write('_init('),
	( ( P='OBCS', wsize(X,S), stack(X,A) ) -> ( write('ws + '), write(A), write(', '), write(S) ); true ),
	write(');'), nl,
	indent(1), write('if (pList[cpt] == NULL) return 0;'), nl,
	indent(1), write('else cpt++;'), nl.

/*``OBCS``Mon Dec  4 15:46:45 MET 2000``*/
/* termination */
/* C024, C028, C030, C031, C034, C040 */

insertTerm(X,T) :-
	write('void '), name2(X,'term(void)'), nl,
	write('{'), nl.
insertTerm(X,T) :- isObject(Y,_,_), hasObcsTask(Y), callTerm(Y,'OBCS').
insertTerm(X,T) :- isConstrained(O,'OPERATION',Y,'ASER',_),
	not(isConstrained(O,'OPERATION',Y,'BY_IT',_)), isTerm(Y), callTerm(Y,O).
insertTerm(X,T) :-
	write('}'), nl.

callTerm(X,P) :- indent(1), name2(X,P), write('_term();'), nl.

/*``C``Mon May 19 09:58:26 MET DST 2003``Tue Apr 15 09:12:15 2003 `*/
/* operations parameters */
/*-----------------------*/
/* OPERATION ARGUMENTS : */
/*-----------------------*/

opProto1(X,U,S) :- write('('), ( /*C002, C005, C029, C033, C034*/
	impMain(X,U) -> ( comLine -> write('int argc, char *argv[ ]'); write('void') );
	argument(U,'OPERATION',X,M,A,Y,T,_,P) -> insertTyp(X,U,M,A,Y,T,P,S);
	write('void') ), fail.
opProto1(X,U,S) :- write(')').

opProto1(X,U) :- opProto1(X,U,''). /*C029*/

opProto2(X,U,S)  :- write('('), ( /*C005, C029, C033, C034*/
	impMain(X,U) -> ( comLine -> write('int argc, char *argv[ ]'); write('void') );
	argument(U,'OPERATION',X,M,A,Y,T,V,P) -> insertArg(X,U,M,A,Y,T,V,P,S);
	write('void') ), fail.
opProto2(X,U,S) :- write(')').

opProto2(X,U) :- opProto2(X,U,''). /*C029*/

opDescr1(X,U) :- write('()'). /*C002, C005*/

opDescr2(X,U,S) :-  write('('), ( /*C029, C033*/
	impMain(X,U) -> ( comLine -> write('argc, argv'); true );
	argument(U,'OPERATION',X,M,A,_,_,_,_) -> insertArg(X,U,M,A)
	), fail.
opDescr2(X,U,S) :- write(')'), fail.
opDescr2(X,U,S) :- ( impMain(X,U) ->
	( comLine -> ( nl, write('int argc;'), nl, write('char *argv[ ];') ); true );
	argument(U,'OPERATION',X,M,A,Y,T,_,P), nl, declArg(X,M,A,Y,T,P,S) ), fail.
opDescr2(X,U,S).

opDescr2(X,U) :- opDescr2(X,U,''). /*C029*/

opCall(X,I,U) :- /*C038*/
	removeSuffix(U,V), write(V), write('('),
	( argument(U,'OPERATION',X,M,A,_,_,_,P) -> insertArg2(X,I+1,U,M,A,P) ), fail.
opCall(X,I,U) :- write(');'), nl.

opcsCall(X,U) :- removeSuffix(U,V), ( impMain(X,U) ->  /*C018, C037*/
	( comLine ->
			( write('return OPCS_'), write(V), ( notANSI -> write('(argc, argv'); write('(argc, &argv[0]') ) );
			( opName(X,U), write('(') ) );
	( ( return(U,'OPERATION',X,_,_,_) -> write('return '); true ),
	  write('OPCS_'), write(V), write('('),
	  ( argument(U,'OPERATION',X,_,A,_,_,_,_) -> insertArg(X,U,A) ) ) ), fail.
opcsCall(X,U) :- write(');'), nl.

callingProc(X,U,Y,V) :- /*C015, C019, C033*/
	revNl, beginReverse(X,0,U,'','OpDecl',''),
	( impMain(X,U) -> ( comLine -> write('int '); write('void ') ); opType(X,U) ), opName(X,U),
	( notANSI -> opDescr2(X,U); ( fullProto -> opProto2(X,U); opProto1(X,U) ) ), nl,
	endReverse(0),
	write('{'), nl, indent(1),
	( impMain(Y,V) ->
		( comLine ->
			( write('return '), opName(Y,V), ( notANSI -> write('(argc, argv'); write('(argc, &argv[0]') ) );
			( opName(Y,V), write('(') ) );
		( ( return(V,'OPERATION',Y,_,_,_) -> write('return '); true ), opName(Y,V), write('('),
		  ( argument(V,'OPERATION',Y,_,A,_,_,_,_) -> insertArg(Y,V,A); true ) ) ), fail.
callingProc(X,U,Y,V) :-
	write(');'), nl, write('};'), nl.

insertTyp(X,U,M,A,Y,T,P,S) :- writeType(X,Y,T,M,P,S), writeMode(M). /*C028, C029*/
insertTyp(X,U,M,A,Y,T,P,S) :- argument(U,'OPERATION',X,N,B,Z,R,_,Q), A\=B,
	write(', '), writeType(X,Z,R,N,Q,S), writeMode(N). /*C028, C029*/

insertArg(X,U,M,A,Y,T,V,P,S) :- ( indent_param -> ( nl, indent(1) ); true ), /*C017*/
	writeType(X,Y,T,M,P,S), writeArg(A,V), writeMode(M). /*C028, C029*/
insertArg(X,U,M,A,Y,T,V,P,S) :- argument(U,'OPERATION',X,N,B,Z,R,W,Q), A\=B,
	write(','), ( indent_param -> ( nl, indent(1) ); sp ),
	writeType(X,Z,R,N,Q,S), writeArg(B,W), writeMode(N). /*C028, C029*/

insertArg(X,U,A) :- write(A). /*C015*/
insertArg(X,U,A) :- argument(U,'OPERATION',X,_,B,_,_,_,_), A\=B,
	write(', '), write(B).

insertArg(X,U,M,A) :- write(A), writeMode(M).
insertArg(X,U,M,A) :- argument(U,'OPERATION',X,N,B,_,_,_,_), A\=B,
	write(', '), write(B), writeMode(N).

insertArg2(X,I,U,M,A,P) :- nl, indent(I),
	( ( P = '*' ; byPointer(M) ) -> write('&'); true ), msgArg(X,U,M,A). /*C038*/
insertArg2(X,I,U,M,A,P) :- argument(U,'OPERATION',X,N,B,_,_,_,Q), A\=B, write(', '), nl, indent(I),
	( ( Q = '*' ; byPointer(N) ) -> write('&'); true ), msgArg(X,U,N,B). /*C038*/

writeExtern(X,U) :- ( isInternal(U,'OPERATION',X), ifStatic(K,_) ) -> 
	true; ( write('extern '), revNl ). /*(cf.C084)*/

writeStatic(X,U) :- ( isInternal(U,'OPERATION',X), ifStatic(K,_) ) -> 
	( write(K), sp, revNl ); true. /*(cf.C114)*/

opType(X,U,S) :-
	return(U,'OPERATION',X,Y,T,P) ->
	( returnConst(X,U) -> /* C047, C086 */
		writeType(X,Y,T,'return_const',P,S);
		writeType(X,Y,T,'return',P,S) );
	write('void '). /*C028, C029*/

opType(X,U) :- impMain(X,U) -> ( comLine -> write('int '); write('void ') ); opType(X,U,''). /*C029, C037*/

opName(X,U) :- /*C012, C028*/
	removeSuffix(U,V),
	( ( isProvided(U,'OPERATION',X); addPrefix ) -> name1(X,V); write(V) ).

taskName(X,U) :- removeSuffix(U,V), name1(X,V). /*C028*/

removeSuffix(U,V) :- /*C028*/
	( $name(U,L), $memberchk(35,L) ) -> ( $reverse(L,R),strip(R,V) ); V = U.

strip([35|R],U) :- $reverse(R,L), $name(U,L), !. /*C028*/
strip([X|R],U) :- strip(R,U).

declArg(X,M,A,Y,T,P,S) :- writeType(X,Y,T,M,P,S), /*C028, C029, C033*/
	write(A), write(';').

writeType(X,Y,T,M,P,S) :-  /*C028, C047, C059 (cf.C116)*/
	( ( not(notANSI), ( ( M = 'in', ( ifPres1 -> P = '*'; true) ); M = 'return_const' ) ) -> write('const '); true ),
	( Y = 'NIL' -> ( isProvided(T,'TYPE',X) -> Z = X; ( isProvided(T,'TYPE',Z) -> true; Z = 'NIL' ) ); Z = Y ), /*C032*/
	name1(Z,T), sp,
	( ( S \= '', ( P = '*' ; byPointer(M) ) ) -> ( write(S), sp ); true ), /*C029*/
	( P\='NIL' -> write(P);
	byPointer(M) -> write('*');
	true ).

writeArg(A,_) :- write(A).
/* writeArg(_,V) :- V\='', write(' = '), write(V). C100 */

writeMode(M) :- sp, write('/*'), write(M), write('*/').

paramTypes(X,O,C) :-
	write('typedef struct {'), nl,
	inArg(X,O,A,Y,T,P,M), indent(1), writeType(X,Y,T,'','NIL',''), sp, writeArg(A,''), write(';'), nl, fail. /*C028, C038*/
paramTypes(X,O,C) :-
	write('} '), name1(X,O), write('_in;'), nl, fail. /*C028*/
paramTypes(X,O,C) :- C \= 'ASER', /*C025*/
	write('typedef struct {'), nl,
	outArg(X,O,A,Y,T,P,M), indent(1), writeType(X,Y,T,'','NIL',''), sp, writeArg(A,''), write(';'), nl, fail. /*C028, C038*/
paramTypes(X,O,C) :- C \= 'ASER', /*C025*/
	write('} '), name1(X,O), write('_out;'), nl, fail. /*C028*/
paramTypes(X,O,C).

inArg(X,O,A,Y,T,P,'in') :- argument(O,'OPERATION',X,'in',A,Y,T,_,P). /*C038*/
inArg(X,O,A,Y,T,P,'in out') :- argument(O,'OPERATION',X,'in out',A,Y,T,_,P). /*C038*/
inArg(X,O,'call_','std','int','NIL','call'). /*C026, C038*/

outArg(X,O,A,Y,T,P,'out') :- argument(O,'OPERATION',X,'out',A,Y,T,_,P). /*C038*/
outArg(X,O,A,Y,T,P,'in out') :- argument(O,'OPERATION',X,'in out',A,Y,T,_,P). /*C038*/
outArg(X,O,'return_',Y,T,P,'return') :- return(O,'OPERATION',X,Y,T,P). /*C038*/
outArg(X,O,'return_','std','int','NIL','return') :- not(return(O,'OPERATION',X,_,_,_)). /*C026, C038*/

inoutArg(X,O,A,Y,T,P,'in out') :- argument(O,'OPERATION',X,'in out',A,Y,T,_,P). /*C038*/

msgArg(X,O,'in',A) :- write(O), write('_msg_in.'), write(A).
msgArg(X,O,'out',A) :- write(O), write('_msg_out.'), write(A).
msgArg(X,O,'in out',A) :- write(O), write('_msg_in.'), write(A).

/*``C``Tue Jul 18 14:59:41 MET DST 2000``*/
/* exceptions */
/*------------*/
/* EXCEPTIONS */
/*------------*/
/* C014, C017 */

insertEx(X,U) :-  ifCom,  ( isProvided(U,'EXCEPTION',X) ->
	insertCom(U,'EXCEPTION',X,'ExcTxt');
	insertCom(U,'EXCEPTION',X,'Exc2Txt') ), lf.

/*``OBCS``Mon Dec 11 16:27:13 MET 2000``*/
/* insertOBCSSpec */
/*------*/
/* OBCS */
/*------*/
/* C024, C025, C028, C030, C031, C043 */

insertOBCSSpec(X) :- ifCom, insertCom(_,_,X,'ObcsTxt').
insertOBCSSpec(X) :- target(T), hasObcsTask(X), nl, info(206),
	( ( wsize(X,_), stack(X,_) ) ->
		task(X,0,'OBCS',T,'_init(int *ws, int wsize)');
		task(X,0,'OBCS',T,'_init(void)') ), write(';'), nl,
	taskBody(X,0,'OBCS',T,''), write(';'), nl,
	write('void '), name2(X,'OBCS_stop(void)'), write(';'), nl,
	write('void '), name2(X,'OBCS_term(void)'), write(';'), nl.
insertOBCSSpec(X) :- target(T), hasServerTask(X), nl, info(207),
	isConstrained(O,'OPERATION',X,'ASER',_),
	not(isConstrained(O,'OPERATION',X,'BY_IT',_)),
	task(X,0,O,T,'_init(void)'), write(';'), nl,
	taskBody(X,0,O,T,'_st'), write(';'), nl,
	write('void '), name1(X,O), write('_stop(void);'), nl,
	write('void '), name1(X,O), write('_term(void);'), nl.

/*``OBCS``Tue Dec  7 08:28:02 MET 1999``*/
/* insertOBCSBody */

insertOBCSBody(X) :- ifCom, insertCom(_,_,X,'ObcsBodyTxt').
insertOBCSBody(X) :- ifPseudo, insertPseudo(_,_,X,'Obcs').
insertOBCSBody(X) :- hasObcsFile(X) ->
	insertFile('NIL','NIL',X,'obcs');
	createOBCSBody(X).

/*``OBCS``Thu Dec 19 09:39:55 MET 2002``29 10 02 `*/
/* createOBCSBody */
/*C030, C031*/

createOBCSBody(X) :- beginReverse(X,0,'NIL','','obcs','c::').

createOBCSBody(X) :- target(T), hasObcsTask(X), nl, info(203),
	task(X,0,'OBCS',T,''), write(';'), nl.
createOBCSBody(X) :- target(T), hasServerTask(X), nl, info(204),
	isConstrained(O,'OPERATION',X,'ASER',_),
	not(isConstrained(O,'OPERATION',X,'BY_IT',_)), task(X,0,O,T,'_st'), write(';'), nl.
createOBCSBody(X) :- target(T), nl, info(205),
	isProvided(O,'OPERATION',X), constrainedOp(X,O,C,_,_),
	not(isConstrained(O,'OPERATION',X,'BY_IT',_)), nl,
	paramTypes(X,O,C), tChannel(X,0,O,C,T).
createOBCSBody(X) :- target(T), nl, info(216), tChannel(X,0,'OBCS','STOP',T). /*C044*/
createOBCSBody(X) :- target(T), hasServerTask(X), nl, info(220),
	isConstrained(O,'OPERATION',X,'ASER',_),
	not(isConstrained(O,'OPERATION',X,'BY_IT',_)), tChannel(X,0,O,'STOP',T). /*C044*/
createOBCSBody(X) :- target(T), nl, info(208),
	isProvided(O,'OPERATION',X), constrainedOp(X,O,C,_,_),
	not(isConstrained(O,'OPERATION',X,'BY_IT',_)),
	messagesDecl(X,O,C).

createOBCSBody(X) :- target(T), nl, info(213),
	isProvided(O,'OPERATION',X), constrainedOp(X,O,C,P,D),
	not(isConstrained(O,'OPERATION',X,'BY_IT',_)), nl,
	callingProc(X,O,C,P,D,T).

/* OBCS_init */

createOBCSBody(X) :- target(T), hasObcsTask(X), nl, info(217),
	( ( wsize(X,_), stack(X,_) ) -> /*C043*/
		( task(X,0,'OBCS',T,'_init(int *ws, int wsize)'), write('{'), nl, indent(1), write('int n;'), nl );
		( task(X,0,'OBCS',T,'_init(void)'), nl, write('{'), nl ) ),
	initHeader(X,1,T),
	isProvided(O,'OPERATION',X), constrainedOp(X,O,C,_,_), C \= 'ASER', C \= 'BY_IT',
	createTChannel(X,1,O,C,T).
createOBCSBody(X) :- target(T), hasObcsTask(X), createTChannel(X,1,'OBCS','STOP',T). /*C044*/
createOBCSBody(X) :- target(T), hasObcsTask(X), createTask(X,1,'OBCS',T,'').
createOBCSBody(X) :- target(T), hasObcsTask(X), initTrailer(X,1,T), startHeader(X,1,T),
	isProvided(O,'OPERATION',X), constrainedOp(X,O,C,_,_), C \= 'ASER', C \= 'BY_IT',
	startTChannel(X,1,O,C,T).
createOBCSBody(X) :- target(T), hasObcsTask(X),
	startTChannel(X,1,'OBCS','STOP',T), /*C044*/
	startTask(X,1,'OBCS',T,''),
	startTrailer(X,1,T),
	indent(1), write('return '), name2(X,'OBCS'), write(';'), nl,
	write('}'), nl.

/* ASER_ST_init */

createOBCSBody(X) :- target(T), hasServerTask(X), nl, info(218),
	isConstrained(O,'OPERATION',X,'ASER',_),
	not(isConstrained(O,'OPERATION',X,'BY_IT',_)), /*C031*/
	task(X,0,O,T,'_init(void)'), nl,
	write('{'), nl,
	initHeader(X,1,T),
	createTChannel(X,1,O,'ASER',T),
	createTChannel(X,1,O,'STOP',T), /*C044*/
	createTask(X,1,O,T,'_st'),
	initTrailer(X,1,T), startHeader(X,1,T),
	startTChannel(X,1,O,'ASER',T),
	startTChannel(X,1,O,'STOP',T), /*C044*/
	startTask(X,1,O,T,'_st'),
	startTrailer(X,1,T),
	indent(1), write('return '), name1(X,O), write('_st;'), nl,
	write('}'), nl, lf.

/* OBCS_proc */

createOBCSBody(X) :- /*C044*/
	target(T), hasObcsTask(X), nl, info(209),
	createTaskBody(X,'OBCS',T,'').

/* ST_proc */

createOBCSBody(X) :- /*C044*/
	target(T), hasServerTask(X), nl, /*C024*/
	isConstrained(O,'OPERATION',X,'ASER',_),
	not(isConstrained(O,'OPERATION',X,'BY_IT',_)), info(210), /*C031*/
	createTaskBody(X,O,T,'_st').

/* OBCS_term */

createOBCSBody(X) :- target(T), hasObcsTask(X), nl, info(211), /*C024*/
	write('void '), name2(X,'OBCS_term(void)'), nl, /*C034*/
	write('{'), nl, /*C028*/
	isProvided(O,'OPERATION',X), constrainedOp(X,O,C,_,_), C \= 'ASER', C \= 'BY_IT',
	closeTChannel(X,1,O,C,T). /*C025*/
createOBCSBody(X) :- target(T), hasObcsTask(X), /*C024*/
	closeTChannel(X,1,'OBCS','STOP',T), /*C044*/
	killTask(X,1,'OBCS',T,''),
	write('}'), nl.

/* ST_term */

createOBCSBody(X) :- target(T), hasServerTask(X), nl, info(212), /*C024*/
	isConstrained(O,'OPERATION',X,'ASER',_),
	not(isConstrained(O,'OPERATION',X,'BY_IT',_)), /*C031*/
	write('void '), name1(X,O), write('_term(void)'), nl, /*C034*/
	write('{'), nl,
	closeTChannel(X,1,O,'ASER',T), /*C025*/
	closeTChannel(X,1,O,'STOP',T), /*C044*/
	killTask(X,1,O,T,'_st'),
	write('}'), nl.

createOBCSBody(X) :- endReverse(0), lf.

/*``OBCS``Tue Dec  5 12:08:29 MET 2000``*/
/* createTaskBody */
/* C044 */

createTaskBody(X,P,T,S) :-
	taskBody(X,0,P,T,S), nl,
	write('{'), nl,
	indent(1), write('int i;'), nl,
	indent(1), write('int running = 1;'), nl,
	indent(1), write('while (running) {'), nl.
createTaskBody(X,'OBCS',T,S) :-
	( hasStd(X) -> insertStd(X,2,T); insertEntries(X,2,T) ).
createTaskBody(X,P,T,S) :- P \= 'OBCS',
	insertAserEntry(X,2,T,P).
createTaskBody(X,P,T,S) :-
	indent(1), write('}'), nl,
	write('}'), nl, nl,
	( P='OBCS' -> info(219); info(221) ),
	write('void '), name2(X,P), write('_stop(void)'), nl,
	write('{'), nl,
	liceTrace(X,1,P,'STOP',0),
	call(X,1,P,'STOP',_,_,T),
	liceTrace(X,1,P,'STOP',1),
	write('}'), nl, nl.

/*``OBCS``Thu Sep 28 15:01:57 MET 2000``*/
/* messagesDecl */

messagesDecl(X,O,C) :- ( C='HSER'; C='LSER'; C='ASER' ),
	write('static '), name1(X,O), write('_in '), write(O), write('_msg_in;'), nl,
	( C = 'ASER' -> true; (  /*C025*/
	write('static '), name1(X,O), write('_out '), write(O), write('_msg_out;'), nl ) ).

/*``OBCS``Mon Dec  4 16:29:20 MET 2000``*/
/* copy*Args */

copyInArgs(X,I,O) :- inArg(X,O,A,_,_,P,M), A \= 'call_', /*C026, C038*/
	sp, sp, msgArg(X,O,'in',A), write(' = '),
	( ( P = '*' ; byPointer(M) ) -> write('*'); true ), writeArg(A,''), write(';'), nl, fail.
copyInArgs(X,N,O).

copyInOutArgs(X,I,O) :- inoutArg(X,O,A,_,_,_,_), /*C038*/
	indent(I), msgArg(X,O,'out',A), write(' = '), msgArg(X,O,'in',A), write(';'), nl, fail.
copyInOutArgs(X,I,O).

copyOutArgs(X,I,O) :- outArg(X,O,A,_,_,P,M),  /*C038*/
	( A = 'return_' ->
		( isFunction(X,O), indent(I), write('return ') );
		( indent(I), ( ( P = '*' ; byPointer(M) ) -> write('*'); true ), writeArg(A,''), write(' = ') ) ),
	msgArg(X,O,'out',A), write(';'), nl, fail.
copyOutArgs(X,I,O).

/*``OBCS``Mon Oct  2 08:35:37 MET 2000``*/
/* callingProc */

callingProc(X,O,C,P,D,T) :- opType(X,O), opName(X,O),
	( notANSI -> opDescr2(X,O); opProto2(X,O) ), nl,
	write('{'), nl,
	liceTrace(X,1,O,C,0),
	call(X,1,O,C,P,D,T),
	liceTrace(X,1,O,C,1),
	write('}'), nl.

/*``OBCS``Tue Dec  5 10:15:53 MET 2000``*/
/* insertStd */
/*C030, C031, C041*/

insertStd(X,I,T) :- isState(X,S,_), insertState(X,I,S,T).

insertState(X,I,S,L) :- ifCom, insertCom2(S,'STATE',X,'StateTxt').
insertState(X,I,S,L) :-
	indent(I), write('if ('), /*C007*/
		( hasGet(X,S) -> insertText2(S,'STATE',X,'GetState'); write('0')),
		write(') {'), nl.
insertState(X,I,S,L) :- hasCyclicTask(X,O,P), isTransition(X,_,S,_,O), accept(X,I+1,O,'BY_IT',P,L).
insertState(X,I,S,L) :- indent(I+1), write('i = ').
insertState(X,I,S,L) :- ( hasCyclicTask(X,O,P), isTransition(X,_,S,_,O) ) ->
	( waitTimerTaskList(X,2,L), write('(DeadLine, ') ); ( waitTaskList(X,2,L), write('(') ).
insertState(X,I,S,L) :- isTransition(X,T,S,D,O), notASER(X,O), name2(X,O), write('_req, ').
insertState(X,I,S,L) :- name2(X,'OBCS'), write('_end, NULL);'), nl,
	indent(I+1), write('switch (i) {'), nl, $globalset(cpt(0)).
insertState(X,I,S,L) :- hasCyclicTask(X,O,P), isTransition(X,_,S,_,O),
	indent(I+2), write('case -1 :'), nl,
	indent(I+3), write('break;'), nl.
insertState(X,I,S,L) :- isTransition(X,T,S,D,O), notASER(X,O),
	cpt(A), B is A + 1, $globalset(cpt(B)),
	indent(I+2), write('case '), write(A), write(' :'), nl,
	insertTrans(X,I+3,T,S,D,O,L),
	indent(I+3), write('break;'), nl.
insertState(X,I,S,L) :- cpt(A),
	indent(I+2), write('case '), write(A), write(' :'), nl,
	accept(X,I+3,'OBCS','STOP',_,L), /*C042*/
	indent(I+3), write('break;'), nl,
	indent(I+1), write('}'), nl,
	indent(I), write('}'), nl.

insertTrans(X,I,T,S,D,O,L) :- ifCom, insertCom2(T,'TRANSITION',X,'TransTxt'), fail.
insertTrans(X,I,T,S,D,O,L) :- hasCond(X,T),
	indent(I), write('if ('), insertText2(T,'TRANSITION',X,'Condition'), write(') {'), nl, fail.
insertTrans(X,I,T,S,D,O,L) :-
	( constrainedOp(X,O,C,P,_) ->  accept(X,I+1,O,C,P,L); accept(X,I+1,O,'ELSE',_,L) ),
	indent(I+1), insertText2(D,'STATE',X,'SetState'), nl, fail.
insertTrans(X,I,T,S,D,O,L) :- hasCond(X,T),
	indent(I), write('}'), nl, hasExc(X,T),
	indent(I), write('else'), nl,
	indent(I+1), insertText2(T,'TRANSITION',X,'Exception'), nl, fail.
insertTrans(X,I,T,S,D,O,L). /*C041*/

/*``OBCS``Thu Dec 19 09:40:46 MET 2002``29 10 02 `*/
/* insertOpStd */
/* C003, C017, C018, C037, C106  */

insertOpStd(X,O) :-
	beginReverse(X,0,O,'','OpDecl',''),
	opType(X,O), opName(X,O), ( notANSI -> opDescr2(X,O); opProto2(X,O) ), nl,
	endReverse(0).
insertOpStd(X,O) :- write('{'), nl,
	isState(X,S,_), insertOpState(X,S,O).
insertOpStd(X,O) :- write('}'), nl, lf.

insertOpState(X,S,O) :- ifCom, insertCom(S,'STATE',X,'StateTxt').
insertOpState(X,S,O) :-
	indent(1), write('if ('), /*C007*/
		insertText(S,'STATE',X,'GetState'), /*C106*/
		write(') {'), nl.
insertOpState(X,S,O) :- isTransition(X,T,S,D,O), insertOpTrans(X,T,S,D,O).
insertOpState(X,S,O) :-
	indent(1), write('}'), nl.
	
defaultGetState :- write('0'). /*C106*/

insertOpTrans(X,T,S,D,O) :- ifCom, insertCom(T,'TRANSITION',X,'TransTxt').
insertOpTrans(X,T,S,D,O) :- hasCond(X,T),
	indent(2), write('if ('), insertText(T,'TRANSITION',X,'Condition'), write(') {'), nl.
insertOpTrans(X,T,S,D,O) :-
	indent2(3), opcsCall(X,O),
	indent2(3), insertFile(D,'STATE',X,'SetState').
insertOpTrans(X,T,S,D,O) :- hasCond(X,T),
	indent(2), write('}'), nl, hasExc(X,T),
	indent(2), write('else'), nl,
	indent2(3), insertFile(T,'TRANSITION',X,'Exception').

/*``OBCS``Wed Dec  6 12:02:30 MET 2000``*/
/* insertAsertStd */
/* C044 */

insertAsertStd(X,I,L,O,P) :- isTransition(X,T,S,D,O), insertAserTrans(X,I,L,O,P,T,S,D).

insertAserTrans(X,I,L,O,P,T,S,D) :- ifCom, insertCom2(T,'TRANSITION',X,'TransTxt').
insertAserTrans(X,I,L,O,P,T,S,D) :-
	indent(I), write('if ('),
	( hasGet(X,S) -> insertText2(S,'STATE',X,'GetState'); write('0')),
	( hasCond(X,T) -> ( write(' && '), insertText2(T,'TRANSITION',X,'Condition') ); true ),
	write(') {'), nl,
	accept(X,I+1,O,'ASER',P,L),
	( hasSet(X,D) -> (
	indent(I+1), insertText2(D,'STATE',X,'SetState'), nl ); true ),
	indent(I), write('}'), nl,
	( hasExc(X,T) -> (
	indent(I), write('else'), nl,
	indent(I+1), insertText2(T,'TRANSITION',X,'Exception'), nl ); true ).

/*``OBCS``Wed Dec  6 08:58:38 MET 2000``*/
/* insertEntries */
/*C030, C031, C042*/

insertEntries(X,I,T) :- hasCyclicTask(X,O,P), accept(X,I,O,'BY_IT',P,T).
insertEntries(X,I,T) :- indent(I), write('i = ').
insertEntries(X,I,T) :- hasCyclicTask(X,O,P) ->
	( waitTimerTaskList(X,1,T),  write('(DeadLine, ') ); ( waitTaskList(X,1,T), write('(') ).
insertEntries(X,I,T) :- isProvided(O,'OPERATION',X), notASER(X,O), name2(X,O), write('_req, ').
insertEntries(X,I,T) :- name2(X,'OBCS'), write('_end, NULL);'), nl,
	indent(I), write('switch (i) {'), nl, $globalset(cpt(0)).
insertEntries(X,I,T) :- hasCyclicTask(X,O,P),
	indent(I+1), write('case -1 :'), nl,
	indent(I+2), write('break;'), nl.
insertEntries(X,I,T) :- isProvided(O,'OPERATION',X), notASER(X,O),
	cpt(A), B is A + 1, $globalset(cpt(B)),
	indent(I+1), write('case '), write(A), write(' :'), nl,
	( constrainedOp(X,O,C,P,_) ->  accept(X,I+2,O,C,P,T); accept(X,I+2,O,'ELSE',_,T) ),
	indent(I+2), write('break;'), nl.
insertEntries(X,I,T) :- cpt(A),
	indent(I+1), write('case '), write(A), write(' :'), nl,
	accept(X,I+2,'OBCS','STOP',_,T), /*C042*/
	indent(I+2), write('break;'), nl,
	indent(I), write('}'), nl.

/*``OBCS``Wed Dec  6 18:28:11 MET 2000``*/
/* insertAserEntry */
/* C044 */

insertAserEntry(X,I,T,O) :- isConstrained(O,'OPERATION',X,'ASER',P),
	indent(I), write('i = '), waitTaskList(X,1,T), write('('),
	name2(X,O), write('_req, '), name2(X,O), write('_end, NULL);'), nl,
	indent(I), write('switch (i) {'), nl,
	indent(I+1), write('case 0 :'), nl,
	( isGuarded(X,O) -> insertAsertStd(X,I+2,T,O,P); accept(X,I+2,O,'ASER',P,T) ).
 insertAserEntry(X,I,T,O) :-
	indent(I+2), write('break;'), nl,
	indent(I+1), write('case 1 :'), nl,
	accept(X,I+2,O,'STOP',_,T),
	indent(I+2), write('break;'), nl,
	indent(I), write('}'), nl.
	
/*``C``Tue Jul 18 15:44:00 MET DST 2000``*/
/* #include */
/*-------------*/
/* WITH CLAUSE */
/*-------------*/
/* C016 */

with(X,Y) :- ( extract(_,_,Y,'spec',F) ->
	( openMakeFile(G), writeFileName(Y,F), sp, closeMakeFile(G),
	  write('#include '), begInc(Y), writeFileName(Y,F), endInc(Y), nl );
	( ( ifStd(Y) ->
		true;
		( openMakeFile(G), writeEnvFileName(Y), sp, closeMakeFile(G) ) ),
	  write('#include '), begInc(Y), writeEnvFileName(Y), endInc(Y), nl ) ),
	$assert(withed(X,Y)).

begInc(X) :- ifStd(X) -> write('<'); write('"').

endInc(X) :- ifStd(X) -> write('>'); write('"').

/*``targets``Fri Dec 15 09:52:45 MET 2000``*/
/* generic */

program(X,I,'generic') :-
	write('PROGRAM('), write(X), write(')'), nl,
	write('#define TaskNumber '), nbTasks(X,N), write(N), nl.

taskType('generic') :- write('TASK_TYPE'). /*C030*/

task(X,I,P,'generic',S) :- indent(I), write('TASK_TYPE *'), taskName(X,P), write(S).

createTask(X,I,P,'generic',S) :- indent(I), write('CREATE_TASK('), taskName(X,P), write(S), write(','), (
	( P='OBCS', wsize(X,S), stack(X,A) ) ->  ( write(S), write(','), write(A), write(')') );
	( wsize(X,S) -> ( write(S), write(',0)') ); write('0,0)') ) ), nl.

startTask(X,I,P,'generic',S) :- indent(I), write('START_TASK('), taskName(X,P), write(S), write(','),
	( ( S='_st' -> write('High'); ( priority(X,L) -> write(L); write('') ) ) ), write(')'), nl.

taskBody(X,I,P,'generic',S) :- write('TASK_BODY('), taskName(X,P), write(S), write(')').

joinTask('generic') :- write('JOIN_TASK'). /*C030*/

killTask(X,I,P,'generic',S) :-
	indent(I), write('KILL_TASK('), taskName(X,P), write(S), write(','),
	taskName(X,P), write(S), write('_term)'), nl.

waitTaskList(X,I,'generic') :- write('WAIT_TASK_LIST'). /*C030*/

waitTimerTaskList(X,I,'generic') :- write('WAIT_TIMER_TASK_LIST'). /*C031*/

tChannel(X,I,O,C,'generic') :- C \='ASER', C \= 'STOP',  /*C044*/
	write('TCHANNEL('), name2(X,O), write('_req,'), name2(X,O), write('_in,1,0)'), nl,
	write('TCHANNEL('), name2(X,O), write('_rep,'), name2(X,O), write('_out,1,0)'), nl.

tChannel(X,I,O,'ASER','generic') :- /*C025*/
	write('TCHANNEL('), name2(X,O), write('_req,'), name2(X,O), write('_in,1,0)'), nl.

tChannel(X,I,O,'STOP','generic') :- /*C044*/
	write('TCHANNEL('), name2(X,O), write('_end,int,1,0)'), nl.

createTChannel(X,I,O,C,'generic') :- C \= 'ASER', C \= 'STOP', /*C044*/
	indent(I), write('CREATE_TCHANNEL('), name2(X,O), write('_req,'),
	  name2(X,O), write('_in,1)'), nl,
	indent(I), write('CREATE_TCHANNEL('), name2(X,O), write('_rep,'),
	  name2(X,O), write('_out,1)'), nl.

createTChannel(X,I,O,'ASER','generic') :- /*C025*/
	indent(I), write('CREATE_TCHANNEL('), name2(X,O), write('_req,'),
	  name2(X,O), write('_in,1)'), nl.

createTChannel(X,I,O,'STOP','generic') :- /*C044*/
	indent(I), write('CREATE_TCHANNEL('), name2(X,O), write('_end,int,1)'), nl.

startTChannel(X,I,O,C,'generic') :- C \= 'ASER', C \= 'STOP', /*C044*/
	indent(I), write('START_TCHANNEL('), name2(X,O), write('_req)'), nl,
	indent(I), write('START_TCHANNEL('), name2(X,O), write('_rep)'), nl.

startTChannel(X,I,O,'ASER','generic') :- /*C025*/
	indent(I), write('START_TCHANNEL('), name2(X,O), write('_req)'), nl.

startTChannel(X,I,O,'STOP','generic') :- /*C044*/
	indent(I), write('START_TCHANNEL('), name2(X,O), write('_end)'), nl.

closeTChannel(X,I,O,C,'generic') :- C \= 'ASER', C \= 'STOP', /*C044*/
	indent(I), write('SEND_EOT('), name2(X,O), write('_req)'), nl,
	indent(I), write('CLOSE_TCHANNEL('), name2(X,O), write('_rep)'), nl.

closeTChannel(X,I,O,'ASER','generic') :- /*C025*/
	indent(I), write('SEND_EOT('), name2(X,O), write('_req)'), nl.

closeTChannel(X,I,O,'STOP','generic') :- /*C044*/
	indent(I), write('SEND_EOT('), name2(X,O), write('_end)'), nl.

call(X,I,O,C,P,0,'generic') :- C \= 'ASER', C \= 'STOP', /*C025, C042*/
	copyInArgs(X,I,O),
	indent(I), write('TSEND('), name2(X,O), write('_req,&'), write(O), write('_msg_in,1,none)'), nl,
	indent(I), write('TRECEIVE('), name2(X,O), write('_rep,&'), write(O), write('_msg_out,1,none)'), nl,
	copyOutArgs(X,I,O).

call(X,I,O,'ASER',P,0,'generic') :-  /*C025*/
	copyInArgs(X,I,O),
	indent(I), write('TSEND('), name2(X,O), write('_req,&'), write(O), write('_msg_in,1,none)'), nl,
	copyOutArgs(X,I,O).

call(X,I,O,C,P,D,'generic') :- D \= 0, C \= 'STOP', /*C042*/
	copyInArgs(X,I,O),
	indent(I), write('if(TSEND_OR_TO('), name2(X,O), write('_req,&'),
	  write(O), write('_msg_in,1,'), write(D), write('))'), nl,
	indent(I), write('{'), nl,
	indent(I+1), write('TRECEIVE('), name2(X,O), write('_rep,&'), write(O), write('_msg_out,1,none)'), nl,
	copyOutArgs(X,I+1,O),
	indent(I), write('}'), nl.

call(X,I,O,'STOP',_,_,'generic') :-  /*C042*/
	indent(I), write('TSEND('), name2(X,O), write('_end,0,1,none)'), nl.

accept(X,I,O,'HSER',P,'generic') :-
	indent(I), write('/* HSER '), write(O), write(' */'), nl,
	indent(I), write('TRECEIVE('), name2(X,O), write('_req,&'), /*C023*/
	  write(O), write('_msg_in,1,none)'), nl,
	indent(I), ( isFunction(X,O) -> ( msgArg(X,O,'out','return_'), write(' = ') ); true ),
	  write('OPCS_'), opCall(X,I,O),
	  ( isFunction(X,O) -> true; ( indent(I), msgArg(X,O,'out','return_'), write(' = 1;'), nl ) ),
	copyInOutArgs(X,I,O),
	indent(I), write('TSEND('), name2(X,O), write('_rep,&'), write(O), write('_msg_out,1,none)'), nl. /*C023*/

accept(X,I,O,'LSER',P,'generic') :- /*C030*/
	indent(I), write('/* LSER '), write(O), write(' */'), nl,
	indent(I), write('TRECEIVE('), name2(X,O), write('_req,&'), /*C023*/
	  write(O), write('_msg_in,1,none)'), nl,
	indent(I), write('TSEND('), name2(X,O), write('_rep,&'), write(O), write('_msg_out,1,none)'), nl, /*C023*/
	indent(I), ( isFunction(X,O) -> ( msgArg(X,O,'out','return_'), write(' = ') ); true ),
	  write('OPCS_'), opCall(X,I,O),
	  ( isFunction(X,O) -> true; ( indent(I), msgArg(X,O,'out','return_'), write(' = 1;'), nl ) ),
	copyInOutArgs(X,I,O).

accept(X,I,O,'ASER',P,'generic') :- /*C025, C030*/
	indent(I), write('/* ASER '), write(O), write(' */'), nl,
	indent(I), write('TRECEIVE('), name2(X,O), write('_req,&'), /*C023*/
	  write(O), write('_msg_in,1,none)'), nl,
	indent(I), ( isFunction(X,O) -> ( msgArg(X,O,'out','return_'), write(' = ') ); true ),
	  write('OPCS_'), opCall(X,I,O).

accept(X,I,O,'BY_IT',P,'generic') :- /*C031*/
	indent(I), write('/* BY_IT '), write(O), write(' */'), nl,
	indent(I), write('int DeadLine = DEADLINE('), write(P), write(')'), nl,
	indent(I), write('OPCS_'), opCall(X,I,O).

accept(X,I,O,'STOP',_,'generic') :- /*C042*/
	indent(I), write('/* STOP '), write(O), write(' */'), nl,
	indent(I), write('TRECEIVE('), name2(X,O), write('_end,0,1,none)'), nl,
	indent(I), write('running = 0;'), nl.

accept(X,I,O,'ELSE',P,'generic') :- isSTATE(X,O) -> true; ( /*C009*/
	indent(I), write('/* direct call to '), write(O), write(' */'), nl,
	indent(I), write('OPCS_'), opCall(X,I,O) ).

includeFiles(X,I,'generic') :- 	write('#include <taskCom.h>'), nl.

initHeader(X,I,'generic') :- indent(I), write('INIT_HEADER( )'), nl.

initTrailer(X,I,'generic') :- indent(I), write('INIT_TRAILER( )'), nl.

startHeader(X,I,'generic') :- indent(I), write('START_HEADER( )'), nl.

startTrailer(X,I,'generic') :- indent(I), write('START_TRAILER( )'), nl.

/*``targets``Fri Dec 15 09:07:24 MET 2000``*/
/* transputer */

program(X,I,'transputer') :- /*C030*/
	write('static Process **pList;'), nl,
	write('#define TaskNumber '), nbTasks(X,N), write(N), nl.

taskType('transputer') :- write('Process'). /*C030*/

task(X,I,P,'transputer',S) :-
	write('Process * '), name2(X,P), write(S). /*C028, C030*/

createTask(X,I,P,'transputer',S) :- ( P='OBCS', wsize(X,_), stack(X,_) ) -> /*C043*/
	( indent(I), name2(X,P), write(' = (Process *)malloc(sizeof(Process));'), nl,
	  indent(I), write('if ('), name2(X,P), write(' == NULL) return NULL;'), nl,
	  indent(I), write('n = ProcInit('), name2(X,P), write(', '), name2(X,P), write('_proc, ws, wsize, 0);'), nl,
	  indent(I), write('if (n != 0) return NULL;'), nl );
	( indent(I), name2(X,P), write(S), write(' = ProcAlloc('), name2(X,P), write('_proc, '),
	  ( P='OBCS', wsize(X,V) -> write(V); write('0') ), write(', 0);'), nl, /*C028, C030*/
	  indent(I), write('if ('), name2(X,P), write(S), write(' == NULL) return NULL;'), nl ).

startTask(X,I,P,'transputer',S) :- indent(I),
	 ( priority(X,'low') -> write('ProcRunLow(');
	   priority(X,'high') -> write('ProcRunHigh(');
	   S = '_st' -> write('ProcRunHigh('); write('ProcRun(') ),
	name2(X,P), write(S), write(');'), nl. /*C028, C030*/

taskBody(X,I,P,'transputer',S) :- /*C028, C030*/
	write('void '), name2(X,P), write('_proc(Process * '), name2(X,P), write(S), write(')').

joinTask('transputer') :- write('ProcJoinList'). /*C030*/

killTask(X,I,P,'transputer',S) :- ( P='OBCS', wsize(X,_), stack(X,_) ) -> /*C043*/
	( indent(I), write('ProcInitClean('), name2(X,P), write(');'), nl,
	  indent(I), write('free('), name2(X,P), write(');'), nl );
	( indent(I), write('ProcAllocClean('), name2(X,P), write(S), write(');'), nl ). /*C028, C030*/

waitTaskList(X,I,'transputer') :- write('ProcAlt'). /*C030*/

waitTimerTaskList(X,I,'transputer') :- write('ProcTimerAlt'). /*C031*/

tChannel(X,I,O,C,'transputer') :- C \= 'ASER', C \= 'STOP', /*C044*/
	write('Channel * '), name2(X,O), write('_req;'), nl,
	write('Channel * '), name2(X,O), write('_rep;'), nl.

tChannel(X,I,O,'ASER','transputer') :- /*C025*/
	write('Channel * '), name2(X,O), write('_req;'), nl.

tChannel(X,I,O,'STOP','transputer') :- /*C044*/
	write('Channel * '), name2(X,O), write('_end;'), nl.

createTChannel(X,I,O,C,'transputer') :- C \= 'ASER', C \= 'STOP', /*C025, C030, C044*/
	indent(I), name2(X,O), write('_req = ChanAlloc();'), nl,
	indent(I), write('if ('), name2(X,O), write('_req'), write(' == NULL) return NULL;'), nl,
	indent(I), name2(X,O), write('_rep = ChanAlloc();'), nl,
	indent(I), write('if ('), name2(X,O), write('_rep'), write(' == NULL) return NULL;'), nl.

createTChannel(X,I,O,'ASER','transputer') :- /*C025, C030*/
	indent(I), name2(X,O), write('_req = ChanAlloc();'), nl,
	indent(I), write('if ('), name2(X,O), write('_req'), write(' == NULL) return NULL;'), nl.

createTChannel(X,I,O,'STOP','transputer') :- /*C044*/
	indent(I), name2(X,O), write('_end = ChanAlloc();'), nl,
	indent(I), write('if ('), name2(X,O), write('_end'), write(' == NULL) return NULL;'), nl.

startTChannel(X,I,O,C,'transputer').

closeTChannel(X,I,O,C,'transputer') :- C \= 'ASER', C \= 'STOP', /*C030, C044*/
	indent(I), write('free('), name2(X,O), write('_req);'), nl,
	indent(I), write('free('), name2(X,O), write('_rep);'), nl.

closeTChannel(X,I,O,'ASER','transputer') :- /*C030*/
	indent(I), write('free('), name2(X,O), write('_req);'), nl.

closeTChannel(X,I,O,'STOP','transputer') :- /*C044*/
	indent(I), write('free('), name2(X,O), write('_end);'), nl.

call(X,I,O,C,P,0,'transputer') :- /*C025, C042*/
	C \= 'ASER', C \= 'STOP',
	copyInArgs(X,I,O),
	indent(I), write('ChanOut('), name2(X,O), write('_req, &'),
	  write(O), write('_msg_in, sizeof('), name2(X,O), write('_in));'), nl,
	indent(I), write('ChanIn('), name2(X,O), write('_rep, &'),
	  write(O), write('_msg_out, sizeof('), name2(X,O), write('_out));'), nl,
	copyOutArgs(X,I,O).

call(X,I,O,'ASER',P,0,'transputer') :- /*C025*/
	copyInArgs(X,I,O),
	indent(I), write('ChanOut('), name2(X,O), write('_req, &'),
	  write(O), write('_msg_in, sizeof('), name2(X,O), write('_in));'), nl,
	copyOutArgs(X,I,O).

call(X,I,O,C,P,D,'transputer') :- /*C042*/
	C \= 'STOP', D \= 0,
	copyInArgs(X,I,O),
	indent(I), write('if(!ChanOutTimeFail('), name2(X,O), write('_req, &'),
	  write(O), write('_msg_in, sizeof('), name2(X,O), write('_in),'), nl,
	  indent(I+1), write('ProcTimePlus(ProcTime(), '), write(D), write(')))'), nl,
	indent(I), write('{'), nl,
	indent(I+1), write('ChanIn('), name2(X,O), write('_rep, &'),
	  write(O), write('_msg_out, sizeof('), name2(X,O), write('_out));'), nl,
	copyOutArgs(X,I+1,O),
	indent(I), write('}'), nl.

call(X,I,O,'STOP',_,_,'transputer') :-
	indent(I), write('ChanOutInt('), name2(X,O), write('_end, 0);'), nl. /*C030, C042*/

accept(X,I,O,'HSER',P,'transputer') :- /*C030*/
	indent(I), write('/* HSER '), write(O), write(' */'), nl,
	indent(I), write('ChanIn('), name2(X,O), write('_req,'), nl,
	  indent(I+1), write('&'), write(O), write('_msg_in, sizeof('), name2(X,O), write('_in));'), nl,
	indent(I), ( isFunction(X,O) -> ( msgArg(X,O,'out','return_'), write(' = ') ); true ),
	  write('OPCS_'), opCall(X,I,O),
	( isFunction(X,O) -> true; ( indent(I), msgArg(X,O,'out','return_'), write(' = 1;'), nl ) ),
	copyInOutArgs(X,I,O),
	indent(I), write('ChanOut('), name2(X,O), write('_rep,'), nl,
	  indent(I+1), write('&'),  write(O), write('_msg_out, sizeof('), name2(X,O), write('_out));'), nl.

accept(X,I,O,'LSER',P,'transputer') :- /*C030*/
	indent(I), write('/* LSER '), write(O), write(' */'), nl,
	indent(I), write('ChanIn('), name2(X,O), write('_req,'), nl,
	  indent(I+1), write('&'), write(O), write('_msg_in, sizeof('), name2(X,O), write('_in));'), nl,
	indent(I), write('ChanOut('), name2(X,O), write('_rep,'), nl,
	  indent(I+1), write('&'),  write(O), write('_msg_out, sizeof('), name2(X,O), write('_out));'), nl,
	indent(I), ( isFunction(X,O) -> ( msgArg(X,O,'out','return_'), write(' = ') ); true ),
	  write('OPCS_'), opCall(X,I,O),
	( isFunction(X,O) -> true; ( indent(I), msgArg(X,O,'out','return_'), write(' = 1;'), nl ) ),
	copyInOutArgs(X,I,O).

accept(X,I,O,'ASER',P,'transputer') :- /*C025, C030*/
	indent(I), write('/* ASER '), write(O), write(' */'), nl,
	indent(I), write('ChanIn('), name2(X,O), write('_req,'), nl,
	  indent(I+1), write('&'), write(O), write('_msg_in, sizeof('), name2(X,O), write('_in)'), write(');'), nl,
	indent(I), ( isFunction(X,O) -> ( msgArg(X,O,'out','return_'), write(' = ') ); true ),
	  write('OPCS_'), opCall(X,I,O).

accept(X,I,O,'BY_IT',P,'transputer') :- /*C031*/
	indent(I), write('/* BY_IT '), write(O), write(' */'), nl,
	indent(I), write('int DeadLine = ProcTimePlus(ProcTime(),'), write(P), write(');'), nl,
	indent(I), write('OPCS_'), opCall(X,I,O).

accept(X,I,O,'STOP',_,'transputer') :- /*C042*/
	indent(I), write('/* STOP '), write(O), write(' */'), nl,
	indent(I), write('running = ChanInInt('), name2(X,O), write('_end);'), nl.

accept(X,I,O,'ELSE',P,'transputer') :- isSTATE(X,O) -> true; ( /*C009*/
	indent(I), write('/* direct call to '), write(O), write(' */'), nl,
	indent(I), write('OPCS_'), opCall(X,I,O) ).

includeFiles(X,I,'transputer') :-
	write('#include <stdio.h>'), nl,
	write('#include <stdlib.h>'), nl,
	write('#include <channel.h>'), nl,
	write('#include <process.h>'), nl.

initHeader(X,I,'transputer').

initTrailer(X,I,'transputer').

startHeader(X,I,'transputer').

startTrailer(X,I,'transputer').