/*--------------------------------------------
--		librairie de communication distComm.h
--		- ARINC 653
--
--				A. Thura	11/03/98
----------------------------------------------*/
#ifndef INCLUDE_taskCom
#define INCLUDE_taskCom

/* Ce fichier ne contient que des Macros Gnriques, qui devront
tre rafines dans le cas d'une implmentation relle; en particulier le traitement des erreurs.
Document de rfrence : ARINC specification 653 du 01/97 */

#include <FICHIERS_SYSTEMES_A_INCLURE.h>
#define BUFFER_SIZE 1
#define INIFINITY 86400001

typedef short BUFFER_ID_TYPE;
/*--------------------------------*/
/* dfinition des macros de channel */
/*--------------------------------*/
#define BUFFER_SIZE 1
static BUFFER_ID_TYPE ChannelCount = 0;
static RETURN_CODE_TYPE returnCode;
static LOCK_LEVEL_TYPE lockLevel;

#define TCHANNEL(CHANNEL_NAME, CHANNEL_TYPE, CHANNEL_SIZE, DIMS) \
		typedef CHANNEL_TYPE CHANNEL_NAME##_buffer_type##DIMS; \
		typedef struct { \
			BUFFER_ID_TYPE buffer_id = ChannelCount++; \
			int msg_size = sizeof(CHANNEL_NAME##_buffer_type); \
			short EOR; \
			short EOS; \
		} CHANNEL_NAME##_type; \
		static CHANNEL_NAME##_type  CHANNEL_NAME;

#define CREATE_TCHANNEL(CHANNEL_NAME, CHANNEL_TYPE, CHANNEL_SIZE) \
	CREATE_BUFFER(#CHANNEL_NAME, BUFFER_SIZE, CHANNEL_NAME.msg_size, FIFO, CHANNEL_NAME.buffer_id, returnCode);\
	CHANNEL_NAME.EOR = 0;\
	CHANNEL_NAME.EOS = 0;

#define START_TCHANNEL(CHANNEL_NAME)

#define TSEND(CHANNEL_NAME,MSG, SIZE, FCTTERM) \
	if (AT_END_OF_RECEIVER(CHANNEL_NAME)) FCTTERM();\
	else SEND_BUFFER(CHANNEL_NAME.buffer_id, MSG, CHANNEL_NAME.msg_size, INFINITY, returnCode);

#define TRECEIVE(CHANNEL_NAME, MSG, SIZE, FCTTERM) \
	if (AT_END_OF_SENDER(CHANNEL_NAME)) FCTTERM();\
	else receive(CHANNEL_NAME.buffer_id, INFINITY, MSG, CHANNEL_NAME.msg_size, returnCode);

/* destroy */
#define CLOSE_TCHANNEL(CHANNEL_NAME) CHANNEL_NAME.EOR = 1;
#define SEND_EOT(CHANNEL_NAME) CHANNEL_NAME.EOS = 1;

/* testing */
#define AT_END_OF_SENDER(CHANNEL_NAME) CHANNEL_NAME.EOS
#define AT_END_OF_RECEIVER(CHANNEL_NAME) CHANNEL_NAME.EOR

/*------------------------------*/
/*dfinition des macros de tache*/
/*------------------------------*/

#define MAXPRIO 10
#define STACKSIZE 10
#define defaultDEADLINE SOFT

#define PROGRAM(ProgramName, Task_Count)  static int TaskCount = Task_Count;

/* declaration du prototype de la tache */
#define TASK(taskName) void *exec_##taskName(void *);\
	PROCESS_ATTRIBUTE_TYPE taskName##_attr;\
	int taskName##_id;

#define INIT(progName) init_##progName()
#define INIT_HEADER()

#define INIT_TRAILER()

/* get_addr a definir */
#define CREATE_TASK(taskName, priority)\
	taskName##_attr.NAME = #taskName;\
	taskName##_attr.ENTRY_POINT = get_addr(taskName##_id);\
	taskName##_attr.STACK_SIZE = STACKSIZE;\
	taskName##_attr.BASE_PRIORITY = priority;\
	taskName##_attr.PERIOD = 0;\
	taskName##_attr.TIME_CAPACITY = 0;\
	taskName##_attr.DEADLINE = defaultDEADLINE;\
	CREATE_PROCESS(taskName##_attr, taskName##_id, returnCode);

#define START_TASK(taskName) start(taskName##_id)
#define START_HEADER() LOCK_PREEMPTION(lockLevel, returnCode);
#define START_TRAILER() UNLOCK_PREEMPTION(lockLevel, returnCode); SET_PARTITION_MODE(NORMAL, returnCode);

/* indique le nom de la tache qui est lancee apres creation */
#define TASK_BODY(taskName) void *exec_##taskName()

/* on peut tuer explicitement le thread */
#define KILL_TASK(taskName,termprog) TaskCount--; \
	if (TaskCount==0) termprog();\
	STOP_SELF();

#define START() start()

/* IO dependent */
#define FOPENR(ficdesc,fic,mode,fctexit) \
	ficdesc = fopen(fic,mode); \
	if (ficdesc == NULL) {fctexit(); printf("Error : file " #fic " not found \n"); exit(1);}

#define FOPENW(ficdesc,fic,mode,fctexit) ficdesc = fopen(fic,mode)

#endif