#!/bin/sh
# code_extractors/c/go.sh
# launch C code extractor
# Stood v4.3 - TNI - December 2002

# This file is executed by internalTools/external.sh

# arguments:
# $1 : this directory
# $2 : input file (prolog predicates)
# $3 : output file (extraction messages)

INCLUDE_DIR="$1"
export INCLUDE_DIR

PREDICATS="$2"
export PREDICATS

DATEPROJ=`date +%x`
export DATEPROJ

SIMPATH="$STOODPRO/modlib":"$STOODPRO/lib":"$STOODPRO/cmplib"
export SIMPATH

# Launch code generator:

echo "=== begin code extraction : `date`"
"$STOODBIN/sbprolog" -m $SBPROLOG_M_SIZE -p $SBPROLOG_P_SIZE "$1/Input.sbp"
echo "=== end code extraction : `date`"

# Launch makefile:

echo "=== begin compilation : `date`"
cd `dirname "$3"` 
PATH=$C_PATH:$PATH
export PATH
make
echo "=== end compilation : `date`"

