#include "sock.h"
#include "server.h"
#include "client.h"
#include <stdio.h>

/*--------------------------------*/
/* dfinition des macros de debuggage  */
/*--------------------------------*/

/* #ifndef SPY */

#define DEBUG 1
#ifdef DEBUG
#define SPY(TEXT) printf(#TEXT "\n");
#else
#define SPY(TEXT)
#endif

/* #endif */

#define PORT_OFFSET 4400

/*--------------------------------*/
/*dfinition des macros de channel */
/*--------------------------------*/
#define PCHANNEL(CHANNEL_NAME, CHANNEL_TYPE, CHANNEL_SIZE, DIMS) \
	typedef CHANNEL_TYPE CHANNEL_NAME##_buffer_type##DIMS; \
	static PCHANNEL_t CHANNEL_NAME;

#define CREATE_PCHANNEL(CHANNEL_NAME, MACH, PORT_NUM, IS_SERVER) \
	CHANNEL_NAME.serverPort=PORT_OFFSET+PORT_NUM; \
	CHANNEL_NAME.socketID=0; \
	CHANNEL_NAME.length=sizeof(CHANNEL_NAME##_buffer_type); \
	if (IS_SERVER) { \
		SPY(CREATE_SERVER CHANNEL_NAME PORT_NUM)\
		CHANNEL_NAME.first=1; \
		CREATE_SERVER(CHANNEL_NAME) \
	}
		
#define CREATE_SERVER(CHANNEL_NAME) \
	if ((openServerSocket(&CHANNEL_NAME)) != OK ) exit(ERROR);

#define CREATE_CLIENT(CHANNEL_NAME) \
	if ((openClientSocket(&CHANNEL_NAME)) != OK ) exit(ERROR);

#define START_PCHANNEL(CHANNEL_NAME, IS_SERVER) \
	if (IS_SERVER) { \
		SPY(START_SERVER CHANNEL_NAME)\
		CHANNEL_NAME.first=1; \
		startServerSocket(&CHANNEL_NAME); \
	} else { \
		SPY(CREATE_CLIENT CHANNEL_NAME)\
		CHANNEL_NAME.first=1; \
		CREATE_CLIENT(CHANNEL_NAME) \
	}


#define PSEND(CHANNEL_NAME, MSG, SIZE, FCTTERM) \
	SPY(send SIZE into socket CHANNEL_NAME)\
	if (AT_END_OF_RECEIVER(CHANNEL_NAME)) FCTTERM();\
	else {\
		memcpy(&(CHANNEL_NAME.buffer), &(MSG), CHANNEL_NAME.length); \
		if ((sendMsg(&CHANNEL_NAME)) != OK) FCTTERM();\
	}\
	SPY(send SIZE into socket CHANNEL_NAME term)

#define PRECEIVE(CHANNEL_NAME, MSG, SIZE, FCTTERM) \
	SPY(wait SIZE from CHANNEL_NAME) \
	if (receiveMsg(&CHANNEL_NAME) == ERROR) FCTTERM();\
	memcpy(&(MSG), &(CHANNEL_NAME.buffer), CHANNEL_NAME.length); \
	SPY(rec SIZE from socket CHANNEL_NAME term)

/* destroy */

#define CLOSE_PCHANNEL(CHANNEL_NAME, IS_SERVER) \
	if (IS_SERVER) { \
		CLOSE_SOCKET(CHANNEL_NAME) \
	} else SEND_EOP(CHANNEL_NAME)

#define CLOSE_SOCKET(CHANNEL_NAME) \
	CHANNEL_NAME.EOR = 1; \
	closeSocket(&CHANNEL_NAME);

static char c1=(char)1;
/* #define SEND_EOP(CHANNEL_NAME) {write((&CHANNEL_NAME)->socketID, (char *)1, 1);} */
#define SEND_EOP(CHANNEL_NAME) {write((&CHANNEL_NAME)->socketID, &c1, 1);}


/* testing */
#ifndef AT_END_OF_RECEIVER
#define AT_END_OF_RECEIVER(CHANNEL_NAME) CHANNEL_NAME.EOR
#endif