/*--------------------------------------------
--		librairie de communication distComm.h
--		- RTC
--
--				X. Mehaut	02/02/98
--				A. Thura	26/02/98
----------------------------------------------*/
#ifndef INCLUDE_taskCom
#define INCLUDE_taskCom

/* Ce fichier ne contient que des Macros Gnriques, qui devront
tre rafines dans le cas d'une implmentation relle.
Le cas des "messages" de + de 4 bytes necessitera un traitement complementaire.
Document de rfrence : REAL TIME CRAFT 68, XEC 68 V2 du 01/89 */

/* #include <FICHIERS_SYSTEMES_A_INCLURE.h>	*/
#define BUFFER_SIZE 1
#define TIME_OUT 10

extern void initMailBox(short,short);
extern short send(short,int);
extern void receive(short,int,short);
extern void initKernel();
extern void initTask(short,short,void *,char *, int, tTaskTCB*, short *, short *, short);
extern void startTask(short);

/*--------------------------------*/
/* dfinition des macros de channel */
/*--------------------------------*/
#define BUFFER_SIZE 1
static short ChannelCount = 0;

#define TCHANNEL(CHANNEL_NAME, CHANNEL_TYPE, CHANNEL_SIZE, DIMS) \
		typedef CHANNEL_TYPE CHANNEL_NAME##_buffer_type##DIMS; \
		typedef struct { \
			short num = ChannelCount++;
			CHANNEL_NAME##_buffer_type buffer[BUFFER_SIZE]DIMS; \
			short EOR; \
			short EOS; \
		} CHANNEL_NAME##_type; \

		static CHANNEL_NAME##_type  CHANNEL_NAME;

#define CREATE_TCHANNEL(CHANNEL_NAME, CHANNEL_TYPE, CHANNEL_SIZE) \
	initMailBox(CHANNEL_NAME.num,BUFFER_SIZE);\
	CHANNEL_NAME.EOR = 0;\
	CHANNEL_NAME.EOS = 0;

#define START_TCHANNEL(CHANNEL_NAME)

#define TSEND(CHANNEL_NAME,MSG, SIZE, FCTTERM) \
	while ((!AT_END_OF_RECEIVER(CHANNEL_NAME)) && (cFull == send(CHANNEL_NAME.num,&MSG))) waitEvents(0,TIME_OUT,NULL);\
	if (AT_END_OF_RECEIVER(CHANNEL_NAME)) FCTTERM();

#define TRECEIVE(CHANNEL_NAME, MSG, SIZE, FCTTERM) \
	if (AT_END_OF_SENDER(CHANNEL_NAME)) FCTTERM();\
	receive(CHANNEL_NAME.num,*MSG,0);

/* destroy */
#define CLOSE_TCHANNEL(CHANNEL_NAME) CHANNEL_NAME.EOR = 1;
#define SEND_EOT(CHANNEL_NAME) CHANNEL_NAME.EOS = 1;

/* testing */
#define AT_END_OF_SENDER(CHANNEL_NAME) CHANNEL_NAME.EOS
#define AT_END_OF_RECEIVER(CHANNEL_NAME) CHANNEL_NAME.EOR

/*------------------------------*/
/*dfinition des macros de tache*/
/*------------------------------*/

#define MAXPRIO 10

#define PROGRAM(ProgramName, Task_Count)  static int TaskCount = Task_Count; static int ActivedTaskCount = 0; static int CurrentTask = 0;

/* declaration du prototype de la tache */
#define TASK(taskName) void *exec_##taskName(void *);\
	int taskName##_id = CurrentTask++;

#define INIT(progName) init_##progName()
#define INIT_HEADER() init_kernel();

#define INIT_TRAILER()

#define CREATE_TASK(taskName, priority)\
	initTask(taskName##_id,priority,(*exec_##taskName()),-1,NULL,NULL,NULL,00);

#define START_TASK(taskName) startTask(taskName##_id)
#define START_HEADER() enterRegion();
#define START_TRAILER() leaveRegion();

/* indique le nom de la tache qui est lancee apres creation */
#define TASK_BODY(taskName) void *exec_##taskName()

/* on peut tuer explicitement le thread */
#define KILL_TASK(taskName,termprog) TaskCount--; \
	if (TaskCount==0) termprog();\
	terminate();

#define START() start()

#endif