/*--------------------------------------------
--		librairie de communication taskCom.h
--				pour OS transputers
--				X. Mehaut	18/05/98
--				P. Dissaux  03/12/99
--				P. Dissaux  15/12/00
--		copyright TNI
----------------------------------------------*/
#ifndef INCLUDE_taskCom
#define INCLUDE_taskCom

#include "channel.h"
#include "process.h"
#include <stdlib.h>

/*----------*/
/* channels */
/*----------*/

#define TCHANNEL(CHANNEL_NAME,CHANNEL_TYPE,CHANNEL_SIZE,DIMS) \
	Channel* CHANNEL_NAME; \
	typedef CHANNEL_TYPE CHANNEL_NAME##_type;

#define CREATE_TCHANNEL(CHANNEL_NAME, CHANNEL_TYPE, CHANNEL_SIZE) \
	CHANNEL_NAME = ChanAlloc();

#define START_TCHANNEL(CHANNEL_NAME)


#define CLOSE_TCHANNEL(CHANNEL_NAME)


#define TSEND(CHANNEL_NAME, MSG, SIZE, FCTTERM) \
	ChanOut(CHANNEL_NAME, MSG, sizeof(CHANNEL_NAME##_type)*SIZE);

#define TSEND_OR_TO(CHANNEL_NAME, MSG, SIZE, TIME_OUT) \
	!ChanOutTimeFail(CHANNEL_NAME, MSG, sizeof(CHANNEL_NAME##_type)*SIZE, \
	ProcTimePlus(ProcTime(),TIME_OUT))

#define TRECEIVE(CHANNEL_NAME, MSG, SIZE, FCTTERM) \
	ChanIn(CHANNEL_NAME, MSG, sizeof(CHANNEL_NAME##_type)*SIZE);

#define TRECEIVE_OR_TO(CHANNEL_NAME, MSG, SIZE, TIME_OUT) \
	!ChanInTimeFail(CHANNEL_NAME, MSG, sizeof(CHANNEL_NAME##_type)*SIZE, \
	ProcTimePlus(ProcTime(),TIME_OUT))

#define SEND_EOT(CHANNEL_NAME)

/*-------*/
/* tasks */
/*-------*/

#define MAXPRIO 0

#define PROGRAM(progName) \
	static Process **pList;

#define DEADLINE(delay) \
	ProcTimePlus(ProcTime(),delay);

#define TASK_TYPE Process

#define TASK(taskName) Process* taskName

#define INIT(progName) init_##progName()

#define INIT_HEADER()

#define INIT_TRAILER()

#define CREATE_TASK(taskName, size, address) \
	taskName=ProcAlloc(taskName##_proc, 0, 0); \
	if (taskName== NULL) { \
		printf("Could not allocate process \n"); \
		exit(EXIT_FAILURE); \
	}

#define START_TASK(taskName, priority) \
	ProcRun##priority(taskName);

#define START_HEADER()

#define START_TRAILER()

#define TASK_BODY(taskName) \
	void taskName##_proc(Process* taskName)

#define JOIN_TASK ProcJoinList

#define KILL_TASK(taskName,termprog) \
	ProcAllocClean(taskName);

#define START() start()

#define WAIT_TASK_LIST ProcAlt

#define WAIT_TIMER_TASK_LIST ProcTimerAlt

#endif
