Letter		[A-Za-z]
Digit		[0-9]
Identifier	{Letter}(_?({Letter}|{Digit}))*
%%

{Identifier}						identifier();
[ \t\n]+						;				/* separators */
\"([^\"\\]|\\.)*\"				anything();		/* string literals */
\'([^\'\\]|\\.)*\'				anything();		/* character literals */
"/*"([^\/]|[^\*]\/)*"*/"			;				/* comments */
"//"[^\n]*\n					;				/* comments */
^#{Letter}*					anything();		/* preprocessor directives */
.								anything(); 	/* anything else */

%%

#define IgnoreCase 0
char *ReservedWordList[] = {

	"void", "auto", "static", "extern", "register", "typedef", "struct", "union", "enum",
	"volatile", 
	"if", "else", "while", "do", "for", "switch", "break", "continue", "return", "goto",
	"case", "default", "sizeof",

	"asm", "class", "const", "delete", "friend", "inline",
	"new", "operator", "overload", "public", "private", "protected",
	"this", "virtual",
	"char", "double", "float", "int", "long", "short", "signed", "unsigned",	"catch", "throw", "try",

0};




/**********************************************************
	this code is independant of the langage :
**********************************************************/

int State = 0;

identifier()
{
	static int BoL = 1;

	if(isReserved(yytext)) {
		State = 0;
		return;
	}
	if (State == 2) {
		printf(" ");
	} else {
		if (!BoL) {printf("\n"); BoL = 1;}
	}
	printf("%s", yytext);
	BoL = 0;
	State = (State == 2) ? 0 : 1;
}

dot()
{
	State = (State == 1) ? 2 : 0;
}

anything()
{
	State = 0;
}

int isReserved(word)
char *word;
{
	char **p = ReservedWordList;
	while (*p) {
		if (stringCompare(word, *p)) return 1;
		p++;
	}
	return 0;
}

int stringCompare(s1, s2)
char *s1, *s2;
{
	do {
		register char c1 = *(s1++);
		register char c2 = *(s2++);
		if (c1 == 0) return (c2 == 0);
		if (c2 == 0) return (c1 == 0);
#if IgnoreCase == 1
		if ('A' <= c1 && c1 <= 'Z' ) c1 += ('a' - 'A');
		if ('A' <= c2 && c2 <= 'Z' ) c2 += ('a' - 'A');
#endif
		if (c1 != c2) return (0);
	} while (1);
}

int yywrap()
{
	return 1;
}
	
main()
{
	yylex();
}
