//-------------------------------------------
//  Stood v4
//  HoodBox.java for html doc generator
//
//  Copyright TNI 1997
//  Pierre DISSAUX (pierre.dissaux@tni.fr)
//  last release : 07/97
//-------------------------------------------

import java.awt.Color;
import java.awt.Graphics;
import java.io.*;

class HoodBox {
	String label;
	int x1, x2, y1, y2;
	int hLine, radius;
	int xProv, yProv, hProv, wProv;
	int xlabel, ylabel;
	int nbProv = 0;
	String elem[];
	String passif_actif;
	public HoodBox(String l,int xx1,int yy1,int xx2,int yy2,int r,int h,int n,String p[],String pa) {
		label = l;
		x1 = xx1;
		x2 = xx2;
		y1 = yy1;
		y2 = yy2;
		radius = r;
		hLine = h;
		xlabel = x1+(x2-x1)/10;
		ylabel = y1+3*h/4;
		nbProv = n;
		xProv = x1-10;
		yProv = y1+h+5;
		hProv = 5+n*12;
		wProv = 100;
		elem = p;
                passif_actif = pa;
	}
	public void draw(Graphics g,Color fg,Color bg,int limitx,int limity,int enf,int ind_limy) {
		g.setColor(bg);
		g.fillRoundRect(x1,y1,x2-x1,y2-y1,radius,radius);
		g.setColor(fg);
		g.drawRoundRect(x1,y1,x2-x1,y2-y1,radius,radius);
		g.drawLine(x1,y1+hLine,x2,y1+hLine);
                if (passif_actif.compareTo("A") == 0) {
                   passif_actif = passif_actif + "|";
                   g.drawString(passif_actif,xlabel-10,ylabel);
                }
		g.drawString(label,xlabel+(x2-x1)/10,ylabel);
		if (nbProv != 0) {
                        int offsetX=0, offsetY=0;
                  if (ind_limy != -1) {   
                    /* calcul offsetX */
                    /* ca de parent*/
                        if (enf == 1) {
                          offsetX = (xProv  + wProv - limitx);
                        } 
                        else {
                          offsetX = (xProv - limitx);
                        }
                    /* calcul offsetY */
                        offsetY = yProv + 12 * (ind_limy)  - limity + 7;
                  }
                  /* dessiner proprement dit */
                  g.setColor(bg);
                  if (enf == 1) { /* cas de parent */
    		    g.fillRect(xProv-offsetX,yProv-offsetY,wProv,hProv);
	            g.setColor(fg);
	       	    g.drawRect(xProv-offsetX,yProv-offsetY,wProv,hProv);
		    for (int i=0; i<nbProv; i++) {
                      String subStr;
                      int lg1, lg;
                      lg = elem[i].length();
                      if (lg > 14) {
                        subStr = elem[i].substring(0,14);
                        lg1 = 0;
                      }
                      else {
                        lg1 = 14 -lg;
                        subStr = elem[i];
                      }
		      g.drawString(subStr,xProv-offsetX+(lg1*wProv/14),yProv-offsetY+(i+1)*12);
		     }
                   }
                   else {
    		     g.fillRect(xProv-offsetX,yProv-offsetY,wProv,hProv);
		     g.setColor(fg);
		     g.drawRect(xProv-offsetX,yProv-offsetY,wProv,hProv);
		     for (int i=0; i<nbProv; i++) {
		       g.drawString(elem[i],xProv-offsetX+5,yProv-offsetY+(i+1)*12);
		     }
                   }
		} 
	}
}

