//-------------------------------------------
//  Stood v4
//  HoodDiagram.java for html doc generator
//
//  Copyright TNI 1997
//  Pierre DISSAUX (pierre.dissaux@tni.fr)
//  last release : 07/97
//-------------------------------------------

import java.util.StringTokenizer;
import java.awt.*;
import java.io.*;
import java.applet.*;

public class HoodDiagram extends Applet {
	Color fg=Color.red, bg=Color.lightGray;
	Color use=Color.red, inh=Color.lightGray, attribut = Color.pink, impby = Color.green;
	static Color colorMap[] = {
		Color.black, Color.white, Color.lightGray, Color.gray,
		Color.darkGray, Color.red, Color.pink, Color.orange,
		Color.yellow, Color.green, Color.magenta, Color.blue,
		Color.cyan };
	int parentR=10, childR=5;
	int parentH=15, childH=15;
	int xLabel=15, yLabel=15;
	int xOffset=20, yOffset=25;
	int scale=3;
        boolean Existe_prov = false;
	HoodBox parent, child[];
	HoodLine useLine[], impLine[];
	int nbChildren, nbimp, nbuse;
	public void init() {
	  readOptions();
	  createLine();
	  createParent();
	  createChildren();
	  /*createLine();*/
	}
	void readOptions() {
	  String param = getParameter("options");
	  StringTokenizer st = new StringTokenizer(param);
	  xOffset = Integer.valueOf(st.nextToken()).intValue();
          xOffset = 40;
	  yOffset = Integer.valueOf(st.nextToken()).intValue();
	  scale = Integer.valueOf(st.nextToken()).intValue();
	  parentR = Integer.valueOf(st.nextToken()).intValue();
	  childR = Integer.valueOf(st.nextToken()).intValue();
	  parentH = Integer.valueOf(st.nextToken()).intValue();
	  childH = Integer.valueOf(st.nextToken()).intValue();
	  fg = colorMap[Integer.valueOf(st.nextToken()).intValue()];
	  bg = colorMap[Integer.valueOf(st.nextToken()).intValue()];
	  impby = colorMap[Integer.valueOf(st.nextToken()).intValue()];
	  use = colorMap[Integer.valueOf(st.nextToken()).intValue()];
	  inh = colorMap[Integer.valueOf(st.nextToken()).intValue()];
	  attribut = colorMap[Integer.valueOf(st.nextToken()).intValue()];
	}
	void createParent() {
	  String param = getParameter("parent");
	  StringTokenizer st = new StringTokenizer(param);
	  String l = st.nextToken();
	  int x1 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	  int y1 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	  int x2 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	  int y2 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	  String pa = st.nextToken();
	  int n = Integer.valueOf(getParameter("nbProvPar")).intValue();
          if (n != 0) Existe_prov = true;
	  String p[] = new String[n];
	  for (int i = 1 ; i < n+1 ; i++ ) {
	    p[i-1] = getParameter("prov"+String.valueOf(i));
	  }
	  parent = new HoodBox(l,x1,y1,x2,y2,parentR,parentH,n,p,pa);
	}
	void createChildren() {
	  nbChildren = Integer.valueOf(getParameter("nbChildren")).intValue();
	  child = new HoodBox[nbChildren];
	  for (int i = 1; i < nbChildren+1; i++) {
	    String param = getParameter("child"+String.valueOf(i));
	    StringTokenizer st = new StringTokenizer(param);
	    String l = st.nextToken();
	    int x1 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	    int y1 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	    int x2 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	    int y2 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	    String pa = st.nextToken();
	    int n = Integer.valueOf(getParameter("nbProv"+String.valueOf(i))).intValue();
            if (n != 0) Existe_prov = true;
	    String p[] = new String[n];
	    for (int j = 1; j < n+1; j++) {
	      p[j-1] = getParameter("prov"+String.valueOf(i)+"#"+String.valueOf(j));
	    }
	    child[i-1] = new HoodBox(l,x1,y1,x2,y2,childR,childH,n,p,pa);
	  }
	}
	void createLine() {
	  nbimp = Integer.valueOf(getParameter("nbImp")).intValue();
	  nbuse = Integer.valueOf(getParameter("nbUse")).intValue();
          impLine = new HoodLine[nbimp];
          useLine = new HoodLine[nbuse];
	  for (int i = 0; i < nbimp; i++) {
	    String param = getParameter("imp"+String.valueOf(i+1));
	    StringTokenizer st = new StringTokenizer(param);
	    String l1 = st.nextToken();
	    String l2 = st.nextToken();
	    int nblien = (Integer.valueOf(st.nextToken()).intValue());
            int x1, x2, x3, x4, y1, y2, y3, y4;
	    x1 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	    y1 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	    x2 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	    y2 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
            if (nblien == 4) {
	      x3 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	      y3 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	      x4 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	      y4 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
              /* Garinture pour afficher les liens entre les boites */
              String l3 = "NONE";
              int type_lg = 1;
	      impLine[i] = new HoodLine(l1,l2,x1,y1,x2,y2,x3,y3,x4,y4,l3,scale,type_lg);
              if (Existe_prov) System.out.println("impLinei 3"+impLine[i]);
             }
             else if (nblien == 3) {
	       x3 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	       y3 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
               if (x2 == x3) {
                 if (y2 < y3) {
                 y3 = y3 - 1;
                 x4 = x3;
                 y4 = y3 + 1;
                 }
                 else {
                 y3 = y3 + 1;
                 x4 = x3;
                 y4 = y3 - 1;
                 }
               }
               else{
                 if (x2 <x3) {
                 x3 = x3 - 1;
                 y4 = y3;
                 x4 = x3 + 1;
                 }
                 else {
                 x3 = x3 + 1;
                 y4 = y3;
                 x4 = x3 - 1;
                 }
               }
              /* Garinture pour afficher les liens entre les boites */
               String l3 = "NONE";
               int type_lg = 1;
	       impLine[i] = new HoodLine(l1,l2,x1,y1,x2,y2,x3,y3,x4,y4,l3,scale,type_lg);
               if (Existe_prov) System.out.println("impLinei 3"+impLine[i]);
             }
             else if (nblien == 2) {
               if (y1 == y2) {
                 if ( x1 < x2) {
                 y3 = y2;
                 y4 = y3;
                 x2 = x2 -2;
                 x3 = x2 + 1;
                 x4 = x3 + 1;
                 }
                 else {
                 y3 = y2;
                 y4 = y3;
                 x2 = x2 +2;
                 x3 = x2 - 1;
                 x4 = x3 - 1;
                 }
               }
               else{
                 if (y1 < y2) {
                 x3 = x2;
                 x4 = x3;
                 y2 = y2 -2;
                 y3 = y2 + 1;
                 y4 = y3 + 1;
                 }
                 else {
                 x3 = x2;
                 x4 = x3;
                 y2 = y2 +2;
                 y3 = y2 - 1;
                 y4 = y3 - 1;
                 }
               }
              /* Garinture pour afficher les liens entre les boites */
               String l3 = "NONE";
               int type_lg = 1;
	       impLine[i] = new HoodLine(l1,l2,x1,y1,x2,y2,x3,y3,x4,y4,l3,scale,type_lg);
               if (Existe_prov) System.out.println("impLinei 2"+impLine[i]);
             }
	}
	for (int i = 0; i < nbuse; i++) {
	  String param = getParameter("use"+String.valueOf(i+1));
          StringTokenizer st = new StringTokenizer(param);
	  String l1 = st.nextToken();
	  String l2 = st.nextToken();
	  int nblien = (Integer.valueOf(st.nextToken()).intValue());
          int x1, x2, x3, x4, y1, y2, y3, y4;
	  x1 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	  y1 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	  x2 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	  y2 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
          if (nblien == 4) {
	    x3 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	    y3 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	    x4 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	    y4 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
            int type_lg = Integer.valueOf(st.nextToken()).intValue();
            String l3 = st.nextToken();
	    useLine[i] = new HoodLine(l1,l2,x1,y1,x2,y2,x3,y3,x4,y4,l3,scale,type_lg);
          }
          else if (nblien == 3) {
	    x3 = xOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
	    y3 = yOffset+(Integer.valueOf(st.nextToken()).intValue())/scale;
            if (x2 == x3) {
             if (y2 < y3) {
             y3 = y3 - 1;
             x4 = x3;
             y4 = y3 + 1;
             }
             else {
             y3 = y3 + 1;
             x4 = x3;
             y4 = y3 - 1;
             }
           } 
           else{
             if (x2 <x3) {
             x3 = x3 - 1;
             y4 = y3;
             x4 = x3 + 1;
             }
             else {
             x3 = x3 + 1;
             y4 = y3;
             x4 = x3 - 1;
             }
           }
          int type_lg = Integer.valueOf(st.nextToken()).intValue();
          String l3 = st.nextToken();
	    useLine[i] = new HoodLine(l1,l2,x1,y1,x2,y2,x3,y3,x4,y4,l3,scale,type_lg);
          }
          else if (nblien == 2) {
           if (y1 == y2) {
             if ( x1 < x2) {
             y3 = y2;
             y4 = y3;
             x2 = x2 -2;
             x3 = x2 + 1;
             x4 = x3 + 1;
             }
             else {
             y3 = y2;
             y4 = y3;
             x2 = x2 +2;
             x3 = x2 - 1;
             x4 = x3 - 1;
             }
           }
           else{
             if (y1 < y2) {
             x3 = x2;
             x4 = x3;
             y2 = y2 -2;
             y3 = y2 + 1;
             y4 = y3 + 1;
             }
             else {
             x3 = x2;
             x4 = x3;
             y2 = y2 +2;
             y3 = y2 - 1;
             y4 = y3 - 1;
             }
           }
            int type_lg = Integer.valueOf(st.nextToken()).intValue();
            String l3 = st.nextToken();
	    useLine[i] = new HoodLine(l1,l2,x1,y1,x2,y2,x3,y3,x4,y4,l3,scale,type_lg);
          }

      }	
  }
  public void paint(Graphics g) {
    boolean exist_prov = false;
    exist_prov = (parent.nbProv != 0);
    for (int i = 0; i < nbChildren; i++) {
      exist_prov = exist_prov || (child[i].nbProv != 0);
    }
    int limx, limy, ind_limy;
    boolean find = false;
    int ij, k;
    if (exist_prov) { 
      for (int i = 1; i < nbimp+1; i++) {
	  impLine[i-1].drawl(g,fg,bg,impby);
      }
      /* calcul limite */
      ij = 0;
      k = 0;
      while (!find && ij < parent.nbProv) {
        k = 0;
        while (!find && k < nbimp) {
          int comp = impLine[k].label1.compareTo(parent.elem[ij]);
          find = (comp == 0) ;
          if (!find) k = k + 1;
        }
        if (!find) ij = ij + 1;
      }
      if (find) {
        limx = impLine[k].x1;
        limy = impLine[k].y1;
        ind_limy = ij;
      }
      else {
        limx = 0;
        limy = 0;
        ind_limy = -1;
      }
    }
    else {
      limx = 0;
      limy = 0;
      ind_limy = -1;
    }
    parent.draw(g,fg,bg,limx,limy,1,ind_limy);
    for (int i = 1; i < nbChildren+1; i++) {
      int lim1x = -1, lim1y = -1;
      boolean Trouve = false;
      int ijk = 0, kk;
      if (exist_prov) {
        ijk = 0;
        kk = 0;
        while (!Trouve && ijk < child[i-1].nbProv) {
          kk = 0;
          while (!Trouve && kk < nbimp) {
            int comp = impLine[kk].label2.compareTo(child[i-1].elem[ijk]);
            Trouve = (comp == 0) ;
            if (!Trouve) kk = kk + 1;
          }
          if (!Trouve) ijk = ijk + 1;
        }
        if (Trouve) {
          lim1x = impLine[kk].x4;
          lim1y = impLine[kk].y4;
          ind_limy = ijk;
        }
        else {
          lim1x = 0;
          lim1y = 0;
          ind_limy = -1;
        }

      }
      else {
        lim1x = 0;
        lim1y = 0;
        ind_limy = -1;
      }
      child[i-1].draw(g,fg,bg,lim1x,lim1y,2,ind_limy);
    }
    if (exist_prov) {
      for (int i = 1; i < nbimp+1; i++) {
        impLine[i-1].drawl(g,fg,bg,impby);
      }
      for (int i = 1; i < nbuse+1; i++) {
        if (useLine[i-1].linetype == 1)
	  useLine[i-1].drawl(g,fg,bg,use);
        else if (useLine[i-1].linetype == 2)
	  useLine[i-1].drawl(g,fg,bg,inh);
        else 
	  useLine[i-1].drawl(g,fg,bg,attribut);
      }
    }
  }
}
