/******************************/
/* Stood 3.0                  */
/* Copyright TNI 1992, 93, 94 */
/******************************************************************************/
/* last version :  22 nov 94                                                  */
/******************************************************************************/

go :-	$init_sys,
	$getenv('NOMTAG',BuffTag), $name(BuffTag,ListTag), $name(Tag, ListTag),
	$globalset(nomTag(Tag)),
	$getenv('PREDICATS',File), $consult(File), 
	openTPSFile, genTPS, closeTPSFile.

/******************************************************************************/

genTPS :- beginDoc, fail.
genTPS :- selectedObject(Obj), insertObj(Obj), fail.
genTPS :- endDoc.

beginDoc :- $getenv('HEADER',F), $see(F), readFile(F), nl.
beginDoc :- pragma_doc_conf('TITLE',T), insertDocTitle(T).

endDoc :- nl.

insertDocTitle(Tit) :-
        write('<!Comment "docName" "string" String="'),
        write(Tit), write('" >'), nl,
        write('<"titre">'), write(Tit), nl.

insertObj(Obj) :-
	docSection(TF,Nam,Par,Lev,Typ,Obj,Tit,Tex),
	insertSec(TF,Nam,Par,Lev,Typ,Tit,Tex).

insertSec('File','PrologDocHF',_,_,_,_,_) :- !.
insertSec('File',_,_,_,_,_,C) :- shortName(C,'MissingFile'), !.
insertSec(_,_,_,L,_,T,_) :- T\='NIL', insertTitle(L,T).
insertSec('Text',_,_,_,I,_,C) :- C\='NIL', insertString(I,C).
insertSec('File',_,_,_,'POSTSCRIPT',_,C) :- insertEPSFile(C).
insertSec('File',_,_,_,I,_,C) :- I\='POSTSCRIPT', insertFile(I,C).
insertSec('Text',_,_,L,I,_,_) :- writeEndTag(L).

insertTitle(L,T) :- writeTag(L), writeString(T).
insertTitle(_,_) :- nl, write('<"para">'), nl.

insertString(_,'') :- write('<HR>'), !.
insertString('TXT',T) :- write('<F11@@Z7@Lfr>'), writeString(T).
insertString('TXTC',T) :- write('<F11@@Z7@Lfr>'), writeString(T).
insertString('TXTEND',T) :- write('<F11@@Z7@Lfr>'), writeString(T).
insertString('CODE',T) :- write('<F8@@Z7@Lfr>'), writeString(T).
insertString(_,_) :- write('<F0><HR>'), nl.

insertFile('TXT',F) :- write('<F11@@Z7@Lfr>').
insertFile('TXTC',F) :- write('<F11@@Z7@Lfr>').
insertFile('TXTEND',F) :- write('<F11@@Z7@Lfr>').
insertFile('CODE',F) :- write('<F8@@Z7@Lfr>').
insertFile(_,F) :- $see(F) -> readDocFile(F); unknownFile(F).
insertFile(_,_) :- write('<F0><HR>'), nl.

writeTag(N) :- write('<'), nomTag(Tag), write(Tag), write(N), write('>').

writeEndTag(N) :- nl.

insertEPSFile(File) :-
	write('<Frame,'),nl,
	write('Name =			"Postscript",'),nl,
	write('Placement = 		At Anchor,'),nl,
	write('Width =			Contents,'),nl,
	write('Height =			Contents,'),nl,
	write('Page # =			1,'),nl,
	write('Diagram ='),nl,
	write('V11,'),nl, 
	write('(g9,2,0'),nl,
	getBoundingBox(File,X1,Y1,X2,Y2),
	W is X2 - X1,
	H is Y2 - Y1,
	W72 is W*0.01388889, 		/* divided by 72 */
	H72 is H*0.01388889,
	write('  (n6,2,0,0,0,'),write(W72),write(',0,0,'),write(H72),
	write(','),write(X1),write(','),write(Y1),write(','),write(X2),
	write(','),write(Y2),nl,
	write('    (p8,2,8552,5,4,0'),nl,
	write('      (g9,2,0'),nl,
	write('        (g9,2,0'),nl,
	write('          (v7,2,0,0,0,'),write(W72),write(',0,7,0,8,0)'),nl,
	write('          (v7,3,0,'),write(W72),write(',0,'),write(W72),write(','),
	write(H72),write(',7,0,8,0)'),nl,
	write('          (v7,4,0,'),write(W72),write(','),write(H72),write(',0,'),
	write(H72),write(',7,0,8,0)'),nl,
	write('          (v7,5,0,0,'),write(H72),write(',0,0,7,0,8,0))))'),nl,
	readPSFile(File),
	write(' (D0,2,0)))>'),nl.

write(T) :- $writename(T).
read(C,W,S) :- '_$builtin'(22).
nl :- $put(10).
tab :- $put(9).
sp :- $put(32).

openTPSFile :- $getenv('TPSFILE',OutputFile),
	( $tell(OutputFile) -> true; unknownFile(F) ).

closeTPSFile :- $told.

unknownFile(F) :- write('*** Cannot open file : '), write(F).

shortName(F1,F2) :-
	$name(F1,L1), $reverse(L1,R1), $name(N1,R1),
	$subdelim(1,'/',N2,0,N1,_),
	$name(N2,R2), $reverse(R2,L2), $name(F2,L2).

readPSFile(File) :- 
	$see(File), getFileSize(0,Size),
	$see(File), cutPSFile(Size).

cutPSFile(Size) :- write(' (D0,2,'),
	( (Size > 2048) ->
		( write('2048)'), nl,
		  readFile(0,2048),
		  NewSize is Size - 2048,
		  cutPSFile(NewSize) );
		( write(Size), write(')'), nl,
		  readFile(0,Size) ) ).

getFileSize(Index,Size) :- $get0(C),
	( C =\= -1 ->
		(J is Index+1, getFileSize(J,Size));
		(Size is Index, $seen) ).

readFile(Index,Tmax) :- $get0(C), NewIndex is Index+1,
	( C =\= -1 ->
		( $put(C), (NewIndex < Tmax  ->
		  readFile(NewIndex,Tmax); nl) );
		( $seen ) ).

readFile(File) :- $get0(C),
	( C =\= -1 ->
		( $put(C), readFile(File) );
		( $seen ) ).

readDocFile(File) :- $get0(C),
	( C =\= -1 ->
		( decode(C), readDocFile(File) );
		( $seen ) ).

/* getBoundingBox(File,X1,Y1,X2,Y2) :-
	( $see(File) ->
		( analyse(X1,Y1,X2,Y2), $seen );
		( unknownFile(File), fail ) ).

analyse(X1,Y1,X2,Y2) :- find(37) ->
	( read(32,A,_), ( A=' BoundingBox' ->
		( read(_,_,_), read(_,_,_), read(32,Y1,_), 
		  read(_,_,_), read(32,Y2,_) );
		( analyse(X1,Y1,X2,Y2) ) ) );
	( write('*** error : not an EPS file ! '), nl ).

find(C) :- $get0(N), N \= -1, ( N ?= C ->
	( $get0(M), M \= -1, ( M ?= C -> true; find(C) ) );
	( find(C) ) ). */

writeString(T) :- $name(T,L), $member2(C,L), decode(C).

decode(C) :- ( C < 0 -> A is C+256; A is C ), ( map(A) -> true; $put(A) ).

map(198) :- write('<#C6>').
map(215) :- write('<#D7>').
map(224) :- write('<#E0>').
map(226) :- write('<#E2>').
map(228) :- write('<#E4>').
map(229) :- write('<#E5>').
map(230) :- write('<#E6>').
map(231) :- write('<#E7>').
map(232) :- write('<#E8>').
map(233) :- write('<#E9>').
map(234) :- write('<#EA>').
map(235) :- write('<#EB>').
map(238) :- write('<#EE>').
map(239) :- write('<#EF>').
map(244) :- write('<#F4>').
map(246) :- write('<#F6>').
map(247) :- write('<#F7>').
map(249) :- write('<#F9>').
map(251) :- write('<#FB>').
map(252) :- write('<#FC>').
map(10) :- write('<HR>').
map(40) :- write('<#28>').
map(41) :- write('<#29>').
map(92) :- write('<#5C>').

$member2(X,L) :- nonvar(L), L = [Y|Z], (X = Y ; $member2(X,Z)).

getBoundingBox(File,X1,Y1,X2,Y2)
        :-
        ($see(File)
                ->
                ($name(St,"%%BoundingBox:"),
                $name(St,SearchList),
                searchBoundingBox(X1,Y1,X2,Y2,SearchList,SearchList),
                $seen)
                ;
                (unknownFile(File), fail)).

searchBoundingBox(X1,Y1,X2,Y2,[],_)
        :-
        getBound(X1),
        getBound(Y1),
        getBound(X2),
        getBound(Y2).

searchBoundingBox(X1,Y1,X2,Y2,[C|SearchString],AllString)
        :-
        $get0(Ch),
        (Ch = -1 -> (X1 is 0, X2 is 0, Y1 is 0, Y2 is 0, seen,fail) ; true),
        (C = Ch
                ->
                searchBoundingBox(X1,Y1,X2,Y2,SearchString,AllString)
                ;
                searchBoundingBox(X1,Y1,X2,Y2,AllString,AllString)).

getBound(X)
        :-
        $get(Ch),
        (Ch = -1 -> (X1 is 0, X2 is 0, Y1 is 0, Y2 is 0, fail) ; true),
        ((Ch <48 ; Ch > 57) -> getBound(X) ; readBound(X,[Ch])).

readBound(X,St)
        :- $get0(Ch),
        ((Ch >= 48, Ch < 58)
                ->
                readBound(X,[Ch|St])
                ;
                computeBound(X,St)).

computeBound(0,[]).

computeBound(X,[Ch|St])
        :-
        N is Ch - 48,
        computeBound(XX,St),
        X is (10 * XX) + N.

