#!/bin/sh
# internalTools/copyin.sh
# checkin to system configuration manager
# Stood 5.0 - TNI Europe - July 2004

# This file is executed by the menus:
# Design/checkin and Component/checkin.
# echo checkin
  
# arguments: 
# echo $1 : current design
# echo $2 : base directory
# echo $3 : version id
# echo $4 : current component
# echo $5 : lock flag
# echo $6 : filename with the list of components 
# when the property CheckInWithArgFile is set to Yes

# if argument is missing, set the default copy version
if test -z $3
then V=Default
else V=$3
fi

cd $2
# create copy area if missing
if test ! -d $V
then mkdir $V
fi

if test $1 = $4
then
  # checkin design
  # remove previous contents in the copy area
  if test -d $V/$1
  then rm -r $V/$1/*
  fi
  if test -f $V/$1.tar.gz
  then 
    # design copy has been compressed
    rm $V/$1.tar.gz
    tar cf $V/$1.tar $1
    gzip $V/$1.tar
  else 
    # design copy hasn't been compressed
    # save the current conf manager lock status
    if test -f $V/$1/StoodCM.lok
    then locked="yes"
    else locked="no"
    fi
    # copy from the working area to the conf manager area
    cp -r $1 $V
    # remove the working area lock from the copy area
    if test -f $V/$1/Stood.lok
    then rm $V/$1/Stood.lok
    fi
    # restore the current conf manager lock status
    if test $locked = "yes"
    then echo "locked" > $V/$1/StoodCM.lok
    fi
  fi
else
  # checkin component
  # remove previous contents in the copy area
  if test -d $V/$1/$4
  then rm -r $V/$1/$4
  fi
  if test -f $V/$1_$4.tar.gz
  then 
    # component copy has been compressed
    rm $V/$1_$4.tar.gz
    tar cf $V/$1_$4.tar $1/$4
    gzip $V/$1_$4.tar
  else 
    # component copy hasn't been compressed
    # save the current conf manager lock status
    if test -f $V/$1/$4/StoodCM.lok
    then locked="yes"
    else locked="no"
    fi
    # create the design directory in the copy area if missing
    if test ! -d $V/$1
    then mkdir $V/$1
    fi
    # copy from the working area to the conf manager area
    if test -d $1/$4
    then cp -r $1/$4 $V/$1
    fi
    # remove the working area lock from the copy area
    if test -f $V/$1/$4/Stood.lok
    then rm $V/$1/$4/Stood.lok
    fi
    # restore the current conf manager lock status
    if test $locked = "yes"
    then echo "locked" > $V/$1/$4/StoodCM.lok
    fi
  fi
fi

