#!/bin/sh
# internalTools/copyout.sh
# checkout from system configuration manager
# Stood 5.0 - TNI Europe - July 2004

# This file is executed by the menus:
# Design/checkout and Component/checkout.
# echo checkout
 
# arguments:
# echo $1 : current design
# echo $2 : base directory
# echo $3 : version id
# echo $4 : selected component
# echo $5 : lock flag
# echo $6 : filename with the list of components 
# when the property CheckOutWithArgFile is set to Yes

# if argument is missing, set the default copy version
if test -z $3
then V=Default
else V=$3
fi

cd $2
if test -d $V
then
  if test $1 = $4
  then
    # checkout design
    # remove previous contents in the working area
    if test -d $1
    then rm -r $1/*
    fi
    if test -f $V/$1.tar.gz
    then
      # design copy has been compressed
      gunzip $V/$1.tar.gz
      tar xf $V/$1.tar
      gzip $V/$1.tar      
    else 
      # design copy hasn't been compressed
      if test -d $V/$1
      then cp -r $V/$1/* $1
      else echo 'cannot find '$2/$V/$1' directory'
      fi
    fi
  else
    # checkout component
    # remove previous contents in the working area
    if test -d $1/$4
    then rm -r $1/$4
    fi
    if test -f $V/$1_$4.tar.gz
    then
      # component copy has been compressed
      gunzip $V/$1_$4.tar.gz
      tar xf $V/$1_$4.tar
      gzip $V/$1_$4.tar
    else 
      # component copy hasn't been compressed
      if test -d $V/$1/$4
      then cp -r $V/$1/$4 $1
      else echo 'cannot find '$2/$V/$1/$4' directory'
      fi
    fi
  fi
  # remove the conf manager lock from the working area
  if test -f $1/StoodCM.lok
  then rm $1/StoodCM.lok
  fi
else echo 'cannot find '$2/$V' directory'
fi