#!/bin/sh
# internalTools/reqtify.sh
# used to get the list of Requirements from Reqtify
# Stood v4.3 - TNI - December 2002

# arguments:
# $1 : name of the .rqtf file to load
# $2 : name of the temporary file
# $3 : name of the relevant node in the traceability graph

# converts /cygdrive/x/ to x:/ for Cygwin under Windows:
rqtfFile=`echo $1 | sed -e 's/\/cygdrive\/\(.\)\//\1:\//'` 
tmpFile=`echo $2 | sed -e 's/\/cygdrive\/\(.\)\//\1:\//'`

if [ $# -lt 3 ]
then
  "$REQTIFY_PATH/reqtify" -batch -exec "openProject(\"$rqtfFile\").docList(\"$tmpFile\")"
else
  "$REQTIFY_PATH/reqtify" -batch -exec "openProject(\"$rqtfFile\").requirementList(\"$tmpFile\",\"$3\")"
fi

