#!/bin/sh
# reverse/aadl/go.sh
# AADL reverse engineering utility
# Stood v4.3 - TNI - February 2003

# arguments:
# $1 : This directory
# $2 : AADL source directory
# $3 : AADL specifications name
# $4 : SIF filename

SPEC=$AADLSUFFIX

cd "$2"

if test -f "$3.pro"
  then rm "$3.pro"
fi

if test -f "$3.log"
  then rm "$3.log"
fi

for file in `ls *$SPEC`
do 
  F=`echo $file | sed "s/$SPEC//"`
  $STOODBIN/aadlrev $file >> "$3.pro"
  echo parsing $F >> "$3.log"
done 

PREDICATS="$3.pro"
export PREDICATS

EXTERNAL_FACTS=external.pro
export EXTERNAL_FACTS

SIMPATH="$STOODPRO/modlib":"$STOODPRO/lib":"$STOODPRO/cmplib"
export SIMPATH

SIFFILE="$4"
export SIFFILE

ROOT_UNIT="$3"
export ROOT_UNIT

"$STOODBIN/sbprolog" -m $SBPROLOG_M_SIZE -p $SBPROLOG_P_SIZE "$1/Input.sbp" >> "$3.log"

echo > tmp.log
cp "$4" "$3.sif"

rm tmp*

