/*``general``Mon May 26 18:36:14 MET DST 2003``*/
/* version */
/*-----------------------------------------------
   Ada2HOOD v1.14 for Stood 5
   Ada code reverse engineering
   SIF 4 generator

   Copyright TNI Europe & Ellidiss Technologies 2004-2005
   Pierre DISSAUX (pierre.dissaux@tni-world.com)
   28.February.2005
------------------------------------------------
last changes:
REV001 (05.03.99) subprogram parameter mode : none -> in
REV002 (05.03.99) subprogram parameter type : t'att -> t_att
REV003 (05.03.99) managing HOOD reserved words : id -> id_
REV004 (06.04.99) adding constants
REV005 (06.04.99) adding exceptions
REV006 (06.04.99) adding data
REV007 (06.04.99) adding renames
REV008 (06.04.99) managing private types and constants
REV009 (07.04.99) identifying parent modules from op renames
REV010 (08.04.99) managing dotted notation in with clauses
REV011 (08.04.99) adding type declarations
REV012 (09.04.99) adding subprogram bodies (in temp file if > 800 bytes)
REV013 (09.04.99) reading external facts
REV014 (07.05.99) managing dotted notation in object names and op param types
REV015 (26.02.01) adding a few missing NONE keywords
REV016 (02.03.01) name of SIF file may be first package name
REV017 (29.03.01) children don't require a withSpec
REV018 (29.03.01) create default Op Set if too many operations
REV019 (27.04.01) fixing missing NONE in DATAFLOWS & REQ_INT
REV020 (27.04.01) managing strange tmp file names
REV021 (18.09.01) additional parameter to packageSpec
REV022 (19.09.01) class inheritance, type attributes, discriminants, representation
REV023 (21.09.01) comments 
REV024 (21.09.01) tasking
REV025 (24.09.01) subprogram as root module
REV026 (10.10.01) various temporary patches
REV027 (05.12.01) managing dotted notation in types declarations
REV028 (05.12.01) main subprogram as op_control
REV029 (19.03.02) new policy for HOOD reserved keywords
REV030 (15.11.02) adding type enumeration declaration
REV031 (15.11.02) fixing case sensitive pb for package and package body names
REV032 (15.11.02) creating an unit root to encompass all the packages
REV033 (19.11.02) escaping --| and |-- for SIF compliancy
REV034 (19.11.02) using HOOD hierarchy for Ada child units
------ CD-Rom #7 (December 2002) --------------------
REV035 (07.02.03) fixing bug when empty root module 
REV036 (07.04.03) fixing bug when exception in root module
REV037 (26.05.03) fixing bug ne END for root
REV038 (26.05.03) no _body when only one package
REV039 (18.02.04) adding INTEGRITY as an HRT keyword
REV040 (20.07.04) replace dashes in root names
REV041 (01.09.04) managing abstract classes (cf.RASTO_03_084)
REV042 (01.09.04) avoid overloading due to case mismatch in parameters
REV043 (08.09.04) managing adarev bug for abstract new types
REV044 (29.10.04) managing NONE OPCS
REV045 (29.11.04) fixing SIF syntax error when several abstract tagged in same package
REV046 (23.12.04) fixing a bug when filename or string was less than 4 chars long
REV047 (23.12.04) task and protected objects
REV048 (25.01.05) better management of Ada child units
REV049 (28.01.05) fixing bugs in subprogram units
REV050 (14.02.05) fixing bugs in subprogram management (also a change in adarev)
REV051 (17.02.05) adding package initialization blocks (also a change in adarev)
REV052 (17.02.05) managing encapsulated packages as children
REV053 (17.02.05) managing large declarations for constants
REV054 (17.02.05) managing instance of subprograms
REV055 (17.02.05) adding pragma no_end_op
REV056 (22.02.05) fixing remaining bugs with 050, 051, 054
REV057 (23.02.05) fixing case sensitivity pb with 048
REV058 (28.02.05) distinguishing prov and int instanciated ops (also change in adarev)
REV059 (28.02.05) adding a discriminant parameter in genericAssociation (also change in adarev)
REV060 (28.02.05) fixing bad location for _body package
------------------------------------------------*/
 
/*``general``Mon May 26 18:31:22 MET DST 2003``*/
/* go */

go :- $init_sys,
	$getenv('PREDICATS',In),
	( $consult(In) -> true; ( write('Cannot open input file. (error 1)'), nl ) ),
	$getenv('SIFFILE',Sif), ( Sif \= '' -> /*REV016*/
		( Out = Sif ); 
		( packageSpec(Root,_) -> /*REV021*/
			( splitName(Root,F,_),  addSuffix(F,'.sif',Out) ); 
			( write('Cannot find root module. (error 3)'), Out='user', nl ) ) ), 
	( $tell(Out) -> true; ( write('Cannot open output file. (error 2)'), nl ) ), 
	$getenv('EXTERNAL_FACTS',Ext), /*REV013*/
	( $exists(Ext) -> $consult(Ext); true ), 
	$getenv('ROOT_UNIT',R), $name(R,L), $name(M,L), 
	genSif(M).

genSif(M) :- sifHeader, notUnique, createRoot(M), fail. /*REV032, REV038*/
genSif(M) :- isOpUnit(P,S), createOpControl(P,S,M), fail. /* REV028, REV049 */
genSif(M) :- isModule(X,Y), createModule(X,Y,M), fail. /*REV021, REV031*/
genSif(M) :- isModule(X,Y), hasBody(X), not(isRootBody(X,M)), createModuleBody(X,Y), fail. /*REV048, REV060*/
genSif(M) :- $told.
 
/*``general``Fri May 23 18:39:59 MET DST 2003``*/
/* sifHeader */

sifHeader :- 
	write('SIF_VERSION --|4.0|--;'), nl,
	write('TOOL_NAME --|Ada2HOOD|--;'), nl,
	write('TOOL_VERSION --|1.14|--;'), nl,
	write('TARGET_LANGUAGE --|Ada|--;'), nl.
 
/*``general``Mon May 26 18:28:42 MET DST 2003``*/
/* hierarchy */
/*REV009, REV013, REV017, REV021*/

isModule(X,Y) :- packageSpec(X,P), ( P = '_root_' ; packageSpec(P,_)), 
	( ( packageBody(B), memezTra(X,B) ) -> Y=B; Y='' ). /*REV031*/

isOpUnit(X,S) :- operationisBody('_root_',X,S,_). /*REV025, REV028, REV032, REV049*/

hasBody(X) :- isChildUnit(X,_); packageSpec(_,X). /*REV060*/

children(X,Y) :- packageSpec(Y,X). /*REV052*/ 
children(X,Y) :- isModule(Z,_), splitName(Z,Y,R), X \= Y, isParent(X,Y,R). /*REV034*/
children(X,Y) :- hasBody(X), splitName(X,Z,_), concat(Z,'_body',Y), !. /*REV048,REV060*/

isChildUnit(X,Y) :- isModule(Z,_), splitName(Z,Y,P), P \= Y, memezTra(X,P). /*REV048,REV057*/
hasChildUnit(X) :- isChildUnit(X,_), !. /*REV048*/

isParent(X,Y,R) :- ( 
	child(X,Y); 
	 memezTra(X,R); /*REV034, REV048,REV057*/
	( withSpec(X,Y), operationRenameSpec(X,_,_,C), 
	  $subdelim(1,'.',Z,0,C,_), memezTra(Y,Z) )
 ), !.
 
uniqueName(X,Y,N) :- 
	packageSpec(Y,X) -> N = Y; /*REV052*/
	( X \= '', isModule(Z,_), splitName(Z,Y,R), X \= R ) -> 
	( $name(X,L1), convert(L1,[],L2), $name(P,L2), concat(P,'_',Y,N) ); N = Y.
	
notUnique :- isModule(X,_), isModule(Y,_), X \= Y, !. /*REV038*/

rootBodySuffix(X,M) :- isRootBody(X,M) -> write('_body'); true. /*REV038, REV048*/
isRootBody(X,M) :- memezTra(X,M), notUnique. /*REV048*/

typeisClass(X,U) :- typeisTagged(X,U), !. /*REV041*/
typeisClass(X,U) :- typeisNew(X,U,S), splitName(S,V,M), 
	( U = V -> true; /*REV043*/
	( M = '' -> typeisClass(X,V); ( splitName(M,Y,_), typeisClass(Y,V) ) ) ).
	
moduleisClass(X) :- typeisClass(X,U), not(anotherClass(X,U,_)). /*REV041*/
moduleisClassLib(X) :- typeisClass(X,U), anotherClass(X,U,_), !. /*REV041*/
anotherClass(X,U,V) :- typeisClass(X,V), U \= V. /*REV041*/

isActive(X) :- ( taskSpec(X,_,_); taskBody(X,_,_); taskTypeSpec(X,_,_); taskTypeBody(X,_,_); taskisBody(X,_,_) ), !. /*REV047*/
hasObcs(X) :- isActive(X). /*REV047*/
hasObcsBody(X) :- taskisBody(X,_,_), !. /*REV047*/
isConstrainedOp(X,T,U,S) :- entrySpec(X,T,U,S); entryPrivate(X,T,U,S); operationSpec(X,T,U,S); operationPrivate(X,T,U,S). /*REV047*/

isProvidedType(X,U,C) :- typeSpec(X,U,C); taskTypeSpec(X,U,C); protectedSpec(X,U,C).
isPrivateType(X,U,C) :- typePrivate(X,U,C); taskTypePrivate(X,U,C); protectedPrivate(X,U,C).
isInternalType(X,U,C) :- typeBody(X,U,C); taskTypeBody(X,U,C); protectedBody(X,U,C).

hasProTy(X) :- isProvidedType(X,_,_); isPrivateType(X,_,_).
hasProCo(X) :- constantSpec(X,_,_); constantPrivate(X,_,_).
hasProOp(X) :- /*REV054, REV058*/
	operationSpec(X,_,_); operationPrivate(X,_,_); 
	operationisNewSpec(X,_,_,_); operationisNewPrivate(X,_,_,_). 
hasProEx(X) :- exceptionSpec(X,_); exceptionPrivate(X,_).
hasProDa(X) :- dataSpec(X,_,_); dataPrivate(X,_,_).

hasTyImpBy(X) :- typeRenameSpec(X,_,_); ( ( hasChildUnit(X); hasBody(X) ), hasProTy(X) ). /*REV060*/
hasCoImpBy(X) :- constantRenameSpec(X,_,_); ( ( hasChildUnit(X); hasBody(X) ), hasProCo(X) ). /*REV060*/
hasOpImpBy(X) :- operationRenameSpec(X,_,_,_); ( ( hasChildUnit(X); hasBody(X) ), ( hasProOp(X); isConstrainedOp(X,_,_,_) ) ). /*REV060*/
hasExImpBy(X) :- exceptionRenameSpec(X,_,_); ( ( hasChildUnit(X); hasBody(X) ), hasProEx(X) ). /*REV060*/
hasDaImpBy(X) :- dataRenameSpec(X,_,_); ( ( hasChildUnit(X); hasBody(X) ), hasProDa(X) ). /*REV060*/

hasIntTy(X,Z) :- isPrivateType(X,_,_); isInternalType(Z,_,_).
hasIntCo(X,Z) :- constantPrivate(X,_,_); dataPrivate(X,_,_); constantBody(Z,_,_).
hasIntOp(X,Z) :- ( /*REV042, REV044, REV047, REV048, REV058*/
	operationBody(Z,U,_); operationBody(Z,_,U,_); operationisNewBody(Z,U,_,_); 
	( operationisBody(Z,U,S,_), not(opInSpec(X,U,S,_,_)) ) ), U\=''. 

hasIntEx(X,Z) :- exceptionPrivate(X,_); exceptionBody(Z,_).
hasIntDa(X,Z) :- dataBody(Z,_,_).

hasOpcs(X,Z) :- ( operationisBody(Z,V,P,C); operationisBody(Z,_,V,P,C); entryisBody(Z,_,V,P,C) ), V \= '', C \= ''. /*REV056*/
hasOpcs(X,Z) :- ( operationisNewSpec(X,V,_,C); operationisNewPrivate(X,V,_,C); operationisNewBody(Z,V,_,C) ), V \= '', C \= ''. /*REV054,REV056,REV058*/
hasOpcs(X,Z) :- initBlock(Z,C), C\=''. /*REV047,REV051,REV056*/

opInSpec(X,U,'',V,'') :- operationSpec(X,V,''), memezTra(U,V). /*REV042,REV056*/
opInSpec(X,U,S,V,T) :- operationSpec(X,V,T), memezTra(U,V), S \= '', T \= '', memezTra(S,T). /*REV056*/
opInSpec(X,U,'',V,'') :- operationPrivate(X,V,''), memezTra(U,V). /*REV042,REV056*/
opInSpec(X,U,S,V,T) :- operationPrivate(X,V,T), memezTra(U,V), S \= '', T \= '', memezTra(S,T). /*REV056*/
opInBody(Z,U,'',V,'') :- operationBody(Z,V,T), memezTra(U,V). /*REV042,REV056*/
opInBody(Z,U,S,V,T) :- operationBody(Z,V,T), memezTra(U,V), S \= '', T \= '', memezTra(S,T). /*REV056*/

/*``ods``Mon May 26 18:32:45 MET DST 2003``*/
/* createModule(X,Z,M) */

createModule(X,Z,M) :- 
	defaultOpSet(X), /*REV018*/
	( moduleisClass(X) -> write('CLASS '); write('OBJECT ') ), /*REV022, REV041*/
	splitName(X,Y,P), uniqueName(P,Y,N), printName(N), rootBodySuffix(Y,M), /*REV032, REV038*/
	( isActive(X) -> write(' IS ACTIVE'); write(' IS PASSIVE') ), nl, /*REV014, REV024, REV047*/
	createPragmas(X),
	createDescription(X), /*REV023*/
	createProvidedInterface(X), 
	write('  OBJECT_CONTROL_STRUCTURE'), nl, 
		( hasObcs(X) -> createVisibleObcs(X); none ), /*REV024, REV047*/
	write('  REQUIRED_INTERFACE'), nl, 
		( hasRequires(X,_) -> createRequires(X); none ), /*REV019*/
	write('  DATAFLOWS'), nl, 
		( hasUses(X,_) -> createUses(X); none ), /*REV019*/
	write('  EXCEPTION_FLOWS'), nl, 
		none, 
	( ( children(X,_), not(isRootBody(Y,M)) ) -> createNotTermInternals(X); createTermInternals(X,Z) ), /*REV009, REV031, REV048*/
	write('END '), printName(N), rootBodySuffix(Y,M), nl. /*REV014, REV032, REV038*/

createModuleBody(X,Z) :- /*REV048*/
	defaultOpSet(X), 
	( moduleisClass(X) -> write('CLASS '); write('OBJECT ') ), 
	splitName(X,Y,P), uniqueName(P,Y,N), printName(N), write('_body'), 
	( isActive(X) -> write(' IS ACTIVE'); write(' IS PASSIVE') ), nl, 
	createPragmas(X),
	createDescription(X), 
	createProvidedInterface(X), 
	write('  OBJECT_CONTROL_STRUCTURE'), nl, 
		( hasObcs(X) -> createVisibleObcs(X); none ), 
	write('  REQUIRED_INTERFACE'), nl, 
		( hasRequires(X,_) -> createRequires(X); none ), 
	write('  DATAFLOWS'), nl, 
		( hasUses(X,_) -> createUses(X); none ), 
	write('  EXCEPTION_FLOWS'), nl, 
		none, 
	createTermInternals(X,Z),
	write('END '), printName(N), write('_body'), nl.

/*``ods``Mon May 26 18:33:22 MET DST 2003``*/
/* createRoot(R) */
/* REV032 */

createRoot(R) :- 
	write('OBJECT '), replaceDashBy(R), write(' IS PASSIVE'), nl, /*REV040*/
	write('  PRAGMA no_end_op'), nl, /*REV055*/
	( ( isOpUnit(M,S), memezTra(R,M) ) -> /*REV049*/
		( write('  PROVIDED_INTERFACE'), nl,
		  write('    OPERATIONS'), nl, 
		  write('      '), createOpDecl('_root_',M,S), 
		  write('  INTERNALS'), nl, 
		  write('    OBJECTS'), nl, 
		  ( packageSpec(X,'_root_'); isOpUnit(X,_) ),
		  write('      '), splitName(X,Y,P), uniqueName(P,Y,N), 
		  printName(N), rootBodySuffix(R,X), nl
		);
		( packageSpec(Z,'_root_'), memezTra(R,Z),  
		  createProvidedInterface(Z),	/*REV035*/
		  write('  INTERNALS'), nl, 
	          write('    OBJECTS'), nl, 
		  ( children(Z,_) -> children(Z,X); ( packageSpec(X,'_root_'); isOpUnit(X,_) ) ), 
		  write('      '), splitName(X,Y,P), uniqueName(P,Y,N), 
		  printName(N), rootBodySuffix(R,X), nl
		) ), fail. /*REV038*/
createRoot(R) :- 	
	( ( isOpUnit(M,S), memezTra(R,M) ) ->
		( write('    OPERATIONS'), nl, createRootOpControl(M,S) ); /*REV049*/
		( packageSpec(Z,'_root_'), memezTra(R,Z), 
		write('    TYPES'), nl, 
			( hasTyImpBy(Z) -> createTyImpByBody(Z); none ), /*REV048*/
		write('    CONSTANTS'), nl,  
			( hasDaImpBy(Z) -> createDaImpByBody(Z); 
			  hasCoImpBy(Z) -> createCoImpByBody(Z); none ), /*REV048*/
		write('    OPERATIONS'), nl, 
			( hasOpImpBy(Z) -> createOpImpByBody(Z); none ),  /*REV048*/
		write('    EXCEPTIONS'), nl, 
			( hasExImpBy(Z) -> createExImpByBody(Z); none ) ) ), fail. /*REV048*/
createRoot(R) :- 	/*REV037*/
	write('END '), replaceDashBy(R), nl. /*REV040*/
 
/*``ods``Mon May 26 18:34:57 MET DST 2003``*/
/* createOpControl(X,S,M) */
/* REV028, REV049 */

createOpControl(X,S,M) :- 
	write('OP_CONTROL '), splitName(X,Y,P), uniqueName(P,Y,N), printName(N), rootBodySuffix(X,M), /*REV032, REV038*/
	write(' IS PASSIVE'), nl, 
	createPragmas(X),
	createDescription(X), 
	write('  PROVIDED_INTERFACE'), nl,
	write('    OPERATIONS'), nl, 
	write('      '), createOpIsDecl('_root_',X,S), 
	write('  REQUIRED_INTERFACE'), nl, 
		( hasRequires(X,_) -> createRequires(X); none ), 
	write('  DATAFLOWS'), nl, 
		( hasUses(X,_) -> createUses(X); none ), 
	write('  EXCEPTION_FLOWS'), nl, 
		none, 
	write('  INTERNALS'), nl,
	write('  OPERATION_CONTROL_STRUCTURES'), nl, 
	operationisBody('_root_',X,S,C), ( C='' -> none; ( 
	write('      OPERATION '), createOpIsDecl('_root_',X,S), 
	( operationisCommentBody('_root_',X,S,D) -> 
		( write('        DESCRIPTION '), nl, ( fileOrString(D) -> true; none) ); true ),
	write('        CODE '), nl, ( fileOrString(C) -> true; none),
	write('      END_OPERATION '), printName(N), nl ) ),
	write('END '), printName(N), rootBodySuffix(X,M), nl. /*REV032, REV038*/
 
/*``ods``Wed Sep 19 15:10:05 MET DST 2001``*/
/* createPragmas(X) */

createPragmas(X) :- write('  PRAGMA no_end_op'), nl, fail. /*REV055*/
createPragmas(X) :- ( operationisNewSpec(Y,U,_,_); operationisNewPrivate(Y,U,_,_); operationisNewBody(Y,U,_,_) ), memezTra(X,Y), /*REV054,REV058*/
	write('  PRAGMA instance_op(operation_name => --|'), write(U), write('|--)'), nl, fail.
createPragmas(X).	
 
/*``ods``Wed Sep 19 16:49:06 MET DST 2001``*/
/* createDescription(X) */
/*REV023*/

createDescription(X) :- 
	write('  DESCRIPTION'), nl, 
	( packageCommentSpec(X,C) -> 
		( write('    PRAGMA HCS(chapter => --|Statement of the Problem (text)|--)'), nl, fileOrString(C) ); true ),
	( packageCommentBody(X,D) -> 
		( write('    PRAGMA HCS(chapter => --|General Strategy (text)|--)'), nl, fileOrString(D) ); true ).
 
/*``ods``Wed Sep 19 17:32:29 MET DST 2001``*/
/* createProvidedInterface(X) */

createProvidedInterface(X) :- 
	write('  PROVIDED_INTERFACE'), nl,
	write('    TYPES'), nl, 
		( hasProTy(X) -> createProvTypes(X); none ), /*REV011, REV048*/
	write('    CONSTANTS'), nl,  
		( hasProDa(X) -> createProvData(X); true ), /*REV006, REV048*/
		( hasProCo(X) -> createProvConstants(X); true ), /*REV004, REV048*/
		( ( not(hasProDa(X)), not(hasProCo(X)) ) -> none; true ), /*REV048*/
	write('    OPERATION_SETS'), nl, 
		( hasOpSet(X) -> createOpSet; none), /*REV018, REV048*/
	write('    OPERATIONS'), nl, 
		( hasProOp(X) -> createProvOperations(X); none ), /*REV048*/
	write('    EXCEPTIONS'), nl, 
		( hasProEx(X) -> createProvExceptions(X); none ). /*REV005, REV048*/
 
/*``ods``Wed Sep 19 17:27:00 MET DST 2001``*/
/* createVisibleObcs(X) */
/*REV024, REV047*/

createVisibleObcs(X) :- ( isConstrainedOp(X,_,_,_) -> ( write('      CONSTRAINED_OPERATIONS'), nl ); none ), fail.
createVisibleObcs(X) :- isConstrainedOp(X,T,E,S), 
	write('        '), createOpDecl(X,E,S), 
	write('        CONSTRAINED_BY '), writeConstraint(X,T), write(';'), nl, fail.
createVisibleObcs(X).

writeConstraint(X,T) :- 
	( taskSpec(X,T,_); taskBody(X,T,_); taskTypeSpec(X,T,_); taskTypeBody(X,T,_); taskisBody(X,T,_) ) ->  
	write('HSER').
writeConstraint(X,T) :- 
	( protectedSpec(X,T,_); protectedBody(X,T,_) ) -> 
	write('RWER').

/* createObcs(X) */
/*REV047*/

createObcs(X) :- write('      CODE'), nl, write('--|'), 
	taskisBody(X,T,C), write('task body '), write(T), write(' is'), nl, 
	( basicFileOrString(C) -> nl; ( write('null;'), nl, write('end '), write(T), write(';'), nl ) ), fail.
createObcs(X) :- write('|--'), nl.
 
/*``ods``Wed Nov 13 16:32:25 MET 2002``*/
/* createTermInternals(X,Z) */
/*REV009, REV015, REV031*/

createTermInternals(X,Z) :- 
	write('  INTERNALS'), nl,
	write('    TYPES'), nl,  /*REV008, REV011*/
		( hasIntTy(X,Z) -> createIntTypes(X,Z); none ), /*REV048*/
	write('    CONSTANTS'), nl, /*REV004, REV008*/
		( hasIntCo(X,Z) -> createIntConstants(X,Z); none ), /*REV048*/
	write('    OPERATIONS'), nl, /*REV012*/
		( hasIntOp(X,Z) -> createIntOperations(X,Z); none ), /*REV050*/
	write('    EXCEPTIONS'), nl, 
		( hasIntEx(X,Z) -> createIntExceptions(X,Z); none ), /*REV005,REV048*/
	write('    DATA'), nl, 
		( hasIntDa(X,Z) -> createIntData(X,Z); none ), /*REV006,REV048*/
	write('  OBJECT_CONTROL_STRUCTURE'), nl, 
		( hasObcsBody(X) -> createObcs(X); none ), /*REV047*/
	write('  OPERATION_CONTROL_STRUCTURES'), nl, /*REV012*/ 
		( hasOpcs(X,Z) -> createOPCS(X,Z); none ). /*REV048, REV054*/
		
/*``ods``Fri Apr  9 11:42:12 MET DST 1999``*/
/* createNotTermInternals(X) */
/*REV009*/

createNotTermInternals(X) :- 
	write('  INTERNALS'), nl,
	write('    OBJECTS'), nl, 
		( children(X,_) -> createChildren(X) ; none ), 
	write('    TYPES'), nl, 
		( hasTyImpBy(X) -> createTyImpBy(X); none ), /*REV007, REV048*/
	write('    CONSTANTS'), nl, 
		( hasDaImpBy(X) -> createDaImpBy(X); true ), /*REV048*/
		( hasCoImpBy(X) -> createCoImpBy(X); true ), /*REV048*/
		( ( not(hasDaImpBy(X)), not(hasCoImpBy(X)) ) -> none; true ), /*REV007, REV048*/
	write('    OPERATIONS'), nl, 
		( hasOpImpBy(X) -> createOpImpBy(X); none ), /*REV007, REV048*/
	write('    EXCEPTIONS'), nl, 
		( hasExImpBy(X) -> createExImpBy(X); none ), /*REV007, REV048*/
	write('  OBJECT_CONTROL_STRUCTURE'), nl, none.
 
/*``ods``Fri Apr  9 18:47:02 MET DST 1999``*/
/* createChildren(X) */
/*REV009*/

createChildren(X) :- children(X,Y), uniqueName(X,Y,N), write('      '), printName(N), nl, fail.
createChildren(X).

/*``types``Thu Nov 14 14:41:25 MET 2002``*/
/* createProvTypes(X) */

createProvTypes(X) :- isProvidedType(X,U,C), 
	write('      '), printName(U), 
	( typeisAbstract(X,U) -> write(' ABSTRACT'); true), nl,  /*REV041*/
	( ( typeisClass(X,U); typeisAbstract(X,U) ) -> classInheritance(X,U); true ), /*REV022, REV041, REV045*/
	typeAttributes(X,U), 
	( typeRepresentation(X,U,R) -> 
		( write('--|'), basicFileOrString(C), nl, 
		  write('for '), write(U), write(' use'), nl, /*REV029*/
		  basicFileOrString(R), write(';|--'), nl );
		( C\='', fileOrString(C) ) ), /*REV011*/
	( ( typeCommentSpec(X,U,_); typeEnumeration(X,U,_) ) -> ( write(';'), nl ); true ),
	( typeCommentSpec(X,U,D) -> fileOrString(D); true ), /*REV023*/
	typeEnum(X,U), /*REV030*/
	fail.
createProvTypes(X) :- isPrivateType(X,U,C), not(isProvidedType(X,U,_)), 
	write('      '), printName(U), 
	( typeisAbstract(X,U) -> write(' ABSTRACT'); true), nl,  /*REV041*/
	( ( typeisClass(X,U); typeisAbstract(X,U) ) -> classInheritance(X,U); true ), /*REV022, REV041, REV045*/
	typeAttributes(X,U), 
	write('--|type '), printName(U), write(' is private;|--'), nl, 
	( typeCommentPrivate(X,U,_) -> 
		write(';'), typeCommentPrivate(X,U,D), nl, fileOrString(D) ), fail.
createProvTypes(X).
 
/*``types``Thu Nov 14 14:55:15 MET 2002``*/
/* createIntTypes(X,Z) */
/* REV031 */

createIntTypes(X,Z) :- isPrivateType(X,U,C), createIntType(X,U,C), fail.
createIntTypes(X,Z) :- isInternalType(Z,U,C), createIntType(Z,U,C), fail.
createIntTypes(X,Z).

createIntType(X,U,C) :-
	write('      '), printName(U), 
	( typeisAbstract(X,U) -> write(' ABSTRACT'); true), nl, /*REV041*/
	( ( typeisClass(X,U); typeisAbstract(X,U) ) -> classInheritance(X,U); true ), /*REV022, REV041, REV045*/
	typeAttributes(X,U),
	( typeRepresentation(X,U,R) -> 
		( write('--|'), basicFileOrString(C), nl, 
		  write('for '), write(U), write(' use'), nl, /*REV029*/
		  basicFileOrString(R), write(';|--'), nl );
		( C\='', fileOrString(C) ) ), /*REV011*/
	( ( typeCommentPrivate(X,U,_); typeCommentBody(X,U,_); typeEnumeration(X,U,_) ) -> ( write(';'), nl ); true ),
	( ( typeCommentPrivate(X,U,D); typeCommentBody(X,U,D) ) -> fileOrString(D); true ), /*REV023*/
	typeEnum(X,U). /*REV030*/
 
/*``types``Thu Nov 14 18:15:35 MET 2002``*/
/* createTyImpBy(X) */
/*REV007, REV048, REV060*/

createTyImpBy(X) :- ( hasChildUnit(X); hasBody(X) ), createTyImpByBody(X), fail.
createTyImpBy(X) :- typeRenameSpec(X,U,C), 
	write('      '), printName(U), nl, 
	write('      IMPLEMENTED_BY '), write(C), nl, fail.
createTyImpBy(X).
 
/*``types``Fri Nov 15 08:22:54 MET 2002``*/
/* createTyImpByBody(X) */
/* REV032, REV048 */

createTyImpByBody(X) :- 
	( typeSpec(X,U,C); taskTypeSpec(X,U,C); protectedSpec(X,U,C);
	  typePrivate(X,U,C); taskTypePrivate(X,U,C); protectedPrivate(X,U,C)), 
	write('      '), printName(U), nl, 
	write('      IMPLEMENTED_BY '), splitName(X,Y,P), uniqueName(P,Y,N), printName(N), 
	write('_body.'), printName(U), nl, fail.
createTyImpByBody(X).
 
/*``types``Wed Dec  5 15:55:43 MET 2001``*/
/* classInheritance(X,T) */
/*REV022, REV027*/

classInheritance(X,T) :- write('        INHERITANCE '), 
	( typeisNew(X,T,S) -> printTypeName(X,S); write('NONE') ), nl, fail.
classInheritance(X,T).
 
/*``types``Wed Nov 13 14:05:17 MET 2002``*/
/* typeAttributes(X,T) */
/*REV022*/

typeAttributes(X,T) :- attribute(X,T,_,_,_) ->  write('        ATTRIBUTES'), nl, fail.
typeAttributes(X,T) :- firstAttribute(X,T,A,B,C), createAttribute(X,T,A,B,C), fail.
typeAttributes(X,T) :- attribute(X,T,_,_,_) -> nl; true.

attribute(X,T,A,B,C) :- typeDiscriminant(X,T,A,B,C) ; typeComponent(X,T,A,B,C).
firstAttribute(X,T,A,B,C) :- attribute(X,T,A,B,C), !.
createAttribute(X,T,A,B,C) :- printAttribute(X,A,B,C), createOthers(X,T,A). /*REV041*/
createOthers(X,T,A) :- attribute(X,T,D,E,F), A\=D, write(','), nl, printAttribute(X,D,E,F). /*REV041*/

printAttribute(X,A,T,V) :- write('          '), printName(A), write(' : '), printTypeName(X,T), /*REV027, REV041*/
	( V \= '' -> ( write(' := --|'), write(V), write('|--') ); true ).
 
/*``types``Thu Nov 14 14:41:53 MET 2002``*/
/* typeEnum(X,T) */
/* REV030 */

typeEnum(X,T) :- typeEnumeration(X,T,E), 
	write('PRAGMA STOOD_ENUM( type => --|'), write(T), 
	write('|--, name => --|'), write(E), 
	write('|--, value => --||-- )'), nl.
 
/*``constants``Tue Mar 19 16:25:26 MET 2002``*/
/* createProvConstants(X) */
/*REV004*/

createProvConstants(X) :- constantSpec(X,U,C), 
	write('      '), printName(U), nl, 
	C\='', write('--|'), write(U), write(' : '), basicFileOrString(C), write('|--'), nl, /*REV029, REV053*/
	( constantCommentSpec(X,U,_) -> /*REV023*/
		write(';'), constantCommentSpec(X,U,D), nl, fileOrString(D) ), 
	fail. 
createProvConstants(X) :- constantPrivate(X,U,C), not(constantSpec(X,U,_)), 
	write('      '), printName(U), nl, 
	C\='', write('--|-- constant '), write(U), write(' is private|--'), nl, 
	( constantCommentPrivate(X,U,_) -> 
		write(';'), constantCommentPrivate(X,U,D), nl, fileOrString(D) ), 
	fail. 
createProvConstants(X).
 
/*``constants``Wed Nov 13 16:41:42 MET 2002``*/
/* createIntConstants(X,Z) */
/*REV004, REV031*/

createIntConstants(X,Z) :- constantPrivate(X,U,C), createIntConstant(X,U,C), fail.
createIntConstants(X,Z) :- dataPrivate(X,U,C), createIntConstant(X,U,C), fail.
createIntConstants(X,Z) :- constantBody(Z,U,C), createIntConstant(Z,U,C), fail.
createIntConstants(X,Z).

createIntConstant(X,U,C) :-
	write('      '), printName(U), nl, 
	C\='', write('--|'), write(U), write(' : '), basicFileOrString(C), write('|--'), nl, /*REV029, REV053*/
	( ( constantCommentPrivate(X,U,_); constantCommentBody(X,U,_) ) -> /*REV023*/
		write(';'), ( constantCommentPrivate(X,U,D); constantCommentBody(X,U,D) ), nl, fileOrString(D) ).
 
/*``constants``Thu Nov 14 18:17:06 MET 2002``*/
/* createCoImpBy(X) */
/*REV007, REV048, REV060*/

createCoImpBy(X) :- ( hasChildUnit(X); hasBody(X) ), createCoImpByBody(X), fail.
createCoImpBy(X) :- constantRenameSpec(X,U,C), 
	write('      '), printName(U), nl, 
	write('      IMPLEMENTED_BY '), write(C), nl, fail.
createCoImpBy(X).
 
/*``constants``Fri Nov 15 08:23:27 MET 2002``*/
/* createCoImpByBody(X) */
/* REV032, REV048 */

createCoImpByBody(X) :- ( constantSpec(X,U,_); constantPrivate(X,U,_) ), 
	write('      '), printName(U), nl, 
	write('      IMPLEMENTED_BY '), splitName(X,Y,P), uniqueName(P,Y,N), printName(N), 
	write('_body.'), printName(U), nl, fail.
createCoImpByBody(X).
 
/*``op_sets``Thu Mar 29 18:14:24 MET DST 2001``*/
/* defaultOpSet(X) */
/* REV018 */

defaultOpSet(X) :- cptRst, operationSpec(X,_,_), cptInc, fail.
defaultOpSet(X) :- cptGet(I), ( I > 20 ->  $assert(hasOpSet(X)); true).
 
/*``op_sets``Thu Mar 29 18:22:04 MET DST 2001``*/
/* createOpSet */
/* REV018*/

createOpSet :- write('      default'), nl.
 
/*``op_sets``Thu Mar 29 18:22:02 MET DST 2001``*/
/* insertMemberClause */
/* REV 018 */

insertMemberClause :- write('        MEMBER_OF default'), nl.
 
/*``operations``Thu Nov 14 18:24:24 MET 2002``*/
/* createProvOperations(X) */

createProvOperations(X) :- 
	( operationSpec(X,U,S); operationPrivate(X,U,S) ), U \= '', /*REV050*/
	write('      '), createOpDecl(X,U,S), 
	( operationisAbstract(X,U,S) -> ( write('        ABSTRACT'), nl ); true ), /*REV041*/
	( hasOpSet(X) -> insertMemberClause; true ), /*REV018*/
	( operationCommentSpec(X,U,S,_) -> /*REV023*/
		write(';'), operationCommentSpec(X,U,S,D), nl, fileOrString(D) ), 
	( operationCommentPrivate(X,U,S,_) -> 
		write(';'), operationCommentPrivate(X,U,S,D), nl, fileOrString(D) ), 
	fail. 
createProvOperations(X) :- 
     	( operationisNewSpec(X,U,S,G); operationisNewPrivate(X,U,S,G) ), /*REV054,REV058*/
	write('      '), createOpDecl(X,U,S),
	( operationCommentSpec(X,U,S,_) -> 
		write(';'), operationCommentSpec(X,U,S,D), nl, fileOrString(D) ), 
	( operationCommentPrivate(X,U,S,_) -> 
		write(';'), operationCommentPrivate(X,U,S,D), nl, fileOrString(D) ), 
	fail.
createProvOperations(X).
 
/*``operations``Thu Nov 14 18:24:40 MET 2002``*/
/* createIntOperations(X,Z) */
/* REV031 */

createIntOperations(X,Z) :- 
	( operationBody(Z,U,S); operationBody(Z,_,U,S) /*REV047*/ ), U \= '', 
	write('      '), createOpDecl(Z,U,S), 
	( operationisAbstract(X,U,S) -> ( write('        ABSTRACT'), nl ); true ), /*REV041*/
	( operationCommentBody(Z,U,S,_) -> /*REV023*/
		write(';'), operationCommentBody(Z,U,S,D), nl, fileOrString(D) ), 
	fail. 
createIntOperations(X,Z) :- /*REV012*/
	operationisBody(Z,U,S,_), U \= '', 
	not(opInBody(Z,U,S,_,_)), not(opInSpec(X,U,S,_,_)), /*REV050, REV056*/
	not(operationBody(Z,_,U,S)), not(operationSpec(X,_,U,S)), /*REV047*/
	not(operationPrivate(X,_,U,S)), /*REV047*/
	write('      '), createOpIsDecl(Z,U,S), 
	( operationisAbstract(Z,U,S) -> ( write('        ABSTRACT'), nl ); true ), /*REV041*/
	fail.
createIntOperations(X,Z) :- 
     	operationisNewBody(Z,U,S,G), U \= '', /*REV058*/
	write('      '), createOpDecl(Z,U,S),
	( operationCommentBody(Z,U,S,_) -> 
		write(';'), operationCommentBody(Z,U,S,D), nl, fileOrString(D) ), 
	fail.
createIntOperations(X,Z).
 
/*``operations``Thu Nov 14 18:25:13 MET 2002``*/
/* createOpImpBy(X) */
/*REV007, REV048, REV060*/

createOpImpBy(X) :- ( hasChildUnit(X); hasBody(X) ), createOpImpByBody(X), fail.
createOpImpBy(X) :- operationRenameSpec(X,U,S,C), 
	write('      '), createOpDecl(X,U,S), 
	write('      IMPLEMENTED_BY '), write(C), nl, fail.
createOpImpBy(X).
 
/*``operations``Fri Nov 15 08:24:19 MET 2002``*/
/* createOpImpByBody(X) */
/* REV032, REV048, REV058 */

createOpImpByBody(X) :- 
	( operationSpec(X,U,S); operationPrivate(X,U,S); 
	  operationisNewSpec(X,U,S,_); operationisNewPrivate(X,U,S,_); 
	  isConstrainedOp(X,_,U,S) ), 
	write('      '), createOpDecl(X,U,S),  
	write('      IMPLEMENTED_BY '), splitName(X,Y,P), uniqueName(P,Y,N), printName(N), 
	write('_body.'), createOpDecl(X,U,S), fail.
createOpImpByBody(X).
 
/*``operations``Fri Nov 15 08:31:30 MET 2002``*/
/* createRootOpControl(X,S) */
/* REV032, REV049 */

createRootOpControl(X,S) :- operationisBody('_root_',X,S,_), 
	write('      '), createOpIsDecl('_root_',X,S),  
	write('      IMPLEMENTED_BY '), write(X), write('_body.'), createOpIsDecl('_root_',X,S), fail.
createRootOpControl(X,S).
 
/*``operations``Thu Nov 14 18:24:00 MET 2002``*/
/* createOpDecl(X,U,S) */

createOpDecl(X,U,S) :- splitName(U,Y,P), uniqueName(P,Y,N), printName(N), fail. /*REV049*/
createOpDecl(X,U,S) :- (param(X,U,S,P,_,_,_), P\='return') -> write(' ('), nl, fail.
createOpDecl(X,U,S) :- firstParam(X,U,S,P,T,M,V), createParams(X,U,S,P,T,M,V), fail.
createOpDecl(X,U,S) :- (param(X,U,S,P,_,_,_), P\='return') -> write(' )'), fail.
createOpDecl(X,U,S) :- param(X,U,S,'return',T,_,_) -> createReturn(T); nl. 

/*``operations``Fri Apr  9 12:16:40 MET DST 1999``*/
/* createOpIsDecl(X,U,S) */

createOpIsDecl(X,U,S) :- splitName(U,Y,P), uniqueName(P,Y,N), printName(N), fail. /*REV049*/
createOpIsDecl(X,U,S) :- (paramis(X,U,S,P,_,_,_), P\='return') -> write(' ('), nl, fail.
createOpIsDecl(X,U,S) :- firstParamIs(X,U,S,P,T,M,V), createParamsIs(X,U,S,P,T,M,V), fail.
createOpIsDecl(X,U,S) :- (paramis(X,U,S,P,_,_,_), P\='return') -> write(' )'), fail.
createOpIsDecl(X,U,S) :- paramis(X,U,S,'return',T,_,_) -> createReturnIs(T); nl.
 
/*``operations``Fri May  7 11:58:44 MET DST 1999``*/
/* Op parameters */
/*REV012*/

firstParam(X,U,S,P,T,M,V) :- param(X,U,S,P,T,M,V), P\='return', !.
createParams(X,U,S,P,T,M,V) :- printParam(P,T,M,V), createOthers(X,U,S,P).
createOthers(X,U,S,P) :- param(X,U,S,Q,T,M,V), Q\=P, Q\='return', 
	write(';'), nl, printParam(Q,T,M,V).
createReturn(T) :- nl, write('        RETURN'), printParamType('return',T), nl. /*REV014*/

firstParamIs(X,U,S,P,T,M,V) :- paramis(X,U,S,P,T,M,V), P\='return', !.
createParamsIs(X,U,S,P,T,M,V) :- printParam(P,T,M,V), createOthersIs(X,U,S,P).
createOthersIs(X,U,S,P) :- paramis(X,U,S,Q,T,M,V), Q\=P, Q\='return', 
	write(';'), nl, printParam(Q,T,M,V).
createReturnIs(T) :- nl, write('        RETURN'), printParamType('return',T), nl. /*REV014*/

printParam(P,T,M,V) :- 
	printParamName(P), 
	printParamMode(M), 
	printParamType(M,T), 
	printParamValue(V).

printParamName(P) :- 
	write('        '), printName(P), write(' : ').
printParamMode(M) :- 
	M='access' -> write('in out'); 
	M='none' -> write('in'); write(M).  /* REV001 */
printParamType(M,T) :-  write(' '), splitName(T,S,P), /*REV014*/
	( P\='' -> ( splitName(P,O,_), printName(O), dot ); true ), printType(S), 
	( M='access' -> write(' BY_POINTER'); true).
printParamValue(V) :- V='' -> true; (write(' := --|'), write(V), write('|--')).
 
/*``operations``Wed Nov 13 16:46:34 MET 2002``*/
/* createOPCS(X,Z) */
/*REV012, REV020, REV023, REV031*/

createOPCS(X,Z) :- 
	( operationisBody(Z,U,P,C); operationisBody(Z,_,U,P,C); entryisBody(Z,_,U,P,C) ), /*REV047*/
	C\='', U\='', /*REV044*/
	write('      OPERATION '), 
	( opInSpec(X,U,P,V,Q) -> createOpDecl(X,V,Q); /*REV056*/
	  opInBody(Z,U,P,V,Q) -> createOpDecl(Z,V,Q); /*REV056*/
	  createOpIsDecl(Z,U,P) ), /*REV042*/
	( operationisCommentBody(Z,U,P,D) -> 
		( write('        DESCRIPTION '), nl, ( fileOrString(D) -> true; none) ); true ),
	write('        CODE '), nl, ( fileOrString(C) -> true; none),
	write('      END_OPERATION '), printName(U), nl, 
	fail.
createOPCS(X,Z) :- 
	( operationisNewSpec(Y,U,S,G); operationisNewPrivate(Y,U,S,G); operationisNewBody(Y,U,S,G) ), 
	memezTra(X,Y), G\='', U\='', /*REV054, REV056, REV058*/
	write('      OPERATION '), createOpDecl(X,U,S), 
	( operationisCommentBody(Z,U,P,D) -> 
		( write('        DESCRIPTION '), nl, ( fileOrString(D) -> true; none) ); true ),
	write('        CODE Ext'), nl, instanceOpAssoc(X,U,G), /*REV056*/
	write('      END_OPERATION '), printName(U), nl, 
	fail.
createOPCS(X,Z) :- initBlock(Z,C), C\='', /*REV051*/
	write('      OPERATION '), splitName(Z,Y,P), uniqueName(P,Y,N), printName(N), write('_Initialize'), nl, /*REV056*/
	write('        CODE '), nl, ( fileOrStringBegin(C) -> true; none),
	write('      END_OPERATION '), printName(N), write('_Initialize'), nl, /*REV056*/
	fail.
createOPCS(X,Z).

instanceOpAssoc(Z,O,G) :- write(' --|is new '), write(G), genAssoc(Z,O,G), write(';|--'), nl. /*REV054*/

genAssoc(Z,O,G) :- ( genericAssociation(Y,O,I,_,_), memezTra(Y,Z) ) -> write(' ('), fail. /*REV054, REV059*/
genAssoc(Z,O,G) :- firstAssociation(Z,O,I,P,V), createAssociations(Z,O,I,P,V), fail. /*REV059*/
genAssoc(Z,O,G) :- ( genericAssociation(Y,O,I,_,_), memezTra(Y,Z) ) -> write(')'), fail. /*REV059*/
genAssoc(Z,O,G).

firstAssociation(Z,O,I,P,V) :- genericAssociation(Y,O,I,P,V), memezTra(Y,Z), !. /*REV054, REV059*/
createAssociations(Z,O,I,P,V) :- /*REV054, REV059*/
	( P \= '' -> ( printName(P), write('=>') ); true ), printName(V), 
	genericAssociation(Y,O,J,Q,W), memezTra(Y,Z), J \= I, write(','), /*REV059*/
	( Q \= '' -> ( printName(Q), write('=>') ); true ), printName(W).
 
/*``exceptions``Fri Sep 21 11:57:36 MET DST 2001``*/
/* createProvExceptions(X) */

createProvExceptions(X) :- exceptionSpec(X,U), 
	write('      '), printName(U), nl, 
	( exceptionCommentSpec(X,U,_) -> /*REV023*/
		write(';'), exceptionCommentSpec(X,U,D), nl, fileOrString(D) ), 
	fail.
createProvExceptions(X).
 
/*``exceptions``Wed Nov 13 16:47:33 MET 2002``*/
/* createIntExceptions(X,Z) */
/* REV031 */

createIntExceptions(X,Z) :- exceptionBody(Z,U), 
	write('      '), printName(U), nl, warning3(U), 
	( exceptionCommentBody(Z,U,_) -> /*REV023*/
		write(';'), exceptionCommentBody(Z,U,D), nl, fileOrString(D) ), 
	fail.
createIntExceptions(X,Z).
 
/*``exceptions``Thu Nov 14 18:19:49 MET 2002``*/
/* createExImpBy(X) */
/*REV007, REV048, REV060*/

createExImpBy(X) :- ( hasChildUnit(X); hasBody(X) ), createExImpByBody(X), fail.
createExImpBy(X) :- exceptionRenameSpec(X,U,C), 
	write('      '), printName(U), nl, 
	write('      IMPLEMENTED_BY '), write(C), nl, fail.
createExImpBy(X).
 
/*``exceptions``Mon Apr  7 09:45:28 MET DST 2003``*/
/* createExImpByBody(X) */
/* REV032, REV048 */

createExImpByBody(X) :- exceptionSpec(X,U), /*REV036*/
	write('      '), printName(U), nl, 
	write('      IMPLEMENTED_BY '), splitName(X,Y,P), uniqueName(P,Y,N), printName(N), 
	write('_body.'), printName(U), nl, fail.
createExImpByBody(X).

/*``data``Tue Mar 19 16:38:35 MET 2002``*/
/* createProvData(X) */
/*REV006*/

createProvData(X) :- dataSpec(X,U,C), 
	write('      '), printName(U), nl, 
	C\='', write('--|'), write(U), write(' : '), writeLong(C), write('|--'), nl, /*C029*/
	warning4(U), 
	( dataCommentSpec(X,U,_) -> /*REV023*/ 
		write(';'), dataCommentSpec(X,U,D), nl, fileOrString(D) ),
	 fail. 
createProvData(X) :- dataPrivate(X,U,C), not(dataSpec(X,U)), 
	write('      '), printName(U), nl, 
	C\='', write('--|-- data '), write(U), write(' is private|--'), nl, 
	warning4(U), 
	( dataCommentPrivate(X,U,_) -> 
		write(';'), dataCommentPrivate(X,U,D), nl, fileOrString(D) ),
	 fail. 
createProvData(X).
 
/*``data``Wed Nov 13 16:48:10 MET 2002``*/
/* createIntData(X,Z) */
/*REV006, REV031*/

createIntData(X,Z) :- dataBody(Z,U,C), createIntData(Z,U,C), fail.
createIntData(X,Z).

createIntData(X,U,C) :- 
	write('      '), printName(U), nl, 
	C\='', write('--|'), write(U), write(' : '), writeLong(C), write('|--'), nl, /*C029*/
	( ( dataCommentPrivate(X,U,_); dataCommentBody(X,U,_) ) -> 
		write(';'), ( dataCommentPrivate(X,U,D); dataCommentBody(X,U,D) ), nl, fileOrString(D) ),
	fail. 
createIntData(X,U,C).
 
/*``data``Thu Nov 14 18:18:30 MET 2002``*/
/* createDaImpBy(X) */
/*REV007, REV048, REV060*/

createDaImpBy(X) :- ( hasChildUnit(X); hasBody(X) ), createDaImpByBody(X), fail.
createDaImpBy(X) :- dataRenameSpec(X,U,C), 
	write('      '), printName(U), nl, 
	write('      IMPLEMENTED_BY '), write(C), nl, fail.
createDaImpBy(X).
 
/*``data``Fri Nov 15 08:27:04 MET 2002``*/
/* createDaImpByBody(X) */
/* REV032, REV048 */

createDaImpByBody(X) :- ( dataSpec(X,U,_); dataPrivate(X,U,_) ), 
	write('      '), printName(U), nl, 
	write('      IMPLEMENTED_BY '), splitName(X,Y,P), uniqueName(P,Y,N), printName(N), 
	write('_body.'), printName(U), nl, fail.
createDaImpByBody(X).
 
/*``ods``Fri Apr 27 12:28:06 MET DST 2001``*/
/* createUses(X) */

hasUses(X,Y) :- ( withSpec(X,Y); withBody(X,Y) ), X\=Y, not(children(X,Y)). /*REV019*/

createUses(X) :- hasUses(X,Y), /*REV009, REV017*/
	write('    default <=> '), splitName(Y,Z,P), uniqueName(P,Z,N), printName(N), nl, fail. /*REV010*/
createUses(X).
 
/*``ods``Fri Apr 27 12:28:16 MET DST 2001``*/
/* createRequires(X) */

hasRequires(X,Y) :- ( withSpec(X,Y); withBody(X,Y) ), X\=Y, not(children(X,Y)). /*REV019*/

createRequires(X) :- hasRequires(X,Y), /*REV009, REV017*/
	write('    OBJECT '), splitName(Y,Z,P), uniqueName(P,Z,N), printName(N), write(';'), nl, none, fail. /*REV010*/
createRequires(X).
 
/*``general``Fri May 23 18:35:58 MET DST 2003``*/
/* printing */

none :- write('      NONE'), nl.

printName('') :- write('MISSING_IDENTIFIER'), !. /* REV026 */
printName(U) :- 
	( ( isReserved(V), memezTra(U,V) ) -> write('sif_keyword_'); true ), 
	write(U). /*REV003-REV029*/

printFreeText(C) :- write(' --|'), writeLong(C), write('|--'), nl. /*REV011*/

printTypeName(M,T) :-  splitName(T,S,P), /*REV027, REV041*/
	( P \= '' -> ( splitName(P,O,_), printName(O), dot ); true ), 
	printType(S).

printType('') :- write('MISSING_IDENTIFIER'), !. /* REV026 */
printType(T) :- 
	( ( isReserved(V), memezTra(T,V) ) -> write('sif_keyword_'); true ), /*REV029*/
	$name(T,L), $member(C,L), /* REV002 */
	( C =:= 39 -> ( $put(95), warning2(T) ); $put(C) ), fail.
printType(T).

write(X) :- $writename(X).
writeLong(X) :- $name(X,L), $member(E,L),  ( E =:= 124 -> $put(33); $put(E) ), fail. /*REV033*/
writeLong(X).
print(X) :- $telling(F), $told, $tell('user'), $writename(X), $tell(F,1).

fileOrString(C) :- /*REV023*/
	write('--|'), basicFileOrString(C), write('|--'), nl.

fileOrStringBegin(C) :- /*REV051*/
	write('--|'), write('begin'), nl, basicFileOrString(C), write('|--'), nl.

basicFileOrString(C) :- ( $conlength(C,L), L < 4 ) -> write(C); /*REV023-REV046*/
	( $substring(1,4,'tmp_',0,C,_) -> ( $see(C) -> printFile; writeLong(C) ); writeLong(C) ).

bricolage(C,D) :- /*REV020*/
	$name(C,[116,109,112,95,C1,C2,C3,C4,C5,C6,C7,C8,X|L]), Y is X+1,
	$name(D,[116,109,112,95,C1,C2,C3,C4,C5,C6,C7,C8,Y|L]).

printFile :- $get0(C), 
	( C =\= -1 -> (  ( C =:= 124 -> $put(33); $put(C) ), printFile ); $seen ). /*REV012, REV033*/

nl :- $put(10).
tab :- $put(9).
sp :- $put(32).
dot :- $put(46).

memezTra('','').
memezTra(A,B) :- A \= '', B \= '', $name(A,L1), $name(B,L2), id(L1,L2).

id([],[]) :- true.
id([E|L1],[F|L2]) :- ( E =:= F ; E =:= F-32 ; E-32 =:= F ), id(L1,L2).

splitName(X,A,B) :- X \= '', /*REV010*/
	$name(X,L1), $reverse(L1,R1), $name(X1,R1),
	$subdelim(1,'.',A2,0,X1,P) -> (
		$name(A2,R2), $reverse(R2,L2), $name(A,L2),
		$conlength(X,S), Q is S-P, $substring(1,Q,B3,P,X1,_),
		$name(B3,R3), $reverse(R3,L3), $name(B,L3) );
		( A=X, B='').

addSuffix(F1,S,F2) :- $name(F1,L1), $name(S,L2), $append(L1,L2,L3), $name(F2,L3). /*REV016*/

replaceDashBy(X) :- X \= '', /*REV040*/
	( ( isReserved(V), memezTra(X,V) ) -> write('sif_keyword_'); true ), 
	$name(X,L), $member(C,L), ( C =:= 45 -> $put(95); $put(C) ), fail.
replaceDashBy(X). 

concat(A,B,C) :- $name(A,L1), $name(B,L2), 
	$append(L1,L2,L), $name(C,L).
concat(A,B,C,D) :- $name(A,L1), $name(B,L2), $name(C,L3), 
	$append(L1,L2,L4), $append(L4,L3,L), $name(D,L).
concat(A,B,C,D,E) :- $name(A,L1), $name(B,L2), $name(C,L3), $name(D,L4), 
	$append(L1,L2,L5), $append(L5,L3,L6), $append(L6,L4,L), $name(E,L).
concat(A,B,C,D,E,F) :- $name(A,L1), $name(B,L2), $name(C,L3), $name(D,L4), $name(E,L5),
	$append(L1,L2,L6), $append(L6,L3,L7), $append(L7,L4,L8), $append(L8,L5,L), $name(F,L).
	
convert([],R,L) :- $reverse(R,L), !. /* . -> _ */
convert([C|L1],L2,L) :- ( C =:= 46 ) ->
	convert(L1,[95|L2],L); convert(L1,[C|L2],L).
 
/*``general``Fri Apr  9 11:43:17 MET DST 1999``*/
/* warnings */

warning1(U) :- $telling(F), $told, $tell('user'), 
	write('WARNING: '), write(U), 
	write(' is a reserved word for HOOD, and has been renamed into: '), 
	write(U), write('_'), nl,
	$told, $tell(F,1).

warning2(U) :- $telling(F), $told, $tell('user'), 
	write('WARNING: for parameter type: '), write(U), 
	write(' tick character was replaced by an underline character'), nl, 
	$told, $tell(F,1).
 
warning3(U) :- $telling(F), $told, $tell('user'), 
	write('WARNING: exception: '), write(U), 
	write(' has been inserted into module internals'), nl, 
	$told, $tell(F,1).

warning4(U) :- $telling(F), $told, $tell('user'), 
	write('WARNING: variable: '), write(U), 
	write(' has been inserted into module provided interface, as a constant'), nl, 
	$told, $tell(F,1).

message(A,B,C,D) :- $telling(F), $told, $tell('user'), 
	write(A), sp, write(B),  sp, write(C), sp, write(D), nl, 
	$told, $tell(F,1).

/*``general``Wed Oct 10 13:51:50 MET 2001``*/
/* isReserved(U) */

isReserved('ATTRIBUTES').
isReserved('ASER_BY_IT').
isReserved('ASER').
isReserved('ACTIVE').
isReserved('ABSTRACT').
isReserved('BY_VALUE').
isReserved('BY_REFERENCE').
isReserved('BY_POINTER').
isReserved('BY_IT').
isReserved('CONSTRAINED_OPERATIONS').
isReserved('CONSTRAINED_BY').
isReserved('CONSTANTS').
isReserved('CODE').
isReserved('CLASS').
isReserved('DESCRIPTION').
isReserved('DATAFLOWS').
isReserved('DATA').
isReserved('EXCEPTION_FLOWS').
isReserved('EXCEPTIONS').
isReserved('ENVIRONMENT').
isReserved('END_OPERATION').
isReserved('END_OBJECT').
isReserved('END').
isReserved('FORMAL_PARAMETERS').
isReserved('GENERIC').
isReserved('HSER_TOER').
isReserved('HSER').
isReserved('HANDLED_EXCEPTIONS').
isReserved('IS').
isReserved('INTERNALS').
isReserved('INSTANCE_RANGE').
isReserved('INSTANCE_OF').
isReserved('INHERITED').
isReserved('INHERITANCE').
isReserved('IN').
isReserved('IMPLEMENTED_BY').
isReserved('IMPLEMENTATION_OR_SYNCHRONIZATION_CONSTRAINTS').
isReserved('IMPLEMENTATION_OR_SYNCHRONISATION_CONSTRAINTS').
isReserved('IMPLEMENTATION_CONSTRAINTS').
isReserved('LSER_TOER').
isReserved('LSER').
isReserved('MTEX').
isReserved('MEMBER_OF').
isReserved('NONE').
isReserved('OUT').
isReserved('OSTD').
isReserved('OP_CONTROL').
isReserved('OPERATION_SETS').
isReserved('OPERATION_CONTROL_STRUCTURES').
isReserved('OPERATIONS').
isReserved('OPERATION').
isReserved('OBJECT_CONTROL_STRUCTURE').
isReserved('OBJECTS').
isReserved('OBJECT').
isReserved('PSEUDO_CODE').
isReserved('PROVIDED_INTERFACE').
isReserved('PROTOCOL').
isReserved('PROPAGATED_EXCEPTIONS').
isReserved('PRAGMA').
isReserved('PASSIVE').
isReserved('PARAMETERS').
isReserved('RWER').
isReserved('ROER').
isReserved('RLSER').
isReserved('RETURN').
isReserved('REQUIRED_INTERFACE').
isReserved('RASER').
isReserved('RAISED_BY').
isReserved('STATE').
isReserved('SIF_VERSION').
isReserved('TYPES').
isReserved('TOOL_VERSION').
isReserved('TOOL_NAME').
isReserved('TO').
isReserved('TARGET_LANGUAGE').
isReserved('USED_OPERATIONS').
isReserved('VIRTUAL_NODE').

/* HRT add-ons */
/* REV026 */

isReserved('PROTECTED').
isReserved('CYCLIC').
isReserved('SPORADIC').
isReserved('REAL_TIME_ATTRIBUTES').
isReserved('WCET').
isReserved('BUDGET').
isReserved('CEILING_PRIORITY').
isReserved('PERIOD').
isReserved('OFFSET').
isReserved('MIN_ARRIVAL_TIME').
isReserved('MAX_ARRIVAL_FREQUENCY').
isReserved('DEADLINE').
isReserved('PRIORITY').
isReserved('PRECEDENCE_CONSTRAINTS').
isReserved('BEFORE').
isReserved('AFTER').
isReserved('EXECUTION_TIME_TRANSFORMATION').
isReserved('IMPORTANCE').
isReserved('HARD').
isReserved('SOFT').
isReserved('BACKGROUND').
isReserved('PAER').
isReserved('PSER').
isReserved('PSER_TOER').
isReserved('ASATC').
isReserved('LSATC').
isReserved('HSATC').
isReserved('LSATC_TOER').
isReserved('HSATC_TOER').
isReserved('INTEGRITY'). /*REV039*/
 
/*``general``Thu Mar 29 18:02:48 MET DST 2001``*/
/* counter */

cptRst :- $globalset(cpt(0)).
cptPut(I) :- $globalset(cpt(I)).
cptGet(I) :- cpt(I).
cptInc :- cpt(I), J is I + 1, $globalset(cpt(J)).
cptDec :- cpt(I), J is I - 1, $globalset(cpt(J)).
cptAdd(I) :- cpt(J), K is J + I, $globalset(cpt(K)).
cptSub(I) :- cpt(J), K is J - I, $globalset(cpt(K)).
cptMul(I) :-  cpt(J), K is J * I, $globalset(cpt(K)).
cptDiv(I) :- cpt(J), K is J // I, $globalset(cpt(K)).
cptNeg :- cpt(I), J is -I, $globalset(cpt(J)).

