#!/bin/sh
# reverse/ada/go.sh
# Ada reverse engineering utility
# Stood v4.3 - TNI - February 2003

# arguments:
# $1 : This directory
# $2 : Ada source directory
# $3 : Ada unit name
# $4 : SIF filename

SPEC=$ADASPECSUFFIX
BODY=$ADABODYSUFFIX

cd "$2"

if test -f "$3.pro"
  then rm "$3.pro"
fi

if test -f external.pro
  then EXTERNAL_HIERARCHY=TRUE
fi

if test -f "$3.log"
  then rm "$3.log"
fi

for file in `ls *$SPEC`
do 
  F=`echo $file | sed "s/^.*-//" | sed "s/$SPEC//"`
  $STOODBIN/adarev $file >> "$3.pro"
  echo parsing $F >> "$3.log"
  if test -z "$EXTERNAL_HIERARCHY"
    then if test "$F" != $3
        then echo "child('"$3"','"$F"')." >> external.pro
    fi
  fi
done 

for file in `ls *$BODY`
do 
  $STOODBIN/adarev $file >> "$3.pro"
done 

PREDICATS="$3.pro"
export PREDICATS

EXTERNAL_FACTS=external.pro
export EXTERNAL_FACTS

SIMPATH="$STOODPRO/modlib":"$STOODPRO/lib":"$STOODPRO/cmplib"
export SIMPATH

SIFFILE="$4"
export SIFFILE

ROOT_UNIT="$3"
export ROOT_UNIT

"$STOODBIN/sbprolog" -m $SBPROLOG_M_SIZE -p $SBPROLOG_P_SIZE "$1/Input.sbp" >> "$3.log"

echo > tmp.log
cp "$4" "$3.sif"

rm tmp*

if test -z "$EXTERNAL_HIERARCHY"
  then if test -f external.pro
    then rm external.pro
  fi
fi
