/*``general``Fri May 30 09:08:18 MET DST 2003``*/
/* version */
/*-----------------------------------------------
   C2HOOD v1.06 for Stood 5
   C code reverse engineering
   SIF 4 generator

   Copyright TNI Europe 2004
   Pierre DISSAUX (pierre.dissaux@tni-world.com)
   20.July.2004
------------------------------------------------
REVC001 (06.12.02) : include all modules into ROOT_UNIT
------ CD-Rom #7 (December 2002) --------------------
REVC002 (07.02.03) fixing bug when empty root module 
REVC003 (12.02.03) compatibility with crev v1.0 + better management of main
REVC004 (12.02.03) adding macros as operations
REVC005 (27.05.03) no _body when only one package
REVC006 (28.05.03) remove module name prefix when exists
REVC007 (30.05.03) remove void parameters
REVC008 (18.02.04) adding INTEGRITY as an HRT keyword
REVC009 (19.05.04) type enum, attribute and prefix
REVC010 (20.07.04) fixing SIF syntax error with array attributes types
REVC011 (20.07.04) getting more comments for OPCS
------------------------------------------------*/
 
/*``general``Tue May 27 09:56:46 MET DST 2003``*/
/* go */

go :- $init_sys,
	( $getenv('PREDICATS',In) -> true; 
		( write('Environment variable PREDICATS should be defined (error 4)'), nl ) ),
	( $consult(In) -> true; 
		( write('Cannot open input file. (error 1)'), nl ) ),
	( $getenv('SIFFILE',Sif) -> true;
		( write('Environment variable SIFFILE should be defined (error 5)'), nl ) ),
	( Sif \= '' -> 
		( Out = Sif ); 
		( packageSpec(Root,_) -> 
			( splitName(Root,F,_),  addSuffix(F,'.sif',Out) ); 
			( write('Cannot find root module. (error 3)'), Out='user', nl ) ) ), 
	( $tell(Out) -> true; 
		( write('Cannot open output file. (error 2)'), nl ) ), 
	( ( $getenv('EXTERNAL_FACTS',Ext), $exist(Ext) ) -> $consult(Ext); true ),
	( $getenv('ROOT_UNIT',R) -> ( $name(R,L), $name(M,L) ); /*(cf.REVC001)*/
		( write('Environment variable ROOT_UNIT should be defined (error 6)'), nl ) ), 
	genSif(M), $told.

genSif(M) :- /*(cf.REVC001) (cf.REVC003)*/
	sifHeader, notUnique, /*(cf.REVC005)*/
	isModule(X), memezTra(X,M), createRoot(X), fail.
genSif(M) :- 
	isModule(X), createModule(X,M), fail. 
 
/*``general``Tue May 27 09:52:41 MET DST 2003``*/
/* sifHeader */

sifHeader :- 
	write('SIF_VERSION --|4.0|--;'), nl,
	write('TOOL_NAME --|C2HOOD|--;'), nl,
	write('TOOL_VERSION --|1.04|--;'), nl,
	write('TARGET_LANGUAGE --|C|--;'), nl.
 
/*``general``Tue May 27 09:57:06 MET DST 2003``*/
/* hierarchy */

isModule(X) :- packageBody(X,_). /*(cf.REVC003)*/
isModule(X) :- packageSpec(X,_), not(packageBody(X,_)).

isMain(X) :- operationisBody(X,'main',_,_). /*(cf.REVC003)*/

children(X,Y) :- isModule(Z), splitName(Z,Y,_), X\=Y, isParent(X,Y).

isParent(X,Y) :- (
	( child(P,E), memezTra(X,P), memezTra(Y,E) ); 
	( withSpec(X,Y), operationRenameSpec(X,_,_,C), 
	  $subdelim(1,'.',Z,0,C,_), memezTra(Y,Z) )
 ), !.

notUnique :- isModule(X), isModule(Y), X \= Y, !. /*(cf.REVC005)*/

rootBodySuffix(X,M) :- ( memezTra(X,M), notUnique ) -> write('_body'); true. /*(cf.REVC005)*/
 
/*``ods``Tue May 27 11:35:31 MET DST 2003``*/
/* createModule(X,M) */

createModule(X,M) :- /*(cf.REVC001)*/
	defaultOpSet(X),
	( typeisTagged(X,_) -> write('CLASS '); write('OBJECT ') ), 
	splitName(X,Y,_), printName(Y), rootBodySuffix(Y,M), /*(cf.REVC001)(cf.REVC005)*/
	( taskSpec(X,_) -> write(' IS ACTIVE'); write(' IS PASSIVE') ), nl, 
	createPragmas(X),
	createDescription(X), 
	createProvidedInterface(X), 
	createVisibleObcs(X),
	write('  REQUIRED_INTERFACE'), nl, 
		( hasRequires(X,_) -> createRequires(X); none ), 
	write('  DATAFLOWS'), nl, 
		( hasUses(X,_) -> createUses(X); none ), 
	write('  EXCEPTION_FLOWS'), nl, 
		none, 
	( children(X,_) -> createNotTermInternals(X); createTermInternals(X) ), 
	write('END '), printName(Y), rootBodySuffix(Y,M), nl. /*(cf.REVC001)(cf.REVC005)*/
 
/*``ods``Tue May 27 11:35:15 MET DST 2003``*/
/* createRoot(R) */
/* (cf.REVC001) (cf.REVC002) (cf.REVC003) (cf.REVC004) (cf.REVC005) */

createRoot(R) :- 
	write('OBJECT '), write(R), write(' IS PASSIVE'), nl, 
	createProvidedInterface(R), 
	write('  INTERNALS'), nl,
	write('    OBJECTS'), nl, 
	isModule(X), 
	write('      '), splitName(X,Y,_), printName(Y), rootBodySuffix(R,X), nl, fail.
createRoot(R) :- 	
	write('    TYPES'), nl, 
		( typeSpec(R,_,_) -> createRootTyImpBy(R); none ), 
	write('    CONSTANTS'), nl,  
		( dataSpec(R,_,_) -> createRootDaImpBy(R);  
		  ( constantSpec(R,_,_); defineSpec(R,_,_) ) -> createRootCoImpBy(R); 
		  none ),
	write('    OPERATIONS'), nl, 
		( ( operationSpec(R,_,_); isMain(R); defineArgsSpec(R,_,_) ) -> createRootOpImpBy(R); none ), 
	write('    EXCEPTIONS'), nl, 
		( exceptionSpec(R,_) -> createRootExImpBy(R); none ),
	write('END '), write(R), nl, fail.
createRoot(R).
 
/*``ods``Wed May 28 09:29:57 MET DST 2003``*/
/* createOpControl(O,X) */

createOpControl(O,X) :- /*(cf.REVC001)*/
	write('OP_CONTROL '), printName(O), write(' IS PASSIVE'), nl, /*(cf.REVC001)*/
	createPragmas(X),
	createDescription(X), 
	write('  PROVIDED_INTERFACE'), nl,
	write('    OPERATIONS'), nl, write('      '), createOpDecl(X,O,''), 
	write('  REQUIRED_INTERFACE'), nl, 
		( hasRequires(X,_) -> createRequires(X); none ), 
	write('  DATAFLOWS'), nl, 
		( hasUses(X,_) -> createUses(X); none ), 
	write('  EXCEPTION_FLOWS'), nl, 
		none, 
	write('  INTERNALS'), nl,
	write('  OPERATION_CONTROL_STRUCTURES'), nl, 
	operationisBody(X,O,'',C), ( C='' -> none; ( 
	write('      OPERATION '), createOpIsDecl(X,O,''), 
	( operationisCommentBody(X,O,'',D) -> 
		( write('        DESCRIPTION '), nl, ( fileOrString(D) -> true; none) ); true ),
	write('        CODE '), nl, ( fileOrString(C) -> true; none),
	write('      END_OPERATION '), printName(O), nl ) ),
	write('END '), printName(O), nl. /*(cf.REVC001)*/
 
/*``ods``Wed Sep 19 15:10:05 MET DST 2001``*/
/* createPragmas(X) */

createPragmas(X).
 
/*``ods``Fri Jun 28 19:11:16 MET DST 2002``*/
/* createDescription(X) */

createDescription(X) :- 
	write('  DESCRIPTION'), nl, 
	( packageCommentSpec(X,_) -> 
		( write('    PRAGMA HCS(chapter => --|Statement of the Problem (text)|--)'), 
		  packageCommentSpec(X,C), nl, fileOrString(C) ); true ),
	( packageCommentBody(X,_) -> 
		( write('    PRAGMA HCS(chapter => --|General Strategy (text)|--)'), 
		  packageCommentBody(X,D), nl, fileOrString(D) ); true ), fail.
createDescription(X).
 
/*``ods``Wed May 28 09:49:59 MET DST 2003``*/
/* createProvidedInterface(X) */

createProvidedInterface(X) :- 
	write('  PROVIDED_INTERFACE'), nl,
	write('    TYPES'), nl, 
		( typeSpec(X,_,_) -> createProvTypes(X); none ), 
	write('    CONSTANTS'), nl,  
		( dataSpec(X,_,_) -> createProvData(X); true ), 
		( ( constantSpec(X,_,_); defineSpec(X,_,_) ) -> createProvConstants(X); true ), 
		( ( not(dataSpec(X,_,_)), not(constantSpec(X,_,_)), not(defineSpec(X,_,_)) ) -> none; true ),
	write('    OPERATION_SETS'), nl, 
		( hasOpSet(X) -> createOpSet; none), 
	write('    OPERATIONS'), nl, 
		( ( operationSpec(X,_,_); isMain(X); defineArgsSpec(X,_,_) ) -> 
			createProvOperations(X); none ), /*(cf.REVC003) (cf.REVC004)*/
	write('    EXCEPTIONS'), nl, 
		( exceptionSpec(X,_) -> createProvExceptions(X); none ). 
 
/*``ods``Fri May 31 18:06:29 MET DST 2002``*/
/* createVisibleObcs(X) */

createVisibleObcs(X) :- write('  OBJECT_CONTROL_STRUCTURE'), nl, 
		none.
 
/*``ods``Wed Feb 12 14:01:03 MET 2003``*/
/* createTermInternals(X) */

createTermInternals(X) :- 
	write('  INTERNALS'), nl,
	write('    TYPES'), nl,  
		( ( typePrivate(X,_,_); typeBody(X,_,_) ) -> createIntTypes(X); none ),
	write('    CONSTANTS'), nl,
		( ( constantPrivate(X,_,_); constantBody(X,_,_); defineBody(X,_,_) ) -> createIntConstants(X); none ),
	write('    OPERATIONS'), nl, 
		( ( operationBody(X,_,_); ( operationisBody(X,U,S,_), not(operationSpec(X,U,S)), U \= 'main' ); 
		    defineArgsBody(X,_,_) ) -> /*(cf.REVC004)*/
			createIntOperations(X); none ), /*(cf.REVC003)*/
	write('    EXCEPTIONS'), nl, 
		( exceptionBody(X,_) -> createIntExceptions(X); none ),
	write('    DATA'), nl, 
		( dataBody(X,_,_) -> createIntData(X); none ),
	write('  OBJECT_CONTROL_STRUCTURE'), nl, none,
	write('  OPERATION_CONTROL_STRUCTURES'), nl,
		( ( operationisBody(X,_,_,_); defineArgsSpec(X,_,_); defineArgsBody(X,_,_) ) -> createOPCS(X); none ).
 
/*``ods``Fri May 31 18:07:11 MET DST 2002``*/
/* createNotTermInternals(X) */

createNotTermInternals(X) :- 
	write('  INTERNALS'), nl,
	write('    OBJECTS'), nl, 
		( children(X,_) -> createChildren(X); none ),
	write('    TYPES'), nl, 
		( typeRenameSpec(X,_,_) -> createTyImpBy(X); none ), 
	write('    CONSTANTS'), nl, 
		( constantRenamesSpec(X,_,_) -> createCoImpBy(X); none ), 
	write('    OPERATIONS'), nl, 
		( operationRenameSpec(X,_,_,_) -> createOpImpBy(X); none ),
	write('    EXCEPTIONS'), nl, 
		( exceptionRenameSpec(X,_,_) -> createExImpBy(X); none ), 
	write('    DATA'), nl, 
		( dataRenameSpec(X,_,_) -> createDaImpBy(X); none ),
	write('  OBJECT_CONTROL_STRUCTURE'), nl, none.
 
/*``ods``Fri May 31 18:07:18 MET DST 2002``*/
/* createChildren(X) */

createChildren(X) :- children(X,Y), write('      '), printName(Y), nl, fail.
createChildren(X).

/*``types``Tue May 27 12:14:03 MET DST 2003``*/
/* createProvTypes(X) */

createProvTypes(X) :- typeSpec(X,U,C), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	typeAttributes(X,U), /*(cf.REVC009)*/
	C\='', fileOrString(C),
	( ( typeCommentSpec(X,U,_); typeEnumeration(X,U,_,_) ) -> 
		( write(';'), nl ); true ), 
	( typeCommentSpec(X,U,D) -> fileOrString(D); true ), 
	typeEnum(X,U), 
	fail.
createProvTypes(X).
 
/*``types``Tue May 27 12:14:11 MET DST 2003``*/
/* createIntTypes(X) */

createIntTypes(X) :- ( typePrivate(X,U,C); typeBody(X,U,C) ),  
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	typeAttributes(X,U), /*(cf.REVC009)*/
	C\='', fileOrString(C), 
	( ( typeCommentPrivate(X,U,_); typeCommentBody(X,U,_); typeEnumeration(X,U,_,_) ) -> 
		( write(';'), nl ); true ), 
	( ( typeCommentPrivate(X,U,D); typeCommentBody(X,U,D) ) -> fileOrString(D); true ), 
	typeEnum(X,U), 
	fail. 
createIntTypes(X).
 
/*``types``Tue May 27 12:14:20 MET DST 2003``*/
/* createTyImpBy(X) */

createTyImpBy(X) :- typeRenameSpec(X,U,C), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	write('      IMPLEMENTED_BY '), write(C), nl, fail.
createTyImpBy(X).
 
/*``types``Tue May 27 12:14:28 MET DST 2003``*/
/* createRootTyImpBy(X) */
/* (cf.REVC001) */

createRootTyImpBy(X) :- typeSpec(X,U,_), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	write('      IMPLEMENTED_BY '), write(X), write('_body.'), printName(X,U), nl, fail.
createRootTyImpBy(X).
 
/*``types``Fri May 31 18:08:33 MET DST 2002``*/
/* typeAttributes(X,T) */

typeAttributes(X,T) :- attribute(X,T,_,_,_) ->  write('        ATTRIBUTES'), nl, fail.
typeAttributes(X,T) :- firstAttribute(X,T,A,B,C), createAttribute(X,T,A,B,C), fail.
typeAttributes(X,T) :- attribute(X,T,_,_,_) -> nl; true.

attribute(X,T,A,B,C) :- typeDiscriminant(X,T,A,B,C) ; typeComponent(X,T,A,B,C).
firstAttribute(X,T,A,B,C) :- attribute(X,T,A,B,C), !.
createAttribute(X,T,A,B,C) :- printAttribute(A,B,C), createOthers(X,T,A).
createOthers(X,T,A) :- attribute(X,T,D,E,F), A\=D, write(','), nl, printAttribute(D,E,F).

printAttribute(A,T,V) :- write('          '), printName(A), write(' : '), printType(T),
	( V \= '' -> ( write(' := --|'), write(V), write('|--') ); true ).
	
/* typeEnum(X,T) */
/* (cf.REVC009) */

typeEnum(X,T) :- typeEnumeration(X,T,E,V), 
	write('PRAGMA STOOD_ENUM( type => --|'), printName(X,T), 
	write('|--, name => --|'), write(E), 
	write('|--, value => --|'), write(V), 
	write('|-- )'), nl.
 
/*``constants``Tue May 27 12:13:21 MET DST 2003``*/
/* createProvConstants(X) */

createProvConstants(X) :- constantSpec(X,U,C), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	C\='', write('--|'), writeLong(C), write('|--'), nl, 
	( constantCommentSpec(X,U,_) -> 
		write(';'), constantCommentSpec(X,U,D), nl, fileOrString(D) ), 
	fail. 
createProvConstants(X) :- defineSpec(X,U,V), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	write('--|#define '), write(U), sp, writeLong(V), write('|--'), nl, 
	( defineCommentSpec(X,U,_) -> 
		write(';'), defineCommentSpec(X,U,D), nl, fileOrString(D) ), 
	fail. 
createProvConstants(X).
 
/*``constants``Tue May 27 12:13:36 MET DST 2003``*/
/* createIntConstants(X) */

createIntConstants(X) :- ( constantPrivate(X,U,C); constantBody(X,U,C) ), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	C\='', write('--|'), writeLong(C), write('|--'), nl, 
	( ( constantCommentPrivate(X,U,_); constantCommentBody(X,U,_) ) ->
		write(';'), ( constantCommentPrivate(X,U,D); constantCommentBody(X,U,D) ), nl, fileOrString(D) ), 
	fail. 
createIntConstants(X) :- defineBody(X,U,V), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	write('--|#define '), write(U), sp, writeLong(V), write('|--'), nl, 
	( defineCommentBody(X,U,_) -> 
		write(';'), defineCommentBody(X,U,D), nl, fileOrString(D) ), 
	fail. 
createIntConstants(X).
 
/*``constants``Tue May 27 12:13:46 MET DST 2003``*/
/* createCoImpBy(X) */

createCoImpBy(X) :- constantRenameSpec(X,U,C), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	write('      IMPLEMENTED_BY '), write(C), nl, fail.
createCoImpBy(X).
 
/*``constants``Tue May 27 12:13:54 MET DST 2003``*/
/* createRootCoImpBy(X) */
/* (cf.REVC001) */

createRootCoImpBy(X) :- ( constantSpec(X,U,_); defineSpec(X,U,_) ), /*(cf.REVC003)*/
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	write('      IMPLEMENTED_BY '), write(X), write('_body.'), printName(X,U), nl, fail.
createRootCoImpBy(X).
 
/*``op_sets``Wed Feb 12 14:00:18 MET 2003``*/
/* defaultOpSet(X) */

defaultOpSet(X) :- cptRst, ( operationSpec(X,_,_); defineArgsSpec(X,_,_) ), cptInc, fail. /*(cf.REVC004)*/
defaultOpSet(X) :- cptGet(I), ( I > 20 ->  $assert(hasOpSet(X)); true).
 
/*``op_sets``Fri May 31 18:12:19 MET DST 2002``*/
/* createOpSet */

createOpSet :- write('      default'), nl.
 
/*``op_sets``Fri May 31 18:12:23 MET DST 2002``*/
/* insertMemberClause */

insertMemberClause :- write('        MEMBER_OF default'), nl.
 
/*``operations``Tue May 27 11:45:22 MET DST 2003``*/
/* createProvOperations(X) */

createProvOperations(X) :- operationSpec(X,U,S), write('      '), 
	( operationisBody(X,U,S,_) -> createOpIsDecl(X,U,S); createOpDecl(X,U,S) ), 
	( hasOpSet(X) -> insertMemberClause; true ), 
	( operationCommentSpec(X,U,S,_) -> 
		write(';'), operationCommentSpec(X,U,S,D), nl, fileOrString(D) ), fail. 
createProvOperations(X) :- isMain(X), write('      '), createOpIsDecl(X,'main',_), fail. /*(cf.REVC003)*/
createProvOperations(X) :- defineArgsSpec(X,U,_), write('      '), printName(X,U), nl, /*(cf.REVC004)(cf.REVC006)*/
	( hasOpSet(X) -> insertMemberClause; true ), fail. 
createProvOperations(X).
 
/*``operations``Tue May 27 11:45:44 MET DST 2003``*/
/* createIntOperations(X) */

createIntOperations(X) :- operationBody(X,U,S), write('      '), 
	( operationisBody(X,U,S,_) -> createOpIsDecl(X,U,S); createOpDecl(X,U,S) ), 
	( operationCommentBody(X,U,S,_) -> 
		write(';'), operationCommentBody(X,U,S,D), nl, fileOrString(D) ), fail. 
createIntOperations(X) :-
	operationisBody(X,U,S,_), not(operationBody(X,U,S)), not(operationSpec(X,U,S)), 
	write('      '), createOpIsDecl(X,U,S), fail.
createIntOperations(X) :- defineArgsBody(X,U,_), write('      '), printName(X,U), nl, fail. /*(cf.REVC004)(cf.REVC006)*/
createIntOperations(X).
 
/*``operations``Mon Dec 23 15:30:40 MET 2002``*/
/* createOpImpBy(X) */

createOpImpBy(X) :- operationRenameSpec(X,U,S,C), 
	write('      '), createOpDecl(X,U,S), 
	write('      IMPLEMENTED_BY '), write(C), nl, fail.
createOpImpBy(X).
 
/*``operations``Tue May 27 11:46:17 MET DST 2003``*/
/* createRootOpImpBy(X) */
/* (cf.REVC001) */

createRootOpImpBy(X) :- operationSpec(X,U,S), 
	write('      '), ( operationisBody(X,U,S,_) -> createOpIsDecl(X,U,S); createOpDecl(X,U,S) ), 
	write('      IMPLEMENTED_BY '), write(X), write('_body.'), 
		( operationisBody(X,U,S,_) -> createOpIsDecl(X,U,S); createOpDecl(X,U,S) ), fail.
createRootOpImpBy(X) :- isMain(X), /*(cf.REVC003)*/
	write('      '), operationisBody(X,'main',S,_), createOpIsDecl(X,'main',S), 
	write('      IMPLEMENTED_BY '), write(X), write('_body.'), createOpIsDecl(X,'main',S), fail.
createRootOpImpBy(X) :- defineArgsSpec(X,U,_), /*(cf.REVC004)*/
	write('      '), printName(X,U), /*(cf.REVC006)*/
	write('      IMPLEMENTED_BY '), write(X), write('_body.'), printName(X,U), nl, fail.
createRootOpImpBy(X).
 
/*``operations``Fri May 30 09:11:07 MET DST 2003``*/
/* createOpDecl(X,U,S) */
/* (cf.REVC007) */

createOpDecl(X,U,S) :- printName(X,U), fail. /*(cf.REVC006)*/
createOpDecl(X,U,S) :- ( param(X,U,S,P,T,_,_), P\='return', notVoid(T) ) -> write(' ('), nl, fail.
createOpDecl(X,U,S) :- firstParam(X,U,S,P,T,M,V), notVoid(T), createParams(X,U,S,P,T,M,V), fail.
createOpDecl(X,U,S) :- ( param(X,U,S,P,T,_,_), P\='return', notVoid(T) ) -> write(' )'), fail.
createOpDecl(X,U,S) :- ( param(X,U,S,'return',T,_,_), notVoid(T) ) -> createReturn(T); nl. 
/*``operations``Fri May 30 09:11:47 MET DST 2003``*/
/* createOpIsDecl(X,U,S) */
/* (cf.REVC007) */

createOpIsDecl(X,U,S) :- printName(X,U), fail. /*(cf.REVC006)*/
createOpIsDecl(X,U,S) :- (paramis(X,U,S,P,T,_,_), P\='return', notVoid(T) ) -> write(' ('), nl, fail.
createOpIsDecl(X,U,S) :- firstParamIs(X,U,S,P,T,M,V), notVoid(T), createParamsIs(X,U,S,P,T,M,V), fail.
createOpIsDecl(X,U,S) :- (paramis(X,U,S,P,T,_,_), P\='return', notVoid(T)) -> write(' )'), fail.
createOpIsDecl(X,U,S) :- ( paramis(X,U,S,'return',T,_,_), notVoid(T) ) -> createReturnIs(T); nl.
 
/*``operations``Fri May 30 09:22:36 MET DST 2003``*/
/* Op parameters */

firstParam(X,U,S,P,T,M,V) :- param(X,U,S,P,T,M,V), P\='return', !.
createParams(X,U,S,P,T,M,V) :- printParam(P,T,M,V), createOthers(X,U,S,P).
createOthers(X,U,S,P) :- param(X,U,S,Q,T,M,V), Q\=P, Q\='return', 
	write(';'), nl, printParam(Q,T,M,V).
createReturn(T) :- T='' -> nl; ( nl, write('        RETURN'), printParamType('return',T), nl ). 

firstParamIs(X,U,S,P,T,M,V) :- paramis(X,U,S,P,T,M,V), P\='return', !.
createParamsIs(X,U,S,P,T,M,V) :- printParam(P,T,M,V), createOthersIs(X,U,S,P).
createOthersIs(X,U,S,P) :- paramis(X,U,S,Q,T,M,V), Q\=P, Q\='return', 
	write(';'), nl, printParam(Q,T,M,V).
createReturnIs(T) :- T='' -> nl; ( nl, write('        RETURN'), printParamType('return',T), nl ). 

printParam(P,T,M,V) :- 
	printParamName(P), 
	printParamMode(M), 
	printParamType(M,T), 
	printParamValue(V).

printParamName(P) :- 
	write('        '), printName(P), write(' : ').
printParamMode(M) :- 
	M='access' -> write('in out'); 
	M='none' -> write('in'); write(M).  
printParamType(M,T) :- /* (cf.REVC009) */
	sp, printType(T), ( M='access' -> write(' BY_POINTER'); true ).
printParamValue(V) :- V='' -> true; (write(' := --|'), write(V), write('|--')).

notVoid(T) :- T \= '', $name(T,L), not(id(L,[118,111,105,100])). /* (cf.REVC007) */
 
/*``operations``Tue May 27 12:08:58 MET DST 2003``*/
/* createOPCS(X) */

createOPCS(X) :- operationisBody(X,U,P,C), C \= '', 
	write('      OPERATION '), createOpIsDecl(X,U,P), 
	( operationisCommentBody(X,U,P,_) -> 
		( write('        DESCRIPTION '), nl, /*(cf.REVC011)*/
		  insertOPCSDescr1(X,U,P) ); true ),
	write('        CODE '), nl, ( fileOrString(C) -> true; none),
	write('      END_OPERATION '), printName(X,U), nl, fail. /*(cf.REVC006)*/
createOPCS(X) :- defineArgsSpec(X,U,C), C \=' ', /*(cf.REVC004)*/
	write('      OPERATION '), printName(X,U), nl, 
	( defineArgsCommentSpec(X,U,_) -> 
		( write('        DESCRIPTION '), nl, /*(cf.REVC011)*/
		  insertOPCSDescr2(X,U,P) ); true ),
	write('        CODE '), nl, ( macroFileOrString(U,C) -> true; none),
	write('      END_OPERATION '), printName(X,U), nl, fail.
createOPCS(X) :- defineArgsBody(X,U,C), C \=' ', /*(cf.REVC004)*/
	write('      OPERATION '), printName(X,U), nl, 
	( defineArgsCommentBody(X,U,_) -> 
		( write('        DESCRIPTION '), nl, /*(cf.REVC011)*/
		  insertOPCSDescr3(X,U,P) ); true ),
	write('        CODE '), nl, ( macroFileOrString(U,C) -> true; none),
	write('      END_OPERATION '), printName(X,U), nl, fail.
createOPCS(X).

insertOPCSDescr1(X,U,P) :- operationisCommentBody(X,U,P,D), fileOrString(D), fail.
insertOPCSDescr1(X,U,P).
insertOPCSDescr2(X,U,P) :- defineArgsCommentSpec(X,U,D), fileOrString(D), fail.
insertOPCSDescr2(X,U,P).
insertOPCSDescr3(X,U,P) :- defineArgsCommentBody(X,U,D), fileOrString(D), fail.
insertOPCSDescr3(X,U,P).
 
/*``exceptions``Tue May 27 12:09:29 MET DST 2003``*/
/* createProvExceptions(X) */

createProvExceptions(X) :- exceptionSpec(X,U), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	( exceptionCommentSpec(X,U,_) -> 
		write(';'), exceptionCommentSpec(X,U,D), nl, fileOrString(D) ), 
	fail.
createProvExceptions(X).
 
/*``exceptions``Tue May 27 12:09:50 MET DST 2003``*/
/* createIntExceptions(X) */

createIntExceptions(X) :- exceptionBody(X,U), 
	write('      '), printName(X,U), nl, warning3(U), /*(cf.REVC006)*/
	( exceptionCommentBody(X,U,_) -> 
		write(';'), exceptionCommentBody(X,U,D), nl, fileOrString(D) ), 
	fail.
createIntExceptions(X).
 
/*``exceptions``Tue May 27 12:10:22 MET DST 2003``*/
/* createExImpBy(X) */

createExImpBy(X) :- exceptionRenameSpec(X,U,C), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	write('      IMPLEMENTED_BY '), write(C), nl, fail.
createExImpBy(X).
 
/*``exceptions``Tue May 27 12:10:49 MET DST 2003``*/
/* createRootExImpBy(X) */
/* (cf.REVC001) */

createRootExImpBy(X) :- exceptionSpec(X,U,_), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	write('      IMPLEMENTED_BY '), write(X), write('_body.'), printName(X,U), nl, fail.
createRootExImpBy(X).
 
/*``data``Tue May 27 12:11:07 MET DST 2003``*/
/* createProvData(X) */

createProvData(X) :- dataSpec(X,U,C), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	C\='', write('--|'), writeLong(C), write('|--'), nl, 
	warning4(U), 
	( dataCommentSpec(X,U,_) ->
		write(';'), dataCommentSpec(X,U,D), nl, fileOrString(D) ),
	 fail. 
createProvData(X).
 
/*``data``Tue May 27 12:11:25 MET DST 2003``*/
/* createIntData(X) */

createIntData(X) :- dataBody(X,U,C), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	C\='', write('--|'), writeLong(C), write('|--'), nl, 
	( dataCommentBody(X,U,_) -> 
		write(';'), dataCommentBody(X,U,D), nl, fileOrString(D) ),
	fail. 
createIntData(X).
 
/*``data``Tue May 27 12:11:41 MET DST 2003``*/
/* createDaImpBy(X) */

createDaImpBy(X) :- dataRenameSpec(X,U,C), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	write('      IMPLEMENTED_BY '), write(C), nl, fail.
createDaImpBy(X).
 
/*``data``Tue May 27 12:12:13 MET DST 2003``*/
/* createRootDaImpBy(X) */
/* (cf.REVC001) */

createRootDaImpBy(X) :- dataSpec(X,U,_), 
	write('      '), printName(X,U), nl, /*(cf.REVC006)*/
	write('      IMPLEMENTED_BY '), write(X), write('_body.'), printName(X,U), nl, fail.
createRootDaImpBy(X).
 
/*``ods``Fri May 31 18:07:27 MET DST 2002``*/
/* createUses(X) */

hasUses(X,Y) :- ( withSpec(X,Y); withBody(X,Y) ), X\=Y, not(children(X,Y)).

createUses(X) :- hasUses(X,Y), 
	write('    default <=> '), splitName(Y,Z,_), printName(Z), nl, fail. 
createUses(X).
 
/*``ods``Fri May 31 18:07:36 MET DST 2002``*/
/* createRequires(X) */

hasRequires(X,Y) :- ( withSpec(X,Y); withBody(X,Y) ), X\=Y, not(children(X,Y)). 

createRequires(X) :- hasRequires(X,Y), 
	write('    OBJECT '), splitName(Y,Z,_), printName(Z), write(';'), nl, none, fail. 
createRequires(X).
 
/*``general``Wed May 28 14:02:59 MET DST 2003``*/
/* printing */

none :- write('      NONE'), nl.

printName(U) :- printName('',U). /*(cf.REVC006)*/
printName(_,'') :- write('MISSING_IDENTIFIER'), !. 
printName(X,U) :- 
	( ( isReserved(V), memezTra(U,V) ) -> write('sif_keyword_'); true ), 
	removePrefix(X,U,W), write(W). 

printFreeText(C) :- write(' --|'), writeLong(C), write('|--'), nl. 

printType(T) :- T \= '', /*(cf.REVC009)(cf.REVC010)*/
	( ( isReserved(V), memezTra(T,V) ) -> write('sif_keyword_'); true ), 
	$name(T,L), $member(C,L),
	( C =:= 32 -> true; 
	  C =:= 9 -> true;
	  C =:= 42 -> write('_ptr'); 
	  C =:= 91 -> true;
	  C =:= 63 -> true;
	  C =:= 93 -> write('_array'); 
	  $put(C) ), fail.
printType(T).

write(X) :- $writename(X).
writeLong(X) :- $name(X,L), $member(E,L), E =\= 13, $put(E), fail.
writeLong(X).
print(X) :- $telling(F), $told, $tell('user'), $writename(X), $tell(F,1).

fileOrString(C) :-
	write('--|'), basicFileOrString(C), write('|--'), nl.

macroFileOrString(U,C) :- /*(cf.REVC004)*/
	write('--|'), printName(U), basicFileOrString(C), write('|--'), nl.

basicFileOrString(C) :- ( $conlength(C,L), L < 4 ) -> write(C); /*(cf.REVC003)*/
	( $substring(1,4,'tmp_',0,C,_) -> ( $see(C) -> printFile; writeLong(C) ); writeLong(C) ).

bricolage(C,D) :- 
	$name(C,[116,109,112,95,C1,C2,C3,C4,C5,C6,C7,C8,X|L]), Y is X+1,
	$name(D,[116,109,112,95,C1,C2,C3,C4,C5,C6,C7,C8,Y|L]).

printFile :- $get0(C),
	( C =\= -1 -> ( ( C =\= 13 -> $put(C); true ), printFile ); $seen ).

nl :- $put(10).
tab :- $put(9).
sp :- $put(32).
dot :- $put(46).

memezTra(A,B) :- $name(A,L1), $name(B,L2), id(L1,L2).

id([],[]) :- true.
id([E|L1],[F|L2]) :- ( E =:= F ; E =:= F-32 ; E-32 =:= F ), id(L1,L2).

splitName(X,A,B) :- 
	$name(X,L1), $reverse(L1,R1), $name(X1,R1),
	$subdelim(1,'.',A2,0,X1,P) -> (
		$name(A2,R2), $reverse(R2,L2), $name(A,L2),
		$conlength(X,S), Q is S-P, $substring(1,Q,B3,P,X1,_),
		$name(B3,R3), $reverse(R3,L3), $name(B,L3) );
		( A=X, B='').

removePrefix(X,U,V) :- /*(REVC006)*/ 
	( X \= '', $name(X,Lx), $name(U,Lu), prefixed(Lx,Lv,Lu) ) -> $name(V,Lv); V=U.

prefixed([],L,[95,95|L]). /*(REVC006)(REVC009)*/
prefixed([E|Lx],Lv,[F|Lu]) :- ( E =:= F ; E =:= F-32 ; E-32 =:= F ), Lu \= [], prefixed(Lx,Lv,Lu).

addSuffix(F1,S,F2) :- $name(F1,L1), $name(S,L2), $append(L1,L2,L3), $name(F2,L3). 
 
/*``general``Fri Apr  9 11:43:17 MET DST 1999``*/
/* warnings */

warning1(U) :- $telling(F), $told, $tell('user'), 
	write('WARNING: '), write(U), 
	write(' is a reserved word for HOOD, and has been renamed into: '), 
	write(U), write('_'), nl,
	$told, $tell(F,1).

warning2(U) :- $telling(F), $told, $tell('user'), 
	write('WARNING: for parameter type: '), write(U), 
	write(' tick character was replaced by an underline character'), nl, 
	$told, $tell(F,1).
 
warning3(U) :- $telling(F), $told, $tell('user'), 
	write('WARNING: exception: '), write(U), 
	write(' has been inserted into module internals'), nl, 
	$told, $tell(F,1).

warning4(U) :- $telling(F), $told, $tell('user'), 
	write('WARNING: variable: '), write(U), 
	write(' has been inserted into module provided interface, as a constant'), nl, 
	$told, $tell(F,1).
 
/*``general``Fri May 31 18:14:15 MET DST 2002``*/
/* isReserved(U) */

isReserved('ATTRIBUTES').
isReserved('ASER_BY_IT').
isReserved('ASER').
isReserved('ACTIVE').
isReserved('ABSTRACT').
isReserved('BY_VALUE').
isReserved('BY_REFERENCE').
isReserved('BY_POINTER').
isReserved('BY_IT').
isReserved('CONSTRAINED_OPERATIONS').
isReserved('CONSTRAINED_BY').
isReserved('CONSTANTS').
isReserved('CODE').
isReserved('CLASS').
isReserved('DESCRIPTION').
isReserved('DATAFLOWS').
isReserved('DATA').
isReserved('EXCEPTION_FLOWS').
isReserved('EXCEPTIONS').
isReserved('ENVIRONMENT').
isReserved('END_OPERATION').
isReserved('END_OBJECT').
isReserved('END').
isReserved('FORMAL_PARAMETERS').
isReserved('GENERIC').
isReserved('HSER_TOER').
isReserved('HSER').
isReserved('HANDLED_EXCEPTIONS').
isReserved('IS').
isReserved('INTERNALS').
isReserved('INSTANCE_RANGE').
isReserved('INSTANCE_OF').
isReserved('INHERITED').
isReserved('INHERITANCE').
isReserved('IN').
isReserved('IMPLEMENTED_BY').
isReserved('IMPLEMENTATION_OR_SYNCHRONIZATION_CONSTRAINTS').
isReserved('IMPLEMENTATION_OR_SYNCHRONISATION_CONSTRAINTS').
isReserved('IMPLEMENTATION_CONSTRAINTS').
isReserved('LSER_TOER').
isReserved('LSER').
isReserved('MTEX').
isReserved('MEMBER_OF').
isReserved('NONE').
isReserved('OUT').
isReserved('OSTD').
isReserved('OP_CONTROL').
isReserved('OPERATION_SETS').
isReserved('OPERATION_CONTROL_STRUCTURES').
isReserved('OPERATIONS').
isReserved('OPERATION').
isReserved('OBJECT_CONTROL_STRUCTURE').
isReserved('OBJECTS').
isReserved('OBJECT').
isReserved('PSEUDO_CODE').
isReserved('PROVIDED_INTERFACE').
isReserved('PROTOCOL').
isReserved('PROPAGATED_EXCEPTIONS').
isReserved('PRAGMA').
isReserved('PASSIVE').
isReserved('PARAMETERS').
isReserved('RWER').
isReserved('ROER').
isReserved('RLSER').
isReserved('RETURN').
isReserved('REQUIRED_INTERFACE').
isReserved('RASER').
isReserved('RAISED_BY').
isReserved('STATE').
isReserved('SIF_VERSION').
isReserved('TYPES').
isReserved('TOOL_VERSION').
isReserved('TOOL_NAME').
isReserved('TO').
isReserved('TARGET_LANGUAGE').
isReserved('USED_OPERATIONS').
isReserved('VIRTUAL_NODE').

/* HRT add-ons */

isReserved('PROTECTED').
isReserved('CYCLIC').
isReserved('SPORADIC').
isReserved('REAL_TIME_ATTRIBUTES').
isReserved('WCET').
isReserved('BUDGET').
isReserved('CEILING_PRIORITY').
isReserved('PERIOD').
isReserved('OFFSET').
isReserved('MIN_ARRIVAL_TIME').
isReserved('MAX_ARRIVAL_FREQUENCY').
isReserved('DEADLINE').
isReserved('PRIORITY').
isReserved('PRECEDENCE_CONSTRAINTS').
isReserved('BEFORE').
isReserved('AFTER').
isReserved('EXECUTION_TIME_TRANSFORMATION').
isReserved('IMPORTANCE').
isReserved('HARD').
isReserved('SOFT').
isReserved('BACKGROUND').
isReserved('PAER').
isReserved('PSER').
isReserved('PSER_TOER').
isReserved('ASATC').
isReserved('LSATC').
isReserved('HSATC').
isReserved('LSATC_TOER').
isReserved('HSATC_TOER').
isReserved('INTEGRITY'). /*REVC008*/
 
/*``general``Thu Mar 29 18:02:48 MET DST 2001``*/
/* counter */

cptRst :- $globalset(cpt(0)).
cptPut(I) :- $globalset(cpt(I)).
cptGet(I) :- cpt(I).
cptInc :- cpt(I), J is I + 1, $globalset(cpt(J)).
cptDec :- cpt(I), J is I - 1, $globalset(cpt(J)).
cptAdd(I) :- cpt(J), K is J + I, $globalset(cpt(K)).
cptSub(I) :- cpt(J), K is J - I, $globalset(cpt(K)).
cptMul(I) :-  cpt(J), K is J * I, $globalset(cpt(K)).
cptDiv(I) :- cpt(J), K is J // I, $globalset(cpt(K)).
cptNeg :- cpt(I), J is -I, $globalset(cpt(J)).

