#!/bin/sh
# reverse/c/go.sh
# C reverse engineering utility
# Stood v5.0 - TNI Europe - May 2004

# arguments:
# $1 : This directory
# $2 : C source directory
# $3 : C unit name
# $4 : SIF filename

SPEC=$CSPECSUFFIX
BODY=$CBODYSUFFIX

cd "$2"

if test -f "$3.pro"
  then rm "$3.pro"
fi

if test -f external.pro
  then EXTERNAL_HIERARCHY=TRUE
fi

if test -f "$3.log"
  then rm "$3.log"
fi

if test -f "$3.tra"
  then rm "$3.tra"
fi

PATH=$C_PATH:$PATH
export PATH

for file in `ls *$BODY`
do 
  gcc $REVERSE_OPTIONS -E -C -dD $file | "$STOODBIN/crev" -sp -tf "$3.tra" >> "$3.pro"
done 

PREDICATS="$3.pro"
export PREDICATS

EXTERNAL_FACTS=external.pro
export EXTERNAL_FACTS

SIMPATH="$STOODPRO/modlib":"$STOODPRO/lib":"$STOODPRO/cmplib"
export SIMPATH

SIFFILE="$4"
export SIFFILE

ROOT_UNIT="$3"
export ROOT_UNIT

"$STOODBIN/sbprolog" -m $SBPROLOG_M_SIZE -p $SBPROLOG_P_SIZE "$1/Input.sbp" >> "$3.log"

echo > tmp.log
cp "$4" "$3.sif"
rm tmp*

if test -z "$EXTERNAL_HIERARCHY"
  then if test -f external.pro
    then rm external.pro
  fi
fi

