/* <begin HeaderTxt sequencer>
<end>                                                                         */
/* Begin Body of sequencer                                                    */
/* <begin c::BodyHeader sequencer>                                            */
/* <end>                                                                      */
/* ---------- include provided interface: ----------------------------------- */
#include "sequencer.h"
/* ---------- include required interface: ----------------------------------- */
#include "motor.h"
#include "user_interface.h"
#include "display_unit.h"
#include "heater.h"
#include "timer.h"

/* ---------- internal operations: ------------------------------------------ */
static void cycle_heater(void);

/* ---------- provided operation bodies: ------------------------------------ */
/* <begin OpDecl sequencer exec>                                              */
int sequencer__exec(int argc, char *argv[ ])
/* <end>                                                                      */
/* <begin c::OpDef sequencer exec>                                            */
{ 
  int running = 1;
  motor__modes current_order = stopped;
  while (running)
  { 
    current_order = user_interface__check_orders();
    switch (current_order)
    { 
      case stopped : 
      {
        motor__switch_off();
        display_unit__display_speed("off");
        display_unit__display_status("off");
        heater__turn_off();
      }
      case low :
      {
        motor__switch_low();
        display_unit__display_speed("low");
        display_unit__display_status("on");
        cycle_heater();
      }
      case high:
      {
        motor__switch_high();
        display_unit__display_speed("high");
        display_unit__display_status("on");
        cycle_heater();
      }
    }
  }
}
/* <end>                                                                      */

/* ---------- internal operation bodies: ------------------------------------ */
/* <begin OpDecl sequencer cycle_heater>                                      */
static void cycle_heater(void)
/* <end>                                                                      */
/* <begin c::OpDef sequencer cycle_heater>                                    */
{ 
  heater__turn_on();
  timer__wait(30);
  heater__turn_off();
}
/* <end>                                                                      */


/* End Body of sequencer                                                      */
