// SPEC OF MODULE : basicClasses
#ifndef INCLUDE_spec_basicClasses
#define INCLUDE_spec_basicClasses
// ========== visibility on required modules : 
// NESTED MODULE : Root
// ---------- provided types and constants : 
class Root
{
public :
	const int pid; 
private:
	static int idCounter;
public:
	Root() : pid(idCounter++) { };
};

// NESTED MODULE : Link
// ---------- provided types and constants : 
class Link : public Root
{
public:
	int data;
	Link* next; 
public:
	Link(const int d) : data(d), next(0) { };
};

// NESTED MODULE : Iterator
// ---------- provided types and constants : 
class Iterator : public Root
{ 
public:
	virtual int more() = 0;
	virtual int next() = 0;
};

// NESTED MODULE : AbstractList
// ---------- provided types and constants : 
class AbstractList : public Root
{ 
public:
	virtual void insert(const int d) = 0;
	virtual Iterator &getIterator() = 0;
};

// END OF MODULE : basicClasses
#endif
