--  visibility on required modules : 
with dash_board;
 use dash_board;
with clocks.accurate_clocks;
use type clocks.accurate_clocks.Accurate_Clock;
with instr;
use type instr.Clock;
use type instr.Gauge;
use type instr.Speedometer;
use type instr.Graphic_Gauge;
use type instr.Chronometer;
with gnat.io;
 use gnat.io;
with instruments;
use type instruments.Acc;
package body car is
  package accurate_clocks renames clocks.accurate_clocks;
  package io renames gnat.io;
  procedure Print_Dash_Board (L : IN pList);
  DB : pList := Nil;
  procedure run is
  	Inc, Sec : Integer; 
  begin
  	DB := 	Append(new instr.Speedometer,			-- 1
  			Append(new instr.Gauge,					-- 2
  			Append(new instr.Graphic_Gauge,			-- 3
  			Append(new instr.Graphic_Gauge,			-- 4
  			Append(new instr.Clock,					-- 5
  			Append(new instr.Chronometer,				-- 6
  			Append(new accurate_clocks.Accurate_Clock)))))));	-- 7
   
  	Instruments.Set_Name(Element(DB, 1).all, "Speed");
  	Instruments.Set_Name(Element(DB, 2).all, "Fuel");
  	Instruments.Set_Name(Element(DB, 3).all, "Water");
  	Instruments.Set_Name(Element(DB, 4).all, "Oil");
  	Instruments.Set_Name(Element(DB, 5).all, "Time in NY");
  	Instruments.Set_Name(Element(DB, 6).all, "Chrono");
  	Instruments.Set_Name(Element(DB, 7).all, "Time in Brest");
  	
  	Instr.Speedometer(Element(DB, 1).all).Value := 45; -- mph
  	Instr.Gauge(Element(DB, 2).all).Value := 60; -- %
  	Instr.Graphic_Gauge(Element(DB, 3).all).Value := 80; -- %
  	Instr.Graphic_Gauge(Element(DB, 4).all).Value := 40; -- %
  
  	Instr.Init(Instr.Clock(Element(DB, 5).all), 12, 15, 0);
  	Instr.Init(Instr.Chronometer(Element(DB, 6).all), 0, 0, 0);
  	accurate_clocks.Init(accurate_clocks.Accurate_Clock(Element(DB, 7).all), 6, 15, 0);
  
  	loop
  		Print_Dash_Board(DB);
  		if Instr.Graphic_Gauge(Element(DB, 3).all).Value < 60 then
  			Put_Line("There is a leak in the radiator.");
  		end if;
  		if Instr.Speedometer(Element(DB, 1).all).Value > 50 then
  			Put_Line("Speed limit is 50 mph ...");
  		end if;
  		if Instr.Clock(Element(DB, 5).all).Seconds 
  			/= accurate_clocks.Accurate_Clock(Element(DB, 7).all).Seconds
  		then
  			Put_Line("Your first clock is not very accurate.");
  		end if;
  
  		Put("Give a time increment in milliseconds (0 to terminate) : ");
  		Get(Inc);
  		exit when Inc <= 0;
  		Sec := Inc / 1000;
  		Instr.Increment(Instr.Clock(Element(DB, 5).all), Sec);
  		Instr.Increment(Instr.Chronometer(Element(DB, 6).all), Sec);
  		accurate_clocks.Increment(accurate_clocks.Accurate_Clock
  			(Element(DB, 7).all), Inc);
  
  		Instr.Gauge(Element(DB, 2).all).Value :=
  			Integer(Float(Instr.Gauge(Element(DB, 2).all).Value)
  				* (1.0 - Float(Sec)/3600.0));
  
  		Instr.Graphic_Gauge(Element(DB, 3).all).Value :=
  			Integer(Float(Instr.Graphic_Gauge(Element(DB, 3).all).Value)
  				* (1.0 - Float(Sec)/600.0));
  
  		Instr.Speedometer(Element(DB, 1).all).Value :=
  			Instr.Speedometer(Element(DB, 1).all).Value + 2;
  
  	end loop;
  exception
  	when others => Put_Line("I think that's enough for today... Kenavo");
  end run;
  procedure Print_Dash_Board (L : IN pList) is
  	L1 : pList := L;
  	A : Instruments.Acc;
  begin 
  	while L1 /= Nil loop
  		A := Element(L1);
  		Instruments.Display_Value(A.all);
  		L1 := Tail(L1);
  	end loop;
  	New_line;
  end Print_Dash_Board;
end car;
