// BODY OF MODULE : lists
// ========== visibility on specification file : 
#include "lists.h"
// ========== visibility on required modules : 
// NESTED MODULE : ListIterator
// ---------- provided operation bodies : 
int ListIterator::more()
{
	return current != 0;
};

int ListIterator::next()
{
	int r = current->data; current = current->next; return r;
};

// NESTED MODULE : List
// ---------- provided operation bodies : 
void List::insert(const int d)
{
	if (head == 0)
		head = new Link(d);
	else {
		Link* p;
		for (p = head; p->next != 0; p = p->next);
		p->next = new Link(d);
	}
};

Iterator &List::getIterator()
{
	return *(new ListIterator(this));
};

// NESTED MODULE : SortedList
// ---------- provided operation bodies : 
void SortedList::insert(const int d)
{
	insertBetween(head, d);
};

int SortedList::before(int a, int b)
{
	if (up)
		return a < b;
	else
		return a > b;
};

void SortedList::insertBetween(Link *&p, int d)
{
	if (p == 0)
		p = new Link(d);
	else if (before(p->data, d))
		insertBetween(p->next, d);
	else {
		Link* q = new Link(d);
		q->next = p;
		p = q;
	}
};

// NESTED MODULE : KeyedList
// END OF MODULE : lists
