// SPEC OF MODULE : lists
#ifndef INCLUDE_spec_lists
#define INCLUDE_spec_lists
// ========== visibility on required modules : 
#include "../../basicClasses/_cpp/basicClasses.h"
class ListIterator;
// NESTED MODULE : List
// ---------- provided types and constants : 
class List : public AbstractList
{
protected:
	friend class ListIterator;
	Link* head;
public:
	List() : head(0) { };
	virtual void insert(const int d);
	virtual Iterator &getIterator();
};

// NESTED MODULE : ListIterator
// ---------- provided types and constants : 
class ListIterator : public Iterator
{
private:
	List* iterated;
	Link* current;
public:
	ListIterator(List *il) : iterated(il), current(il->head) { };
	int more();
	int next();
};

// NESTED MODULE : SortedList
// ---------- provided types and constants : 
class SortedList : public List
{
protected:
	int up; 
public:
	SortedList(int u) : up(u) { };
	void insert(const int d);
protected:
	int before(int a, int b);
	void insertBetween(Link *&p, int d);
};

// NESTED MODULE : KeyedList
// ---------- provided types and constants : 
class KeyedList : public SortedList
{
public:
	KeyedList() : SortedList(1) { };
};

// END OF MODULE : lists
#endif
