--  visibility on required modules : 
package bank is
  subtype Customer_Type is String;
  N_Customer_IDs : constant := 20;
  type Customer_ID      is range 0 .. N_Customer_IDs;
  subtype Password_Type is String;
  function Balance (me : IN Customer_Type; Password : IN Password_Type) return Integer;
  procedure Create (me : IN Customer_Type; Password : IN Password_Type; Deposit : IN Positive);
  procedure Deposit (me : IN Customer_Type; Amount : IN Positive);
  procedure Withdraw (me : IN Customer_Type; Password : IN Password_Type; Amount : IN Positive);
  function Is_Activated (me : IN Customer_ID) return Boolean;
  function Get_Customer (me : IN Customer_ID) return Customer_Type;
  function Get_Password (me : IN Customer_ID) return Password_Type;
  function Get_Balance (me : IN Customer_ID) return Integer;
  Wrong_Password : exception;
  No_More_IDs : exception;
  Wrong_Donator : exception;
  Wrong_Customer : exception;
end bank;
