-- Dining Philosophers - Ada 95 edition
-- 
-- Philosopher is an Ada 95 task type with discriminant.
-- 
-- Michael B. Feldman, The George Washington University, July 1995.
-- HOOD version by Pierre Dissaux, TNI, June 1998.


--  required interface : 
--   Required OPERATION :
--     OPERATION : report_state of object : room
--     OPERATION : get_stick of object : room
--     OPERATION : pick_up of object : chop
--     OPERATION : put_down of object : chop
--   Required EXCEPTION : NONE
--   Required TYPE :
--     TYPE : Unique_DNA_Codes of object : society
--     TYPE : Positive of object : standard
--     TYPE : Duration of object : standard
--   Required CONSTANT : NONE
--   Required DATA : NONE

--  visibility on required modules : 
with society;
use type society.Unique_DNA_Codes;

package phil is

  task type Philosopher (My_ID : society.Unique_DNA_Codes)  is 

    entry start_eating (
      Who_Am_I : IN Society.Unique_DNA_Codes; 
      Chopstick1 : IN Positive; 
      Chopstick2 : IN Positive);
  end Philosopher;

  type Philosopher_Ptr is access all Philosopher;

  type States is (
    Breathing, Thinking, Eating, Done_Eating, 
    Got_One_Stick, Got_Other_Stick, Dying);

  procedure start_eating (
    me : IN OUT Philosopher; 
    Who_Am_I : IN Society.Unique_DNA_Codes; 
    Chopstick1 : IN Positive; 
    Chopstick2 : IN Positive);

end phil;
