A few changes in initial source code were required to fit HOOD4 design rules:
- Sticks variable was initially declared within package spec, which is forbidden with HOOD, so it was moved into package body, and an additional access function (Get_Stick) may be used to pick_up on one of the five chopsticks.
- As chopsticks are instances of a  protected type, which is thus a limited type, they cannot be returned directly by an access function. Sticks thus became an array of pointers on chopsticks.
- To comply with standard HOOD code generation rules, task entries are not directly called from outside. Remote clients should call Room.Start_Serving and Room.Report_State which remame task entries of the same name. For the same reason, relevant bodies are implemented into additional internal OPCS_Start_serving and OPCS_Report_State procedures.
- Within original code, main control task was called "Maitre_D". Its name become "OBCS" when generated from a HOOD design. Task body is also automatically generated from STD and operation constraints: this implies changes to code structure.