packageSpec('Auto_Simulator', '_root_').
withSpec('Auto_Simulator', 'Aiu').
withSpec('Auto_Simulator', 'Asu').
withSpec('Auto_Simulator', 'Tu').
packageCommentSpec('Auto_Simulator', '  pragma Elaborate_Body;
').
constantSpec('Auto_Simulator', 'Throttle_Limit', ' constant Aiu.Millimeters := Max_Throttle;').
operationSpec('Auto_Simulator', 'Accelerate_Body', ':Aiu.Millimeters').
param('Auto_Simulator', 'Accelerate_Body', ':Aiu.Millimeters',
	'Setting', 'Aiu.Millimeters', 'none', '').
operationSpec('Auto_Simulator', 'Current_Speed', '^Aiu.Feet_Per_Second').
param('Auto_Simulator', 'Current_Speed', '^Aiu.Feet_Per_Second',
	'return', 'Aiu.Feet_Per_Second', 'out', '').
packageRename('_root_', 'Aiu', 'Automobile_Interface_Units').
packageRename('_root_', 'Asu', 'Auto_Simulator_Units').
operationisBody('Automobile_Interface', 'Engine', '^Aiu.Rev_Per_Minute', '
begin
  return +0; -- Placeholder for now
end Engine;').
paramis('Automobile_Interface', 'Engine', '^Aiu.Rev_Per_Minute',
	'return', 'Aiu.Rev_Per_Minute', 'out', '').
operationisCommentBody('Automobile_Interface', 'Engine', '^Aiu.Rev_Per_Minute', ' Placeholder for now
').
operationisBody('Automobile_Interface', 'Speed', '^Aiu.Feet_Per_Second', '
begin
  return Mid_Sized_Auto.Current_Speed;
end Speed;').
paramis('Automobile_Interface', 'Speed', '^Aiu.Feet_Per_Second',
	'return', 'Aiu.Feet_Per_Second', 'out', '').
operationisBody('Automobile_Interface', 'Gas_Pedal', '^Aiu.Millimeters', 'begin
    if Unprocessed_Command then
      if Command_Was_Received(More_Gas) then
        Command_Was_Received(More_Gas) := False;
        Unprocessed_Command := False;
        Gas := Gas + (+1);
        if Gas > Mid_Sized_Auto.Throttle_Limit then
          Gas := Mid_Sized_Auto.Throttle_Limit;
        end if;
        Brake_Is_On := False;
      elsif Command_Was_Received(Less_Gas) then
        Command_Was_Received(Less_Gas) := False;
        Unprocessed_Command := False;
        Gas := Gas - (+1);
        if Gas < +0 then
          Gas := +0;
        end if;
        Brake_Is_On := False;
      end if;
    end if;
    return Gas;
  end Gas_Pedal;').
paramis('Automobile_Interface', 'Gas_Pedal', '^Aiu.Millimeters',
	'return', 'Aiu.Millimeters', 'out', '').
operationisBody('Automobile_Interface', '', '^Aiu.Millimeters', 'tmp_Automobile_Interface00').
paramis('Automobile_Interface', '', '^Aiu.Millimeters',
	'return', 'Aiu.Millimeters', 'out', '').
packageBody('Automobile_Interface').
withBody('Automobile_Interface', 'Ada.Integer_Text_Io').
withBody('Automobile_Interface', 'Ada.Text_Io').
withBody('Automobile_Interface', 'Di').
withBody('Automobile_Interface', 'Interfaces').
withBody('Automobile_Interface', 'Keyboard').
typeEnumeration('Automobile_Interface', 'Command_Kind', 'Toggle_Brake').
typeEnumeration('Automobile_Interface', 'Command_Kind', 'Set_Desired_Speed').
typeEnumeration('Automobile_Interface', 'Command_Kind', 'Resume_Desired_Speed').
typeEnumeration('Automobile_Interface', 'Command_Kind', 'Turn_Control_Off').
typeEnumeration('Automobile_Interface', 'Command_Kind', 'More_Gas').
typeEnumeration('Automobile_Interface', 'Command_Kind', 'Less_Gas').
typeBody('Automobile_Interface', 'Command_Kind', 'type Command_Kind is 
      (Toggle_Brake, 
       Set_Desired_Speed, 
       Resume_Desired_Speed, 
       Turn_Control_Off, 
       More_Gas, 
       Less_Gas);').
typeCommentBody('Automobile_Interface', 'Command_Kind', ' This body lets a user at a terminal interactively test the
 performance of a cruise control algorithm.
').
dataBody('Automobile_Interface', 'Brake_Was_On', ' Boolean := True;').
dataBody('Automobile_Interface', 'Brake_Is_On', ' Boolean := False;').
dataBody('Automobile_Interface', 'Cruise_Control_Was_On', ' Boolean := True;').
dataBody('Automobile_Interface', 'Gas', ' Aiu.Millimeters := +0;').
dataBody('Automobile_Interface', 'Last_Gas', ' Aiu.Millimeters := Aiu.Type_Convert(Di.Last);').
dataBody('Automobile_Interface', 'Last_Mph', ' Integer_32 := Integer_32''First;').
dataBody('Automobile_Interface', 'Last_Throttle_Setting', ' Aiu.Millimeters := Type_Convert(Di.Last);').
dataBody('Automobile_Interface', 'Command_Was_Received', ' array (Command_Kind) of Boolean := (others => False);').
dataBody('Automobile_Interface', 'Throttle_Setting', ' Aiu.Millimeters := +0;').
dataBody('Automobile_Interface', 'Unprocessed_Command', ' Boolean := False;').
operationisBody('Automobile_Interface', 'Brake', '^Boolean', 'begin
    if Unprocessed_Command and then Command_Was_Received(Toggle_Brake) then
      Command_Was_Received(Toggle_Brake) := False;
      Unprocessed_Command := False;
      Brake_Is_On := not Brake_Is_On;
    end if;
    if Brake_Is_On /= Brake_Was_On then
      Put("Brake is ");
      if Brake_Is_On then
        Put_Line("On");
      else
        Put_Line("Off");
      end if;
    end if;
    Brake_Was_On := Brake_Is_On;
    if Brake_Is_On then
      Gas := +0;
      return True;
    else
      return False;
    end if;
  end Brake;').
paramis('Automobile_Interface', 'Brake', '^Boolean',
	'return', 'Boolean', 'out', '').
operationisBody('Automobile_Interface', 'Cruise_Control', ':Boolean:Aiu.Feet_per_second', 'begin
    if On /= Cruise_Control_Was_On then
      Cruise_Control_Was_On := On;
      Put("Cruise Control is ");
      if On then
        Put("On, Cruising speed = ");
        Put(Integer(Aiu.Dimensionless(Speed) * 60 / 88), Width => 0);
        Put_Line(" mph");
      else
        Put_Line("Off");
      end if;
    end if;
  end Cruise_Control;').
paramis('Automobile_Interface', 'Cruise_Control', ':Boolean:Aiu.Feet_per_second',
	'On', 'Boolean', 'none', '').
paramis('Automobile_Interface', 'Cruise_Control', ':Boolean:Aiu.Feet_per_second',
	'Speed', 'Aiu.Feet_per_second', 'none', '').
operationisCommentBody('Automobile_Interface', 'Cruise_Control', ':Boolean:Aiu.Feet_per_second', ' display state of Cruise Control
').
operationisBody('Automobile_Interface', 'Cruise_Off', '^boolean', 'begin
    if Unprocessed_Command and then Command_Was_Received(Turn_Control_Off) then
      Command_Was_Received(Turn_Control_Off) := False;
      Unprocessed_Command := False;
      return True;
    end if;
    return False;
  end Cruise_Off;').
paramis('Automobile_Interface', 'Cruise_Off', '^boolean',
	'return', 'boolean', 'out', '').
operationisSeparate('Automobile_Interface', 'Engine').
operationisBody('Automobile_Interface', 'Resume', '^Boolean', 'begin
    if Unprocessed_Command and then Command_Was_Received(Resume_Desired_Speed) then
      Command_Was_Received(Resume_Desired_Speed) := False;
      Unprocessed_Command := False;
      return True;
    end if;
    return False;
  end Resume;').
paramis('Automobile_Interface', 'Resume', '^Boolean',
	'return', 'Boolean', 'out', '').
operationisCommentBody('Automobile_Interface', 'Resume', '^Boolean', ' This function depends on the auto simulator.
').
operationisBody('Automobile_Interface', 'Set_Speed', '^Boolean', 'begin
    if Unprocessed_Command and then Command_Was_Received(Set_Desired_Speed) then
      Command_Was_Received(Set_Desired_Speed) := False;
      Unprocessed_Command := False;
      return True;
    end if;
    return False;
  end Set_Speed;').
paramis('Automobile_Interface', 'Set_Speed', '^Boolean',
	'return', 'Boolean', 'out', '').
operationisSeparate('Automobile_Interface', 'Speed').
operationisBody('Automobile_Interface', 'Speedometer', ':Aiu.Feet_per_second', 'Mph : Integer_32;
  begin
    -- Show Gas, Brake, and Throttle diagnostic info first.
    if Gas /= Last_Gas then
      Last_Gas := Gas;
      Put("Gas = ");
      Put(Integer(Aiu.Dimensionless(Gas)), Width => 0);
      New_Line;
    end if;
    if Throttle_Setting /= Last_Throttle_Setting then
      Last_Throttle_Setting := Throttle_Setting;
      Put("Throttle = ");
      Put(Integer(Aiu.Dimensionless(Throttle_Setting)), Width => 0);
      New_Line;
    end if;
    -- 88 feet/sec = 60 MPH
    Mph := (Aiu.Dimensionless(Speed) * 60) / 88;
    if Mph /= Last_Mph then
      Put("Speed = ");
      Put(Integer(Mph), Width => 0);
      New_Line;
    end if;
    Last_Mph := Mph;
  end Speedometer;').
paramis('Automobile_Interface', 'Speedometer', ':Aiu.Feet_per_second',
	'Speed', 'Aiu.Feet_per_second', 'none', '').
operationisCommentBody('Automobile_Interface', 'Speedometer', ':Aiu.Feet_per_second', ' This function depends on the auto simulator.
 Show Gas, Brake, and Throttle diagnostic info first.
 88 feet/sec = 60 MPH
').
operationisSeparate('Automobile_Interface', 'Throttle').
operationisBody('Automobile_Interface', 'Update_Driver_Inputs', '', 'tmp_Automobile_Interface01').
operationisCommentBody('Automobile_Interface', 'Update_Driver_Inputs', '', ' This function depends on the auto simulator.
 Gets the next command available, if any.
 If we already know there is an unprocessed command,
 then don''t bother to check.
 Throw away invalid input keys.
').
operationisBody('Automobile_Interface', 'Write_Header', '', 'begin
    Put_Line("Command syntax: <command_letter>[<repeat_count>]");
    Put_Line("S = Set Desired Speed");
    Put_Line("R = Resume Previous Speed");
    Put_Line("O = Turn Cruise Control Off");
    Put_Line("M = More Gas");
    Put_Line("L = Less Gas");
    Put_Line("B = Brake On/Off");
    Put_Line("D = Delay (no command for one cycle)");
    Put_Line("Q to quit");
    New_Line;
  end Write_Header;').
packageSpec('Automobile_Interface', '_root_').
withSpec('Automobile_Interface', 'Aiu').
packageCommentSpec('Automobile_Interface', 'pragma Elaborate_All (Aiu);
  pragma Elaborate_Body;
 Cruise control buttons.
').
operationSpec('Automobile_Interface', 'Cruise_Off', '^Boolean').
param('Automobile_Interface', 'Cruise_Off', '^Boolean',
	'return', 'Boolean', 'out', '').
operationSpec('Automobile_Interface', 'Resume', '^Boolean').
param('Automobile_Interface', 'Resume', '^Boolean',
	'return', 'Boolean', 'out', '').
operationSpec('Automobile_Interface', 'Set_Speed', '^Boolean').
param('Automobile_Interface', 'Set_Speed', '^Boolean',
	'return', 'Boolean', 'out', '').
operationSpec('Automobile_Interface', 'Brake', '^Boolean').
param('Automobile_Interface', 'Brake', '^Boolean',
	'return', 'Boolean', 'out', '').
operationCommentSpec('Automobile_Interface', 'Brake', '^Boolean', ' Sensors.
').
operationSpec('Automobile_Interface', 'Engine', '^Aiu.Rev_Per_Minute').
param('Automobile_Interface', 'Engine', '^Aiu.Rev_Per_Minute',
	'return', 'Aiu.Rev_Per_Minute', 'out', '').
operationSpec('Automobile_Interface', 'Speed', '^Aiu.Feet_Per_Second').
param('Automobile_Interface', 'Speed', '^Aiu.Feet_Per_Second',
	'return', 'Aiu.Feet_Per_Second', 'out', '').
operationSpec('Automobile_Interface', 'Throttle', ':Aiu.Millimeters').
param('Automobile_Interface', 'Throttle', ':Aiu.Millimeters',
	'Setting', 'Aiu.Millimeters', 'none', '').
operationCommentSpec('Automobile_Interface', 'Throttle', ':Aiu.Millimeters', ' Controls.
').
operationSpec('Automobile_Interface', 'Cruise_Control', ':Boolean:Aiu.Feet_Per_Second').
param('Automobile_Interface', 'Cruise_Control', ':Boolean:Aiu.Feet_Per_Second',
	'On', 'Boolean', 'none', '').
param('Automobile_Interface', 'Cruise_Control', ':Boolean:Aiu.Feet_Per_Second',
	'Speed', 'Aiu.Feet_Per_Second', 'none', '').
operationCommentSpec('Automobile_Interface', 'Cruise_Control', ':Boolean:Aiu.Feet_Per_Second', ' Displays.
').
operationSpec('Automobile_Interface', 'Speedometer', ':Aiu.Feet_Per_Second').
param('Automobile_Interface', 'Speedometer', ':Aiu.Feet_Per_Second',
	'Speed', 'Aiu.Feet_Per_Second', 'none', '').
operationCommentSpec('Automobile_Interface', 'Speedometer', ':Aiu.Feet_Per_Second', ' Shows if the cruise control is on or off and what the cruising 
 speed is if it is on.
').
operationSpec('Automobile_Interface', 'Update_Driver_Inputs', '').
operationCommentSpec('Automobile_Interface', 'Update_Driver_Inputs', '', ' Simulation.
').
exceptionSpec('Automobile_Interface', 'Quit').
exceptionCommentSpec('Automobile_Interface', 'Quit', ' Update_Driver_Inputs must be called every cycle.
').
packageBody('Automobile_Interface_Units').
withBody('Automobile_Interface_Units', 'Interfaces').
operationisBody('Automobile_Interface_Units', '"*"', ':Feet_Per_Second:Tu.Milliseconds^Millimeters', 'Speed : Float;
    Time : Float;
    Distance : Float;
  begin
    Speed := Float(Dimensionless(Left));
    Time := Float(Tu.Dimensionless(Right));
    Distance := (Speed * 30.54)
      -- millimeters per second
        * (Time / 1000.0); -- seconds
    return Type_Convert(Integer_32(Distance));
  end "*";').
paramis('Automobile_Interface_Units', '"*"', ':Feet_Per_Second:Tu.Milliseconds^Millimeters',
	'Left', 'Feet_Per_Second', 'none', '').
paramis('Automobile_Interface_Units', '"*"', ':Feet_Per_Second:Tu.Milliseconds^Millimeters',
	'Right', 'Tu.Milliseconds', 'none', '').
paramis('Automobile_Interface_Units', '"*"', ':Feet_Per_Second:Tu.Milliseconds^Millimeters',
	'return', 'Millimeters', 'out', '').
operationisCommentBody('Automobile_Interface_Units', '"*"', ':Feet_Per_Second:Tu.Milliseconds^Millimeters', ' Raised when the simulation is complete.
 (I.e., when ''Q'' or ''q'' is entered.)
 millimeters per second
 seconds
').
packageSpec('Automobile_Interface_Units', '_root_').
withSpec('Automobile_Interface_Units', 'Di').
withSpec('Automobile_Interface_Units', 'Tu').
packageCommentSpec('Automobile_Interface_Units', '  pragma Elaborate_Body;
').
typeisNew('Automobile_Interface_Units', 'Millimeters', 'Di.Units').
typeSpec('Automobile_Interface_Units', 'Millimeters', 'type Millimeters is new Di.Units;').
typeisNew('Automobile_Interface_Units', 'Feet_Per_Second', 'Di.Units').
typeSpec('Automobile_Interface_Units', 'Feet_Per_Second', 'type Feet_Per_Second is new Di.Units;').
typeisNew('Automobile_Interface_Units', 'Rev_Per_Minute', 'Di.Units').
typeSpec('Automobile_Interface_Units', 'Rev_Per_Minute', 'type Rev_Per_Minute is new Di.Units;').
operationSpec('Automobile_Interface_Units', '"*"', ':Feet_Per_Second:Tu.Milliseconds^Millimeters').
param('Automobile_Interface_Units', '"*"', ':Feet_Per_Second:Tu.Milliseconds^Millimeters',
	'Left', 'Feet_Per_Second', 'none', '').
param('Automobile_Interface_Units', '"*"', ':Feet_Per_Second:Tu.Milliseconds^Millimeters',
	'Right', 'Tu.Milliseconds', 'none', '').
param('Automobile_Interface_Units', '"*"', ':Feet_Per_Second:Tu.Milliseconds^Millimeters',
	'return', 'Millimeters', 'out', '').
packageBody('Diagnostics').
dataBody('Diagnostics', 'Loop_Start_Time', ' Seconds;').
dataCommentBody('Diagnostics', 'Loop_Start_Time', ' This body displays the performance
 of a cruise control algorithm on
 the CRT screeen.
 for Millisecond arithmetic
').
dataBody('Diagnostics', 'Loop_Stop_Time', ' Seconds;').
constantBody('Diagnostics', 'Available_Time', ' constant Seconds := Convert(Delta_T);').
operationisBody('Diagnostics', 'Open', '', 'begin
    null;
  end Open;').
operationisBody('Diagnostics', 'Start', '', 'begin
    Loop_Start_Time := Polled_Timer.Time_Used;
  end Start;').
operationisBody('Diagnostics', 'Stop', '', 'Used : Seconds;
  begin
    Loop_Stop_Time := Polled_Timer.Time_Used;
    Used := Loop_Stop_Time - Loop_Start_Time;
-- This is useless with a 1 second timer (gnat 2.04, OS/2).
--    Put("% CPU time used =");
--    Put(100.0 * Float(Dimensionless(Used)) / 
--        Float(Dimensionless(Available_Time)), Fore => 4, Aft => 2, Exp => 0);
--    New_Line;
  end Stop;').
operationisCommentBody('Diagnostics', 'Stop', '', ' This is useless with a 1 second timer (gnat 2.04, OS/2).
    Put("% CPU time used =");
    Put(100.0 * Float(Dimensionless(Used)) / 
        Float(Dimensionless(Available_Time)), Fore => 4, Aft => 2, Exp => 0);
    New_Line;
').
operationisBody('Diagnostics', 'Close', '', 'begin
    null;
  end Close;').
operationisBody('Auto_Computer', 'Do_Other_Stuff', '', '
  -- A hook for other functions that 
  -- could be added later.
begin
  null;
  -- <optional miles per gallon,
  -- miles till empty, and so on,
  -- displayed here>
  -- <optional climate control here>
  -- <optional check of doors
  -- and lights here>
  -- <optional navigation here>
end Do_Other_Stuff;').
operationisCommentBody('Auto_Computer', 'Do_Other_Stuff', '', ' A hook for other functions that 
 could be added later.
 <optional miles per gallon,
 miles till empty, and so on,
 displayed here>
 <optional climate control here>
 <optional check of doors
 and lights here>
 <optional navigation here>
').
packageRename('_root_', 'Ai', 'Automobile_Interface').
packageSpec('Diagnostics', 'Auto_Computer').
withSpec('Diagnostics', 'Ada.Text_Io').
withSpec('Diagnostics', 'Automobile_Interface').
withSpec('Diagnostics', 'Cruise').
withSpec('Diagnostics', 'Polled_Timer').
operationSpec('Diagnostics', 'Open', '').
operationSpec('Diagnostics', 'Start', '').
operationSpec('Diagnostics', 'Stop', '').
operationSpec('Diagnostics', 'Close', '').
operationisSeparate('_root_', 'Do_Other_Stuff').
operationisBody('_root_', 'Do_Other_Stuff', '', 'tmp__root_02').
operationisComment('_root_', 'Do_Other_Stuff', '', ' Start a timer that expires every Delta_T milliseconds.
Change milliseconds to seconds
 Update the simulation status of the car''s controls.
 Control speed.
 Display instruments.
').
operationisBody('Auto_Simulator', 'Brake_Force', '^Asu.Lbs', '
begin
  if Automobile_Interface.Brake then
    if Body_Speed /= +0.0 then
      declare
        Direction : Float;
      begin
        Direction := Dimensionless(Body_Speed) / abs(Dimensionless(Body_Speed));
        if +Direction /= Nan then
          return +(Direction * (Dimensionless(Max_Thrust)));
        end if;
      end;
    end if;
  end if;
  return +0.0;
end Brake_Force;').
paramis('Auto_Simulator', 'Brake_Force', '^Asu.Lbs',
	'return', 'Asu.Lbs', 'out', '').
operationisCommentBody('Auto_Simulator', 'Brake_Force', '^Asu.Lbs', 'pragma Elaborate_All(Automobile_Interface);
').
operationisBody('Auto_Simulator', 'Drag', '^Asu.Lbs', '
  Speed_Squared : Float;
begin
  Speed_Squared := Float(Dimensionless(Body_Speed))**2;
  return +(0.0343 * Speed_Squared);
end Drag;').
paramis('Auto_Simulator', 'Drag', '^Asu.Lbs',
	'return', 'Asu.Lbs', 'out', '').
operationisBody('Auto_Simulator', 'Up_Hill', '^Asu.Lbs', ' 
begin
  return +0.0; -- Placeholder for now
end Up_Hill;').
paramis('Auto_Simulator', 'Up_Hill', '^Asu.Lbs',
	'return', 'Asu.Lbs', 'out', '').
operationisCommentBody('Auto_Simulator', 'Up_Hill', '^Asu.Lbs', ' Placeholder for now
').
packageBody('Auto_Simulator').
withBody('Auto_Simulator', 'Ada.Float_Text_Io').
withBody('Auto_Simulator', 'Ada.Integer_Text_Io').
withBody('Auto_Simulator', 'Ada.Text_Io').
withBody('Auto_Simulator', 'Df').
withBody('Auto_Simulator', 'Interfaces').
typeisNew('Auto_Simulator', 'Fps', 'Df.Units').
typeBody('Auto_Simulator', 'Fps', 'type Fps is new Df.Units;').
typeisNew('Auto_Simulator', 'Fps2', 'Df.Units').
typeBody('Auto_Simulator', 'Fps2', 'type Fps2 is new Df.Units;').
typeCommentBody('Auto_Simulator', 'Fps2', ' Feet per second
').
dataBody('Auto_Simulator', 'Body_Speed', ' Fps;').
dataCommentBody('Auto_Simulator', 'Body_Speed', ' Feet per second squared
').
constantBody('Auto_Simulator', 'Coefficient_Of_Friction', ' constant Float := 0.7;').
constantBody('Auto_Simulator', 'Debug', ' constant Boolean := False;').
dataBody('Auto_Simulator', 'Max_Thrust', ' Asu.Lbs := Coefficient_Of_Friction * Car_Weight;').
operationBody('Auto_Simulator', 'Divide', ':Float:Float^Float').
param('Auto_Simulator', 'Divide', ':Float:Float^Float',
	'N', 'Float', 'none', '').
param('Auto_Simulator', 'Divide', ':Float:Float^Float',
	'D', 'Float', 'none', '').
param('Auto_Simulator', 'Divide', ':Float:Float^Float',
	'return', 'Float', 'out', '').
operationBody('Auto_Simulator', 'Push_Body_With', ':Asu.Lbs').
param('Auto_Simulator', 'Push_Body_With', ':Asu.Lbs',
	'Thrust', 'Asu.Lbs', 'none', '').
operationCommentBody('Auto_Simulator', 'Push_Body_With', ':Asu.Lbs', ' Needed here by Plus_Infinity and Nan.
').
operationisSeparate('Auto_Simulator', 'Up_Hill').
constantBody('Auto_Simulator', 'Nan', ' constant Asu.Lbs := Type_Convert(Divide(0.0, 0.0));').
constantCommentBody('Auto_Simulator', 'Nan', ' Needed here by Accelerate_Body.
 Needed here by Push_Body_With
').
constantBody('Auto_Simulator', 'Plus_Infinity', ' constant Asu.Lbs := Type_Convert(Divide(1.0, 0.0));').
operationisBody('Auto_Simulator', '"/"', ':Asu.Hp:Fps^Asu.Lbs', 'L, R : Float;
  begin
    -- 1 Hp = 550 ft-lbs/sec.
    L := Asu.Dimensionless(Left);
    R := Dimensionless(Right);
    return Asu.Type_Convert(550.0 * L / R);
  end "/";').
paramis('Auto_Simulator', '"/"', ':Asu.Hp:Fps^Asu.Lbs',
	'Left', 'Asu.Hp', 'none', '').
paramis('Auto_Simulator', '"/"', ':Asu.Hp:Fps^Asu.Lbs',
	'Right', 'Fps', 'none', '').
paramis('Auto_Simulator', '"/"', ':Asu.Hp:Fps^Asu.Lbs',
	'return', 'Asu.Lbs', 'out', '').
operationisCommentBody('Auto_Simulator', '"/"', ':Asu.Hp:Fps^Asu.Lbs', ' 1 Hp = 550 ft-lbs/sec.
').
operationisBody('Auto_Simulator', '"/"', ':Asu.Lbs:Asu.Lbs^Fps2', 'L, R : Float;
  begin
    L := Asu.Dimensionless(Left);
    R := Asu.Dimensionless(Right);
    -- One pound of force will accelerate one pound of mass
    -- at 32.2 feet per second squared.
    return Type_Convert(32.2 * L / R);
  end "/";').
paramis('Auto_Simulator', '"/"', ':Asu.Lbs:Asu.Lbs^Fps2',
	'Left', 'Asu.Lbs', 'none', '').
paramis('Auto_Simulator', '"/"', ':Asu.Lbs:Asu.Lbs^Fps2',
	'Right', 'Asu.Lbs', 'none', '').
paramis('Auto_Simulator', '"/"', ':Asu.Lbs:Asu.Lbs^Fps2',
	'return', 'Fps2', 'out', '').
operationisCommentBody('Auto_Simulator', '"/"', ':Asu.Lbs:Asu.Lbs^Fps2', ' pounds of force
 pounds of mass
 One pound of force will accelerate one pound of mass
 at 32.2 feet per second squared.
').
operationisBody('Auto_Simulator', '"*"', ':Fps2:Tu.Milliseconds^Fps', 'L, R : Float;
  begin
    L := Dimensionless(Left);
    R := Float(Tu.Dimensionless(Right));
    return Type_Convert(L * R / 1000.0);
  end "*";').
paramis('Auto_Simulator', '"*"', ':Fps2:Tu.Milliseconds^Fps',
	'Left', 'Fps2', 'none', '').
paramis('Auto_Simulator', '"*"', ':Fps2:Tu.Milliseconds^Fps',
	'Right', 'Tu.Milliseconds', 'none', '').
paramis('Auto_Simulator', '"*"', ':Fps2:Tu.Milliseconds^Fps',
	'return', 'Fps', 'out', '').
operationisBody('Auto_Simulator', 'Accelerate_Body', ':Aiu.Millimeters', 'tmp_Auto_Simulator03').
paramis('Auto_Simulator', 'Accelerate_Body', ':Aiu.Millimeters',
	'Setting', 'Aiu.Millimeters', 'none', '').
operationisCommentBody('Auto_Simulator', 'Accelerate_Body', ':Aiu.Millimeters', ' Compute horsepower created by engine.
 Convert that to thrust applied to the body.
 Evaluation may raise Numeric_Error or Constraint_Error
 *** but not in OS/2 gnat! ***
 Move the car with it.
').
operationisSeparate('Auto_Simulator', 'Brake_Force').
operationisBody('Auto_Simulator', 'Current_Speed', '^Aiu.Feet_Per_Second', 'Speed : Integer_32;
  begin
    Speed := Integer_32(Dimensionless(Body_Speed));
    return Aiu.Type_Convert(Speed);
  end Current_Speed;').
paramis('Auto_Simulator', 'Current_Speed', '^Aiu.Feet_Per_Second',
	'return', 'Aiu.Feet_Per_Second', 'out', '').
operationisBody('Auto_Simulator', 'Divide', ':Float:Float^Float', 'begin
    return N / D;
  end Divide;').
paramis('Auto_Simulator', 'Divide', ':Float:Float^Float',
	'N', 'Float', 'none', '').
paramis('Auto_Simulator', 'Divide', ':Float:Float^Float',
	'D', 'Float', 'none', '').
paramis('Auto_Simulator', 'Divide', ':Float:Float^Float',
	'return', 'Float', 'out', '').
operationisCommentBody('Auto_Simulator', 'Divide', ':Float:Float^Float', ' To work around non-overflowing IEEE arithmetic.
 (Static expressions that evaluate to +/- infinity or NaN
 are rejected.)
').
operationisSeparate('Auto_Simulator', 'Drag').
operationisBody('Auto_Simulator', 'Push_Body_With', ':Asu.Lbs', 'tmp_Auto_Simulator04').
paramis('Auto_Simulator', 'Push_Body_With', ':Asu.Lbs',
	'Thrust', 'Asu.Lbs', 'none', '').
operationisCommentBody('Auto_Simulator', 'Push_Body_With', ':Asu.Lbs', ' Simple integrator.
').
packageSpec('Auto_Simulator_Units', '_root_').
withSpec('Auto_Simulator_Units', 'Df').
typeisNew('Auto_Simulator_Units', 'Hp', 'Df.Units').
typeSpec('Auto_Simulator_Units', 'Hp', 'type Hp is new Df.Units;').
typeisNew('Auto_Simulator_Units', 'Lbs', 'Df.Units').
typeSpec('Auto_Simulator_Units', 'Lbs', 'type Lbs is new Df.Units;').
packageSpec('Compensation_Memory', '_root_').
withSpec('Compensation_Memory', 'Automobile_Interface_Units').
packageCommentSpec('Compensation_Memory', 'pragma Elaborate_All (Automobile_Interface_Units);
').
dataSpec('Compensation_Memory', 'Last_Speed', ' Automobile_Interface_Units.Feet_Per_Second := +0;').
packageBody('Cruise').
withBody('Cruise', 'Automobile_Interface').
withBody('Cruise', 'Df').
packageRenameBody('Cruise', 'Ai', 'Automobile_Interface').
typeisNew('Cruise', 'Gs', 'Df.Units').
typeBody('Cruise', 'Gs', 'type Gs is new Df.Units;').
typeCommentBody('Cruise', 'Gs', 'pragma Elaborate_All (Automobile_Interface);
').
dataBody('Cruise', 'Cruise_Control_On', ' Boolean;').
dataCommentBody('Cruise', 'Cruise_Control_On', ' Non-volatile variables
').
dataBody('Cruise', 'Desired_Speed', ' Aiu.Feet_Per_Second;').
dataBody('Cruise', 'Last_Speed', ' Aiu.Feet_Per_Second;').
dataBody('Cruise', 'Throttle_Setting', ' Aiu.Millimeters;').
operationBody('Cruise', 'Wheels_Spinning', '^Boolean').
param('Cruise', 'Wheels_Spinning', '^Boolean',
	'return', 'Boolean', 'out', '').
operationisBody('Cruise', '"/"', ':Aiu.Feet_Per_Second:Tu.Milliseconds^Gs', 'Speed : Float;
    Time : Float;
    Feet_Per_Second_Squared : Float;
  begin
    Speed := Float(Dimensionless(Left));
    Time := Float(Dimensionless(Right)) / 1000.0;
    Feet_Per_Second_Squared := Speed / Time;
    return +(Feet_Per_Second_Squared / 32.2);
  end "/";').
paramis('Cruise', '"/"', ':Aiu.Feet_Per_Second:Tu.Milliseconds^Gs',
	'Left', 'Aiu.Feet_Per_Second', 'none', '').
paramis('Cruise', '"/"', ':Aiu.Feet_Per_Second:Tu.Milliseconds^Gs',
	'Right', 'Tu.Milliseconds', 'none', '').
paramis('Cruise', '"/"', ':Aiu.Feet_Per_Second:Tu.Milliseconds^Gs',
	'return', 'Gs', 'out', '').
operationisCommentBody('Cruise', '"/"', ':Aiu.Feet_Per_Second:Tu.Milliseconds^Gs', ' Needed by Adjust_Throttle.
').
operationisBody('Cruise', 'Integrate', ':Aiu.Feet_Per_Second^Aiu.Millimeters', 'Integrated_Error : Aiu.Millimeters;
    Adjustment : Aiu.Millimeters;
  begin
    Integrated_Error := Speed * Delta_T;
    Adjustment := Integrator_Gain * Integrated_Error;
    return Throttle_Setting + Adjustment;
  end Integrate;').
paramis('Cruise', 'Integrate', ':Aiu.Feet_Per_Second^Aiu.Millimeters',
	'Speed', 'Aiu.Feet_Per_Second', 'none', '').
paramis('Cruise', 'Integrate', ':Aiu.Feet_Per_Second^Aiu.Millimeters',
	'return', 'Aiu.Millimeters', 'out', '').
operationisBody('Cruise', 'Adjust_Throttle', '', 'tmp_Cruise05').
operationisCommentBody('Cruise', 'Adjust_Throttle', '', ' Check driver''s controls.
 Note:  Could set Desired_Speed to 0 here if desired.
 Safety checks.
 Throttle has physical limits.
 Throttle_Setting = 0 when CC is off.
 Quit is expected to occur.
').
operationisBody('Cruise', 'Cruising_Speed', '^Aiu.Feet_Per_Second', 'begin
    return Desired_Speed;
  end Cruising_Speed;').
paramis('Cruise', 'Cruising_Speed', '^Aiu.Feet_Per_Second',
	'return', 'Aiu.Feet_Per_Second', 'out', '').
operationisBody('Cruise', 'Is_On', '^Boolean', 'begin
    return Cruise_Control_On;
  end Is_On;').
paramis('Cruise', 'Is_On', '^Boolean',
	'return', 'Boolean', 'out', '').
operationisBody('Cruise', 'Wheels_Spinning', '^Boolean', 'Acceleration : Gs;
    New_Speed : Aiu.Feet_Per_Second;
  begin
    New_Speed := Ai.Speed;
    Acceleration := (New_Speed - Last_Speed) / Delta_T;
    Last_Speed := New_Speed;
    -- Wheels must be spinning if apparent acceleration
    -- is greater than 1 G.
    return Acceleration > +1.0;
  end Wheels_Spinning;').
paramis('Cruise', 'Wheels_Spinning', '^Boolean',
	'return', 'Boolean', 'out', '').
operationisCommentBody('Cruise', 'Wheels_Spinning', '^Boolean', ' Wheels must be spinning if apparent acceleration
 is greater than 1 G.
').
packageSpec('Cruise', '_root_').
withSpec('Cruise', 'Aiu').
withSpec('Cruise', 'Interfaces').
withSpec('Cruise', 'Tu').
packageCommentSpec('Cruise', 'pragma Elaborate_All(Aiu);
pragma Elaborate_All(Tu);
  pragma Elaborate_Body;
').
operationSpec('Cruise', 'Adjust_Throttle', '').
operationSpec('Cruise', 'Is_On', '^Boolean').
param('Cruise', 'Is_On', '^Boolean',
	'return', 'Boolean', 'out', '').
operationCommentSpec('Cruise', 'Is_On', '^Boolean', ' Controls the throttle if the Cruise Control unit is enabled.
').
operationSpec('Cruise', 'Cruising_Speed', '^Aiu.Feet_Per_Second').
param('Cruise', 'Cruising_Speed', '^Aiu.Feet_Per_Second',
	'return', 'Aiu.Feet_Per_Second', 'out', '').
operationCommentSpec('Cruise', 'Cruising_Speed', '^Aiu.Feet_Per_Second', ' True if cruise control is enabled.
').
packageRename('_root_', 'Df', 'Dim_Float').
packageRename('_root_', 'Di', 'Dim_Int').
packageBody('FLOAT_UNITS').
operationBody('FLOAT_UNITS', 'Float_Type_Divide', ':Float_Type''Base:Float_Type''Base^Float_Type''Base').
param('FLOAT_UNITS', 'Float_Type_Divide', ':Float_Type''Base:Float_Type''Base^Float_Type''Base',
	'L', 'Float_Type''Base', 'none', '').
param('FLOAT_UNITS', 'Float_Type_Divide', ':Float_Type''Base:Float_Type''Base^Float_Type''Base',
	'R', 'Float_Type''Base', 'none', '').
param('FLOAT_UNITS', 'Float_Type_Divide', ':Float_Type''Base:Float_Type''Base^Float_Type''Base',
	'return', 'Float_Type''Base', 'out', '').
operationCommentBody('FLOAT_UNITS', 'Float_Type_Divide', ':Float_Type''Base:Float_Type''Base^Float_Type''Base', ' Returns the desired cruising speed.
 This version is specialized for non-overflowing IEEE arithmetic.
').
operationBody('FLOAT_UNITS', 'Units_Divide', ':Units:Units^Units').
param('FLOAT_UNITS', 'Units_Divide', ':Units:Units^Units',
	'L', 'Units', 'none', '').
param('FLOAT_UNITS', 'Units_Divide', ':Units:Units^Units',
	'R', 'Units', 'none', '').
param('FLOAT_UNITS', 'Units_Divide', ':Units:Units^Units',
	'return', 'Units', 'out', '').
constantBody('FLOAT_UNITS', 'Plus_Infinity_Float', ' constant Float_Type''Base := Float_Type_Divide(1.0, 0.0);').
constantBody('FLOAT_UNITS', 'Minus_Infinity_Float', ' constant Float_Type''Base := Float_Type_Divide(-1.0, 0.0);').
constantBody('FLOAT_UNITS', 'Nan_Float', ' constant Float_Type''Base := Float_Type_Divide(0.0, 0.0);').
constantBody('FLOAT_UNITS', 'Plus_Infinity_Units', ' constant Units := Units_Divide(1.0, 0.0);').
constantBody('FLOAT_UNITS', 'Minus_Infinity_Units', ' constant Units := Units_Divide(Units(Float_Type''(-1.0)), 0.0);').
constantBody('FLOAT_UNITS', 'Nan_Units', ' constant Units := Units_Divide(0.0, 0.0);').
operationisBody('FLOAT_UNITS', 'Float_Type_Divide', ':Float_Type''Base:Float_Type''Base^Float_Type''Base', 'begin
    return L / R;
  end Float_Type_Divide;').
paramis('FLOAT_UNITS', 'Float_Type_Divide', ':Float_Type''Base:Float_Type''Base^Float_Type''Base',
	'L', 'Float_Type''Base', 'none', '').
paramis('FLOAT_UNITS', 'Float_Type_Divide', ':Float_Type''Base:Float_Type''Base^Float_Type''Base',
	'R', 'Float_Type''Base', 'none', '').
paramis('FLOAT_UNITS', 'Float_Type_Divide', ':Float_Type''Base:Float_Type''Base^Float_Type''Base',
	'return', 'Float_Type''Base', 'out', '').
operationisBody('FLOAT_UNITS', 'Units_Divide', ':Units:Units^Units', 'begin
    return L / R;
  end Units_Divide;').
paramis('FLOAT_UNITS', 'Units_Divide', ':Units:Units^Units',
	'L', 'Units', 'none', '').
paramis('FLOAT_UNITS', 'Units_Divide', ':Units:Units^Units',
	'R', 'Units', 'none', '').
paramis('FLOAT_UNITS', 'Units_Divide', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', 'Type_Convert', ':Float_type^Units', 'begin
    if X = Plus_Infinity_Float then
      return Plus_Infinity_Units;
    elsif X = Minus_Infinity_Float then
      return Minus_Infinity_Units;
    elsif X = Nan_Float then
      return Nan_Units;
    else
      return Units(X);
    end if;
  end Type_Convert;').
paramis('FLOAT_UNITS', 'Type_Convert', ':Float_type^Units',
	'X', 'Float_type', 'none', '').
paramis('FLOAT_UNITS', 'Type_Convert', ':Float_type^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', '"+"', ':Float_type^Units', 'begin
    return Units(X);
  end "+";').
paramis('FLOAT_UNITS', '"+"', ':Float_type^Units',
	'X', 'Float_type', 'none', '').
paramis('FLOAT_UNITS', '"+"', ':Float_type^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', '"-"', ':Float_type^Units', 'NEG : Float_Type''Base;
  begin
    NEG := -X;
    return Units(NEG);
  end "-";').
paramis('FLOAT_UNITS', '"-"', ':Float_type^Units',
	'X', 'Float_type', 'none', '').
paramis('FLOAT_UNITS', '"-"', ':Float_type^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', '"+"', ':Units^Units', 'begin
    return RIGHT;
  end "+";').
paramis('FLOAT_UNITS', '"+"', ':Units^Units',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"+"', ':Units^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', '"-"', ':Units^Units', 'NEG : Float_Type''Base;
  begin
    NEG := -1.0 * Float_Type''Base(RIGHT);
    return Units(NEG);
  end "-";').
paramis('FLOAT_UNITS', '"-"', ':Units^Units',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"-"', ':Units^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', '"abs"', ':Units^Units', 'begin
    return Units(abs(Float_type(RIGHT)));
  end "abs";').
paramis('FLOAT_UNITS', '"abs"', ':Units^Units',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"abs"', ':Units^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', '"+"', ':Units:Units^Units', 'begin
    return Units(Float_Type''Base(LEFT) + Float_Type''Base(RIGHT));
  end "+";').
paramis('FLOAT_UNITS', '"+"', ':Units:Units^Units',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"+"', ':Units:Units^Units',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"+"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', '"-"', ':Units:Units^Units', 'begin
    return Units(Float_Type''Base(LEFT) - Float_Type''Base(RIGHT));
  end "-";').
paramis('FLOAT_UNITS', '"-"', ':Units:Units^Units',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"-"', ':Units:Units^Units',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"-"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', '"*"', ':Float_Type''Base:Units^Units', 'begin
    return Units(LEFT * Float_Type''Base(RIGHT));
  end "*";').
paramis('FLOAT_UNITS', '"*"', ':Float_Type''Base:Units^Units',
	'LEFT', 'Float_Type''Base', 'none', '').
paramis('FLOAT_UNITS', '"*"', ':Float_Type''Base:Units^Units',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"*"', ':Float_Type''Base:Units^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', '"*"', ':Units:Float_Type''Base^Units', 'begin
    return Units(Float_Type''Base(LEFT) * RIGHT);
  end "*";').
paramis('FLOAT_UNITS', '"*"', ':Units:Float_Type''Base^Units',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"*"', ':Units:Float_Type''Base^Units',
	'RIGHT', 'Float_Type''Base', 'none', '').
paramis('FLOAT_UNITS', '"*"', ':Units:Float_Type''Base^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', '"/"', ':Units:Float_Type''Base^Units', 'begin
    return Units(Float_Type''Base(LEFT) / RIGHT);
  end "/";').
paramis('FLOAT_UNITS', '"/"', ':Units:Float_Type''Base^Units',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"/"', ':Units:Float_Type''Base^Units',
	'RIGHT', 'Float_Type''Base', 'none', '').
paramis('FLOAT_UNITS', '"/"', ':Units:Float_Type''Base^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', '"/"', ':Units:Units^Float_Type''Base', 'begin
    return Float_Type''Base(LEFT) / Float_Type''Base(RIGHT);
  end "/";').
paramis('FLOAT_UNITS', '"/"', ':Units:Units^Float_Type''Base',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"/"', ':Units:Units^Float_Type''Base',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"/"', ':Units:Units^Float_Type''Base',
	'return', 'Float_Type''Base', 'out', '').
operationisBody('FLOAT_UNITS', '"<"', ':Units:Units^boolean', 'begin
    return Float_Type''Base(LEFT) < Float_Type''Base(RIGHT);
  end "<";').
paramis('FLOAT_UNITS', '"<"', ':Units:Units^boolean',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"<"', ':Units:Units^boolean',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"<"', ':Units:Units^boolean',
	'return', 'boolean', 'out', '').
operationisBody('FLOAT_UNITS', '"<="', ':Units:Units^boolean', 'begin
    return Float_Type''Base(LEFT) <= Float_Type''Base(RIGHT);
  end "<=";').
paramis('FLOAT_UNITS', '"<="', ':Units:Units^boolean',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"<="', ':Units:Units^boolean',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"<="', ':Units:Units^boolean',
	'return', 'boolean', 'out', '').
operationisBody('FLOAT_UNITS', '">"', ':Units:Units^boolean', 'begin
    return Float_Type''Base(LEFT) > Float_Type''Base(RIGHT);
  end ">";').
paramis('FLOAT_UNITS', '">"', ':Units:Units^boolean',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '">"', ':Units:Units^boolean',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '">"', ':Units:Units^boolean',
	'return', 'boolean', 'out', '').
operationisBody('FLOAT_UNITS', '">="', ':Units:Units^boolean', 'begin
    return Float_Type''Base(LEFT) >= Float_Type''Base(RIGHT);
  end ">=";').
paramis('FLOAT_UNITS', '">="', ':Units:Units^boolean',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '">="', ':Units:Units^boolean',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '">="', ':Units:Units^boolean',
	'return', 'boolean', 'out', '').
operationisBody('FLOAT_UNITS', '"/"', ':Units:Units^Integer_Type''Base', 'EXACT : Float_Type''Base;
    ROUNDED, TRUNCATED : Integer_Type''Base;
  begin
    EXACT := LEFT / RIGHT;
    ROUNDED := Integer_Type''Base(EXACT);
    if Float_Type''Base(abs(ROUNDED)) > abs(EXACT) then
      if ROUNDED > 0 then
        TRUNCATED := ROUNDED-1;
      else
        TRUNCATED := ROUNDED+1;
      end if;
    else
      TRUNCATED := ROUNDED;
    end if;
    return TRUNCATED;
  end "/";').
paramis('FLOAT_UNITS', '"/"', ':Units:Units^Integer_Type''Base',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"/"', ':Units:Units^Integer_Type''Base',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"/"', ':Units:Units^Integer_Type''Base',
	'return', 'Integer_Type''Base', 'out', '').
operationisCommentBody('FLOAT_UNITS', '"/"', ':Units:Units^Integer_Type''Base', ' divide and truncate toward zero
').
operationisBody('FLOAT_UNITS', '"rem"', ':Units:Units^Units', 'COMPLETE_CYCLES : Integer_Type''Base;
    REMAINDER       : Units;
  begin
    COMPLETE_CYCLES := LEFT / RIGHT;
    REMAINDER := LEFT - Float_Type''Base(COMPLETE_CYCLES) * RIGHT;
    return REMAINDER;
  end "rem";').
paramis('FLOAT_UNITS', '"rem"', ':Units:Units^Units',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"rem"', ':Units:Units^Units',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"rem"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', '"mod"', ':Units:Units^Units', 'REMAINDER : Units;
  begin
    REMAINDER := LEFT rem RIGHT;
    if LEFT * RIGHT > 0.0 then
      return REMAINDER;
    elsif REMAINDER = 0.0 then
      return REMAINDER;
    else
      return REMAINDER + RIGHT;
    end if;
  end "mod";').
paramis('FLOAT_UNITS', '"mod"', ':Units:Units^Units',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"mod"', ':Units:Units^Units',
	'RIGHT', 'Units', 'none', '').
paramis('FLOAT_UNITS', '"mod"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationisBody('FLOAT_UNITS', 'Dimensionless', ':Units^Float_Type''Base', 'begin
    return Float_Type''Base(LEFT);
  end Dimensionless;').
paramis('FLOAT_UNITS', 'Dimensionless', ':Units^Float_Type''Base',
	'LEFT', 'Units', 'none', '').
paramis('FLOAT_UNITS', 'Dimensionless', ':Units^Float_Type''Base',
	'return', 'Float_Type''Base', 'out', '').
operationisBody('FLOAT_UNITS', 'First', '^Float_Type''Base', 'begin
    return MIN;
  end First;').
paramis('FLOAT_UNITS', 'First', '^Float_Type''Base',
	'return', 'Float_Type''Base', 'out', '').
operationisBody('FLOAT_UNITS', 'Last', '^Float_Type''Base', 'begin
    return MAX;
  end Last;').
paramis('FLOAT_UNITS', 'Last', '^Float_Type''Base',
	'return', 'Float_Type''Base', 'out', '').
packageSpec('FLOAT_UNITS', '_root_').
packageCommentSpec('FLOAT_UNITS', '  pragma Elaborate_Body;
 This package provides useful parent types for derived
 dimensional units. That is, it makes it possible to
 do this:
 package DIMENSIONAL_FLOAT is new FLOAT_UNITS
  (Float, Integer_Type => Interfaces.Integer_32);
 type Feet is new DIMENSIONAL_FLOAT.Units;
 package TEMPERATURE is new FLOAT_UNITS
  (Float_Type => Float, MIN => -273.16, MAX => 32000.0,
  Integer_Type => integer);
 type Celsius is new TEMPERATURE.Units;
 Objects of type Feet can be added to other objects of
 type feet to produce a result in Feet, but Ada will not
 allow you to erroneously multiply objects of type Feet
 together and assign the result to another object of
 type Feet. Ada will raise CONSTRAINT_ERROR if you try
 to assign a value colder than absolute zero to an
 object of type Celsius.
').
typeSpec('FLOAT_UNITS', 'Units', 'type Units is private;').
operationSpec('FLOAT_UNITS', 'Type_Convert', ':Float_Type''Base^Units').
param('FLOAT_UNITS', 'Type_Convert', ':Float_Type''Base^Units',
	'X', 'Float_Type''Base', 'none', '').
param('FLOAT_UNITS', 'Type_Convert', ':Float_Type''Base^Units',
	'return', 'Units', 'out', '').
operationCommentSpec('FLOAT_UNITS', 'Type_Convert', ':Float_Type''Base^Units', ' Because Units are PRIVATE types, Ada can''t be sure they
 are real numbers. Therefore, she will not let you do
 this:
 TARGET_RANGE : Feet := 587.0;
 Since you have to be able to assign numeric values to
 objects of type Feet, I have given you three type
 conversion routines.
 The preferred way is to do this:
 TARGET_RANGE := Feet := Type_Convert(587.0);
 This makes it obvious to other programmers that you
 have converted a numeric literal to a special kind of
 data type.
 But if you do this a lot, your program will be filled
 with so many Type_Convert() statements that people will
 get so used to them that they will ignore them. They
 lose their value, so you might as well use an operator
 which is 11 characters shorter.
 TARGET_RANGE : Feet := +587.0; -- or -587.0;
').
operationSpec('FLOAT_UNITS', '"+"', ':Float_Type''Base^Units').
param('FLOAT_UNITS', '"+"', ':Float_Type''Base^Units',
	'X', 'Float_Type''Base', 'none', '').
param('FLOAT_UNITS', '"+"', ':Float_Type''Base^Units',
	'return', 'Units', 'out', '').
operationSpec('FLOAT_UNITS', '"-"', ':Float_Type''Base^Units').
param('FLOAT_UNITS', '"-"', ':Float_Type''Base^Units',
	'X', 'Float_Type''Base', 'none', '').
param('FLOAT_UNITS', '"-"', ':Float_Type''Base^Units',
	'return', 'Units', 'out', '').
operationSpec('FLOAT_UNITS', '"+"', ':Units^Units').
param('FLOAT_UNITS', '"+"', ':Units^Units',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '"+"', ':Units^Units',
	'return', 'Units', 'out', '').
operationSpec('FLOAT_UNITS', '"-"', ':Units^Units').
param('FLOAT_UNITS', '"-"', ':Units^Units',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '"-"', ':Units^Units',
	'return', 'Units', 'out', '').
operationSpec('FLOAT_UNITS', '"abs"', ':Units^Units').
param('FLOAT_UNITS', '"abs"', ':Units^Units',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '"abs"', ':Units^Units',
	'return', 'Units', 'out', '').
operationSpec('FLOAT_UNITS', '"+"', ':Units:Units^Units').
param('FLOAT_UNITS', '"+"', ':Units:Units^Units',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', '"+"', ':Units:Units^Units',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '"+"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationSpec('FLOAT_UNITS', '"-"', ':Units:Units^Units').
param('FLOAT_UNITS', '"-"', ':Units:Units^Units',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', '"-"', ':Units:Units^Units',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '"-"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationSpec('FLOAT_UNITS', '"*"', ':Float_Type''Base:Units^Units').
param('FLOAT_UNITS', '"*"', ':Float_Type''Base:Units^Units',
	'LEFT', 'Float_Type''Base', 'none', '').
param('FLOAT_UNITS', '"*"', ':Float_Type''Base:Units^Units',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '"*"', ':Float_Type''Base:Units^Units',
	'return', 'Units', 'out', '').
operationSpec('FLOAT_UNITS', '"*"', ':Units:Float_Type''Base^Units').
param('FLOAT_UNITS', '"*"', ':Units:Float_Type''Base^Units',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', '"*"', ':Units:Float_Type''Base^Units',
	'RIGHT', 'Float_Type''Base', 'none', '').
param('FLOAT_UNITS', '"*"', ':Units:Float_Type''Base^Units',
	'return', 'Units', 'out', '').
operationSpec('FLOAT_UNITS', '"/"', ':Units:Float_Type''Base^Units').
param('FLOAT_UNITS', '"/"', ':Units:Float_Type''Base^Units',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', '"/"', ':Units:Float_Type''Base^Units',
	'RIGHT', 'Float_Type''Base', 'none', '').
param('FLOAT_UNITS', '"/"', ':Units:Float_Type''Base^Units',
	'return', 'Units', 'out', '').
operationSpec('FLOAT_UNITS', '"/"', ':Units:Units^Float_Type''Base').
param('FLOAT_UNITS', '"/"', ':Units:Units^Float_Type''Base',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', '"/"', ':Units:Units^Float_Type''Base',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '"/"', ':Units:Units^Float_Type''Base',
	'return', 'Float_Type''Base', 'out', '').
operationSpec('FLOAT_UNITS', '"<"', ':Units:Units^boolean').
param('FLOAT_UNITS', '"<"', ':Units:Units^boolean',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', '"<"', ':Units:Units^boolean',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '"<"', ':Units:Units^boolean',
	'return', 'boolean', 'out', '').
operationCommentSpec('FLOAT_UNITS', '"<"', ':Units:Units^boolean', ' "=" and "/=" are already defined for private types
').
operationSpec('FLOAT_UNITS', '"<="', ':Units:Units^boolean').
param('FLOAT_UNITS', '"<="', ':Units:Units^boolean',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', '"<="', ':Units:Units^boolean',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '"<="', ':Units:Units^boolean',
	'return', 'boolean', 'out', '').
operationSpec('FLOAT_UNITS', '">"', ':Units:Units^boolean').
param('FLOAT_UNITS', '">"', ':Units:Units^boolean',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', '">"', ':Units:Units^boolean',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '">"', ':Units:Units^boolean',
	'return', 'boolean', 'out', '').
operationSpec('FLOAT_UNITS', '">="', ':Units:Units^boolean').
param('FLOAT_UNITS', '">="', ':Units:Units^boolean',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', '">="', ':Units:Units^boolean',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '">="', ':Units:Units^boolean',
	'return', 'boolean', 'out', '').
operationSpec('FLOAT_UNITS', '"/"', ':Units:Units^Integer_Type''Base').
param('FLOAT_UNITS', '"/"', ':Units:Units^Integer_Type''Base',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', '"/"', ':Units:Units^Integer_Type''Base',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '"/"', ':Units:Units^Integer_Type''Base',
	'return', 'Integer_Type''Base', 'out', '').
operationCommentSpec('FLOAT_UNITS', '"/"', ':Units:Units^Integer_Type''Base', ' The modulo operation for Units is provided to make
 it easy to normalize angular measurements.
 The division operator for Units which returns integers
 truncates toward zero (rather than rounding) to make it
 consistent with integer division, and it lets you do
 this:
 type Radians is new DIMENSIONAL_FLOAT.Units;
 PI           : constant Radians := 3.14159;
 ANGLE        : Radians;
 REVOLUTIONS  : integer; -- (if Integer_Type is integer)
 ANGLE := ANGLE mod (2.0 * PI);
 REVOLUTIONS := ANGLE / (2.0 * PI);
').
operationSpec('FLOAT_UNITS', '"rem"', ':Units:Units^Units').
param('FLOAT_UNITS', '"rem"', ':Units:Units^Units',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', '"rem"', ':Units:Units^Units',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '"rem"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationCommentSpec('FLOAT_UNITS', '"rem"', ':Units:Units^Units', ' truncates toward zero
').
operationSpec('FLOAT_UNITS', '"mod"', ':Units:Units^Units').
param('FLOAT_UNITS', '"mod"', ':Units:Units^Units',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', '"mod"', ':Units:Units^Units',
	'RIGHT', 'Units', 'none', '').
param('FLOAT_UNITS', '"mod"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationSpec('FLOAT_UNITS', 'Dimensionless', ':Units^Float_Type''Base').
param('FLOAT_UNITS', 'Dimensionless', ':Units^Float_Type''Base',
	'LEFT', 'Units', 'none', '').
param('FLOAT_UNITS', 'Dimensionless', ':Units^Float_Type''Base',
	'return', 'Float_Type''Base', 'out', '').
operationCommentSpec('FLOAT_UNITS', 'Dimensionless', ':Units^Float_Type''Base', ' Suppose you want to multiply two objects of type Feet
 together to get an answer in Square_feet. You need to
 write your own multiplication routine which converts
 the objects to dimensionless numbers, multiplies them,
 and converts them to type Square_feet. You are given
 the Dimensionless function to do this.
 function "*"(LEFT,RIGHT : Feet) return Square_feet is
   L, R : float; -- or whatever Float_Type is
 begin
   L := Dimensionless(LEFT);
   R := Dimensionless(RIGHT);
   return Type_Convert(L * R);
 end "*";
 The Dimensionless function is also handy for printing
 values. Assuming you have instantiated Float_Io for
 Float_Type and called it Float_Type_Io, you can do
 this:
 Float_Type_Io.Put(Dimensionless(TARGET_RANGE));
').
operationSpec('FLOAT_UNITS', 'First', '^Float_Type''Base').
param('FLOAT_UNITS', 'First', '^Float_Type''Base',
	'return', 'Float_Type''Base', 'out', '').
operationCommentSpec('FLOAT_UNITS', 'First', '^Float_Type''Base', ' Since private types (and the underlying real type)
 don''t have ''FIRST and ''LAST attributes, I have given
 you functions that will act like those attributes.
').
operationSpec('FLOAT_UNITS', 'Last', '^Float_Type''Base').
param('FLOAT_UNITS', 'Last', '^Float_Type''Base',
	'return', 'Float_Type''Base', 'out', '').
typeisNew('FLOAT_UNITS', 'Units', 'Float_Type''Base').
typePrivate('FLOAT_UNITS', 'Units', 'type Units is new Float_Type''Base range MIN..MAX;').
typeCommentPrivate('FLOAT_UNITS', 'Units', ' For example:
    ABSOLUTE_ZERO : constant Celsius
      := Type_Convert(TEMPERATURE.First);
').
packageBody('Integer_Units').
operationisBody('Integer_Units', 'Type_Convert', ':Integer_Type''Base^Units', 'begin
    return Units(X);
  end Type_Convert;').
paramis('Integer_Units', 'Type_Convert', ':Integer_Type''Base^Units',
	'X', 'Integer_Type''Base', 'none', '').
paramis('Integer_Units', 'Type_Convert', ':Integer_Type''Base^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', '"+"', ':Integer_Type^Units', 'begin
    return Units(Right);
  end "+";').
paramis('Integer_Units', '"+"', ':Integer_Type^Units',
	'Right', 'Integer_Type', 'none', '').
paramis('Integer_Units', '"+"', ':Integer_Type^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', '"-"', ':Integer_Type^Units', 'Neg : Integer_Type''Base;
  begin
    Neg := -1 * Right;
    return Units(Neg);
  end "-";').
paramis('Integer_Units', '"-"', ':Integer_Type^Units',
	'Right', 'Integer_Type', 'none', '').
paramis('Integer_Units', '"-"', ':Integer_Type^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', '"+"', ':Units^Units', 'begin
    return Right;
  end "+";').
paramis('Integer_Units', '"+"', ':Units^Units',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '"+"', ':Units^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', '"-"', ':Units^Units', 'Neg : Integer_Type''Base;
  begin
    Neg := -1 * Integer_Type''Base(Right);
    return Units(Neg);
  end "-";').
paramis('Integer_Units', '"-"', ':Units^Units',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '"-"', ':Units^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', '"abs"', ':Units^Units', 'begin
    return Units(abs(Integer_Type''Base(Right)));
  end "abs";').
paramis('Integer_Units', '"abs"', ':Units^Units',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '"abs"', ':Units^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', '"+"', ':Units:Units^Units', 'begin
    return Units(Integer_Type''Base(Left) + Integer_Type''Base(Right));
  end "+";').
paramis('Integer_Units', '"+"', ':Units:Units^Units',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', '"+"', ':Units:Units^Units',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '"+"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', '"-"', ':Units:Units^Units', 'begin
    return Units(Integer_Type''Base(Left) - Integer_Type''Base(Right));
  end "-";').
paramis('Integer_Units', '"-"', ':Units:Units^Units',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', '"-"', ':Units:Units^Units',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '"-"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', '"*"', ':Integer_Type''Base:Units^Units', 'begin
    return Units(Left * Integer_Type''Base(Right));
  end "*";').
paramis('Integer_Units', '"*"', ':Integer_Type''Base:Units^Units',
	'Left', 'Integer_Type''Base', 'none', '').
paramis('Integer_Units', '"*"', ':Integer_Type''Base:Units^Units',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '"*"', ':Integer_Type''Base:Units^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', '"*"', ':Units:Integer_Type''Base^Units', 'begin
    return Units(Integer_Type''Base(Left) * Right);
  end "*";').
paramis('Integer_Units', '"*"', ':Units:Integer_Type''Base^Units',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', '"*"', ':Units:Integer_Type''Base^Units',
	'Right', 'Integer_Type''Base', 'none', '').
paramis('Integer_Units', '"*"', ':Units:Integer_Type''Base^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', '"/"', ':Units:Integer_Type''Base^Units', 'begin
    return Units(Integer_Type''Base(Left) / Right);
  end "/";').
paramis('Integer_Units', '"/"', ':Units:Integer_Type''Base^Units',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', '"/"', ':Units:Integer_Type''Base^Units',
	'Right', 'Integer_Type''Base', 'none', '').
paramis('Integer_Units', '"/"', ':Units:Integer_Type''Base^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', '"/"', ':Units:Units^Integer_Type''Base', 'begin
    return Integer_Type''Base(Left) / Integer_Type''Base(Right);
  end "/";').
paramis('Integer_Units', '"/"', ':Units:Units^Integer_Type''Base',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', '"/"', ':Units:Units^Integer_Type''Base',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '"/"', ':Units:Units^Integer_Type''Base',
	'return', 'Integer_Type''Base', 'out', '').
operationisBody('Integer_Units', '"/"', ':Units:Units^Float', 'Exact_Quotient : Float;
  begin
    Exact_Quotient := Float(Left) / Float(Right);
    return Exact_Quotient;
  end "/";').
paramis('Integer_Units', '"/"', ':Units:Units^Float',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', '"/"', ':Units:Units^Float',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '"/"', ':Units:Units^Float',
	'return', 'Float', 'out', '').
operationisBody('Integer_Units', '"rem"', ':Units:Units^Units', 'begin
    return Units
      (Integer_Type''Base(Left) rem Integer_Type''Base(Right));
  end "rem";').
paramis('Integer_Units', '"rem"', ':Units:Units^Units',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', '"rem"', ':Units:Units^Units',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '"rem"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', '"mod"', ':Units:Units^Units', 'begin
    return Units
      (Integer_Type''Base(Left) mod Integer_Type''Base(Right));
  end "mod";').
paramis('Integer_Units', '"mod"', ':Units:Units^Units',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', '"mod"', ':Units:Units^Units',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '"mod"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationisBody('Integer_Units', 'Dimensionless', ':Units^Integer_Type''Base', 'begin
    return Integer_Type''Base(Left);
  end Dimensionless;').
paramis('Integer_Units', 'Dimensionless', ':Units^Integer_Type''Base',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', 'Dimensionless', ':Units^Integer_Type''Base',
	'return', 'Integer_Type''Base', 'out', '').
operationisBody('Integer_Units', '"<"', ':Units:Units^Boolean', 'begin
    return Integer_Type''Base(Left) < Integer_Type''Base(Right);
  end "<";').
paramis('Integer_Units', '"<"', ':Units:Units^Boolean',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', '"<"', ':Units:Units^Boolean',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '"<"', ':Units:Units^Boolean',
	'return', 'Boolean', 'out', '').
operationisBody('Integer_Units', '"<="', ':Units:Units^Boolean', 'begin
    return Integer_Type''Base(Left) <= Integer_Type''Base(Right);
  end "<=";').
paramis('Integer_Units', '"<="', ':Units:Units^Boolean',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', '"<="', ':Units:Units^Boolean',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '"<="', ':Units:Units^Boolean',
	'return', 'Boolean', 'out', '').
operationisBody('Integer_Units', '">"', ':Units:Units^Boolean', 'begin
    return Integer_Type''Base(Left) > Integer_Type''Base(Right);
  end ">";').
paramis('Integer_Units', '">"', ':Units:Units^Boolean',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', '">"', ':Units:Units^Boolean',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '">"', ':Units:Units^Boolean',
	'return', 'Boolean', 'out', '').
operationisBody('Integer_Units', '">="', ':Units:Units^Boolean', 'begin
    return Integer_Type''Base(Left) >= Integer_Type''Base(Right);
  end ">=";').
paramis('Integer_Units', '">="', ':Units:Units^Boolean',
	'Left', 'Units', 'none', '').
paramis('Integer_Units', '">="', ':Units:Units^Boolean',
	'Right', 'Units', 'none', '').
paramis('Integer_Units', '">="', ':Units:Units^Boolean',
	'return', 'Boolean', 'out', '').
operationisBody('Integer_Units', 'First', '^Integer_Type''Base', 'begin
    return Min;
  end First;').
paramis('Integer_Units', 'First', '^Integer_Type''Base',
	'return', 'Integer_Type''Base', 'out', '').
operationisBody('Integer_Units', 'Last', '^Integer_Type''Base', 'begin
    return Max;
  end Last;').
paramis('Integer_Units', 'Last', '^Integer_Type''Base',
	'return', 'Integer_Type''Base', 'out', '').
packageSpec('Integer_Units', '_root_').
packageCommentSpec('Integer_Units', 'tmp_Integer_Units06').
typeSpec('Integer_Units', 'Units', 'type Units is private;').
operationSpec('Integer_Units', 'Type_Convert', ':Integer_Type''Base^Units').
param('Integer_Units', 'Type_Convert', ':Integer_Type''Base^Units',
	'X', 'Integer_Type''Base', 'none', '').
param('Integer_Units', 'Type_Convert', ':Integer_Type''Base^Units',
	'return', 'Units', 'out', '').
operationCommentSpec('Integer_Units', 'Type_Convert', ':Integer_Type''Base^Units', ' Because Units are private types, Ada can''t be sure they
 are integers. Therefore, she will not let you do this:
 Target_Range : Feet := 587;
 Since you have to be able to assign numeric values to
 objects of type Feet, I have given you three type
 conversion routines.
 The preferred way is to do this:
 Target_Range : Feet := Type_Convert(587);
 This makes it obvious to other programmers that you
 have converted a numeric literal to a special kind of
 data type.
 But if you do this a lot, your program will be filled
 with so many Type_Convert() statements that people will
 get so used to them that they will ignore them. They
 loose their value, so you might as well use an operator
 which is 11 characters shorter.
 Target_Range : Feet := +587; -- or -587;
').
operationSpec('Integer_Units', '"+"', ':Integer_Type''Base^Units').
param('Integer_Units', '"+"', ':Integer_Type''Base^Units',
	'Right', 'Integer_Type''Base', 'none', '').
param('Integer_Units', '"+"', ':Integer_Type''Base^Units',
	'return', 'Units', 'out', '').
operationSpec('Integer_Units', '"-"', ':Integer_Type''Base^Units').
param('Integer_Units', '"-"', ':Integer_Type''Base^Units',
	'Right', 'Integer_Type''Base', 'none', '').
param('Integer_Units', '"-"', ':Integer_Type''Base^Units',
	'return', 'Units', 'out', '').
operationSpec('Integer_Units', '"+"', ':Units^Units').
param('Integer_Units', '"+"', ':Units^Units',
	'Right', 'Units', 'none', '').
param('Integer_Units', '"+"', ':Units^Units',
	'return', 'Units', 'out', '').
operationCommentSpec('Integer_Units', '"+"', ':Units^Units', ' The derived data types will inherit all the operations
 in the package below. These are all the operations that
 make sense for dimensional quantities.
').
operationSpec('Integer_Units', '"-"', ':Units^Units').
param('Integer_Units', '"-"', ':Units^Units',
	'Right', 'Units', 'none', '').
param('Integer_Units', '"-"', ':Units^Units',
	'return', 'Units', 'out', '').
operationSpec('Integer_Units', '"abs"', ':Units^Units').
param('Integer_Units', '"abs"', ':Units^Units',
	'Right', 'Units', 'none', '').
param('Integer_Units', '"abs"', ':Units^Units',
	'return', 'Units', 'out', '').
operationSpec('Integer_Units', '"+"', ':Units:Units^Units').
param('Integer_Units', '"+"', ':Units:Units^Units',
	'Left', 'Units', 'none', '').
param('Integer_Units', '"+"', ':Units:Units^Units',
	'Right', 'Units', 'none', '').
param('Integer_Units', '"+"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationSpec('Integer_Units', '"-"', ':Units:Units^Units').
param('Integer_Units', '"-"', ':Units:Units^Units',
	'Left', 'Units', 'none', '').
param('Integer_Units', '"-"', ':Units:Units^Units',
	'Right', 'Units', 'none', '').
param('Integer_Units', '"-"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationSpec('Integer_Units', '"*"', ':Integer_Type''Base:Units^Units').
param('Integer_Units', '"*"', ':Integer_Type''Base:Units^Units',
	'Left', 'Integer_Type''Base', 'none', '').
param('Integer_Units', '"*"', ':Integer_Type''Base:Units^Units',
	'Right', 'Units', 'none', '').
param('Integer_Units', '"*"', ':Integer_Type''Base:Units^Units',
	'return', 'Units', 'out', '').
operationSpec('Integer_Units', '"*"', ':Units:Integer_Type''Base^Units').
param('Integer_Units', '"*"', ':Units:Integer_Type''Base^Units',
	'Left', 'Units', 'none', '').
param('Integer_Units', '"*"', ':Units:Integer_Type''Base^Units',
	'Right', 'Integer_Type''Base', 'none', '').
param('Integer_Units', '"*"', ':Units:Integer_Type''Base^Units',
	'return', 'Units', 'out', '').
operationSpec('Integer_Units', '"/"', ':Units:Integer_Type''Base^Units').
param('Integer_Units', '"/"', ':Units:Integer_Type''Base^Units',
	'Left', 'Units', 'none', '').
param('Integer_Units', '"/"', ':Units:Integer_Type''Base^Units',
	'Right', 'Integer_Type''Base', 'none', '').
param('Integer_Units', '"/"', ':Units:Integer_Type''Base^Units',
	'return', 'Units', 'out', '').
operationSpec('Integer_Units', '"/"', ':Units:Units^Integer_Type''Base').
param('Integer_Units', '"/"', ':Units:Units^Integer_Type''Base',
	'Left', 'Units', 'none', '').
param('Integer_Units', '"/"', ':Units:Units^Integer_Type''Base',
	'Right', 'Units', 'none', '').
param('Integer_Units', '"/"', ':Units:Units^Integer_Type''Base',
	'return', 'Integer_Type''Base', 'out', '').
operationSpec('Integer_Units', '"/"', ':Units:Units^Float').
param('Integer_Units', '"/"', ':Units:Units^Float',
	'Left', 'Units', 'none', '').
param('Integer_Units', '"/"', ':Units:Units^Float',
	'Right', 'Units', 'none', '').
param('Integer_Units', '"/"', ':Units:Units^Float',
	'return', 'Float', 'out', '').
operationSpec('Integer_Units', '"rem"', ':Units:Units^Units').
param('Integer_Units', '"rem"', ':Units:Units^Units',
	'Left', 'Units', 'none', '').
param('Integer_Units', '"rem"', ':Units:Units^Units',
	'Right', 'Units', 'none', '').
param('Integer_Units', '"rem"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationSpec('Integer_Units', '"mod"', ':Units:Units^Units').
param('Integer_Units', '"mod"', ':Units:Units^Units',
	'Left', 'Units', 'none', '').
param('Integer_Units', '"mod"', ':Units:Units^Units',
	'Right', 'Units', 'none', '').
param('Integer_Units', '"mod"', ':Units:Units^Units',
	'return', 'Units', 'out', '').
operationSpec('Integer_Units', '"<"', ':Units:Units^Boolean').
param('Integer_Units', '"<"', ':Units:Units^Boolean',
	'Left', 'Units', 'none', '').
param('Integer_Units', '"<"', ':Units:Units^Boolean',
	'Right', 'Units', 'none', '').
param('Integer_Units', '"<"', ':Units:Units^Boolean',
	'return', 'Boolean', 'out', '').
operationCommentSpec('Integer_Units', '"<"', ':Units:Units^Boolean', ' "=" and "/=" are already defined for private types
').
operationSpec('Integer_Units', '"<="', ':Units:Units^Boolean').
param('Integer_Units', '"<="', ':Units:Units^Boolean',
	'Left', 'Units', 'none', '').
param('Integer_Units', '"<="', ':Units:Units^Boolean',
	'Right', 'Units', 'none', '').
param('Integer_Units', '"<="', ':Units:Units^Boolean',
	'return', 'Boolean', 'out', '').
operationSpec('Integer_Units', '">"', ':Units:Units^Boolean').
param('Integer_Units', '">"', ':Units:Units^Boolean',
	'Left', 'Units', 'none', '').
param('Integer_Units', '">"', ':Units:Units^Boolean',
	'Right', 'Units', 'none', '').
param('Integer_Units', '">"', ':Units:Units^Boolean',
	'return', 'Boolean', 'out', '').
operationSpec('Integer_Units', '">="', ':Units:Units^Boolean').
param('Integer_Units', '">="', ':Units:Units^Boolean',
	'Left', 'Units', 'none', '').
param('Integer_Units', '">="', ':Units:Units^Boolean',
	'Right', 'Units', 'none', '').
param('Integer_Units', '">="', ':Units:Units^Boolean',
	'return', 'Boolean', 'out', '').
operationSpec('Integer_Units', 'Dimensionless', ':Units^Integer_Type''Base').
param('Integer_Units', 'Dimensionless', ':Units^Integer_Type''Base',
	'Left', 'Units', 'none', '').
param('Integer_Units', 'Dimensionless', ':Units^Integer_Type''Base',
	'return', 'Integer_Type''Base', 'out', '').
operationCommentSpec('Integer_Units', 'Dimensionless', ':Units^Integer_Type''Base', 'tmp_Integer_Units07').
operationSpec('Integer_Units', 'First', '^Integer_Type''Base').
param('Integer_Units', 'First', '^Integer_Type''Base',
	'return', 'Integer_Type''Base', 'out', '').
operationCommentSpec('Integer_Units', 'First', '^Integer_Type''Base', ' Since private types don''t have ''Fisrt and ''Last
 attributes, I have given you functions that
 will act like those attributes.
').
operationSpec('Integer_Units', 'Last', '^Integer_Type''Base').
param('Integer_Units', 'Last', '^Integer_Type''Base',
	'return', 'Integer_Type''Base', 'out', '').
typeisNew('Integer_Units', 'Units', 'Integer_Type''Base').
typePrivate('Integer_Units', 'Units', 'type Units is new Integer_Type''Base range Min..Max;').
typeCommentPrivate('Integer_Units', 'Units', ' For example,
  Absolute_Zero : constant Celsius
    := Type_Convert(Temperature.First);
').
packageBody('Keyboard').
withBody('Keyboard', 'Text_Io').
dataBody('Keyboard', 'Available', ' Boolean := False;').
dataCommentBody('Keyboard', 'Available', ' This version takes its input from a file 
 named "kbdinput.dat" (which must be
 present in the execution (sub)directory),
 instead of the keyboard.
 Command syntax: <character>[<repeat_count>]
 ''D'' or ''d'' are not passed to the caller but are
 skipped (they represent a one call ''delay'' to 
 Keyboard.Hit).  Encountering an end of file is 
 represented by the value ''q'' (for "quit").
').
dataBody('Keyboard', 'File', ' File_Type;').
dataBody('Keyboard', 'Repeat_Count', ' Integer := 0;').
dataBody('Keyboard', 'Value', ' Character := ''q'';').
operationisBody('Keyboard', 'Check_Input', '', 'tmp_Keyboard08').
operationisCommentBody('Keyboard', 'Check_Input', '', ' not EOF after Get
 Make the first repeat available.
 not Available and then Repeat_Count = 0
').
operationisBody('Keyboard', 'Hit', '^Boolean', 'begin
    Check_Input;
    return Available;
  end Hit;').
paramis('Keyboard', 'Hit', '^Boolean',
	'return', 'Boolean', 'out', '').
operationisBody('Keyboard', 'Char', '^Character', 'begin
    if Available then
      Available := False;
      return Value;
    else
      Text_Io.Put_Line("Keyboard.Char called when not Keyboard.Hit");
    end if;
  end Char;').
paramis('Keyboard', 'Char', '^Character',
	'return', 'Character', 'out', '').
packageSpec('Keyboard', '_root_').
operationSpec('Keyboard', 'Hit', '^Boolean').
param('Keyboard', 'Hit', '^Boolean',
	'return', 'Boolean', 'out', '').
operationSpec('Keyboard', 'Char', '^Character').
param('Keyboard', 'Char', '^Character',
	'return', 'Character', 'out', '').
operationCommentSpec('Keyboard', 'Char', '^Character', ' Returns True if a key has been struck.
 Hit must be called until it returns True,
 indicating that a character is available.
 then Char must be called to consume and 
 retrieve the value of the key.
').
packageBody('POLLED_TIMER').
withBody('POLLED_TIMER', 'CALENDAR').
dataBody('POLLED_TIMER', 'CALENDAR_TICK', ' float := 1.0;').
dataCommentBody('POLLED_TIMER', 'CALENDAR_TICK', ' If a character is available (as determined by
 a preceding call to Hit), returns its value.
 Otherwise, it raises Program_Error.
 The following use clauses make the various "+" operators 
 which are used below visible:
 for Millimeters (Max_Throttle);
 for Hp (Max_Horsepower)
 for Lbs (Car_Weight)
 for Milliseconds (Delta_T)
 including 200 lb driverwith Aiu;
 The following use clauses make the various "+" operators 
 which are used below visible:
 for Millimeters (Max_Throttle)
 for Rev_Per_Minute (Max_Rpm)
 for Milliseconds (Delta_T)
 This body is for longer time periods on the IBM PC.
  CALENDAR_TICK : float := 65_536.0 / 1_193_180.0;
').
dataBody('POLLED_TIMER', 'CALENDAR_MAX', ' float := 86_400.0;').
dataCommentBody('POLLED_TIMER', 'CALENDAR_MAX', ' Modified for gnat 2.x under OS/2.
').
dataBody('POLLED_TIMER', 'TIMER_PERIOD', ' Duration;').
dataBody('POLLED_TIMER', 'TIMER_MODE', ' Modes;').
dataBody('POLLED_TIMER', 'START_TIME', ' CALENDAR.Time;').
dataBody('POLLED_TIMER', 'DONE', ' CALENDAR.Time;').
dataBody('POLLED_TIMER', 'TIME_ALREADY_USED', ' Duration;').
dataBody('POLLED_TIMER', 'STOPPED', ' boolean;').
operationisBody('POLLED_TIMER', 'Open', ':Seconds:Modes', 'begin
    if Dimensionless(PERIOD) > CALENDAR_MAX then
      raise INVALID_PERIOD;
    end if;
    if Dimensionless(PERIOD) < CALENDAR_TICK then
      raise INVALID_PERIOD;
    end if;
    TIMER_PERIOD := Duration(Dimensionless(PERIOD));
    TIME_ALREADY_USED := 0.0;
    STOPPED := TRUE;
    TIMER_MODE   := MODE;
  end Open;').
paramis('POLLED_TIMER', 'Open', ':Seconds:Modes',
	'PERIOD', 'Seconds', 'none', '').
paramis('POLLED_TIMER', 'Open', ':Seconds:Modes',
	'MODE', 'Modes', 'none', '').
operationisBody('POLLED_TIMER', 'Close', '', 'begin
    null;
  end Close;').
operationisBody('POLLED_TIMER', 'Start', '', 'use CALENDAR; -- for "+" and "-"
  begin
    START_TIME := CALENDAR.Clock;
    DONE := START_TIME + TIMER_PERIOD
      - TIME_ALREADY_USED;
    STOPPED := FALSE;
  end Start;').
operationisCommentBody('POLLED_TIMER', 'Start', '', ' for "+" and "-"
').
operationisBody('POLLED_TIMER', 'Restart', '', 'begin
    TIME_ALREADY_USED := 0.0;
    Start;
  end Restart;').
operationisBody('POLLED_TIMER', 'Has_Expired', '^boolean', 'use CALENDAR; -- for ">=" and "+"
  begin
    if Dimensionless(Time_Left) > 0.0 then
      return FALSE;
    else
      case TIMER_MODE is
        when SINGLE =>
          Stop;
          return TRUE;
        when REPEATED =>
          TIME_ALREADY_USED := CALENDAR.Clock - DONE;
          Start;
          return TRUE;
      end case;
    end if;
  end Has_Expired;').
paramis('POLLED_TIMER', 'Has_Expired', '^boolean',
	'return', 'boolean', 'out', '').
operationisCommentBody('POLLED_TIMER', 'Has_Expired', '^boolean', ' for ">=" and "+"
').
operationisBody('POLLED_TIMER', 'Stop', '', 'use CALENDAR; -- for "-"
  begin
    TIME_ALREADY_USED := CALENDAR.Clock
      - START_TIME;
    STOPPED := TRUE;
  end Stop;').
operationisCommentBody('POLLED_TIMER', 'Stop', '', ' for "-"
').
operationisBody('POLLED_TIMER', 'Time_Used', '^Seconds', 'TIME : float;
    use CALENDAR; -- for "-"
  begin
    if STOPPED then
      TIME := float(TIME_ALREADY_USED);
    else
      TIME := float(TIMER_PERIOD
         - (DONE - CALENDAR.Clock));
    end if;
    return Type_Convert(TIME);
  end Time_Used;').
paramis('POLLED_TIMER', 'Time_Used', '^Seconds',
	'return', 'Seconds', 'out', '').
operationisCommentBody('POLLED_TIMER', 'Time_Used', '^Seconds', ' for "-"
').
operationisBody('POLLED_TIMER', 'Time_Left', '^Seconds', 'DIFFERENCE : float;
    use CALENDAR; -- for "-"
  begin
    if STOPPED then
      DIFFERENCE := float(TIMER_PERIOD - TIME_ALREADY_USED);
    else
      DIFFERENCE := float(DONE - CALENDAR.Clock);
    end if;
    return Type_Convert(DIFFERENCE);
  end Time_Left;').
paramis('POLLED_TIMER', 'Time_Left', '^Seconds',
	'return', 'Seconds', 'out', '').
operationisCommentBody('POLLED_TIMER', 'Time_Left', '^Seconds', ' for "-"
').
operationisBody('POLLED_TIMER', 'Max_Period', '^Seconds', 'begin
    return Type_Convert(CALENDAR_MAX);
  end Max_Period;').
paramis('POLLED_TIMER', 'Max_Period', '^Seconds',
	'return', 'Seconds', 'out', '').
operationisBody('POLLED_TIMER', 'Single_Tick', '^Seconds', 'begin
    return Type_Convert(CALENDAR_TICK);
  end Single_Tick;').
paramis('POLLED_TIMER', 'Single_Tick', '^Seconds',
	'return', 'Seconds', 'out', '').
packageSpec('POLLED_TIMER', '_root_').
withSpec('POLLED_TIMER', 'TIME_UNITS').
packageCommentSpec('POLLED_TIMER', '   Seconds
  pragma Elaborate_Body;
').
typeEnumeration('POLLED_TIMER', 'Modes', 'SINGLE').
typeEnumeration('POLLED_TIMER', 'Modes', 'REPEATED').
typeSpec('POLLED_TIMER', 'Modes', 'type Modes is (SINGLE, REPEATED);').
operationSpec('POLLED_TIMER', 'Open', ':Seconds:Modes').
param('POLLED_TIMER', 'Open', ':Seconds:Modes',
	'PERIOD', 'Seconds', 'none', '').
param('POLLED_TIMER', 'Open', ':Seconds:Modes',
	'MODE', 'Modes', 'none', '').
operationCommentSpec('POLLED_TIMER', 'Open', ':Seconds:Modes', ' Program the timer to expire once, then stop (SINGLE),
 or program it to start another timing cycle as soon
 as the first one finishes (REPEATED).
').
exceptionSpec('POLLED_TIMER', 'INVALID_PERIOD').
exceptionCommentSpec('POLLED_TIMER', 'INVALID_PERIOD', ' Initializes the timer.
 It may raise INVALID_PERIOD.  If it does, use the two
 functions at the end of this package to find out what
 went wrong.
').
operationSpec('POLLED_TIMER', 'Close', '').
operationSpec('POLLED_TIMER', 'Start', '').
operationCommentSpec('POLLED_TIMER', 'Start', '', ' Turns the timer off.  On some target systems (like
 the IBM PC), it restores the physical timer chip to
 its default condition.  (On the IBM PC, the
 POLLED_TIMER uses the timer chip normally used by the
 speaker for timing.  If you don''t call Close at the
 end of the application program, then subsequent
 programs may not be able to use the speaker.)
').
operationSpec('POLLED_TIMER', 'Restart', '').
operationCommentSpec('POLLED_TIMER', 'Restart', '', ' Starts the timer running in the MODE determined by
 Set.
').
operationSpec('POLLED_TIMER', 'Has_Expired', '^boolean').
param('POLLED_TIMER', 'Has_Expired', '^boolean',
	'return', 'boolean', 'out', '').
operationCommentSpec('POLLED_TIMER', 'Has_Expired', '^boolean', ' Reloads the counter with the desired time delay and
 starts the counter again.
').
operationSpec('POLLED_TIMER', 'Stop', '').
operationCommentSpec('POLLED_TIMER', 'Stop', '', ' Poll this function to see if the time delay has
 expired yet.
').
operationSpec('POLLED_TIMER', 'Time_Used', '^Seconds').
param('POLLED_TIMER', 'Time_Used', '^Seconds',
	'return', 'Seconds', 'out', '').
operationCommentSpec('POLLED_TIMER', 'Time_Used', '^Seconds', ' Holds the timer at its current count until started or
 restarted again.
').
operationSpec('POLLED_TIMER', 'Time_Left', '^Seconds').
param('POLLED_TIMER', 'Time_Left', '^Seconds',
	'return', 'Seconds', 'out', '').
operationCommentSpec('POLLED_TIMER', 'Time_Left', '^Seconds', ' Tells you how many seconds have gone by since you
 started the timer.  It does NOT stop the timer.
').
operationSpec('POLLED_TIMER', 'Max_Period', '^Seconds').
param('POLLED_TIMER', 'Max_Period', '^Seconds',
	'return', 'Seconds', 'out', '').
operationCommentSpec('POLLED_TIMER', 'Max_Period', '^Seconds', ' Tells you how many seconds until the time delay will
 expire.  It does NOT stop the timer.
 The following two functions tell the limitations of the
 underlying physical timer. They can be called before
 setting the period to make sure the timer can support
 the desired time resolution, or they can be called
 after Set raises INVALID_PERIOD to find out what went
 wrong.
').
operationSpec('POLLED_TIMER', 'Single_Tick', '^Seconds').
param('POLLED_TIMER', 'Single_Tick', '^Seconds',
	'return', 'Seconds', 'out', '').
packageBody('Time_Units').
withBody('Time_Units', 'Ada.Integer_Text_Io').
withBody('Time_Units', 'Interfaces').
constantBody('Time_Units', 'Twelve_Hours', ' constant Milliseconds
      := Type_Convert(43_200_000);').
constantBody('Time_Units', 'One_Day', ' constant Milliseconds
      := 2 * Twelve_Hours;').
constantCommentBody('Time_Units', 'One_Day', ' (12 * 60 * 60 * 1000)
').
operationisBody('Time_Units', 'Image', ':Milliseconds^Time_Strings', 'T, Hours, Min, Sec, Msec
        : Integer_32;
      Time_String : Time_Strings
        := "HH:MM:SS.TTT";
        --  123456789012  (to help count positions)
  begin
    T := Dimensionless(Time);
    Hours := T / 3600000;
    T := T mod 3600000;
    Min := T / 60000;
    T := T mod 60000;
    Sec := T / 1000;
    Msec := T mod 1000;

    Put(Time_String(1 .. 2), Integer(Hours));
    Put(Time_String(4 .. 5), Integer(Min));
    Put(Time_String(7 .. 8), Integer(Sec));
    Put(Time_String(10 .. 12), Integer(Msec));

    return Time_String;

  end Image;').
paramis('Time_Units', 'Image', ':Milliseconds^Time_Strings',
	'Time', 'Milliseconds', 'none', '').
paramis('Time_Units', 'Image', ':Milliseconds^Time_Strings',
	'return', 'Time_Strings', 'out', '').
operationisCommentBody('Time_Units', 'Image', ':Milliseconds^Time_Strings', '  123456789012  (to help count positions)
').
operationisBody('Time_Units', 'Value', ':Time_strings^Milliseconds', 'T, Hours, Min, Sec, Msec
        : Integer_32;
  begin
    Hours := Integer_32''Value(Time(1..2));
    Min   := Integer_32''Value(Time(4..5));
    Sec   := Integer_32''Value(Time(7..8));
    Msec  := Integer_32''Value(Time(10..12));

    T := Msec + 1000 * (Sec + 60 * (Min + 60 * Hours));

    return Type_Convert(T);

  end Value;').
paramis('Time_Units', 'Value', ':Time_strings^Milliseconds',
	'Time', 'Time_strings', 'none', '').
paramis('Time_Units', 'Value', ':Time_strings^Milliseconds',
	'return', 'Milliseconds', 'out', '').
operationisBody('Time_Units', 'Convert', ':Milliseconds^Seconds', 'T : Float;
  begin
    if abs(Dimensionless(Time)) > 999_999 then
      raise Range_Error;
    end if;
    T := Float(Dimensionless(Time)) / 1000.0;
    return Type_Convert(T);
  end Convert;').
paramis('Time_Units', 'Convert', ':Milliseconds^Seconds',
	'Time', 'Milliseconds', 'none', '').
paramis('Time_Units', 'Convert', ':Milliseconds^Seconds',
	'return', 'Seconds', 'out', '').
operationisBody('Time_Units', 'Convert', ':Seconds^Milliseconds', 'T : Float;
  begin
    if abs(Dimensionless(Time)) > 999.999 then
      raise Range_Error;
    end if;
    T := Dimensionless(Time) * 1000.0;
    return Type_Convert(
      Integer_32(T));
  end Convert;').
paramis('Time_Units', 'Convert', ':Seconds^Milliseconds',
	'Time', 'Seconds', 'none', '').
paramis('Time_Units', 'Convert', ':Seconds^Milliseconds',
	'return', 'Milliseconds', 'out', '').
operationisBody('Time_Units', '"*"', ':Seconds:Hertz^Float', 'begin
    return Dimensionless(Left) * Dimensionless(Right);
  end "*";').
paramis('Time_Units', '"*"', ':Seconds:Hertz^Float',
	'Left', 'Seconds', 'none', '').
paramis('Time_Units', '"*"', ':Seconds:Hertz^Float',
	'Right', 'Hertz', 'none', '').
paramis('Time_Units', '"*"', ':Seconds:Hertz^Float',
	'return', 'Float', 'out', '').
operationisBody('Time_Units', '"*"', ':Hertz:Seconds^Float', 'begin
    return Dimensionless(Left) * Dimensionless(Right);
  end "*";').
paramis('Time_Units', '"*"', ':Hertz:Seconds^Float',
	'Left', 'Hertz', 'none', '').
paramis('Time_Units', '"*"', ':Hertz:Seconds^Float',
	'Right', 'Seconds', 'none', '').
paramis('Time_Units', '"*"', ':Hertz:Seconds^Float',
	'return', 'Float', 'out', '').
operationisBody('Time_Units', '"/"', ':Float:Seconds^Hertz', 'begin
    return Type_Convert(
      Left / Dimensionless(Right));
  end "/";').
paramis('Time_Units', '"/"', ':Float:Seconds^Hertz',
	'Left', 'Float', 'none', '').
paramis('Time_Units', '"/"', ':Float:Seconds^Hertz',
	'Right', 'Seconds', 'none', '').
paramis('Time_Units', '"/"', ':Float:Seconds^Hertz',
	'return', 'Hertz', 'out', '').
operationisBody('Time_Units', '"/"', ':Float:Hertz^Seconds', 'begin
    return Type_Convert(
      Left / Dimensionless(Right));
  end "/";').
paramis('Time_Units', '"/"', ':Float:Hertz^Seconds',
	'Left', 'Float', 'none', '').
paramis('Time_Units', '"/"', ':Float:Hertz^Seconds',
	'Right', 'Hertz', 'none', '').
paramis('Time_Units', '"/"', ':Float:Hertz^Seconds',
	'return', 'Seconds', 'out', '').
operationisBody('Time_Units', 'Normalize', ':Milliseconds', 'begin
    Time := Time mod ONE_DAY;
  end Normalize;').
paramis('Time_Units', 'Normalize', ':Milliseconds',
	'Time', 'Milliseconds', 'in out', '').
operationisBody('Time_Units', '">="', ':Milliseconds:Milliseconds^Boolean', 'L, R : Milliseconds;
  begin
    L := Left;
    Normalize(L);
    R := Right;
    Normalize(R);
    if Dimensionless(L - R) > Dimensionless(TWELVE_Hours) or
       Dimensionless(L - R) < 0 then
         return False;
    else
      return True;
    end if;
  end ">=";').
paramis('Time_Units', '">="', ':Milliseconds:Milliseconds^Boolean',
	'Left', 'Milliseconds', 'none', '').
paramis('Time_Units', '">="', ':Milliseconds:Milliseconds^Boolean',
	'Right', 'Milliseconds', 'none', '').
paramis('Time_Units', '">="', ':Milliseconds:Milliseconds^Boolean',
	'return', 'Boolean', 'out', '').
operationisBody('Time_Units', '"<"', ':Milliseconds:Milliseconds^Boolean', 'begin
    return not (Left >= Right);
  end "<";').
paramis('Time_Units', '"<"', ':Milliseconds:Milliseconds^Boolean',
	'Left', 'Milliseconds', 'none', '').
paramis('Time_Units', '"<"', ':Milliseconds:Milliseconds^Boolean',
	'Right', 'Milliseconds', 'none', '').
paramis('Time_Units', '"<"', ':Milliseconds:Milliseconds^Boolean',
	'return', 'Boolean', 'out', '').
operationisBody('Time_Units', '"<="', ':Milliseconds:Milliseconds^Boolean', 'begin
    return Left < Right or Left = Right;
  end "<=";').
paramis('Time_Units', '"<="', ':Milliseconds:Milliseconds^Boolean',
	'Left', 'Milliseconds', 'none', '').
paramis('Time_Units', '"<="', ':Milliseconds:Milliseconds^Boolean',
	'Right', 'Milliseconds', 'none', '').
paramis('Time_Units', '"<="', ':Milliseconds:Milliseconds^Boolean',
	'return', 'Boolean', 'out', '').
operationisBody('Time_Units', '">"', ':Milliseconds:Milliseconds^Boolean', 'begin
    return not (Left <= Right);
  end ">";').
paramis('Time_Units', '">"', ':Milliseconds:Milliseconds^Boolean',
	'Left', 'Milliseconds', 'none', '').
paramis('Time_Units', '">"', ':Milliseconds:Milliseconds^Boolean',
	'Right', 'Milliseconds', 'none', '').
paramis('Time_Units', '">"', ':Milliseconds:Milliseconds^Boolean',
	'return', 'Boolean', 'out', '').
packageSpec('Time_Units', '_root_').
withSpec('Time_Units', 'Dim_Int').
withSpec('Time_Units', 'Dim_Float').
packageCommentSpec('Time_Units', 'tmp_Time_Units09').
typeisNew('Time_Units', 'Milliseconds', 'Dim_Int.Units').
typeSpec('Time_Units', 'Milliseconds', 'type Milliseconds is new Dim_Int.Units;').
typeisNew('Time_Units', 'Seconds', 'Dim_Float.Units').
typeSpec('Time_Units', 'Seconds', 'type Seconds is new Dim_Float.Units;').
typeisNew('Time_Units', 'Hertz', 'Dim_Float.Units').
typeSpec('Time_Units', 'Hertz', 'type Hertz is new Dim_Float.Units;').
exceptionSpec('Time_Units', 'Range_Error').
typeSpec('Time_Units', 'Time_Strings', 'subtype Time_Strings is String(1..12);').
typeisSubtype('Time_Units', 'Time_Strings', 'String').
operationSpec('Time_Units', 'Image', ':Milliseconds^Time_Strings').
param('Time_Units', 'Image', ':Milliseconds^Time_Strings',
	'Time', 'Milliseconds', 'none', '').
param('Time_Units', 'Image', ':Milliseconds^Time_Strings',
	'return', 'Time_Strings', 'out', '').
operationCommentSpec('Time_Units', 'Image', ':Milliseconds^Time_Strings', ' Raised by Convert if the number of
 milliseconds is too large to be
 accurately represented by Seconds
 (which has only 6 digits of accuracy).
 The following functions convert time to
 a character string and vice versa.
 HH:MM:SS.TTT
').
operationSpec('Time_Units', 'Value', ':Time_Strings^Milliseconds').
param('Time_Units', 'Value', ':Time_Strings^Milliseconds',
	'Time', 'Time_Strings', 'none', '').
param('Time_Units', 'Value', ':Time_Strings^Milliseconds',
	'return', 'Milliseconds', 'out', '').
operationSpec('Time_Units', 'Convert', ':Milliseconds^Seconds').
param('Time_Units', 'Convert', ':Milliseconds^Seconds',
	'Time', 'Milliseconds', 'none', '').
param('Time_Units', 'Convert', ':Milliseconds^Seconds',
	'return', 'Seconds', 'out', '').
operationCommentSpec('Time_Units', 'Convert', ':Milliseconds^Seconds', ' The following functions do the conversions
 between Milliseconds and Seconds.
').
operationSpec('Time_Units', 'Convert', ':Seconds^Milliseconds').
param('Time_Units', 'Convert', ':Seconds^Milliseconds',
	'Time', 'Seconds', 'none', '').
param('Time_Units', 'Convert', ':Seconds^Milliseconds',
	'return', 'Milliseconds', 'out', '').
operationCommentSpec('Time_Units', 'Convert', ':Seconds^Milliseconds', ' May raise Range_Error;
').
operationSpec('Time_Units', '"*"', ':Seconds:Hertz^Float').
param('Time_Units', '"*"', ':Seconds:Hertz^Float',
	'Left', 'Seconds', 'none', '').
param('Time_Units', '"*"', ':Seconds:Hertz^Float',
	'Right', 'Hertz', 'none', '').
param('Time_Units', '"*"', ':Seconds:Hertz^Float',
	'return', 'Float', 'out', '').
operationCommentSpec('Time_Units', '"*"', ':Seconds:Hertz^Float', ' May raise Range_Error;
 The following operators accomodate the
 relationship between time and frequency.
').
operationSpec('Time_Units', '"*"', ':Hertz:Seconds^Float').
param('Time_Units', '"*"', ':Hertz:Seconds^Float',
	'Left', 'Hertz', 'none', '').
param('Time_Units', '"*"', ':Hertz:Seconds^Float',
	'Right', 'Seconds', 'none', '').
param('Time_Units', '"*"', ':Hertz:Seconds^Float',
	'return', 'Float', 'out', '').
operationSpec('Time_Units', '"/"', ':Float:Seconds^Hertz').
param('Time_Units', '"/"', ':Float:Seconds^Hertz',
	'Left', 'Float', 'none', '').
param('Time_Units', '"/"', ':Float:Seconds^Hertz',
	'Right', 'Seconds', 'none', '').
param('Time_Units', '"/"', ':Float:Seconds^Hertz',
	'return', 'Hertz', 'out', '').
operationSpec('Time_Units', '"/"', ':Float:Hertz^Seconds').
param('Time_Units', '"/"', ':Float:Hertz^Seconds',
	'Left', 'Float', 'none', '').
param('Time_Units', '"/"', ':Float:Hertz^Seconds',
	'Right', 'Hertz', 'none', '').
param('Time_Units', '"/"', ':Float:Hertz^Seconds',
	'return', 'Seconds', 'out', '').
operationSpec('Time_Units', 'Normalize', ':Milliseconds').
param('Time_Units', 'Normalize', ':Milliseconds',
	'Time', 'Milliseconds', 'in out', '').
operationCommentSpec('Time_Units', 'Normalize', ':Milliseconds', ' The next routine effectively performs a "mod"
 function to convert negative times and times
 exceeding 24 hours to the equivalent value
 in the range 0 to 24 hours.
').
operationSpec('Time_Units', '"<"', ':Milliseconds:Milliseconds^Boolean').
param('Time_Units', '"<"', ':Milliseconds:Milliseconds^Boolean',
	'Left', 'Milliseconds', 'none', '').
param('Time_Units', '"<"', ':Milliseconds:Milliseconds^Boolean',
	'Right', 'Milliseconds', 'none', '').
param('Time_Units', '"<"', ':Milliseconds:Milliseconds^Boolean',
	'return', 'Boolean', 'out', '').
operationCommentSpec('Time_Units', '"<"', ':Milliseconds:Milliseconds^Boolean', ' The following subprograms take into account the fact
 that time rolls over at midnight.  They require that
 the time difference be less than 12 hours.  The
 expression Left < Right tells if the Left time is
 earlier than the Right time. 
').
operationSpec('Time_Units', '"<="', ':Milliseconds:Milliseconds^Boolean').
param('Time_Units', '"<="', ':Milliseconds:Milliseconds^Boolean',
	'Left', 'Milliseconds', 'none', '').
param('Time_Units', '"<="', ':Milliseconds:Milliseconds^Boolean',
	'Right', 'Milliseconds', 'none', '').
param('Time_Units', '"<="', ':Milliseconds:Milliseconds^Boolean',
	'return', 'Boolean', 'out', '').
operationSpec('Time_Units', '">"', ':Milliseconds:Milliseconds^Boolean').
param('Time_Units', '">"', ':Milliseconds:Milliseconds^Boolean',
	'Left', 'Milliseconds', 'none', '').
param('Time_Units', '">"', ':Milliseconds:Milliseconds^Boolean',
	'Right', 'Milliseconds', 'none', '').
param('Time_Units', '">"', ':Milliseconds:Milliseconds^Boolean',
	'return', 'Boolean', 'out', '').
operationSpec('Time_Units', '">="', ':Milliseconds:Milliseconds^Boolean').
param('Time_Units', '">="', ':Milliseconds:Milliseconds^Boolean',
	'Left', 'Milliseconds', 'none', '').
param('Time_Units', '">="', ':Milliseconds:Milliseconds^Boolean',
	'Right', 'Milliseconds', 'none', '').
param('Time_Units', '">="', ':Milliseconds:Milliseconds^Boolean',
	'return', 'Boolean', 'out', '').
packageRename('_root_', 'Tu', 'Time_Units').
