

--  visibility on required modules : 
with counter;
use type counter.counter;
use type counter.counter_colour;
with cell;
use type cell.cell;
use type cell.cell_holds;

package board is

  type board is private;

  type state_of_game is (
    PLAY,
    WIN,
    DRAW,
    LOSE);

  type move_status is (OK, INVALID, PASS);

  SIZE : constant := 8;

  procedure set_up (me : IN OUT board);

  procedure add (me : IN OUT board; x : IN integer; y : IN integer; move_is : IN move_status);

  procedure now_playing (me : IN OUT board; c : IN counter.counter_colour);

  procedure display (me : IN OUT board);

  function check_move (me : IN board; x : IN integer; y : IN integer) return move_status;

  function status (me : IN board) return state_of_game;

  function contents (me : IN board; x : IN integer; y : IN integer) return cell.cell_holds;

private

  subtype board_index is integer range 1..SIZE;

  subtype board_range is board_index;

  type board_array is array(board_range, board_range) of cell.cell;

  type score_array is array(counter.counter_colour) of natural;

  type move_array is array(counter.counter_colour) of move_status;

  type board is tagged 
  record 
    sqrs : board_array;
    player : counter.counter_colour;
    opponent : counter.counter_colour;
    score : score_array;
    last_move : move_array;
  end record;

end board;
