

--  visibility on required modules : 


package body cell is

  procedure initialise (me : IN OUT cell) is
  begin
    me.contents := EMPTY_CELL;
  end initialise;

  function holds (me : IN cell) return cell_holds is
  begin
    case me.contents is
      when EMPTY_CELL =>
        return EMPTY;
      when NOT_EMPTY_CELL =>
        case counter.rep(me.item) is
          when counter.WHITE => return C_WHITE;
          when counter.BLACK => return C_BLACK;
        end case;
    end case;
  end holds;

  procedure add (me : IN OUT cell; players_counter : IN counter.counter) is
  begin
    me := (NOT_EMPTY_CELL, players_counter);
  end add;

  procedure display (me : IN cell) is
  begin
    if me.contents = NOT_EMPTY_CELL then
      counter.display(me.item);
    else
      counter.display_none(me.item);
    end if;
  end display;

  procedure flip (me : IN OUT cell) is
  begin
    counter.flip(me.item);
  end flip;

  function to_colour (c : IN cell_holds) return counter.counter_colour is
  begin
    case c is
      when C_WHITE => return counter.WHITE;
      when C_BLACK => return counter.BLACK;
      when others => raise constraint_error;
    end case;
  end to_colour;


end cell;
