

--  visibility on required modules : 
with counter;
use type counter.counter;
use type counter.counter_colour;

package cell is

  type cell is private;

  type cell_holds is (C_WHITE, C_BLACK, EMPTY);

  procedure initialise (me : IN OUT cell);

  function holds (me : IN cell) return cell_holds;

  procedure add (me : IN OUT cell; players_counter : IN counter.counter);

  procedure display (me : IN cell);

  procedure flip (me : IN OUT cell);

  function to_colour (c : IN cell_holds) return counter.counter_colour;

private

  type cell_is is (EMPTY_CELL, NOT_EMPTY_CELL);

  type cell is tagged 
  record 
    contents : cell_is := EMPTY_CELL;
    item : counter.counter;
  end record;

end cell;
