

--  visibility on required modules : 
with board;
use type board.board;
use type board.state_of_game;
use type board.move_status;
with counter;
use type counter.counter_colour;
with player;
use type player.player;


package body game is

  reversi : board.board;

  contestant : array(counter.counter_colour) of player.player;

  procedure play is
    current_state : board.state_of_game;
    person : counter.counter_colour;
    x, y : integer;
    move_is : board.move_status;
  begin
    board.set_up(reversi);
    player.set(contestant(counter.BLACK), counter.BLACK);
    player.set(contestant(counter.WHITE), counter.WHITE);
    current_state := board.PLAY;
    person := counter.BLACK;
    board.display(reversi);
    while current_state=board.PLAY loop
      board.now_playing(reversi, person);
      loop
        player.get_move(contestant(person), x, y);
        move_is := board.check_move(reversi, x, y);
        exit when move_is=board.OK or move_is=board.PASS;
      end loop;
      board.add(reversi, x, y, move_is);
      board.display(reversi);
      current_state := board.status(reversi);
      if current_state=board.PLAY then
        case person is
          when counter.BLACK => person := counter.WHITE;
          when counter.WHITE => person := counter.BLACK;
        end case;
      end if;
    end loop;
    player.announce(contestant(person), current_state);
  end play;


end game;
