

--  visibility on required modules : 

with ada.text_io;

package body player is

  package text_io renames ada.text_io;
  procedure set (me : IN OUT player; c : IN counter.counter_colour) is
    a_counter : counter.counter;
  begin
    counter.set(a_counter, c);
    me.plays_with := a_counter;
  end set;

  procedure get_move (me : IN player; row : OUT integer; column : OUT integer) is
    valid_move : boolean := FALSE;
    package io is new text_io.integer_io(integer);
  begin
    while not valid_move loop
      begin
        text_io.put("Please enter move ");
        counter.display(me.plays_with);
        text_io.put(" row column : ");
        io.get(row);
        io.get(column);
        valid_move := TRUE;
      exception
        when text_io.data_error =>
          row := -1;
          column := -1;
          text_io.skip_line;
        when text_io.end_error =>
          row := 0;
          column := 0;
      end;
    end loop;
  end get_move;

  function my_counter (me : IN player) return counter.counter is
  begin
    return me.plays_with;
  end my_counter;

  procedure announce (me : IN player; what : IN board.state_of_game) is
  begin
    case what is
      when board.WIN =>
        text_io.put("Player ");
        counter.display(me.plays_with);
        text_io.put(" has won");
      when board.LOSE =>
        text_io.put("Player ");
        counter.display(me.plays_with);
        text_io.put(" has lost");
      when board.DRAW =>
        text_io.put("It's a draw");
      when others =>
        raise constraint_error;
    end case;
  end announce;


end player;
