-- Simple screen interface.
-- 
-- Compatible with Michael Feldman's "simple ANSI terminal emulator", The George
--  Washington University, July 1995.
-- Requires Jerry van Dijk's "nt_console".
-- HOOD version by Pierre Dissaux, TNI, June 1998.


--  visibility on required modules : 
with ada.text_io;


package body screen is

  package TEXT_IO renames ada.text_io;
  package Int_IO is new Text_IO.Integer_IO(Num => Integer);

  procedure Beep is
  begin
    nt_console.Bleep;
  end Beep;

  procedure ClearScreen is
  begin
    nt_console.Clear_Screen;
  end ClearScreen;

  procedure MoveCursor (
    To : IN Position) is
  begin
    nt_console.Goto_XY(To.Column, To.Row);
  end MoveCursor;


end screen;
