-- Simple screen interface.
-- 
-- Compatible with Michael Feldman's "simple ANSI terminal emulator", The George
--  Washington University, July 1995.
-- Requires Jerry van Dijk's "nt_console".
-- HOOD version by Pierre Dissaux, TNI, June 1998.


--  visibility on required modules : 
with nt_console;
use type nt_console.X_Pos;
use type nt_console.Y_Pos;

package screen is

  subtype Height is nt_console.Y_Pos;

  subtype Width is nt_console.X_Pos;

  type Position is record
  	Row : Height := 1;
  	Column : Width := 1;
  end record;

  ScreenHeight : constant INTEGER := 24;

  ScreenWidth : constant INTEGER := 80;

  procedure Beep;

  procedure ClearScreen;

  procedure MoveCursor (
    To : IN Position);

end screen;
