--  visibility on required modules : 
with environment_monitor;
use type environment_monitor.ch4_reading;
use type environment_monitor.co_reading;
with pump_controller;
use type pump_controller.water_mark;
use type pump_controller.motor_state_changes;
--  visibility on real_time attributes : 
with data_logger_RTATT;
package data_logger is
  task OBCS is
    entry co_log (reading : IN co_reading);
    entry ch4_log (reading : IN ch4_reading);
    entry air_flow_log (reading : IN air_flow_reading);
    entry high_low_water_log (reading : IN water_mark);
    entry water_flow_log (reading : IN boolean);
    entry motor_log (status : IN motor_state_changes);
  end OBCS;
  procedure co_log (reading : IN co_reading) renames OBCS.co_log;
  procedure ch4_log (reading : IN ch4_reading) renames OBCS.ch4_log;
  procedure air_flow_log (reading : IN air_flow_reading) renames OBCS.air_flow_log;
  procedure high_low_water_log (reading : IN water_mark) renames OBCS.high_low_water_log;
  procedure water_flow_log (reading : IN boolean) renames OBCS.water_flow_log;
  procedure motor_log (status : IN motor_state_changes) renames OBCS.motor_log;
end data_logger;
