--  visibility on required modules : 
with system;
use type system.Address;
with device_register;
use type device_register.csr;
with hwcsr;
with lwcsr;
with data_logger;
with motor;
package body hlw_handler is
  procedure initialise;
  hwcsr : device_register.csr;
  for hwcsr'address use 16#AA10#;
  lwcsr : device_register.csr;
  for lwcsr'address use 16#AA12#;
  int : water_mark;
  task THREAD is
    pragma PRIORITY(hlw_handler_RTATT.INITIAL_THREAD_PRIORITY);
  end THREAD;
  procedure OPCS_start (int : IN water_mark) is
  begin
    null;
  end OPCS_start;
  procedure initialise is
  begin
    hwcsr.device := D_Enabled;
    hwcsr.interrupt := I_Enabled;
    lwcsr.device := D_Enabled;
    lwcsr.interrupt := I_Enabled;
  end initialise;
  procedure OPCS_thread is
  begin
    if int = high then
      motor.set_pump(on);
      data_logger.high_low_water_log(high);
    else
      motor.set_pump(off);
      data_logger.high_low_water_log(low);
    end if;
  end OPCS_thread;
  task body THREAD is
  begin
    loop
      OBCS.WAIT_START;
      OPCS_start (int );
    end loop;
  end THREAD;
  protected body OBCS is
    procedure start (int : IN water_mark) is
    begin
      if not STARTED then
        STARTED := TRUE;
      end if;
    end start;
    entry WAIT_START when STARTED is
    begin
      STARTED := FALSE;
    end WAIT_START;
  end OBCS;
end hlw_handler;
