--  visibility on required modules : 
with Ada.Real_Time; use Ada.Real_Time;
with RTA; use RTA;
--  visibility on real_time attributes : 
with motor_RTATT;
package motor is
  type Pump_Status is (On, Off, Disabled);
  type Motor_State_Changes is (Motor_Started, Motor_Stopped, Motor_Safe, Motor_Unsafe);
  pump_not_safe : exception;
  protected OBCS is
    pragma PRIORITY(motor_RTATT.INITIAL_CEILING_PRIORITY);
    procedure not_safe;
    procedure is_safe;
    function request_status return pump_status;
    procedure set_pump (status : IN pump_status);
  private
  end OBCS;
  procedure not_safe renames OBCS.not_safe;
  procedure is_safe renames OBCS.is_safe;
  function request_status return pump_status renames OBCS.request_status;
  procedure set_pump (status : IN pump_status) renames OBCS.set_pump;
end motor;
