--  visibility on required modules : 
with motor;
use type motor.pump_status;
with system;
use type system.Address;
with device_register;
use type device_register.csr;
with Ada.Real_Time; use Ada.Real_Time;
with RTA; use RTA;
with wfcsr;
with operator_console;
with data_logger;
package body water_flow_sensor is
  procedure initialise;
  flow : water_flow := No;
  current_pump_status : pump_status;
  last_pump_status : pump_status;
  wfcsr : device_register.csr(Device => D_Enabled);
  for wfcsr'address use 16#AA14#;
  task THREAD is
    pragma PRIORITY(water_flow_sensor_RTATT.INITIAL_THREAD_PRIORITY);
  end THREAD;
  procedure initialise is
  begin
    -- enable device
    wfcsr.device := D_Enabled;
  end initialise;
  procedure OPCS_thread is
  begin
    current_pump_status := motor.request_status;
    -- read device register
    if (wfcsr.operation = set) then
      flow := yes;
    else
      flow := no;
    end if;
    if current_pump_status = on and
         last_pump_status = on and
         flow = no then
      operator_console.alarm(pump_dead);
    end if;
    last_pump_status := current_pump_status;
    data_logger.water_flow_log(flow);
  end OPCS_thread;
  task body THREAD is
    T : Ada.Real_Time.TIME := Ada.Real_Time.CLOCK;
  begin
    if T < RTA.SYSTEM_START_UP_TIME then
      T := RTA.SYSTEM_START_UP_TIME;
    end if;
    T := T + water_flow_sensor_RTATT.OFFSET(RTA.START_MODE);
    loop
      delay until T;
      OPCS_thread;
      T := T + water_flow_sensor_RTATT.PERIOD(RTA.CURRENT_MODE);
    end loop;
  end THREAD;
end water_flow_sensor;
