Analogue to digital converters work in many different ways and have a range of operational characteristics. The code presented here is for a simple converter. Having been asked for a reading (by setting CH4CSR.OPERATION) the device will perform the conversion (by successive approximation), place the scaled integer on the data buffer register and set the done bit on the control/status register (this typically might take a few microseconds). The driver task loops around waiting for the done bit to be set. Other types of converter are interupt driven or give a continuous reading in the data buffer. To protect the software from a faulty device (i.e. one that never sets the done bit) the task delays for 0.1 seconds and then checks the flag. The device's operational characteristics dictate that the reading should be available well within the time range. If the done bit is not set then an error condition is reported to the operator console.

Once a reading has been obtained it is compared with the HIGH value and, if necessary, the appropriate call in the pump controller is made. Alternatively if the reading is below the HIGH level, and the motor is disabled (unsafe), then a call to restart the motor is undertaken. To prevent the motor being continuously switched on and off when the methane level is hovering around the HIGH level a "jitter_range" (hysteresis) is incorporated into the test for motor_safe.

The above algorithm uses a simple tactic to decide if the methane level is acceptable. Other strategies might involve monitoring the change in methane level so that predictions could be made about the likelihood of a HIGH reading in the future.

Having taken a reading, (and  undertaken whatever communications with the pump controller are appropriate) the task then logs its reading in the data logger.