/* Begin Body of client                                                       */
/* ---------- include provided interface: ----------------------------------- */
#include "client.h"
/* ---------- include required interface: ----------------------------------- */
#include "server.h"
#include "shared.h"

/* ---------- internal data: ------------------------------------------------ */
int mode = 1;

/* ---------- provided operation bodies: ------------------------------------ */
int client__run(int argc, char *argv[ ])
{ 
  mode = 1; 
  server__op1((shared__T_value)mode,0);
  return 0;
}

/*  constrained operation OPCS:                                               */
void OPCS_notify(void)
{ 
  mode = 2; 
  server__op2((shared__T_value)mode); 
}

/* ---------- obcs body: ---------------------------------------------------- */

/*  OBCS main task:                                                           */
Process * client__OBCS;

/*  input and output channels:                                                */

typedef struct {
  int  call_;
} client__notify_in;
typedef struct {
  int  return_;
} client__notify_out;
Channel * client__notify_req;
Channel * client__notify_rep;

/*  OBCS stop channel:                                                        */
Channel * client__OBCS_end;

/*  channels messages:                                                        */
static client__notify_in notify_msg_in;
static client__notify_out notify_msg_out;

/*  constrained operation calling procedure:                                  */

void client__notify(void)
{
  ChanOut(client__notify_req, &notify_msg_in, sizeof(client__notify_in));
  ChanIn(client__notify_rep, &notify_msg_out, sizeof(client__notify_out));
}

/*  OBCS initialization procedure:                                            */
Process * client__OBCS_init(void)
{
  client__notify_req = ChanAlloc();
  if (client__notify_req == NULL) return NULL;
  client__notify_rep = ChanAlloc();
  if (client__notify_rep == NULL) return NULL;
  client__OBCS_end = ChanAlloc();
  if (client__OBCS_end == NULL) return NULL;
  client__OBCS = ProcAlloc(client__OBCS_proc, 1000, 0);
  if (client__OBCS == NULL) return NULL;
  ProcRunLow(client__OBCS);
  return client__OBCS;
}

/*  OBCS execution procedure:                                                 */
void client__OBCS_proc(Process * client__OBCS)
{
  int i;
  int running = 1;
  while (running) {
    i = ProcAlt(client__notify_req, client__OBCS_end, NULL);
    switch (i) {
      case 0 :
        /* HSER notify */
        ChanIn(client__notify_req,
          &notify_msg_in, sizeof(client__notify_in));
        OPCS_notify();
        notify_msg_out.return_ = 1;
        ChanOut(client__notify_rep,
          &notify_msg_out, sizeof(client__notify_out));
        break;
      case 1 :
        /* STOP OBCS */
        running = ChanInInt(client__OBCS_end);
        break;
    }
  }
}

/*  OBCS stop procedure:                                                      */
void client__OBCS_stop(void)
{
  ChanOutInt(client__OBCS_end, 0);
}


/*  OBCS termination procedure:                                               */
void client__OBCS_term(void)
{
  free(client__notify_req);
  free(client__notify_rep);
  free(client__OBCS_end);
  ProcAllocClean(client__OBCS);
}


/* End Body of client                                                         */
