/* ---------- include provided interface: ----------------------------------- */
#include "transputer.h"
/* ---------- include real-time libraries: ---------------------------------- */
#include <stdio.h>
#include <stdlib.h>
#include <channel.h>
#include <process.h>
/* ---------- global real-time declarations: -------------------------------- */
static Process **pList;
#define TaskNumber 4
/* ---------- tasks and communications initialisation: ---------------------- */
#include "client.h"
#include "cyclic.h"
#include "server.h"
int transputer__init(void)
{
  int cpt = 0;
  pList[cpt] = client__OBCS_init();
  if (pList[cpt] == NULL) return 0;
  else cpt++;
  pList[cpt] = cyclic__OBCS_init();
  if (pList[cpt] == NULL) return 0;
  else cpt++;
  pList[cpt] = server__OBCS_init();
  if (pList[cpt] == NULL) return 0;
  else cpt++;
  pList[cpt] = server__op3_init();
  if (pList[cpt] == NULL) return 0;
  else cpt++;
  pList[cpt] = NULL;
  return 1;
}
/* ---------- tasks and communications finalization: ---------------------- */
void transputer__term(void)
{
  client__OBCS_term();
  cyclic__OBCS_term();
  server__OBCS_term();
  server__op3_term();
}

/* ---------- main entry point: --------------------------------------------- */
int main(int argc, char *argv[ ])
{
  int status;
  pList = malloc((TaskNumber+1)*sizeof(Process*));
  status = transputer__init();
  if (status != 1) exit(EXIT_FAILURE);
  status = transputer__run(argc, &argv[0]);
  ProcJoinList(pList);
  transputer__term();
  free(pList);
  exit(EXIT_SUCCESS);
}

